;
;
;	VT-DOS kompatibilis floppy diszk illeszt ver.1.2
;
;	0. ROM lap: inicializlsok, MDD, egysgkezel, FISH funkcik
;
;

;
;	RAM-ba msolt rutinok cmei (a fordthatsg miatt)
;
LDB2E	.equ	0DB2Eh
LDB28	.equ	0DB28h
LDBC1	.equ	0DBC1h
LDC0E	.equ	0DC0Eh




	.org	0C000h
;
	.db	"MOPS"
	.db	004h			; azonost nv hossza
	.db	"DISK"			; azonostnv
	.dw	0DB6Fh			; VT-DOS megszaktskiszolgl rutin cme
;
	.dw	LC21C			; inicializl rutin cme
	.db	00Ch			; funkcik szma
	.dw	LDBC1			; megszaktskiszolgl rutin cme
	.dw	LC499			; karakter I/O
	.dw	LC4FF			; blokk I/O
	.dw	LC35B			; fjl megnyitsa
	.dw	LC53B			; fjl lezrsa
	.dw	LC5D5			; blokk ellenrzs (VERIFY)
	.dw	LC5F5			; fjlmutat belltsa
	.dw	LC5F9			; fjlmutat belltsa az akt. llapothoz kpest
	.dw	LC5FD			; fjlmutat belltsa a fjl vghez kpest
	.dw	LC6E8			; CLI puffer definilsa
	.dw	LC6FD			; CLI parancs vgrehajtsa
	.dw	LC703			; FISH-funkci vgrehajtsa
;


	.org	0C02Eh
;
;
;	Egy-egy belpsi pont a FISH s a DISKIO modulok elrshez VT-DOS-bl
;
LC02E:	jp	LCD46			; ugrs a FISH funkci vgrehajtsra
;
;
LC031:	call	LDB2E			; 2.lapon lv rutin hvsa (cm: 0EB49h)
;
	.dw	0EB49h			; DISKIO hvsa
;
	ret


;
;
;	Szektorbufferek s meghajt tblzatok ltrehozsa
;	tovbb:
;	 - logikai sszerendelsek trlse (ha A=00h)
;	 - meghajtk alaphelyzetbe lltsa
;	 - egylemezes rendszer esetn 2. fizikai meghajt 1.-hez rendelse
;	in:   A - funkcivlaszt:
;	           0 - rendszer alaphelyzetbe lltsa meghajtk szmnak vizsglatval
;	         <>0 - rendszer alaphelyzetbe lltsa
;	out: -
;
LC037:	ld	iy,0D080h		; IY belltsa, hogy a RAM els 256 bjtja elrhet legyen indexelt cmzssel
	ld	(0DFF5h),iy
	ld	hl,0D067h		; HL= els szektorbuffer cmt tartalmaz RAM vltoz cme
	ld	de,0D4FAh		; DE= az els szektorbuffer cme
	ld	b,004h			; 4 ciklus -> 3 szektorbuffer lesz
LC047:	dec	b			; B reg. ellenrzse
	jr	nz,LC04C		; ugrs, ha nem az utols ciklus kvetkezik
	ld	d,b			; DE= 0000h (az utols bufferben a "kvetkez buffer cme" 0000h)
	ld	e,b
LC04C:	inc	b			; B reg. visszalltsa
	ld	(hl),e			; kvetkez szektorbuffer kezdcmnek bersa HL mutatta cmre (az elz szektorbuffer elejre)
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),000h		; fizikai egysgszm nullzsa a bufferben (els buffernl az "aktulis szektorbuffer cme" RAM vltoz, als bjt)
	inc	hl
	ld	(hl),000h		; flag bjt nullzsa a bufferben (els buffernl az "aktulis szektorbuffer cme" RAM vltoz, fels bjt)
	ld	hl,0020Bh		; HL= 512 + 11 (szektormret + 11 bjtos buffer fejlc)
	add	hl,de
	ex	de,hl			; DE a kvetkez szektorbuffer elejre mutat, HL az elzre
	djnz	LC047
	or	a
	jr	nz,LC06D		; ugrs, ha belpskor az A-ban tadott kd nem nulla volt
	inc	(iy-05Fh)		; DEF_UNIT vltoz nvelse  (= 001h)
	dec	(iy-05Bh)		; VERIFY vltoz cskkentse (= 0FFh)
	ld	b,a			; B= 00h -> minden korbbi ASSIGN mvelet trldik
	call	LDB2E			; 1.lapon lv rutin hvsa (cm: 0D1E2h)
;
	.dw	0D1E2h			; FISH 19h: ASSING (logikai s fizikai meghajtk sszerendelse)
;
	xor	a			; egysgkezel parancskd: 0 - rendszer alaphelyzetbe lltsa meghajtk szmnak vizsglatval
LC06D:	call	LC0C1			; meghajt tblzatok ltrehozsa, meghajt rendszer reset
	ret	nz			; visszatrs, ha nem egymeghajts a rendszer (vagy A<>0 volt belpskor)
	ld	bc,00201h		; msodik meghajtt az elshz rendeli (B= els fizikai egysgszm C= msodik fizikai egysgszm)
	call	LDB2E			; 1.lapon lv rutin hvsa (cm: 0D1A7h)
;
	.dw	0D1A7h			; FISH 18h: MAPDISK (fizikai meghajtk egymshoz rendelse)
;
	ret


;
;
;	Hasznlt meghajtk megjellse, hogy a benne lv lemezt ellenrizni kell (pdf. 79. oldal)
;	in:   -
;	out:  A - A=0
;
LC07A:	ld	b,010h			; 16 meghajtt vizsgl vgig
LC07C:	ld	a,b			; A reg. = logikai meghajt sorszma
	call	LC095			; logikai meghajt hozzrendelsi tblzatelemnek kiolvassa HL-be
	ld	e,(hl)
	inc	hl
	ld	d,(hl)			; DE = fizikai meghajt adattblzatnak kezdcme
	ld	a,d
	or	e
	jr	z,LC091			; ugrs, ha DE=0000h
	ld	hl,00009h
	add	hl,de			; HL= bels hasznlatra fenntartott bjt cme
	ld	a,(hl)
	or	a
	jr	z,LC091			; ugrs, ha 0 volt
	ld	(hl),001h		; jelzs, hogy ellenrizni kell a lemezt (?)
LC091:	djnz	LC07C			; ismtls, amg az sszes logikai meghajtn vgig nem ment
	xor	a			; hibajelzk trlse
	ret


;
;
;	Logikai meghajt hozzrendelsi tblzatelemnek kiolvassa
;	in:   A - logikai meghajt
;	out:  A - hozzrendelt fizikai meghajt (1..16)
;	     HL - fizikai meghajt tblzatelem cme (0D0BBh tblzatban)
;
LC095:	cp	011h
	jr	c,LC09A			; ugrs, ha A reg.< 17
	xor	a			; egybknt A=0
LC09A:	push	de
	ld	de,0D0DDh		; DE=logikai meghajtk hozzrendelsi tblzata
	ld	l,a
	ld	h,000h
	add	hl,de			; HL= az adott logikai mehajt tblzatelem cme
	ld	a,(hl)			; A= hozzrendelt fizikai meghajt
	push	af
	call	LC0B3			; meghajtnak megfelel tblzatelem cm betltse HL-be
	pop	af
	pop	de
	ret


;
;
;	Fizikai meghajt tblzatcmnek kiolvassa
;	in:   A - fizikai meghajt
;	out: DE - fizikai meghajt tblzatra mutat
;	     ZF - ZF=1 ha nem ltez meghajt (DE= 0000h)
;
LC0AA:	call	LC0B3			; meghajtnak megfelel tblzat-cm betltse HL-be
	ld	e,(hl)			; tblzat elem DE-be
	inc	hl
	ld	d,(hl)
	ld	a,d
	or	a			; ha D=0, akkor hiba - nem ltez fizikai meghajt
	ret


;
;
;	Fizikai meghajt tblzatelem cmnek meghatrozsa
;	in:   A - fizikai meghajt
;	out: HL - cm a bels RAM-ban
;
LC0B3:	cp	011h
	jr	c,LC0B8			; ugrs, ha A reg.< 17
	xor	a			; egybknt A=0
LC0B8:	ld	e,a
	ld	d,000h
	ld	hl,0D0BBh
	add	hl,de
	add	hl,de			; HL=2*meghajt sorszma + 0D0BBh
	ret


;
;
;	Meghajt tblzatok ltrehozsa (egysgler terlet, ld. pdf 84. oldal)
;	in:   A - egysgkezel meghvsakor hasznland parancskd:
;	           0 - rendszer alaphelyzetbe lltsa meghajtk szmnak vizsglatval
;	           1 - rendszer alaphelyzetbe lltsa
;	out: egysgkezel visszatrsi rtkei
;
LC0C1:	push	af			; A reg. mentse
	ld	b,004h			; 4 meghajt tblzat lesz (egy tblzat 96 bjt hossz)
	ld	de,0D0EEh		; DE= az els fizikai meghajt tblzatnak kezdcme
	ld	hl,0D0BDh		; HL= a meghajt tblzatok cmt tartalmaz tblzat 1. eleme
LC0CA:	di
	ld	(hl),e			; meghajt tblzat kezdcmnek bersa a tblzatok cmt tartalmaz tblzatba
	inc	hl
	ld	(hl),d
	inc	hl
	push	hl			; aktulis tblzatcm mentse
	ei
	ld	hl,00006h
	add	hl,de			; HL a fizikai meghajt tblzatnak 6. elemre mutat
	ld	a,004h
	sub	b
	ld	(hl),a			; meghajt sorszm az egysgkezelnek (0..3)
	inc	hl
	inc	a
	ld	(hl),a			; aktulis egysgszm
	inc	hl
	ld	(hl),a			; fizikai egysgszm
	inc	hl
	ld	(hl),000h		; meghajt idzt bjt nullzsa
	ld	de,00016h
	add	hl,de			; HL a fizikai meghajt tblzatnak 31. (01Fh) elemre mutat
	ld	(hl),0FFh		; a meghajt aktulis knyvtra a fknyvtr
	ld	e,041h			; HL nvelse 65 bjttal (aktulis tvonalnv string puffer)
	add	hl,de
	ex	de,hl			; DE= a kvetkez meghajt tblzat cme
	pop	hl			; HL= a meghajt tblzatok cmt tartalmaz tblzat aktulis eleme
	djnz	LC0CA			; ismtls az sszes meghajt tblzat ltrehozsig
	ld	hl,0D0EEh		; HL az els meghajt tblzatra mutat
	pop	af			; A reg.= belpskori rtk
	sub	001h			; CY=1 ha belpskor A reg.= 00h volt
	sbc	a,a			; A=00h vagy 0FFh
	inc	a			; A=01h vagy 00h (ha eredetileg is 00h volt)

;
;
;	Egysgkezel meghvsa konstans, bels RAM-ban lv diszk tviteli cmmel
;
LC0F6:	ld	ix,0D26Eh

;
;
;	Egysgkezel funkcijnak meghvsa
;	in:   A - funkciszm
;	      B - szektorok szma (4,5,6) vagy "hordoz" bjt (8)
;	     DE - szektorcm (4,5,6)
;	     HL - meghajt adattblzata
;	     IX - diszk tviteli cm
;	out:  A - hibajelz bitek
;	      F - jelzbitek "OR A" utastssal belltva
;	     BC - ???
;	      B - sszes tvitt szektor (4,5,6)
;	      C - mg htralv tvivend szektorok szma (4,5,6) vagy "hordoz" bjt (8)
;	     DE - ???
;	     HL - vltozatlan
;
LC0FA:	push	ix			; megrzend regiszterrtkek a verembe
	push	iy
	push	hl
	exx
	ex	af,af'
	push	hl
	push	de
	push	bc
	push	af
	ex	af,af'
	exx
	push	de
	ld	de,00006h
	add	hl,de
LC10C:	ld	c,(hl)			; C = egysgszm az egysgkezelnek (0..3)
	pop	de
	call	LC77F			; egysgkezel parancsfeldolgozjnak hvsa
	ex	af,af'
	call	LC123			; CTRL-ESC llapotjelz vizsglata
	pop	af
	ex	af,af'
	exx
	pop	bc			; regiszterek helyrelltsa
	pop	de
	pop	hl
	exx
	pop	hl
	pop	iy
	pop	ix
	or	a			; jelzbitek A reg.-nek megfelelen belltva
	ret


;
;	CTRL-ESC llapotjelz vizsglata
;
LC123:	ld	a,(0DFF4h)		; A reg.= STOP_FLAG msolata
	inc	a
	ret	nz			; visszatrs, ha nem 0FFh volt
	ld	a,0F5h			; hibakd: .STOP - CTRL-ESC-t nyomtak
	ex	af,af'
	cp	a			; ZF=1
	ret


;
;--------------------------------------------------------------------------------------
;		Inicializlskor a bels RAM-ba kerl programrszek
;--------------------------------------------------------------------------------------
;


;
;
;	FISH funkcik vgrehajtsa a RAM-on keresztl
;
LC12D:	call	LDB2E			; rutin RAM-beli kezdcme: 0DB28h
	.dw	00000h			; a hvand FISH rutin cme itt helyezkedik el
	ret				; vgrehajts utn ide tr vissza, majd vissza a hvhoz


;
;
;	Lapoz rutin
;
	ld	(0DB1Bh),a		; A reg. mentse, rutin kezdcme: 0DB2Eh
	ld	(0DB1Ch),de		; DE reg. mentse
	ex	(sp),hl			; HL=visszatrsi cm, HL mentse
	ld	e,(hl)			; az utna lv kt bjtra msolta be a FISH rutin cmt
	inc	hl
	ld	d,(hl)			; DE=rutin cme
	inc	hl
	ex	(sp),hl			; visszatrsi cm+2 s HL helyrelltva
	ld	a,(0DFFAh)
	push	af
	ld	a,d			; rutin cm fels bjt
	ld	(0DFFAh),a		; D5..4 bitek vlasztanak, tbbi nincs bektve
	out	(008h),a		; HBF memrialapoz regiszter (18h,28h,38h,48h)
	ld	a,(0DB1Bh)		; A reg. helyrelltsa
	push	hl			; HL mentse
	ld	hl,0DB57h
	ex	(sp),hl			; visszatrsi cm a verembe, HL helyrelltsa
	res	4,d			; ez a kt bit lltotta a lapoz regisztert
	res	5,d
	push	de			; rutin cme a verembe
	ld	de,(0DB1Ch)		; DE helyrelltsa
	ret				; ugrs a rutinra (a vermbl veszi ki a cmet)
;
LDB57:	ex	(sp),hl			; ez a visszatrsi cm a rutin meghvsa utn
	push	af			; A reg. mentse, a korbban mentett fels cmbjtot HL-be msolta
	ld	a,h
	ld	(0DFFAh),a		; 0DFFAh helyrelltsa
	out	(008h),a		; lapozs helyrelltsa
	pop	af			; A reg. vissza
	pop	hl			; HL vissza
	ret				; visszatrs az eredeti cm+2 -re


;
;
;	Konstans stringek a RAM-ban letrolva, hogy a lapozssal hvott rutinoknak
;	paramterknt tadhatak legyenek
;
LDB62:	.db	02Eh,02Eh			; ".."
	.db	020h,020h,020h,020h,020h	; sszesen 10 db. SPACE karakter
	.db	020h,020h,020h,020h,020h
LDB6E:	.db	00h				; nulla karakter, pl. res stringhez


;
;	VT-DOS megszaktskiszolgl rutin
;
LC174:	push	ix			; RAM cme: 0DB6Fh
	push	iy
	ld	a,(0DB1Bh)		; lapoz rutin tmeneti vltozinak elmentse a verembe
	ld	hl,(0DB1Ch)		; arra az esetre, ha pont a lapozst szaktotta volna meg az INT
	push	af			; (az idztsi vltozk frisstse rutin lapozssal lesz elrve)
	push	hl
	ld	a,(0DFFFh)
	push	af
	call	LDB2E			; 2.lapon lv rutin hvsa (cm: 0EEC0h)
;
	.dw	0EEC0h			; Idztsi vltozk frisstse
;
	out	(007h),a		; cursor/hang INT trlse
	pop	af
	ld	(0DFFFh),a
	out	(002h),a
	pop	hl			; lapoz rutin tmeneti vltozi vissza
	pop	af
	ld	(0DB1Ch),hl
	ld	(0DB1Bh),a
	pop	iy
	pop	ix
	ret


;
;
;	Megszakts kiszolgl rutin (RAM cme: 0DB99h)
;	- kzvetlenl a 0038h cmrl ugrik ide a program
;	- krtya inicializlsa s MOPS funkcik vgrehajtsa alatt aktv
;	- 0DBA8h cmen eltrolt rutint hvja meg, ezek: 0DBBBh vagy 0DBD7h
;
LC19E:	push	af
	push	hl
	ld	a,(0DFFFh)		; memrialapozs msolata A reg.-be
	ld	(00003h),a		; bersa P_SAVE-be
	ld	hl,(0DBA8h)		; 0DBA8h a kvetkez CALL L0000 utasts paramternek cme
	ld	(00039h),hl		; a hvand rutint kzvetlenl belltja a megszak. kiszolgl ugrsi cmnek
	call	00000h			; rutin meghvsa
	di
	ld	hl,0DB99h
	ld	(00039h),hl		; visszalltja sajt magt a f megszakts kezelnek
	ld	a,(00003h)
	ld	(0DFFFh),a		; s a memrialapozs llapott ismt elmenti
	pop	hl
	pop	af
	ei
	ret

;
;
;	Eredeti megszakts kiszolgl hvsa (RAM cm: 0DBBBh)
;
LC1C0:	push	af			; A reg. mentse s belltsa, az eredeti rutinnak megfelelen
	ld	a,070h
	jp	0003Bh			; ugrs az eredeti megszaktskezel folytatsra (az els 3 bjtban a "JP 0DB99h" szerepel)

;
;
;	MOPS megszaktskezel rutin (0.funkci, RAM cme: 0DBC1h)
;
LC1C6:	ld	a,(0DB1Bh)		; az esetleg megszaktott FISH funkci lementett regiszter-rtkeinek beolvassa
	ld	hl,(0DB1Ch)
	push	af			; regiszterek mentse a verembe
	push	hl
	call	LDB2E			; 2.lapon (ROM-ban) lv rutin hvsa (cm: 0EE5Dh)
;
	.dw	0EE5Dh			; a CALL utasts paramternek RAM cme: 0DBCCh, ezt trja a meghvott rutin (!)
;
	pop	hl			; megszaktott FISH funkci lementett rtkeinek visszalltsa
	pop	af
	ld	(0DB1Ch),hl
	ld	(0DB1Bh),a
	ret


;
;
;	Megszakts kiszolglbl hvott rutin (RAM cme: 0DBD7h)
;
LC1DC:	push	af
	push	bc
	push	de
	push	hl
	push	ix
	push	iy
	exx
	push	bc
	push	de
	push	hl
	ex	af,af'
	push	af
	ld	a,(00003h)		; A reg.= P_SAVE
	push	af			; eredeti lapozsi rtk a verembe
	ld	a,0F0h			; j lapozs: U0, U1, U2, EXT
	ld	(00003h),a
	out	(002h),a		; lapozs belltsa
	out	(007h),a		; kurzor/hang INT trlse
	ld	hl,(0C00Eh)		; HL= MOPS megszaktskiszolgl rutin cme (0DBC1h)
	call	LDC0E			; megszakts rutin meghvsa, kzvetett ugrssal
	pop	af
	ld	(00003h),a		; eredeti lapozs visszalltsa
	out	(002h),a
	pop	af
	ex	af,af'
	pop	hl
	pop	de
	pop	bc
	exx
	pop	iy
	pop	ix
	pop	hl
	pop	de
	pop	bc
	pop	af
	ei
	ret


;
LC213:	jp	(hl)			; ugr utasts (RAM cme: 0DC0Eh)


;
;
;	BASIC CLI kls hibakezelje (RAM cme: 0DC0Fh)
;
	ld	a,001h
	ret

; ---------------- eddig msoldik a RAM-ba --------------------------


;
;
;	Az trand I/O port cmeket tartalmaz tblzat
;
LC217:	.db	002h			; szmll bjt: 2 memriacmet tartalmaz a tblzat
	.dw	0DB44h			; megfelel cme a ROM-ban: 0C149h
	.dw	0DB5Eh			; megfelel cme a ROM-ban: 0C163h




;
;
;	Inicializl rutin
;
LC21C:	di				; megszaktsok tiltsa
	ld	a,(00B21h)		; WARM_FLAG ellenrzse
	or	a
	jp	nz,LC24C		; ugrs, ha meleg reset van folyamatban (0FFh)
	ld	hl,0DB2Eh		; HL= memria lapoz rutin cme a bels RAM-ban
	ld	de,0C133h		; DE= memria lapoz rutin cme a ROM-ban (prototpus)
	ld	b,006h			; 6 bjtot ellenriz
LC22C:	ld	a,(de)
	cp	(hl)			; RAM tartalom sszehasonltsa a ROM-ban lvvel
	inc	hl			; mutatk a kvetkez bjtokra lltsa
	inc	de
	jr	nz,LC23A		; ugrs, ha nem egyezik a ROM s a RAM tartalma
	djnz	LC22C			; ismtls a szksges szm bjt sszehasonltsig
	ld	a,(0DFF1h)
	or	a
	jr	nz,LC24C		; egyezs estn nem trli a memrit
LC23A:	ld	hl,0D000h		; majdnem a teljes 4kB RAM terlet nullzsa
	ld	de,0D001h
	ld	bc,00FF2h		; 0FF3h hosszon (4083 bjt)
	ld	(hl),l
	ldir
	ld	a,0FFh
	ld	(0DFF2h),a		; jelzs az utols bjton
	xor	a			; A= 00h -> a meghajtk szmt is ellenrizni kell majd
LC24C:	ex	af,af'			; j memrinl itt folytatja, A reg. mentse A'-be
	ld	hl,0DFF3h		; utols 13 bjt nullzsa minden esetben
	ld	b,00Dh
	xor	a
LC253:	ld	(hl),a
	inc	hl
	djnz	LC253
	ld	(0D020h),a		; BOOT_DRV vltozt is minden esetben trli
	push	ix			; IX= a krtyaazonost utni 40 bjtos pufferre mutata U0-ban (40h,70h,0A0h,0D0h krtya azonostk kezdete + 8bjt)
	pop	hl			; HL= IX
	ld	a,l			; A= a puffer cm als bjtja
	sub	010h
	and	0C0h			; A= fels kt biten a csatlakoz sorszma
	ld	(0DFFEh),a		; ments a RAM-ba
	rrca
	rrca				; A= 4..5 biten a sorszm
	add	a,010h
	ld	(0D02Bh),a		; krtya I/O port bziscmnek belltsa a RAM vltozba
	ld	de,00008h
	add	hl,de
	ex	de,hl			; 6 bjt tmsolsa a ROM-bl a krtyapuffer 8. cmre: "VT-DOS"
	ld	hl,0C32Ch
	ld	bc,00006h
	ldir
	ld	(0DB26h),de		; utols karakter utni cm elmentse (ez majd az EXT2 belpsi cme lesz)
	ld	c,021h			; tovbbi 33 bjt tmsolsa U0-ba (EXT2 belpsi rutin)
	ldir
	ld	hl,0C12Dh		; HL= tmsoland terlet kezdete a ROM-ban
	ld	de,0DB28h		; DE= bels RAM-ban lv cm
	ld	bc,000EAh		; 234 bjt lesz
	ldir				; memrialapoz rutin tmsolsa a bels RAM-ba
	ld	b,(hl)			; a kvetkez ROM cmrl szmll betltse B reg.-be
LC28D:	inc	hl
	ld	e,(hl)			; trand memriacm betltse DE-be
	inc	hl
	ld	d,(hl)
	ex	de,hl			; beolvasott rtk HL-be, HL rgi rtke DE-be mentve
	ld	a,(0D02Bh)		; A reg.= alap I/O port cm
	add	a,(hl)
	ld	(hl),a			; HL mutatta memriacm rtknek nvelse az alap I/O cmmel
	ex	de,hl			; HL ismt a ROM cmre mutat
	djnz	LC28D			; ismtls, amg vannak trand memriacmek
	xor	a			; A reg.= 0
	out	(058h),a		; az sszes csatolkrtya megszaktskrsnek tiltsa
	out	(059h),a
	out	(05Ah),a
	out	(05Bh),a
	out	(005h),a		; hang megszaktskrs tiltsa
	ld	hl,0C31Ch		; HL= CRTC regiszterekbe belltand rtkek tblzatcme
	ld	b,010h			; 16 regisztert programoz fel
	ld	c,071h			; kpernyvezrl (CRTC) adatregiszter I/O cme
LC2AC:	ld	a,b			; a magasabb regisztercmekkel kezdi
	dec	a
	out	(070h),a		; belltand bels CRTC regiszter cme
	outi				; adatregiszterbe a tblzatbl olvasott rtk
	jr	nz,LC2AC		; ismtls, amg a B-ben adott szm regisztert be nem lltotta
	ld	a,080h			; port 6-ba rand rtk: 7.- nyomtat (nSTROBE)  5..2 - hang amplitd  1..0 - grafikus md
	out	(006h),a		; 2-szn grafikus md belltsa (?)
	ld	(0DFFCh),a		; md mentse a RAM vltozba is
	xor	a			; A reg.= 00h
	out	(060h),a		; 0. sznregiszter nullzsa
	out	(061h),a		; 1. sznregiszter nullzsa
	ld	a,0F0h
	ld	(0DFFFh),a		; P_SAVE msolata = 0F0h (U0,U1,U2,EXT)
	ld	a,0C3h			; JP NN - kdja
	ld	hl,0DB99h		; HL= memriacm
	ld	(00038h),a		; megszaktsi rutin els 3 btjnak trsa
	ld	(00039h),hl		; j IT rutin: JP 0DB99h
	ld	hl,0DBD7h
	ld	(0DBA8h),hl		; az j IT ltal hvott rutin cmnek belltsa 0DBD7h-ra
	ei				; az inicializls kezdete ta itt engedlyezi a megszaktsokat elszr
	ex	af,af'			; A reg.= 00h -ha trlni kellett  a RAM terletet, minden ms esetben nem nulla
	call	LC037			; szektorbufferek s meghajttblzatok ltrehozsa, meghajt rendszer alaphelyzetbe lltsa
	di
	ld	a,0F5h			; A reg.= PUSH AF kdja
	ld	hl,0703Eh		; HL= LD A,070h kdja
	ld	(00038h),a		; megszakts rutin eredeti els 3 btjnak visszalltsa
	ld	(00039h),hl
	ld	hl,0DBBBh
	ld	(0DBA8h),hl		; a RAM-ban lv IT ltal hvott rutin cmnek belltsa 0DBBBh-ra
	xor	a
	ld	(0DFF1h),a		; 00h rsa a RAM trlst engedlyez vltozba
	ld	a,(0D02Bh)		; A reg.= alap I/O port cm
	ld	bc,0087Fh
LC2F7:	inc	c			; C-ben a csatlakoznak megfelel szm lesz: 80h..83h
	sla	b			; B-ben is a csatlakoznak megfelel rtk: 10h..40h
	sub	010h			; port bziscm cskkentse
	jr	nz,LC2F7		; ismtls a port bziscmnek megfelel alkalommal
	ld	a,b			; csatlakozszmnak megfelel bit A reg.-be
	cpl				; A-ban lv bitek invertlsa (maszk ksztse)
	ld	hl,00B10h		; INT_DES vltoz cme: kurzor IT ltal kiszolglt eszkzk
	and	(hl)			; a csatlakoznak megfelel IT kiszolglsnak tiltsa (?)
	ld	(hl),a			; INT_DES vltoz frisstse
	ld	a,c
	ld	(00B05h),a		; kazetta input  direkt hozzrendelse az aktulis sorszm krtyhoz
	ld	(00B0Dh),a		; kazetta output direkt hozzrendelse az aktulis sorszm krtyhoz
	or	080h			; SF (sign flag) belltsa 1-re (hatsra IX= 0DC45h lesz)
	call	LC311			; ktszer futtatja le a kvetkez rutint
LC311:	call	LC6CC			; IX rtknek belltsa SF szerint
	xor	a			; A reg.= 00h  SF=0 (hatsra IX= 0DD78h lesz)
	ld	(ix-033h),a		; 0DC12h= 00h  s  0DD45h = 00h (nincsenek megnyitott fjlok)
	ld	(ix-001h),a		; 0DC44h= 00h  s  0DD77h = 00h
	ret


;
;
;	CRTC regiszterekbe rand rtkek
;	(a magasabb cm bels regiszterekbe rand adatok vannak elbb, cskken sorrendben)
;	megj.: egyedl a kurzor pozci H regiszterbe rand rtk klnbzik a def. op. rendszertl (0Eh helyett 0Ah)
;
LC31C:	.db	0FFh,00Ah,000h,000h,003h,003h,003h,000h
	.db	042h,03Ch,002h,04Dh,032h,04Bh,040h,063h
;
;
LC32C:	.db	"VT-DOS"


;
;
;	EXT2 belpsi rutin (U0-n lv krtyapufferbe msolva inicializlskor)
;	in:  HL - CLI parancssorra mutat
;	     IX - a BASIC vltozterletre mutat (01700h)
;	     IY - a BASIC verem utols bjtjra mutat (magasabb cmtl az alacsonyabb fel terjeszkedik)
;	out:    -
;
LC332:	inc	hl			; (az itt kezdd 33 bjt msoldik t a krtyapufferbe)
	ld	de,(01726h)		; DE= TOP - kvetkez szabad bjt cme a szimblumtblban
	ld	a,(iy-001h)		; BASIC verem ellenrzse (?)
	cp	040h
	jr	nz,LC342
	ld	l,e			; a CLI puffer a szimblumtbla utni szabad terleten kezddik
	ld	h,d
	ld	(hl),000h		; CLI interaktv md jelzse
LC342:	push	iy
	ex	(sp),hl			; HL= BASIC verem alja, HL korbbi rtke a verembe
	dec	h			; 256 bjtot szabadon hagy a BASIC verem aljig
	sbc	hl,de
	ld	c,l			; BC= puffer mrete bjtokban
	ld	b,h
	rst	30h			; MOPS funkcihvs
;
	.db	059h			; CLI puffer definilsa
;
	rst	10h			; MOPS hibakezel meghvsa (hibakd A reg.-ben)
	pop	de			; DE= a vgrehajtand parancssor karakterlncra mutat (0. bjt a hosszbjt, ha 00h akkor interaktv md)
	ld	c,a			; C= I/O vlaszts (00h, interaktv mdban kzmbs)
	rst	30h			; MOPS funkcihvs
;
	.db	0DAh			; CLI parancs vgrehajtsa
;
	rst	10h			; MOPS hibakezel meghvsa (hibakd A reg.-ben)
	ret				; visszatrs (az inicializl rutin eddig msolja t a krtyapufferbe)


;
;
;	VT-DOS cartridge indtsa (pl. CLI-bl)
;
LC353:	di
	ld	a,0E0h			; lapozs: SYS, U1, U2, EXT
	out	(002h),a		; lapoz regiszter belltsa
	jp	00000h			; ugrs a reset-el egyenrtk 0000h cmre




;
;-----------------------------------------------
;	MOPS: fjl megnyitsa
;-----------------------------------------------
;  in: DE - tvonalnv stringre mutat (0. bjt a hosszbjt)
; out:  A - hibakd
;      DE - a fjlnvre mutat (az tvonalat nem adja vissza)
;-----------------------------------------------
;
LC35B:	call	LC736			; MOPS funkcihvsok kezd programrsze (INT belltsa)
	call	LC6CC			; IX rtknek belltsa SF (sign flag) szerint
	ex	af,af'			; tviteli irny mentse (F'-be)
	push	de
	call	LC554			; I/O fjlpufferek kirsa a lemezre s a korbbi fjlok lezrsa
	pop	de
	ret	nz			; visszatrs, ha hiba trtnt
	push	ix
	pop	bc
	ld	hl,00030h
	add	hl,bc			; HL az aktulis irny puffernek +030h cmre mutat
	push	hl
	ex	de,hl			; HL= tvonalnv string  DE= puffer +030h cme
	ld	c,(hl)			; C= tvonalnv string hossza
	xor	a
	ld	b,a
	cp	c
	jr	z,LC37A			; ugrs, ha 0 hosszsg az tvonalnv
	inc	hl
	ldir				; string tmsolsa a pufferbe
LC37A:	ld	(de),a			; zr 00h karakter elhelyezse
	pop	de
	call	LC6D6			; bevezet szkz s TAB karakterek eltvoltsa a string elejrl
	ex	de,hl			; HL a javtott stringre mutat
	xor	a
	push	ix
	pop	de			; DE a puffer elejre mutat (FCB helye)
	ld	(ix+006h),a		; fjlattribtum (00h)
	ld	(ix+007h),a		; default meghajt (00h)
	dec	a			; A reg.= 0FFh
	ld	(de),a			; hasznlatlan FCB jelzse
	ld	a,001h			; parancskd: tvonalnv elemzse (C reg.= 00h)
	call	LC5CD			; FISH funkci vgrehajtsa
	ret	nz			; visszatrs, ha hiba trtnt
	ld	a,c			; A reg.= zr karakter
	call	LC6DE			; zr karakter vizsglata
	jr	nz,LC39C		; ugrs, ha A reg. nem 00h, SPACE vagy TAB
	inc	de			; DE= zr karakter utni cm
	call	c,LC6D6			; szkz s TAB karakterek eltvoltsa, ha a zrkarakter az volt
LC39C:	ld	a,0A9h			; hibakd: .IFNM - rvnytelen fjlnv
	ret	nz			; visszatrs, ha az utols karakter nem 00h
	ld	a,b			; tvonalnvelemzs visszatrsi jelzbitjei A reg.-be
	ex	af,af'			; jelzbitek mentse, tviteli irnynak megfelel SF rtk vissza
	ld	a,006h
	jp	p,LC3C3			; ugrs, ha rsra kell megnyitni
	ld	a,b			; jelzbitek ismt A reg.-be
	and	018h
	jr	nz,LC3BC		; ugrs, ha fjlnv vagy fjlnv kiterjeszts van az tvonal utols elemben
	push	ix
	ex	(sp),hl			; HL= fjl bels puffere (FCB helye), rgi rtke a verembe
	ld	de,00008h
	add	hl,de
	ex	de,hl			; DE= a fjlnv elejre mutat a hasznlatlan FCB-ben
	ld	hl,0C48Eh		; HL= "START   " szvegre mutat a ROM-ban
	ld	bc,00008h
	ldir				; 8 karakter msolsa az FCB-be
	pop	hl			; HL ismt az tvonalnv elejre mutat
LC3BC:	or	0FFh			; A reg.= 0FFh s SF=1 (olvass)
	ld	(00B6Bh),a		; BUFFER vltoz = 0FFh -> pufferelt fjl
	ld	a,004h
LC3C3:	ex	af,af'			; tvonalnvelemzs jelzbitjei ismt A reg.-be, tviteli irny mentse
	and	010h
	jr	nz,LC3D9		; ugrs, ha van fjlnv kiterjeszts
	push	ix
	ex	(sp),hl			; HL= fjl bels puffere (FCB helye), rgi rtke a verembe
	ld	de,00010h
	add	hl,de
	ex	de,hl			; DE= a fjlnv kiterjesztsre mutat a hasznlatlan FCB-ben
	ld	hl,0C496h		; HL= "CAS" szvegre mutat a ROM-ban
	ld	bc,00003h
	ldir				; 3 karakter msolsa az FCB-be
	pop	hl			; HL ismt az tvonalnv elejre mutat
LC3D9:	call	LC6AE			; aktulis I/O irnynak megfelel FCB cmnek betltse DE-be
	ld	c,e			; BC= j FCB cme
	ld	b,d
	push	ix
	pop	de			; DE= hasznlatlan FCB cme
	ex	af,af'			; A=4 ha olvass (els keresse) s A=6 ha rs (fjl ltrehozsa)
	push	af			; A reg. mentse a verembe
	ex	af,af'			; tviteli irny jelzse ismt F'-be
	pop	af			; parancskd thozsa a "norml" A reg.-be
	call	LC5CD			; FISH funkci vgrehajtsa IX mentsvel
	ret	nz			; visszatrs, ha hiba trtnt
	ld	(ix-001h),a		; a bufferben lv karakterek szma = 00h
	ld	(ix-003h),a		; a bufferben htralv karakterek szma = 00h
	bit	2,(ix-020h)		; attribtum bjt vizsglata
	ld	a,0A8h			; hibakd: .IATTR - rvnytelen fjlattribtumok
	ret	nz			; visszatrs, ha rendszer fjl (SYSTEM)
	push	de			; FCB-k cmeinek mentse
	push	bc
	ld	hl,00008h
	add	hl,bc
	ex	de,hl			; DE az j (meghatrozott) FCB-ben a fjlnvre mutat
	ld	hl,00BF5h		; HL a kazetta munkaterlet 5. bjtjra mutat (cl terlet)
	ld	c,000h			; C-ben szmolja az tmsolt karaktereket
	ld	b,008h			; B= max. 8 karaktert msol
	call	LC482			; string msolsa szkzk kihagysval
	ld	a,(de)			; A reg.= fjlnv kiterjeszts els karaktere az FCB-bl
	cp	020h
	jr	z,LC415			; ugrs, ha szkz a kiterjeszts els karaktere
	ld	(hl),02Eh		; '.' karakter bersa
	inc	hl
	inc	c			; karakterszm nvelse
	ld	b,003h
	call	LC482			; kiterjeszts msolsa szkzk kihagysval
LC415:	ld	a,c
	ld	(00BF4h),a		; kazetta munkaterletre msolt fjlnv string hosszbjtjnak belltsa
	pop	de			; DE= meghatrozott FCB cme
	pop	hl			; HL= hasznlatlan (v. keressi) FCB cme
	ld	a,00Ch			; A reg.= fjl megnyitsa parancskd
	call	LC5CD			; FISH funkci vgrehajtsa IX mentsvel
	call	z,LC46C			; megnyitott fjl kiterjesztsnek ellenrzse, ha nem volt hiba
	jr	nz,LC468		; ugrs, ha a nem volt hiba s a fjl kiterjesztse sem "CAS"
	ex	af,af'			; tviteli irny ellenrzse
	jp	p,LC463			; ugrs, ha rs
	ld	bc,00080h		; BC= olvasand bjtok szma (128)
	call	LC6AE			; aktulis I/O irnynak megfelel FCB cmnek betltse DE-be
	ld	a,001h
	ld	(0DFF7h),a		; FSH_PG (a 3. memrialap lapozsa): bels RAM
	ld	a,00Fh			; A reg.= olvass fjlbl parancskd
	call	LC5CD			; FISH funkci vgrehajtsa IX mentsvel
	ret	nz			; visszatrs, ha hiba trtnt
	ld	a,(ix+000h)		; els beolvasott karakter ellenrzse
	cp	011h
	jr	z,LC445			; ugrs, ha a fjl "CAS" fejlc azonostval kezddik
	dec	a
	ld	a,0E7h			; hibakd: .INTERR - rvnytelen .CAS fjl-fejlc
	ret	nz			; visszatrs, ha A reg. nem 011h vagy 01h volt
LC445:	ld	l,(ix+002h)
	ld	h,(ix+003h)		; HL= a program ltal elfoglalt 128 bjtos blokkok szma
	ld	a,(ix+004h)		; A reg.= az utols blokkban lv bjtok szma
	cp	080h
	jr	nz,LC454		; ugrs, ha nem 128 bjt van az utols blokkban
	inc	hl			; tnyleges blokkok szmnak nvelse
	xor	a
LC454:	srl	h			; HL= HL/2
	rr	l
	rla
	rrca				; CY belptetse A reg. 7.bit-be
	ld	(ix-01Ah),h		; a szmtott rtk alapjn a fjlmret belltsa a nyitott FCB-ben
	ld	(ix-01Bh),l
	ld	(ix-01Ch),a
LC463:	ld	(ix-00Bh),080h		; fjlmutat belltsa 128-ra a nyitott FCB-ben
	xor	a			; hibakd trlse
LC468:	ld	de,00BF4h		; DE a megnyitott fjl nevre mutat a kazetta munkaterleten
	ret


;
;
;	Megnyitott fjl kiterjesztsnek ellenrzse
;	in:  IX - az aktulis I/O irnynak megfelel fjl adatterletnek cme
;	out: ZF - ZF=1 a fjl kiterjesztse "CAS"
;
LC46C:	push	ix
	pop	hl
	ld	de,0FFDDh
	add	hl,de			; HL a fjlnv kiterjesztsre mutat az FCB-ben
	ld	de,0C496h		; DE= "CAS" szveg cme a ROM-ban
	ld	b,003h			; B= 3 karakter sszahasonltsa lesz
LC478:	ld	a,(de)
	cp	(hl)			; FCB-ben lv s a ROM-ban letrolt karakterek sszahasonltsa
	ld	a,000h
	ret	nz			; visszatrs, ha nem egyeznek
	inc	hl			; mutatk kvetkez karakterekre lltsa
	inc	de
	djnz	LC478			; ismtls
	ret


;
;
;	String msolsa szkzk kihagysval
;	in:   B - forrs string hossza
;	      C - karakter szmll kezdrtke (0)
;	     DE - forrs kezdcme
;	     HL - cl kezdcme
;	out:  C - tmsolt karakterek
;	     DE - a forrs string vgre mutat
;	     HL - az tmsolt string vgre mutat
;
LC482:	ld	a,(de)			; forrs aktulis karaktere A reg.-be
	inc	de			; forrsmutat nvelse
	cp	020h
	jr	z,LC48B			; ugrs, ha SPACE karakter
	ld	(hl),a			; karakter bemsolsa a cl terletre
	inc	hl			; clmutat nvelse
	inc	c			; karakter szmll nvelse
LC48B:	djnz	LC482			; ismtls
	ret
;
LC48E:	.db	"START"
	.db	020h,020h,020h
LC496:	.db	"CAS"



;
;-----------------------------------------------
;	MOPS: karakter I/O
;-----------------------------------------------
;  in:  C - karakter (rsnl)
; out:  A - hibakd
;       C - karakter (olvassnl)
;-----------------------------------------------
;
LC499:	call	LC736			; MOPS funkcihvsok kezd programrsze (INT belltsa)
	call	LC6B8			; nyitott fjl ellenrzse
	ret	z			; visszatrs, ha nincs megnyitott fjl egyik irnyban sem
	ex	af,af'			; belpskori flag-ek visszalltsa
	jp	p,LC4E1			; ugrs, ha rs
LC4A4:	ld	a,(ix-003h)		; A reg.= a bufferben htralv bjtok szma 
	or	a
	jr	nz,LC4CC		; ugrs, ha mg vannak adatok a bufferben
	call	LC5B8			; adatok kirsa a bels bufferbl (?)
	ret	nz			; visszatrs, ha hiba trtnt
	inc	a			; A reg.= 1
	ld	(0DFF7h),a		; FSH_PG (a 3. memrialap lapozsa): bels RAM 
	call	LC6AE			; aktulis I/O irnynak megfelel FCB cmnek betltse DE-be
LC4B5:	ld	bc,00100h		; BC= tviteli hossz (256 bjt)
	ld	a,00Fh			; A reg.= FISH parancskd: olvass fjlbl
	call	LC5CD			; FISH funkci vgrehajtsa IX mentsvel
	jr	z,LC4C2			; ugrs, ha nem volt hiba
	cp	0ECh			; .EOF hiba volt ?
	ret	nz			; visszatrs, ha nem
LC4C2:	ld	a,b			; beolvasott bjtok szmnak vizsglata
	or	c
	ld	a,0ECh			; hibakd: .EOF - fjl vge
	ret	z			; visszatrs, ha egy bjtot sem sikerlt beolvasni
	ld	(ix-002h),000h		; aktulis karakter cmnek nullzsa
	ld	a,c			; A reg.= beolvasott bjtok szma
LC4CC:	dec	a			; htralv bjtok szmnak cskkentse
	ld	(ix-003h),a		; ments a RAM vltozba
	call	z,LC67B			; ha nincs tbb bjt a bufferben, akkor a fjl-vg elrsnek ellenrzse (EOF vltoz belltsa)
	ld	c,(ix-002h)		; C= aktulis karakter cme
	inc	(ix-002h)		; aktulis cm nvelse
	xor	a
LC4DA:	ld	b,a			; BC= eltolsi rtk
	add	ix,bc
	ld	c,(ix+000h)		; C= olvasott karakter
	ret
;
LC4E1:	push	bc			; rand karakter a verembe
	call	LC654			; fjlmutat cskkentse a buffer nem hasznlt karaktereinek szmval
	ld	c,(ix-001h)		; C= a bufferben lv karakterek szma
	push	ix
	pop	hl			; HL a bufferre mutat
	xor	a
	ld	b,a
	add	hl,bc			; HL a buffer utols utni bjtjra mutat
	pop	bc			; C= rand karakter a verembl
	ld	(hl),c			; karakter a bufferbe
	inc	(ix-001h)		; buffer mretnek nvelse
	push	af
	call	LC67B			; a fjl-vg elrsnek ellenrzse
	pop	af
	ret	nz			; visszatrs, ha mg nem rte el a buffer vgt
	ld	bc,00100h		; BC= tviteli hossz (256 bjt)
	jp	LC5C0			; folytats az adatok kirsval a bels bufferbl



;
;-----------------------------------------------
;	MOPS: blokk I/O
;-----------------------------------------------
;  in: BC - karakterek szma
;      DE - a blokk elejre mutat
; out:  A - hibakd
;      BC - t nem vitt bjtok szma (hiba esetn)
;      DE - a blokk vgnek aktualizlt memriacme
;-----------------------------------------------
;
LC4FF:	exx
	call	LC736			; MOPS funkcihvsok kezd programrsze (INT belltsa)
	call	LC6B8			; nyitott fjl ellenrzse
	ret	z			; visszatrs, ha nincs megnyitott fjl egyik irnyban sem
	call	LC5B8			; adatok kirsa a bels bufferbl
	ret	nz			; visszatrs, ha hiba trtnt
	call	LC654			; fjlmutat cskkentse a buffer nem hasznlt karaktereinek szmval
	exx
	push	de			; regiszterek belpskori rtknek mentse
	push	bc
	push	de
	call	LC6AE			; aktulis I/O irnynak megfelel FCB cmnek betltse DE-be
	pop	ix			; IX az tvivend blokk elejre mutat
	ex	af,af'			; belpskori A reg. rtk s flag-ek visszalltsa
	add	a,080h			; A reg. rsnl 082h  olvassnl 002h lesz
	sbc	a,a			; A reg. rsnl 000h  olvassnl 0FFh lesz
	add	a,010h			; A reg. rsnl 010h  olvassnl 00Fh lesz
	call	LCD46			; FISH funkci vgrehajtsa
	pop	hl			; HL= belpskori karakterek szma
	jr	z,LC52A			; ugrs, ha nem volt hiba
	cp	0ECh
	jr	z,LC52A			; ugrs, ha .EOF hiba volt
	pop	de			; DE= a blokk belpskori elejre mutat
	jr	LC52F			; ugrs a folytatshoz
LC52A:	sbc	hl,bc			; HL= t nem vitt bjtok szma
	ex	(sp),ix			; IX= a blokk belpskori elejre mutat, korbbi rtke a verembe
	pop	de			; DE= a blokk vgnek aktualizlt memriacme
LC52F:	ld	b,h			; BC= t nem vitt bjtok szma
	ld	c,l
	push	de			; kimeneti rtkek mentse
	push	bc
	push	af
	call	LC67B			; a fjl-vg elrsnek ellenrzse (EOF vltoz belltsa, ha fjl-vge)
	pop	af			; kimeneti rtkek visszalltsa
	pop	bc
	pop	de
	ret



;
;-----------------------------------------------
;	MOPS: fjl lezrsa
;-----------------------------------------------
;  in:    -
; out:  A - hibakd
;-----------------------------------------------
;
LC53B:	call	LC736			; MOPS funkcihvsok kezd programrsze (INT belltsa)
	call	LC6CC			; IX rtknek belltsa SF (sign flag) szerint
	call	LC554			; I/O fjlpufferek kirsa a lemezre s a korbbi fjlok lezrsa
	ld	(ix-033h),000h		; aktulis irnynak megfelel FCB tpusnak kinullzsa
	ex	af,af'			; hibakd mentse
	ld	bc,0FFFFh		; BC= az sszes meghajthoz tartoz puffer trlse s rvnytelentse
	ld	a,00Eh			; A reg.= szektorpufferek trlse parancskd
	call	LC5CD			; FISH funkci vgrehajtsa IX mentsvel
	ret	nz			; visszatrs, ha hiba volt a pufferek trlsekor
	ex	af,af'			; fjl-lezrskor keletkezett hibakd visszalltsa
	ret


;
;
;	I/O fjlpufferek kirsa a lemezre s a fjlok lezrsa
;	- mindkt tviteli irny fjlpuffert trli s lezrja az (rsra) nyitott fjlokat
;	in: -
;	out:  A - hibakd
;	     IX - megrzdik
;
LC554:	push	ix			; eredeti IX mentse
	ld	ix,0DC45h		; IX az input fjl terletre mutat
	call	LC5B8			; adatok kirsa lemezre a bels bufferbl
	call	z,LC56D			; ha nem trtnt hiba, akkor a fjl lezrsa
	ld	ix,0DD78h		; IX az output fjl terletre mutat
	call	z,LC5B8			; ha nem trtnt hiba, az adatok kirsa lemezre a bels bufferbl
	call	z,LC56D			; ha nem trtnt hiba, akkor a fjl lezrsa
	pop	ix			; eredeti IX visszalltsa
	ret


;
;
;	Megnyitott fjl lezrsa
;	- "CAS" fjlok esetn frissti a fjl 128 bjtos fejlct is
;	- minden esetben meghvja a fjl-lezrsi funkcit, ha rs trtnt a fjlba
;	in:  IX - az aktulis I/O irnynak megfelel fjl adatterletnek cme
;	out:  A - hibakd
;
LC56D:	ld	a,(ix-033h)		; A reg.= a megnyitott fjl FCB-je
	or	a
	ret	z			; visszatrs, ha mg nem hasznlt
	xor	a
	bit	6,(ix-013h)		; a fjlba rs trtnt ?
	ret	z			; visszatrs, ha mg nem
	call	LC46C			; megnyitott fjl kiterjesztsnek ellenrzse
	jr	nz,LC5B1		; ugrs, ha nem "CAS" (csak egyszeren lezrja a fjlt)
	push	ix
	pop	hl			; HL= fjl bufferre mutat
	ld	(hl),011h		; "CAS" fjl fejlcnek elksztse: 0. bjt : 011h
	inc	hl
	ld	(hl),a			; 1. bjt: 00h
	inc	hl
	ld	a,(ix-01Ch)		; A reg.= fjlmret LSB
	rlca
	srl	a			; A reg. 7.bit CY-be, s kinullzsa A-ban
	ld	(ix+004h),a		; bers a buffer 4. cmre (az utols 128 bjtos blokkban lv hasznos bjtok szma)
	ld	a,(ix-01Bh)		; A reg.= fjlmret kvetkez bjtja
	adc	a,a
	ld	(hl),a			; bers a buffer 2. cmre (128 bjtos blokkok szma, als bjt)
	inc	hl
	ld	a,(ix-01Ah)		; A reg.= fjlmret kvetkez bjtja
	adc	a,a
	ld	(hl),a			; bers a buffer 3. cmre (128 bjtos blokkok szma, fels bjt)
	inc	hl
	inc	hl			; HL= fjl buffer 5. cmre mutat
	ld	b,07Bh			; B= 123 bjt lesz (128-5)
	xor	a
LC59E:	ld	(hl),a			; maradk bjtok kinullzsa a bufferben
	inc	hl
	djnz	LC59E			; ismtls
	ld	de,0FF75h
	add	hl,de			; HL a fjlmutatra mutat az FCB-ben
	ld	b,004h
LC5A8:	ld	(hl),a			; fjlmutat kinullzsa (a fjl elejre mutasson)
	inc	hl
	djnz	LC5A8			; ismtls
	ld	c,080h			; BC= rand bjtok szma (128)
	call	LC5C0			; adatok kirsa a bels bufferbl
LC5B1:	call	LC6AE			; aktulis I/O irnynak megfelel FCB cmnek betltse DE-be
	ld	a,00Dh			; parancskd: fjl lezrsa
	jr	LC5CD			; ugrs a folytatsra: FISH funkci vgrehajtsa IX mentsvel


;
;
;	Adatok kirsa a bels bufferbl
;	in:  IX - diszk tviteli cm
;	out:  A - hibakd
;	     BC - tvitt bjtok szma
;	     DE - FCB
;	     IX - megrzdik
;
LC5B8:	ld	a,(ix-001h)		; A reg.= a bufferben lv karakterek szma
	or	a
	ret	z			; visszatrs, ha nulla
	ld	c,a			; BC= rand bjtok szma
	ld	b,000h
LC5C0:	call	LC6AE			; aktulis I/O irnynak megfelel FCB cmnek betltse DE-be
	xor	a
	ld	(ix-001h),a		; a bufferben lv bjtok RAM vltozjnak nullzsa
	inc	a			; A reg. = 1
	ld	(0DFF7h),a		; FSH_PG (a 3. memrialap lapozsa): bels RAM
	ld	a,010h			; parancskd: rs fjlba
LC5CD:	push	ix
	call	LCD46			; FISH funkci vgrehajtsa
	pop	ix
	ret



;
;-----------------------------------------------
;	MOPS: blokk ellenrzs (VERIFY)
;-----------------------------------------------
;  in: BC - karakterek szma
;      DE - a blokk kezdetre mutat
; out:  A - hibakd
;-----------------------------------------------
;
LC5D5:	call	LC736			; MOPS funkcihvsok kezd programrsze (INT belltsa)
	call	LC6B8			; nyitott fjl ellenrzse
	ret	z			; visszatrs, ha nincs megnyitott fjl egyik irnyban sem
LC5DC:	push	de			; memriacm mentse
	push	bc			; karakter szmll mentse
	push	ix
	call	LC4A4			; MOPS: karakter olvassa
	pop	ix
	ld	l,c			; olvasott karakter L reg.-be
	pop	bc
	pop	de
	ret	nz			; visszatrs, ha hiba trtnt a karakter olvassnl
	ld	a,(de)
	cp	l			; fjlbl olvasott karakter s a memriban lv karakter sszehasonltsa
	ld	a,0E8h			; hibakd: .VERIFY - hiba az ellenrzsnl
	ret	nz			; visszatrs, ha a kt karakter nem egyezett meg
	inc	de			; memriacm nvelse
	dec	bc			; htralv karakterek szmnak cskkentse
	ld	a,b			; BC ellenrzse
	or	c
	jr	nz,LC5DC		; ismtls, ha BC mg nem nulla
	ret



;
;-----------------------------------------------
;	MOPS: fjlmutat belltsa
;-----------------------------------------------
;  in: BC:DE - fjlmutat eltols
; out:     A - hibakd
;      BC:DE - aktulis fjlmutat
;-----------------------------------------------
;
LC5F5:	ld	a,002h
	jr	LC5FF


;
;-----------------------------------------------
;	MOPS: fjlmutat belltsa az akt. llapothoz kpest
;-----------------------------------------------
;  in: BC:DE - fjlmutat eltols
; out:     A - hibakd
;      BC:DE - aktulis fjlmutat
;-----------------------------------------------
;
LC5F9:	ld	a,001h
	jr	LC5FF


;
;-----------------------------------------------
;	MOPS: fjlmutat belltsa a fjl vghez kpest
;-----------------------------------------------
;  in: BC:DE - fjlmutat eltols
; out:     A - hibakd
;      BC:DE - aktulis fjlmutat
;-----------------------------------------------
;
LC5FD:	ld	a,000h
LC5FF:	push	af
	ex	af,af'			; flag-ek s A reg.-ben belltott mveleti kd mentse
	pop	af			; irnyjelz flag tmsolsa a jelenleg hasznlt AF-be
	exx
	call	LC736			; MOPS funkcihvsok kezd programrsze (INT belltsa)
	call	LC6B8			; nyitott fjl ellenrzse
	ret	z			; visszatrs, ha nincs megnyitott fjl egyik irnyban sem
	call	LC5B8			; adatok kirsa a bels bufferbl
	ret	nz			; visszatrs, ha hiba trtnt
	call	LC654			; fjlmutat cskkentse a buffer nem hasznlt karaktereinek szmval
	exx
	push	bc
	ex	af,af'			; A reg.-ben belltott mveleti kd visszalltsa
	sub	001h			; mveleti kd cskkentse eggyel
	ld	a,b			; A reg.= eltolsi rtk MSB bjtja
	ld	bc,0FFE7h		; BC= eltolsi rtk a fjlmrethez az FCB-ben
	jr	c,LC628			; ugrs, ha a fjl vghez kpest kell belltani
	ld	bc,0FFF8h		; BC= eltolsi rtk a fjlmutathoz az FCB-ben
	jr	z,LC628			; ugrs, ha az akt. llapothoz kpest kell belltani
	sbc	hl,hl			; HL= 0000h
	ld	c,l			; BC= 0000h
	ld	b,h
	add	a,a			; A reg.= eltolsi rtk MSB bjtja * 2
	jr	LC635			; folytats az j fjlmutat kiszmtsval
;
LC628:	push	ix
	pop	hl			; HL= aktulis irnynak megfelel fjl adatterlete
	add	hl,bc			; HL= az FCB-ben a fjlmret vagy a fjlmutat MSB bjtjnak cme
	ld	b,(hl)			; BC= fjlmret/fjlmutat fels szava
	dec	hl
	ld	c,(hl)
	dec	hl
	add	a,a			; A reg.= eltolsi rtk MSB bjtja * 2
	ld	a,(hl)
	dec	hl
	ld	l,(hl)
	ld	h,a			; HL= fjlmret/fjlmutat als szava
LC635:	sbc	a,a			; A reg.= 0FFh ha az eltolsi rtk legfels bitje 1 volt
	add	hl,de
	ex	de,hl			; DE= j fjlmutat rtk als szava
	pop	hl
	adc	hl,bc
	ld	c,l
	ld	b,h			; BC= j fjlmutat rtk fels szava
	ld	l,a			; L= 0FFh ha az eltolsi rtk legfels bitje 1 volt
	sbc	a,a			; A reg.= 0FFh ha az eltols sorn tlcsorduls volt (nagyobb 0FFFFFFFFh-nl)
	xor	l
	and	0E5h			; hibakd: .IPTR - rvnytelen fjlmutat vlts
	ret	nz			; visszatrs, ha A reg. s L rtke klnbz
	ld	(ix-00Bh),e		; fjlmutat szmtott rtknek belltsa az FCB-ben
	ld	(ix-00Ah),d
	ld	(ix-009h),c
	ld	(ix-008h),b
	call	LC67B			; a fjl-vg elrsnek ellenrzse (EOF vltoz belltsa, ha fjl-vge)
	xor	a			; hibakd trlse
	ret


;
;
;	Fjlmutat cskkentse a buffer nem hasznlt karaktereinek szmval
;	in:  IX - az aktulis I/O irnynak megfelel fjl adatterletnek cme
;	out: -
;
LC654:	ld	a,(ix-003h)		; A reg.= a bufferben htralv karakterek szma
	or	a
	ret	z			; visszatrs, ha a teljes buffer ki van hasznlva
	push	ix
	pop	hl			; HL az aktulis I/O fjl adatterletre mutat
	ld	de,0FFF5h		; DE= eltols az FCB-n belli helyre (a fjlmutatra)
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	ex	de,hl			; HL= fjlmutat als szava, DE= fjlmutat als sz cme az FCB-ben
	ld	c,a
	xor	a
	ld	b,a			; BC= a bufferben htralv (nem hasznlt) karakterek szma
	ld	(ix-003h),a		; htralev karakterek szmnak nullzsa a RAM vltozban
	sbc	hl,bc			; kivons a fjlmutat als szavbl
	ex	de,hl
	ld	(hl),d			; a nemhasznlt karakterek szmval cskkentett fjlmutat visszarsa az FCB-be
	dec	hl
	ld	(hl),e
	ret	nc			; visszatrs, ha nem volt alulcsorduls a kivonsnl
	inc	hl
	inc	hl
	ld	e,(hl)
	inc	hl
	ld	d,(hl)			; DE= fjlmutat fels szava
	dec	de			; fels sz cskkentse eggyel
	ld	(hl),d			; fjlmutat frisstett fels szavnak visszarsa
	dec	hl
	ld	(hl),e
	ret


;
;
;	Aktulis I/O irnynak megfelel fjl vgnek ellenrzse
;	- ha elrte a fjl vgt, akkor belltja EOF vltozt
;	in:  IX - az aktulis I/O irnynak megfelel fjl adatterletnek cme
;	out: CY - CY=0 elrte vagy mr tl is lpte a fjl vgt
;
LC67B:	push	ix
	pop	hl			; HL az aktulis I/O fjl adatterletre mutat
	ld	de,0FFE7h		; DE= eltols az FCB-n belli helyre
	add	hl,de
	push	hl			; HL= +01Ah cm az FCB-n bell
	ld	de,0000Eh
	add	hl,de			; HL= +028h cm az FCB-n bell
	ld	e,(hl)
	inc	hl
	ld	d,(hl)			; DE= fjlmutat als szava
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)			; BC= fjlmutat fels szava
	ld	l,(ix-001h)
	ld	h,000h			; HL= pufferben lv karakterek szma
	add	hl,de
	ex	de,hl			; DE= fjlmutat megnvelt als szava
	jr	nc,LC698		; ugrs, ha nincs tvitel a fels szra
	inc	bc			; fels sz nvelse
LC698:	pop	hl			; HL a fjlmret MSB bjtjra mutat
	ld	a,b
	cp	(hl)			; fjlmutat s fjlmret MSB bjt sszehasonltsa
	ret	c			; visszatrs, ha a fjlmret a nagyobb
	dec	hl
	ld	a,c
	cp	(hl)			; fels szavak als bjtjnak sszahasonltsa
	ret	c			; visszatrs, ha a fjlmret a nagyobb
	dec	hl
	ld	a,d
	cp	(hl)			; als szavak fels bjtjnak sszahasonltsa
	ret	c			; visszatrs, ha a fjlmret a nagyobb
	dec	hl
	ld	a,e
	cp	(hl)			; als szavak als bjtjnak sszahasonltsa
	ret	c			; visszatrs, ha a fjlmret a nagyobb
LC6A8:	ld	hl,00B6Eh		; HL= EOF vltoz cme
	ld	(hl),0FFh		; fjl vge jelzs
	ret


;
;
;	Aktulis I/O irnynak megfelel FCB cmnek betltse DE-be
;	in:  IX - az aktulis I/O irnynak megfelel fjl adatterletnek cme
;	out: DE - az FCB kezdcme
;	     HL,IX - megrzdik
;
LC6AE:	push	ix
	ex	(sp),hl			; HL= aktulis I/O irnynak megfelel fjl adatterlete
	ld	de,0FFCDh		; DE= eltolsi rtk az FCB-hez
	add	hl,de
	ex	de,hl			; DE az FCB-re mutat
	pop	hl			; HL be a belpskori rtke
	ret


;
;
;	MOPS ltal megnyitott fjl ellenrzse
;	- ha a funkcikdban megadott irnyban nincs megnyitott fjl, akkor ellenrzi a msik irnyt is
;	- csak akkor jelez hibt, ha egyik irnyban sincs megnyitva fjl
;	in:   A - MOPS funkcikd
;	out:  A - hibakd
;	     IX - a tallt megnyitott fjl adatterletre mutat
;
LC6B8:	ld	l,a			; L= funkcikd
	ex	af,af'			; funkckd s flag-ek mentse
	ld	a,l
	or	a			; eljel bit belltsa az I/O irnynak megfelelen
	call	LC6C1			; megfelel FCB tpusbjtjnak vizsglata
	ret	nz			; visszatrs, ha mr hasznlt az FCB
	xor	l			; eljel bit invertlsa (A reg.-ben 0E9h volt)
LC6C1:	call	LC6CC			; IX rtknek belltsa SF (sign flag) szerint
	ld	a,(ix-033h)		; aktulis irnynak megfelel fjl FCB-jnek vizsglata
	or	a
	ret	nz			; visszatrs, ha mr hasznlt az FCB
	ld	a,0E9h			; hibakd: .NOTOP
	ret


;
;
;	IX rtknek belltsa SF (sign flag) szerint
;
LC6CC:	ld	ix,0DC45h
	ret	m			; visszatrs, ha "sign negative"
	ld	ix,0DD78h
	ret


;
;
;	Bevezet szkz s TAB karakterek eltvoltsa a string elejrl
;	in:  DE - string kezdcme
;	out: DE - az els nem SPACE vagy TAB karakterre mutat
;
LC6D6:	ld	a,(de)			; A reg.= string kvetkez karaktere
	call	LC6DE			; SPACE, TAB vizsglata
	ret	nc			; visszatrs, ha se SPACE se TAB
	inc	de			; cm nvelse
	jr	LC6D6			; ismtls


;
;
;	A reg.-ben lv karakter SPACE vagy TAB ?
;	in:   A - ASCII karakterkd
;	out: CY - CY=1 A reg.-ben SPACE vagy TAB van
;	          CY=0 minden ms esetben
;	     ZF - ZF=1 ha A reg. 00h, SPACE vagy TAB
;
LC6DE:	cp	020h
	scf
	ret	z			; visszatrs, ha SPACE karakter
	cp	009h
	scf
	ret	z			; visszatrs, ha TAB karakter
	or	a			; CY=0
	ret



;
;-----------------------------------------------
;	MOPS: CLI puffer definilsa
;-----------------------------------------------
;  in: BC - a mret bjtokban
;      DE - a puffer elejre mutat
; out:  A - hibakd
;-----------------------------------------------
;
LC6E8:	ld	l,e
	ld	h,d
	add	hl,bc
	jr	c,LC6F0			; ugrs, ha a megadott puffer tlg a 64kB-os hatron
	ld	a,0BFh			; A reg.= a fels bjt hatrrtke
	cp	h
LC6F0:	ld	a,0FCh			; hibakd: .PAGE3 - a CLI puffere a 3. lapra nylik
LC6F2:	ret	c			; visszatrs, ha a puffer tnyleg tllg
	ld	(00BF0h),de		; puffer kezdcm elmentse a kazetta munkaterlet elejre
	ld	(00BF2h),bc		; mret elmentse a kvetkez szra
	xor	a			; hibakd trlse
	ret



;
;-----------------------------------------------
;	MOPS: CLI parancs vgrehajtsa
;-----------------------------------------------
;  in:  C - I/O vlaszts
;      DE - egy parancssorra mutat
; out:  A - hibakd
;      BC - a pufferben lv karakterek szma
;      DE - a puffer elejre mutat
;-----------------------------------------------
;
LC6FD:	call	LDB2E			; 3.lapon lv rutin hvsa (cm: 0F010h)
;
	.dw	0F010h			; CLI parancs vgrehajtsa
;
	ret



;
;-----------------------------------------------
;	MOPS: FISH-funkci vgrehajtsa
;-----------------------------------------------
;  in:  C - FISH funkci kdja
;      DE - FISH paramterblokkra (FPB) mutat
; out:  A - hibakd
;      DE - ugyanarra a frisstett FPB-re mutat
;-----------------------------------------------
;
LC703:	call	LC741			; memrialapozs elmentse, INT (RST38H) vektor belltsa		
	ld	a,c			; funkcikd A reg.-be
	ex	de,hl			; HL az FPB kezdcmre mutat
	ld	e,(hl)			; FISH funkci paramtereinek beolvassa a regiszterekbe
	inc	hl
	ld	d,(hl)
	inc	hl
	push	de
	pop	ix			; 0..1 - IX
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	push	de			; 2..3 - HL (egyelre a veremben marad)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)			; 4..5 - DE
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)			; 6..7 - BC
	ex	(sp),hl			; HL belltsa a verembl, FPB befejez cmnek mentse
	call	LCD46			; FISH funkci vgrehajtsa
	ex	(sp),hl			; HL= FPB befejez cm vissza, visszatrsi rtk a verembe
	ld	(hl),b			; FPB frisstse vgtl az eleje fel
	dec	hl
	ld	(hl),c
	dec	hl
	ld	(hl),d
	dec	hl
	ld	(hl),e
	dec	hl
	pop	de			; DE= HL visszatrsi rtke
	ld	(hl),d
	dec	hl
	ld	(hl),e
	dec	hl
	push	ix
	pop	de			; DE= IX visszatrsi rtke
	ld	(hl),d
	dec	hl
	ld	(hl),e
	ex	de,hl			; DE= FPB kezdcme
	jr	LC767			; memrialapozs s INT vektor visszamsolsa, visszatrs


;
;
;	MOPS funkcihvsok kezd programrsze
;	in:  -
;	out: AF - megrzdik
;
LC736:	ld	hl,0C759h		; HL= MOPS funkcik befejez rsznek cme
	ex	(sp),hl			; visszatrsi cm HL-be, 0C759h rtk a verembe
	push	hl			; visszatrsi cm ismt a verembe
	push	af			; A reg. mentse
	xor	a
	ld	(00B6Eh),a		; EOF vltoz nullzsa (mg nem rtk el a fjl vgt)
	pop	af			; A reg. vissza
;
;	memrialapozs mentse, INT belltsa
;
LC741:	di
	push	af			; A reg. mentse
	push	hl			; HL mentse
	ld	a,(00003h)		; A reg.= P_SAVE
	ld	(0DFFFh),a		; P_SAVE msolata a bels RAM-ba
	ld	a,0C3h			; 0C3h = JP NN
	ld	hl,0DB99h		; floppy megszak. rutin cme
	ld	(00038h),a		; INT vektor: JP 0DB99h
	ld	(00039h),hl
	pop	hl			; elmentett regiszterek vissza
	pop	af
	ei
	ret


;
;
;	MOPS funkcihvsok befejez programrsze
;	in:  A - hibakd
;	out: minden regiszter megrzdik
;
LC759:	push	af			; A reg. mentse
	cp	0ECh			; .EOF hibakd ellenrzse
	call	z,LC6A8			; ha A reg.= .EOF , fjl vge jelzs belltsa
	sub	0F5h			; .STOP hibakd ellenrzse
	jr	nz,LC766		; ugrs, ha nem nyomtak CTRL-ESC-et
	ld	(00B16h),a		; STOP_FLAG = 0
LC766:	pop	af
;
;	eredeti memrialapozsi rtk (P_SAVE) s INT visszalltsa
;
LC767:	di
	push	af			; regiszterek mentse
	push	hl
	ld	a,(0DFFFh)
	ld	(00003h),a
	ld	a,0F5h			;    0F5h = PUSH AF
	ld	hl,0703Eh		; 3Eh,70h = LD A,70h
	ld	(00038h),a		; az eredeti megszak. rutin elejnek visszalltsa
	ld	(00039h),hl
	ei
	pop	hl			; regiszterek visszalltsa
	pop	af
	ret
;
;--------------------------------- MOPS vge ---------------------------------
;



;
;
;	Egysgkezel parancsrtelmezje
;	in:   A - parancskd:
;	           0 - rendszer alaphelyzetbe lltsa meghajtk szmnak vizsglatval
;	           1 - rendszer alaphelyzetbe lltsa
;	           2 - meghvja a DISKIO 7. szm, meg nem valstott funkcijt
;	           3 - UPB adatok beolvassa a lemezrl
;	           4 - szektorok olvassa
;	           5 - szektorok rsa
;	           6 - szektorok rsa ellenrzssel
;	           8 - lemez formzsa
;	out:  A - hibakd
;
LC77F:	ld	(iy-048h),a		; parancskd mentse
	sub	002h
	jr	c,LC797			; ugrs, ha A<2 (A=0..1)
	jr	z,LC7C7			; ugrs, ha A=2
	dec	a
	jr	z,LC7E8			; ugrs, ha A=3
	sub	004h
	jp	c,LC9E9			; ugrs, ha 3<A<7 (A=4..6)
	dec	a
	jp	z,LCBDE			; ugrs, ha A=8
	ld	a,0BFh			; egybknt hiba: .ICMD - rvnytelen parancs
	ret
;
;
;	Egysgkezel 0. s 1. parancsnak vgrehajtsa
;	in:  A - parancskd-2
;	out: A - 0. parancs esetn:   0 - egymeghajts a rendszer
;	                            <>0 - nem egymeghajts a rendszer
;
LC797:	ex	af,af'			; 2-vel cskkentett parancskd mentse A'-be
	xor	a			; diszk-rendszer reset
	ld	b,00Fh			; minden meghajtra rvnyes
	call	LDB2E			; 2.lapon lv rutin hvsa (cm: 0EB49h)
;
	.dw	0EB49h			; DISKIO hvsa
;
	ld	c,008h			; 3. meghajtval kezd
LC7A2:	ld	b,c
	ld	a,007h			; A reg.= parancskd: "fenntartott" (nincs dokumentlva)
	call	LDB2E			; 2.lapon lv rutin hvsa (cm: 0EB49h)
;
	.dw	0EB49h			; DISKIO hvsa
;
	rrc	c			; meghajt maszk lptetse jobbra
	jr	nc,LC7A2		; ismtls, amg mind a 4 meghajtn vgig nem ment
	ld	bc,00401h
LC7B1:	ld	(iy-041h),c		; meghajtkat kivlaszt kd (1,2,4,8) belltsa a RAM-ban
	rlc	c
	inc	iy
	djnz	LC7B1			; mind a 4 meghajt kdjt belltja
	ex	af,af'			; 2-vel cskkentett parancskd vissza A reg.-be
	cp	0FFh			; 1. parancs volt?
	ret	z			; visszatrs, ha igen
	ld	a,008h			; A reg.= parancskd: meghajt vizsglata
	ld	h,b			; H= 0  B= 0 -> rendszer vizsglata: 1 vagy 2 meghajt van?
	call	LDB2E			; 2.lapon lv rutin hvsa (cm: 0EB49h)
;
	.dw	0EB49h			; DISKIO hvsa
;
	ret


;
;
;	Egysgkezel 2. parancsnak vgrehajtsa (a DISKIO 7. szm, dummy funkcijt hvja meg)
;	in:   C - egysgszm (0..3)
;	out:  A - 0
;	      B - B = 0 - ha van UPB s meghvta az res DISKIO funkcit
;		  B = 1 - az ezt bellt g soha nem kerl vgrehajtsra
;	          B = 0FFh - ha nincs UPB beolvasva
;	     CY - 0
;
LC7C7:	call	LCA79			; egysgszm ellenrzse, meghajtt kivlaszt kd belltsa B-ben
	bit	3,(ix-03Dh)		; 3.bit: UPB beolvasott-e
	jr	z,LC7E4			; ugrs, ha nincs
	ld	a,007h			; A reg.= parancskd: "fenntartott" (nincs dokumentlva)
	call	LDB2E			; 2.lapon lv rutin hvsa (cm: 0EB49h)
;
	.dw	0EB49h			; DISKIO hvsa
;
	jr	nz,LC7E4		; ugrs, ha hiba trtnt (ez nem trtnhet meg, mert a meg nem valstott funkci mindig A=0-val tr vissza)
	ld	a,b			; B=0
	or	a
	ret	z			; itt mindig visszatr
	xor	a
	cp	(iy-05Ch)
	ld	b,a
	ret	z
	inc	b
	ret
LC7E4:	ld	b,0FFh
	xor	a
	ret


;
;
;	Egysgkezel 3. parancsnak vgrehajtsa
;	Mkds:
;	 - reseteli a kvnt meghajtt
;	 - megprblja beolvasni a lemez 1. szektort:
;	   - ha sikerl: BOOT szektorbl kikeresi az UPB-t
;	       - ha megvan, kimsolja a lemez paramtereit
;	       - ha nincs, beolvassa a lemez 2. szektort, s abbl megprblja kivenni a mdia azonostt:
;		  - ha tall mdia azonostt, az alapjn legenerl egy sajt UPB-t s azzal dolgozik tovbb
;	          - ha nem, akkor "nem DOS lemez" hibval tr vissza
;	    - ha nem sikerl: megprbl szektorfejlceket olvasni MFM majd FM mdban
;	       - ha tall szektorfejlcet, akkor "nem DOS lemez" hibval tr vissza
;	       - egybknt "formzatlan lemez" hibval
;
;	in:   C - egysgszm (0..3)
;	out:  A - hibakd
;
LC7E8:	call	LCA79			; egysgszm ellenrzse, meghajtt kivlaszt kd belltsa B-ben
	res	3,(ix-03Dh)		; 3.bit: UPB bit trlse
	xor	a			; A reg.= parancskd: diszk-rendszer reset
	call	LDB2E			; 2.lapon lv rutin hvsa (cm: 0EB49h)
;
	.dw	0EB49h			; DISKIO hvsa
;
	ld	de,00001h		; D= 0 (svszm) E=1 (kezd szektor szma)
	ld	c,d			; C= 0 (oldal szma)
	ld	l,e			; L= 1 (tvivend szektorok szma)
	exx
	push	hl			; tviteli terlet cme a verembe
	exx				; BOOT szektor olvassa (3. parancskdot olvassknt kezeli)
	call	LCB26			; egysgkezel 4,5,6,8-as parancsnak vgrehajtsa hibajavtssal/jraprblkozssal
	pop	hl			; HL = tviteli terlet cme
	jr	nz,LC836		; ugrs, ha hiba trtnt
	push	hl			; tviteli terlet cme vissza a verembe
	push	bc
	call	LC858			; UPB kikeresse s ellenrzse
	pop	bc
	jr	nz,LC80F		; ugrs, ha hibs az UPB
	pop	bc			; BC= tviteli terlet kezdete  HL= UPB-re mutat
	jp	LC924			; ugrs az UPB feldolgozsra
;
LC80F:	pop	hl			; HL= tviteli terlet kezdete
	push	hl			; tviteli terlet cme a verembe
	push	hl			; tviteli terlet cme a verembe mgegyszer
	exx
	pop	hl			; HL'= tviteli terlet kezdete
	exx				; msodik szektor olvassa: ha DOS lemez, akkor ez az els FAT szektor
	ld	de,00002h		; D= 0 (svszm) E=2 (kezd szektor szma)
	ld	c,d			; C= 0 (oldal szma)
	ld	l,001h			; L= 1 (tvivend szektorok szma)
	call	LCB26			; egysgkezel 4,5,6,8-as parancsnak vgrehajtsa hibajavtssal/jraprblkozssal
	pop	hl			; HL = tviteli terlet cme
	jr	nz,LC84B		; ugrs, ha hiba trtnt
	ld	c,(hl)			; C= 0. bjt
	inc	hl
	ld	a,(hl)			; A= 1. bjt
	inc	hl
	and	(hl)			; 2. bjt
	inc	a
	jr	nz,LC855		; ugrs, ha az 1. s 2. bjt nem 0FFh volt
	ld	a,c			; A reg.= 0. bjt
	cp	0F8h
	jr	c,LC855			; ugrs, ha kisebb 0F8h-nl (nem mdia azonost bjt)
	dec	hl
	dec	hl			; HL = tviteli terlet cme
	call	LC8C1			; lemez formtumnak megfelel UPB adatterlet elksztse (kamu UPB)
	jp	LC924			; ugrs az UPB feldolgozsra
;
LC836:	and	021h
	jr	nz,LC84D		; ugrs, ha a meghajt nem zemksz
	call	LCA95			; aktulis svon egy szektorfejlc beolvassa (MFM kdolssal)
	and	021h
	jr	nz,LC84D		; ugrs, ha a meghajt nem zemksz
	bit	4,d			; D-ben az eredeti hibajelzk a DISKIO-tl
	jr	z,LC855			; ugrs, ha megtallta a rekordot
	ld	de,0FF20h		; jra prblkozik, de FM kdolssal
	call	LCA99			; aktulis svon egy szektorfejlc beolvassa
LC84B:	and	021h			; meghajt nem zemksz vizsglata
LC84D:	jp	nz,LC9CE		; ugrs a hibakd meghatrozsra, ha DISKIO hiba trtnt
	bit	4,d
	ld	a,0B6h			; hibakd: .UFORM - formlatlan lemez
	ret	nz			; visszatr, ha a rekord nem tallhat
LC855:	ld	a,0B5h			; hibakd: .NDOS - nem DOS lemez
	ret


;
;
;	UPB kikeresse s ellenrzse
;	in:  HL - adattviteli terlet cme
;	out:  A - fejek szma (vagy 24. bjt az UPB-bl), ha CY=1
;	     HL - UPB-re mutat az adattviteli terleten bell (11. bjt vagy 80. bjt ha CY=1)
;	     ZF - 0 - hibs az UPB
;	     CY - 1 - fels memria terletrl kellett az UPB-t tmsolni
;
;
LC858:	ld	de,0000Bh		; DE= cm eltols az adattviteli terleten
	add	hl,de			; HL= tviteli terlet +11
	push	hl			; szmtott rtk a verembe
	call	LC898			; UPB ellenrzse
	jr	nz,LC874		; ugrs, ha hibs
	dec	a
	cp	00Ah
	jr	nc,LC874		; ugrs, ha a svonknti szektorszm > 9
	ld	d,(hl)			; D= 25. bjt (svonknti szektorszm, fels bjt)
	inc	hl
	ld	a,(hl)			; A= 26. bjt (fejek szma, als bjt)
	inc	hl
	dec	a
	srl	a
	or	(hl)			; 27. bjt (fejek szma, fels bjt)
	or	d
	jr	nz,LC874		; ugrs, ha a fejek szma > 2, vagy D nem nulla
	pop	hl			; HL= tviteli terlet +11
	ret
;
LC874:	pop	hl			; HL= tviteli terlet +11
	dec	hl
	dec	hl
	dec	hl
	ld	a,(hl)			; A= 8. bjt
	dec	a
	ret	nz			; visszatrs, ha a 8. bjt nem 1 volt
	ld	de,00048h		; DE= eltols az UPB msik lehetsges helyhez
	add	hl,de			; HL= tviteli terlet +80
	call	LC898			; UPB ellenrzse
	ret	nz			; visszatrs, ha hibs
	cp	003h			; A reg.-ben ilyenkor a fejek szma van (?)
	jr	nc,LC896		; ugrs, ha a fejek szma > 2
	ex	de,hl			; DE - a 94. bjtra mutat
	ld	hl,0FFBBh		; HL= -69
	add	hl,de
	ex	de,hl			; DE - a 25. bjtra mutat  HL a 94.-re
	ld	bc,0000Fh		; 15 bjtot msol
	lddr				; tallt UPB tmozgatsa a megszokott helyre (a 11. bjtra)
	inc	hl			; HL= tviteli terlet +80
	cp	a			; ZF=1
	scf				; CY=1
	ret
;
LC896:	or	h			; ZF=0
	ret


;
;
;	UPB ellenrzse (Unit Parameter Block -> BOOT szektorban van (ld. pdf 53.old)
;	in:  HL - UPB-re mutat az adattviteli terleten bell (11. bjt)
;	out:  A - svonknti szektorszm
;	     HL - a 25. bjtra mutat
;	     ZF - 0 - hibs az UPB
;
;
LC898:	ld	d,(hl)			; D= 11. bjt (szektoronknti bjtszm als bjtja)
	inc	hl
	ld	a,(hl)			; A= 12. bjt (szektoronknti bjtszm fels bjtja)
	inc	hl
	sub	002h
	or	d
	ret	nz			; visszatrs, ha a szektoronknti bjtszm nem 512
	or	(hl)			; 13. bjt: klaszterenknti szektorszm
	jr	z,LC896			; ugrs, ha nulla (hibs rtk)
	neg				; A= 0-A
	and	(hl)
	cp	(hl)
	inc	hl
	ret	nz			; visszatrs, ha nem 2 hatvnya (1,2,4,8,16)
	inc	hl
	inc	hl
	ld	a,(hl)			; A= 16. bjt (FAT pldnyok szma)
	dec	a
	cp	007h
	jr	nc,LC896		; ugrs, ha nagyobb 7-nl
LC8B1:	ld	e,006h
	add	hl,de
	ld	a,(hl)			; A= 22. bjt (egy FAT pldny szektorainak szma, als bjt)
	inc	hl
	dec	a
	cp	00Ch
	jr	nc,LC896		; ugrs, ha nagyobb 12-nl
	ld	a,(hl)			; A= 23. bjt (egy FAT pldny szektorainak szma, fels bjt)
	inc	hl
	or	a			; ZF trlse, ha a fels bjt nem nulla (hibs rtk)
	ld	a,(hl)			; A= 24. bjt (svonknti szektorszm, als bjt)
	inc	hl
	ret


;
;
;	Lemez formtumnak megfelel UPB adatterlet elksztse (BOOT szektorhoz)
;	in:   A - "hordoz" bjt
;	      C - "hordoz" bjt
;	     HL - tviteli terlet kezdcme
;	out: HL - tviteli terlet kezdcme + 11
;
LC8C1:	ld	de,00064h
	add	hl,de			; HL= tviteli terlet + 100
	ld	b,059h
LC8C7:	dec	hl			; tviteli terlet kinullzsa +100-tl visszafel
	ld	(hl),d			; csak az els 11 bjtot hagyja meg
	djnz	LC8C7
	push	hl			; aktulis cm a verembe
	ld	b,002h
	inc	hl			; 11. bjt = 0 (szektoronknti bjtszm als bjtja)
	ld	(hl),b			; 12. bjt = 2 (szektoronknti bjtszm fels bjtja)
	inc	hl
	inc	(hl)			; 13. bjt = 1 (klaszterenknti szektorszm)
	and	005h			; "hordoz" bjt vizsglata
	sub	004h
	jr	z,LC8D9			; ugrs, ha 1 oldalas s 40 svos a kvnt lemez
	inc	(hl)			; 13. bjt = 2
LC8D9:	inc	hl
	inc	(hl)			; 14. bjt = 1 (fenntartott szektorok szma a lemez elejn)
	inc	hl
	inc	hl
	ld	(hl),b			; 16. bjt = 2 (FAT pldnyok szma)
	inc	hl
	ld	(hl),040h		; 17. bjt = 040h (bejegyzsek max. szma a fknyvtrban)
	or	a
	jr	z,LC8E6			; ugrs, ha 1 oldalas s 40 svos a kvnt lemez
	ld	(hl),070h		; 17. bjt = 070h
LC8E6:	inc	hl
	inc	hl
	push	hl			; 19. bjt cme a verembe
	ld	a,c			; A reg. = "hordoz" bjt
	ld	hl,00140h		; HL= lemezen lv szektorok szma (1 oldal/8 szektor/40 sv)
	ld	bc,00028h		; BC= 40 plusz szektor 9 szektor/sv formtum esetre
	ld	de,00801h
	bit	1,a
	jr	nz,LC8F9		; ugrs, ha 8 szektoros a formtum
	inc	d			; D= 9
	add	hl,bc			; HL nvelse plusz 1 szektornyi rtkkel
LC8F9:	bit	0,a
	jr	z,LC8FF			; ugrs, ha 1 oldalas a formtum
	inc	e			; E= 2
	add	hl,hl			; HL megduplzsa
LC8FF:	bit	2,a
	jr	nz,LC904		; ugrs, ha 40 svos a formtum
	add	hl,hl			; HL megduplzsa
LC904:	ex	de,hl			; DE = szmtott lemezen lv szektorok szma
	ex	(sp),hl			; HL = 19. bjt cme, DE korbbi rtke a verembe
	ld	(hl),e			; 19. bjt (sszes szektor szma a lemezen, als bjt)
	inc	hl
	ld	(hl),d			; 20. bjt (sszes szektor szma a lemezen, fels bjt)
	inc	hl
	ld	(hl),a			; 21. bjt (mdia azonost = "hordoz" bjt)
	inc	hl
	inc	(hl)			; 22. bjt = 1 (egy FAT pldny szektorainak szma, als bjt)
	cp	0FEh
	jr	nc,LC91A		; ugrs, ha 8 szektoros s 40 svos (1 vagy 2 oldalas)
	sub	0FAh
	jr	z,LC91A			; ugrs, ha 1 oldalas 8 szektoros s 80 svos
	inc	(hl)			; 22. bjt = 2
	inc	a
	jr	nz,LC91A		; ugrs, ha nem 2 oldalas 9 szektoros 80 svos
	inc	(hl)			; 22. bjt = 3
LC91A:	inc	hl
	inc	hl
	pop	de
	ld	(hl),d			; 24. bjt = svonknti szektorok szma (8 vagy 9)
	inc	hl
	inc	hl
	ld	(hl),e			; 26. bjt = oldalak szma (1 vagy 2)
	pop	hl			; HL = 11. bjt cme
	or	a
	ret


;
;
;	Lemezinformcik kiolvassa az UPB-bl s a RAM vltozk belltsa
;	in:   A - fejek szma (vagy 24. bjt az UPB-bl), ha CY=1
;	     HL - UPB-re mutat (11. bjt, vagy 80. bjt ha CY=1)
;	     CY - 1 - fels memria terletrl kellett az UPB-t tmsolni
;
LC924:	ex	af,af'			; CY mentse
	ld	bc,00008h
	add	hl,bc
	ld	e,(hl)			; E= 19. bjt (szektorok szma a lemezen, als bjt)
	inc	hl
	ld	d,(hl)			; D= 20. bjt (szektorok szma a lemezen, fels bjt)
	inc	hl
	ld	(ix-02Dh),e		; legnagyobb szektorsorszm als bjtja
	ld	(ix-029h),d		; legnagyobb szektorsorszm fels bjtja
	ld	b,(hl)			; B= 21. bjt (mdia azonost v. "hordoz" bjt)
	inc	hl
	inc	hl
	inc	hl
	ld	c,(hl)			; C= 24. bjt (svonknti szektorszm)
	inc	hl
	ex	af,af'
	jr	c,LC942			; ugrs, ha msolni kellett az UPB-t
	inc	hl
	ld	a,(hl)			; A= 26. bjt (fejek szma)
	inc	hl
	inc	hl
	jr	LC94A
;
LC942:	cp	002h			; fejek szmnak ellenrzse CY=1 esetn
	jr	z,LC948			; ugrs, ha 2
	ld	a,001h			; egybknt 1
LC948:	ld	c,009h			; svonknti szektorszm = 9
LC94A:	ld	(ix-039h),c		; szektorszm a RAM vltozba
	exx
	cp	(ix-031h)		; lemez oldalainak szma
	jr	z,LC97F			; ugrs, ha megegyezik a korbban letrolt rtkkel
	cp	001h
	jr	z,LC97F			; ugrs, ha az UPB szerint egyoldalas a lemez
	ld	h,a			; H= 2 (?) lpssebessg s ciklusszmll egyben (?)
LC958:	ld	de,0FF00h		; D= aktulis sv  E= FDC paramterek
	ld	c,001h			; C= 1. oldal
	ld	b,(ix-041h)		; B= meghajtt kivlaszt kd
	call	LCA9D			; adott svon egy szektorfejlc beolvassa
	jr	z,LC977			; ugrs, ha nem volt hiba
	and	021h
	jr	nz,LC9BF		; ugrs, ha nem zemksz a meghajt
	bit	4,d			; D-ben az eredeti hibajelzk a DISKIO-tl
	jr	nz,LC970		; ugrs, ha a rekord nem tallhat
	dec	h
	jr	nz,LC958		; 2-szer prblkozik
LC970:	ld	a,0B1h			; hibakd: .NCOMP - nem kompatibilis lemez
	.db	21h			; a kvetkez bjtokkal: ld hl,0B53Eh - elfedi ld a,0B5h-t
LC973:	ld	a,0B5h			; hibakd: .NDOS - nem DOS lemez
LC975:	or	a
	ret
;
LC977:	ld	a,(iy-046h)		; A reg. = lemezrl olvasott oldalszm
	dec	a
	jr	nz,LC970		; ugrs, ha nem 1 volt (hiba)
	ld	a,002h			; a lemez tnyleg 2 oldalas
LC97F:	ld	(ix-031h),a		; lemez oldalainak szma a RAM vltozba
	exx
	ld	a,(hl)			; A= 28. bjt (rejtett szektorok, als bjt)
	inc	hl
	ld	h,(hl)			; A= 29. bjt (rejtett szektorok, fels bjt)
	ld	(ix-025h),a
	ld	(ix-021h),h
	dec	de			; DE = legnagyobb szektorsorszm -1
	call	LCA47			; sv/fej/szektor paramterek kiszmtsa az abszolt szektorsorszmbl
	jr	c,LC973			; ugrs, ha tlcsorduls trtnt a szektorcm szmtsnl
	ld	a,d
	or	a
	ret	nz			; visszatrs, ha a svszm fels bjtja nem nulla
	ld	a,e			; A reg.= svszm als bjtja
	dec	a
	cp	0FEh
	jr	nc,LC973		; ugrs, ha nagyobb 254-nl (hiba)
	ld	(ix-035h),e		; legnagyobb svszm trolsa a RAM-ban
	ld	a,b			; A reg.= mdia azonost v. "hordoz" bjt
	cp	(ix-01Dh)
	jr	z,LC9C8			; ugrs, ha megegyezik a korbban trolt rtkkel
	ld	a,e			; A reg.= legnagyobb svszm
	cp	033h			; sszehasonlts 51-el
	ld	a,(ix-03Dh)		; A reg.= meghajt paramter bjtja
	res	2,a			; 80 svos jelzs trlse
	jr	c,LC9C2			; ugrs, ha a lemez svszma kisebb 51-nl
	set	2,a			; 80 svos jelzs belltsa
	bit	1,a			; meghajt svszma (?)
	jr	nz,LC9C2		; ugrs, ha a meghajt is 80 svos (?)
	ld	c,a
	push	bc			; mdia azonost s meghajt param. bjt a verembe
	ld	b,(ix-041h)		; B= meghajtt kivlaszt kd
	call	LCB85			; meghajtban lv lemez svszmnak meghatrozsa (40 vagy 80)
	pop	bc
	jr	c,LC975			; ugrs, ha hiba trtnt (nem kompatibilis lemez)
LC9BF:	jr	nz,LC9CE		; ugrs, ha DISKIO hiba volt
	ld	a,c
LC9C2:	ld	(ix-03Dh),a		; meghajt paramter bjt a RAM vltozba
	ld	(ix-01Dh),b		; mdia azonost bjt a RAM vltozba
LC9C8:	set	3,(ix-03Dh)		; rvnyes UPB jelzse
	xor	a			; A reg.= nem trtnt hiba
	ret


;
;
;	DISKIO hibajelz bitek tkonvertlsa hibakdd
;	in:  A - hibajelzk a DISKIO-tl
;	out: A - hibakd
;
LC9CE:	ld	hl,0C9E0h		; HL = hibakdok cme -1
LC9D1:	inc	hl			; kvetkez hibakd cme
	rrca				; kvetkez hibajelz bit CY-be
	jr	nc,LC9D1		; ugrs, ha a bit nem jelez hibt
	ld	a,(hl)			; hibakd A reg.-be
	exx
	cp	0AFh
	jr	nz,LC9DF		; ugrs, ha nem .NOUPB hiba
	res	3,(ix-03Dh)		; UPB bit trlse a meghajt paramterbjtjban
LC9DF:	or	a			; jelzbitek A reg.-nek megfelelen
	ret
;
LC9E1:	.db	0BCh			; .NRDY  - nem zemksz
	.db	0BAh			; .VERFY - hiba az ellenrzsnl
	.db	0B9h			; .DATA  - adattviteli hiba (a lemez nem olvashat)
	.db	0B9h			; .DATA  - adattviteli hiba (a lemez nem olvashat)
	.db	0B8h			; .RNF   - a szektor nem tallhat
	.db	0AFh			; .NOUPB - nincs UPB
	.db	0B7h			; .WPROT - rsvdett lemez
	.db	0BFh			; .ICMD  - rvnytelen parancs


;
;
;	Egysgkezel 4,5,6 parancsainak vgrehajtsa (fciklus)
;	in:   B - szektorok szma
;	      C - egysgszm (0..3)
;	     DE - szektorcm
;	out:  A - hibakd
;
LC9E9:	call	LCA79			; egysgszm ellenrzse, meghajtt kivlaszt kd belltsa B-ben
	exx
	ld	b,000h			; B' = sszes tvitt szektor
	ld	c,a			; C' = szektorok szma
	exx
	bit	3,(ix-03Dh)		; meghajt paramter vizsglata
	jr	z,LCA1C			; ugrs, ha nincs UPB beolvasva
	ld	l,a			; L reg.= szektorok szma
	or	a
	jr	z,LCA1E			; ugrs, ha a szektorok szma = 0
	xor	a
	bit	0,(ix-03Dh)		; svszm ellenrztt?
	call	z,LCB85			; meghajtban lv lemez svszmnak meghatrozsa (40 vagy 80)
	jr	c,LCA1E			; ugrs, ha nem kompatibilis lemez
	or	a
	jr	nz,LC9CE		; ugrs a hibakd meghatrozsra, ha DISKIO hiba trtnt
	ld	h,a			; H=0
	dec	l			; L=szektorok szma-1
	add	hl,de			; HL = az utols szektor cme
	jr	c,LCA19			; ugrs, ha 16 biten nem brzolhat, mert meghamisthatja az ellenrzst 
	push	bc
	ld	c,(ix-02Dh)		; BC= meghajt legnagyobb szektorsorszma
	ld	b,(ix-029h)
	sbc	hl,bc			; HL-ben lv szektorsorszm ellenrzse
	pop	bc
	jr	c,LCA20			; ugrs, ha rvnyes a szektorcm
LCA19:	ld	a,0BDh			; hibakd: .ISECT - rvnytelen szektor
	.db	021h			; a kvetkez bjtokkal: ld hl,0AF3Eh -gy tlpi A reg. jabb belltst
LCA1C:	ld	a,0AFh			; hibakd: .NOUPB - nincs UPB
LCA1E:	exx
	ret
LCA20:	call	LCA47			; sv/fej/szektor paramterek kiszmtsa
	ld	d,e			; svszm als bjtja D-be
	ld	e,a			; szektor szma E-be
LCA25:	ld	a,(ix-039h)		; A= svonknti szektorszm
	sub	e			; A reg.-ben a kezd szektortl az adott sv
	inc	a			; adott oldaln htralv szektorok szma +1
	exx
	cp	c			; sszehasonlts az tvivend szektorok szmval (C')
	jr	c,LCA2F			; ugrs, ha az A-ban lv rtk kisebb
	ld	a,c			; egybknt A reg. cskkentse az tvivend rtkre
LCA2F:	exx
	ld	l,a			; L reg.-be a kiszmolt tvivend szektorok szma
	call	LCB26			; szektortvitel DISKIO hvssal, hibajavts jraprblkozssal
	jr	nz,LC9CE		; ugrs a hibakd meghatrozsra, ha DISKIO hiba trtnt
	exx
	or	c
	ret	z			; visszatrs, ha az sszes szektort tvitte
	exx
	ld	e,001h			; kezd szektor szma = 1 (a msik oldalon folytatja az tvitelt)
	inc	c			; oldalszm nvelse
	ld	a,(ix-031h)		; A reg.= meghajtban lv lemez oldalainak szma (1 vagy 2)
	sub	c
	jr	nz,LCA45		; ugrs, ha az aktulis oldalszm nem rte el a max. rtket
	ld	c,a			; egybknt a 0. oldalra ll
	inc	d			; s az eggyel nagyobb svon folytatja
LCA45:	jr	LCA25			; ismtls, amg az sszes szektort t nem vitte


;
;
;	Sv/fej/szektor paramterek kiszmtsa az abszolt szektorsorszmbl
;	in:  DE - abszolt szektorsorszm
;	out:  A - szektor
;	      C - fej
;	     DE - sv
;	     CY - 1 - a szektorsorszm tllg a 16 biten brzolhat rtken
;
LCA47:	xor	a			; A=0
	ld	l,(ix-025h)		; HL= eltolsi rtk (rejtett szektorok a lemez elejn)
	ld	h,(ix-021h)
	add	hl,de
	ex	de,hl			; DE= abszolt szektorsorszm
	ret	c
	ld	c,(ix-039h)		; C= svonknti szektorszm
	call	LCA67			; DE osztsa C-vel
	ld	c,(ix-031h)		; C= oldalak szma
	or	a			; CY=0, az egyoldalas lemez esetre
	dec	c
	jr	z,LCA63			; ugrs, ha egyoldalas a lemez
	dec	c			; C reg.=0
	sra	d			; DE osztsa 2-vel a svszmhoz
	rr	e
LCA63:	rl	c			; CY belptetse C reg.-be -> oldalszm
	inc	a			; A = szektorsorszm (szektorok szmozsa 1-tl indul)
	ret


;
;
;	DE osztsa C-vel, DE-ben az eredmny, A-ban a maradk
;
LCA67:	push	bc			; BC mentse
	ld	b,010h			; 16-bites oszts lesz
	xor	a
LCA6B:	sla	e			; E lptetse balra, als bitbe 0 lp
	rl	d
	rla
	cp	c			; megnzi, hogy A >= C
	jr	c,LCA75			; ugrs, ha nem
	sub	c			; A reg. cskkentse C-vel
	inc	e			; E reg. nvelse nem vltoztatja meg a felsbb biteket, csak a 0.-at
LCA75:	djnz	LCA6B
	pop	bc			; BC visszalltsa
	ret


;
;
;	Egysgszm ellenrzse, meghajtt kivlaszt kd belltsa B-ben
;	in:   C - egysgszm (0..3)
;	     IX - adattviteli terlet cme
;	     IY - vltozblokk elejre mutat
;	out:  A - hibakd, egybknt B belpskori rtke
;	      B - hiba esetn 0, egybknt az egysgszmnak megfelel meghajtt kivlaszt kd (1,2,4,8)
;	     HL'- adattviteli terlet cme
;	     IX - IY-al megegyez helyre mutat, csak a meghajt sorszmval eltolva
;
LCA79:	ld	a,c			; egysgszm A reg.-be
	cp	004h			; sszehasonlts, hogy nagyobb-e 4-nl
	jr	nc,LCA8F		; ugrs, ha nagyobb vagy egyenl
	exx
	ld	d,000h
	ld	e,a			; DE'= egysgszmnak megfelel eltols
	push	iy
	ex	(sp),ix			; IX eredeti rtke a verembe, j rtke IY-bl tvve 
	add	ix,de			; IX eltolsa a meghajt sorszmmal
	pop	hl			; korbbi IX vissza HL'-be (tviteli terlet cme)
	exx
	ld	a,b
	ld	b,(ix-041h)		; meghajtt kivlaszt kd (1,2,4,8) B reg.-be
	ret
LCA8F:	pop	hl
	ld	a,0BEh			; bels hiba: .IUNUM - rvnytelen egysgszm
	ld	b,000h
	ret


;
;
;	Adott svon egy szektorfejlc beolvassa
;	in:   D - sv szma (csak LCA97 s LCA99-nl belpve)
;	      E - FDC paramterek (pl. MFM kdols, dupla plya)
;	out:  A - hibajelzk a DISKIO-tl
;	      D - hibajelzk a DISKIO-tl
;
LCA95:	ld	d,0FFh			; D = sv szma (0FFh -> aktulis sv)
LCA97:	ld	e,000h			; E = FDC vezrl paramter mdostk
LCA99:	push	bc			; B = meghajt szma
	ld	c,000h			; C = oldal szma
	.db	03Eh			; a kvetkez bjttal: ld a,0C5h , elfedve push bc-t
LCA9D:	push	bc
	push	hl
	push	ix
	ld	ix,0D039h		; IX-be bels RAM cm adattviteli terletnek
	ld	a,(iy-05Eh)		; fejlptets sebessge A reg.-be
	and	003h			; als 2 bit maszkolsa
	or	e
	ld	h,a			; H = FDC vezrl paramterbjt
	ld	l,001h			; L = szektorok szma
	ld	a,006h			; parancskd: cm olvassa
	call	LDB2E			; 2.lapon lv rutin hvsa (cm: 0EB49h)
;
	.dw	0EB49h			; DISKIO hvsa
;
	pop	ix
	pop	hl
	pop	bc
	ld	d,a			; hibajelz bitek D reg.-be is
	ret


;
;
;	Olvass, rs, ellenrztt rs, formzs vgrehajtsa DISKIO-val
;	in:   B - meghajtt kivlaszt kd (1,2,4,8)
;	      C - oldal szma (0,1)
;	      D - svszm
;	      E - kezd szektor szma
;	      H - eddig tvitt szektorok szma
;	      L - a kiszmolt tvivend szektorok szma (adott sv, adott oldaln)
;	      B'- sszes eddig tvitt szektor
;	      C'- mg htralv tvivend szektorok szma
;	     HL'- diszk tviteli cm
;	out:  A - hibajelzk a DISKIO-tl
;	     BC - vltozatlan
;	     DE - vltozatlan
;	      H - megnvelve az tvitt szektorokkal
;	      L - az t nem vitt szektorok szma
;	      B'- sszes tvitt szektor (frisstve)
;	      C'- mg htralv tvivend szektorok szma (frisstve)
;	     HL'- tvitt szektorok szmval megnvelt diszk tviteli cm
;
LCABB:	push	hl
	ld	a,(iy-05Eh)		; fejlptets sebessge
	and	003h			; csak az als 2 bit kell
	ld	h,a
	ld	a,(ix-03Dh)
	and	006h
	cp	002h
	jr	nz,LCACD
	set	3,h			; "dupla plya" jelz (pdf 100.old) - pl. 40-svos lemeznl
LCACD:	ld	a,(ix-035h)		; A reg.-be a lemez sv-szma
	sra	a			; oszts kettvel
	cp	d			; sszehasonlts a svszmmal
	jr	nc,LCAD7		; ha kisebb nla (kls sv), nem kell elkompenzci (pdf 100.old)
	set	2,h			; elkompenzls engedlyezse (rsnl s formzsnl)
LCAD7:	exx
	push	hl
	ex	(sp),ix			; IX= diszk tviteli cm, rgi rtke a verembe
	exx
	ld	a,(iy-048h)		; az egysgkezel lementett parancskdja
	cp	008h
	jr	nz,LCAE6		; ugrs, ha nem formzs
	rrca				; parancskd osztsa 2-vel
	jr	LCAED
LCAE6:	cp	005h
	ld	a,001h
	jr	c,LCAED			; ha kisebb volt mint 5, akkor olvass
	inc	a			; ha >=5, akkor rs
LCAED:	call	LDB2E			; 2.lapon lv rutin hvsa (cm: 0EB49h)
;
	.dw	0EB49h			; DISKIO hvsa
;
	ex	af,af'			; visszatrsi hibajelzk mentse
	ld	a,(iy-048h)		; az egysgkezel lementett parancskdja
	sub	006h
	jr	nz,LCB07		; ugrs, ha nem 6-os parancskd volt (rs ellenrzssel)
	or	l
	jr	z,LCB07			; ugrs, ha az tvitt szektorok szma 0
	ld	a,003h			; szektorok ellenrzse
	call	LDB2E			; 2.lapon lv rutin hvsa (cm: 0EB49h)
;
	.dw	0EB49h			; DISKIO hvsa
;
	jr	z,LCB07			; ugrs, ha nincs hiba
	ex	af,af'			; jelenlegi hibajelzk mentse, az elzk elveszhetnek
LCB07:	pop	ix			; IX visszalltsa
	cp	008h			; flag-eket llt (?) vagy bug (?)
	ld	a,e			; A = szektor szma
	add	a,l
	ld	e,a			; E = kezd szektor + tvitt szektorok
	ld	a,l			; A = tvitt szektorok
	exx
	ld	e,a			; E'= tvitt szektorok
	add	a,h
	add	a,e
	ld	h,a			; H'= (diszk tviteli cm + tvitt szektorok * 512) fels bjtja
	ld	a,b
	add	a,e
	ld	b,a			; B'= sszes tvitt szektor
	ld	a,c
	sub	e
	ld	c,a			; C'= mg htralv tvivend szektorok szma
	exx
	ld	a,l			; A = tvitt szektorok
	pop	hl			; HL = belpskori rtke
	add	a,h
	ld	h,a			; H nvelse az tvitt szektorokkal
	ld	a,l			; A = a kiszmolt tvivend szektorok szma
	exx
	sub	e			; A = szmolt tvivend - tvitt szektorok
	exx
	ld	l,a			; L = az t nem vitt szektorok szma
	ex	af,af'			; hibajelzk vissza A reg.-be
	ret


;
;
;	Egysgkezel 4,5,6,8-as parancsnak vgrehajtsa hibajavtssal/jraprblkozssal
;	(hibajavtsi stratgik: ld. pdf 103.old - nincs teljesen sszhangban az itt lekdoltakkal)
;
;	in:   B - meghajtt kivlaszt kd (1,2,4,8)
;	      C - oldal szma (0,1)
;	      D - svszm
;	      E - kezd szektor szma
;	      L - a kiszmolt tvivend szektorok szma (adott sv, adott oldaln)
;	      B'- sszes eddig tvitt szektor
;	      C'- mg htralv tvivend szektorok szma
;	     HL'- diszk tviteli cm
;	out:  A - hibajelzk a DISKIO-tl
;	     BC - vltozatlan
;	     DE - vltozatlan
;	      L - tvitt szektorok szma
;
;
LCB26:	exx
	ld	d,004h			; D'=4 (prblkozs-szmllshoz)
	exx
	ld	h,000h
LCB2C:	call	LCABB			; egysgkezel 4,5,6,8-as parancsnak vgrehajtsa
	or	a
	jr	z,LCB82			; ugrs, ha nem trtnt hiba
	push	hl
	ld	l,a			; hibakd mentse L-be is
	and	061h
	jr	nz,LCB62		; ugrs, ha 'rsvdett' vagy 'nem zemksz' hiba jelzk vannak (H=5 lesz, nincs jraprblkozs)
	ld	a,l			; eredeti hibajelzk vissza A reg.-be
	and	00Eh
	jr	nz,LCB65		; ugrs, ha 'CRC' vagy 'adatveszts' vagy 'ellenrzsi hiba' bitek jeleznek (H=1 lesz)
	exx				; 'a rekord nem tallhat' hibabit lekezelse
	ld	a,d			; A reg. = D'
	exx
	cp	004h
	ld	a,l			; eredeti hibajelzk vissza A reg.-be
	jr	nz,LCB68		; ugrs, ha nem az els prblkozs volt
	push	de
	ld	de,0FF00h		; D= 0FFh- aktulis plya E= 00h- MFM kdols
	call	LCA9D			; az aktulis plyn egy szektorfejlcet beolvas
	pop	de
	jr	z,LCB55			; ugrs, ha sikerlt
	and	020h			; a fenntartott bitet vizsglja (?)
	jr	nz,LCB62
	jr	LCB5B
;
LCB55:	ld	a,(iy-047h)
	cp	d			; sszehasonlts a svszmmal
	jr	z,LCB5F			; ugrs, ha egyezik
LCB5B:	call	LCB85			; meghajtban lv lemez svszmnak meghatrozsa (40 vagy 80)
	or	a
LCB5F:	ld	a,l			; eredeti hibajelzk vissza A reg.-be
	jr	z,LCB68			; ugrs, ha nem volt hiba (H=2)
LCB62:	ld	h,005h			; ZF = 0
	.db	0CAh			; a kvetkez bjtokkal: jp z,L0126 elfedi ld h,001h-t
LCB65:	ld	h,001h
	.db	0CAh			; a kvetkez bjtokkal: jp z,L0226 elfedi ld h,002h-t
LCB68:	ld	h,002h
	push	af			; hibajelzk a verembe
	exx
	ld	a,d			; A reg.= prblkozs-szmll
	push	af
	exx
	sub	004h
	jr	z,LCB78			; ugrs, ha A=0, ms esetben az A-ban v parancskddal hvja a DISKIO-t
	call	LDB2E			; 2.lapon lv rutin hvsa (cm: 0EB49h)
;
	.dw	0EB49h			; DISKIO hvsa, mindig ismeretlen parancs jelzssel tr vissza (mert A=0FFh..0FCh) (bug?)
;
LCB78:	pop	af
	sub	h			; A reg.= D'-H
	exx
	ld	d,a			; szmolt rtk mentse D'-be
	exx
	pop	hl			; eredeti hibajelzk vissza a verembl H-ba (flag-ek nem vltoznak)
	ld	a,h			; majd A reg.-be, visszatrs esetre
	pop	hl
	jr	nc,LCB2C		; ismtls D' rtknek megfelelen
LCB82:	ld	l,h			; L= tvitt szektorok szma
	or	a			; flag-ek a hibakd szerint belltva
	ret


;
;
;	Meghajtban lv lemez svszmnak meghatrozsa (40 vagy 80)
;	(Reseteli a meghajtt, az r/olvas fejt a 8. sv fl mozgatja, majd jra reset)
;	in:   B - meghajtt kivlaszt kd (1,2,4,8)
;	     IX - bels vltozblokkra mutat
;	out:  A - hibakd (DISKIO vagy MOPS)
;	     ZF - 0- volt hiba
;	     CY - 1- volt hiba (MOPS hibakd A reg.-ben)
;
LCB85:	push	bc			; B= meghajt szma
	push	de			; DE mentse
	ld	c,002h			; C = prblkozsok szma
	res	0,(ix-03Dh)
	res	1,(ix-03Dh)
LCB91:	xor	a			; parancskd: diszk-rendszer reset
	call	LDB2E			; 2.lapon lv rutin hvsa (cm: 0EB49h)
;
	.dw	0EB49h			; DISKIO hvsa
;
	ld	d,008h			; D = sv szma (8.)
	call	LCA97			; szektor fejrsz olvassa
	jr	z,LCBA9			; ugrs, ha nem trtnt hiba
	and	021h
	jr	nz,LCBD3		; ugrs, ha "nem zemksz" jelzst kapott
LCBA2:	dec	c			; prblkozsok szmnak cskkentse
	jr	nz,LCB91		; ismtls, ha mg csak az els prba volt
	ld	a,d			; hibajelz bitek ismt A reg.-be
	or	a
	jr	LCBD3			; ugrs a visszatrsi procedurra
;
LCBA9:	ld	e,(ix-03Dh)		; meghajt paramterbjtja
	set	1,e			; 40 svosra lltja
	ld	a,(iy-047h)		; ellenrzi, hogy a 4. vagy a 8. sv fl kerlt-e a fej
	cp	004h			; ha a 4. fltt van, akkor csak 40-svos a lemez
	jr	z,LCBCB
	cp	008h			; ha a 8. fltt van, akkor 80-svos
	jr	z,LCBC4
	cp	010h			; megvizsglja 16-ra is
	ld	d,010h
	jr	nz,LCBA2		; ugrs, ha nem egyenl, jra kell prblkozni
	ld	a,0B1h			; hibakd: .NCOMP - nem kompatibilis lemez
	scf				; hiba jelzse
	jr	LCBD3			; ugrs a visszatrsi procedurra
;
LCBC4:	bit	2,e
	jr	nz,LCBCD
	res	1,e			; 40-svos jelzs trlse, ZF marad 1
	.db	0C2h			; a kvetkez bjtokkal: jp nz,L93CB - elfedi "res 2,e" -t
LCBCB:	res	2,e			; 80-svos jelzs trlse
LCBCD:	set	0,e			; ellenrzttsg jelzse (?)
	ld	(ix-03Dh),e		; meghajt paramter mentse
	xor	a
LCBD3:	push	af			; hibajelzk mentse
	xor	a			; parancskd: diszk-rendszer reset
	call	LDB2E			; 2.lapon lv rutin hvsa (cm: 0EB49h)
;
	.dw	0EB49h			; DISKIO hvsa
;
	pop	af			; hibajelzk visszalltsa
	pop	de			; elmentett regiszterek vissza
	pop	bc
	ret


;
;
;	Egysgkezel 8. parancsnak vgrehajtsa (fciklus)
;	Leformzza a lemezt s felrja a BOOT szektort.
;	in:   B - "hordoz" bjt (a lemez kvnt formtumt azonostja pl. 0F9h -> 2 oldal, 9 szektor/old, 80 sv)
;	      C - egysgszm (0..3)
;	out:  A - hibakd
;
LCBDE:	call	LCA79			; egysgszm ellenrzse, meghajtt kivlaszt kd belltsa B-ben
	ld	c,a			; C= "hordoz" bjt
	cp	0F8h
	ld	a,0B5h			; hibajelzs: .NDOS - nem DOS lemez
	ret	c			; visszatrs, ha a "hordoz" bjt < 0F8h
	ld	h,(iy-05Eh)		; H= fejlptets sebessge
	ld	a,008h			; A reg. = meghajt vizsglata parancskd
	call	LDB2E			; 2.lapon lv rutin hvsa (cm: 0EB49h)
;
	.dw	0EB49h			; DISKIO hvsa
;
	jp	nz,LC9CE		; ugrs a hibakd meghatrozsra, ha DISKIO hiba trtnt
	ld	d,003h			; meghajt ellenrztt s 80 svos (???) jelzs
	inc	l			; meghajt tpusa
	jr	z,LCBFD			; ugrs, ha 80 svos
	res	1,d			; (???)
	set	2,c			; a "hordoz" bjtot tlltja 40 sv formtumra (oldal- s szektorszm marad)
LCBFD:	bit	2,c			; "hordoz" bjt ellenrzse svszm szempontjbl
	jr	nz,LCC03		; ugrs, ha 40 svos a formtum
	set	2,d			; 80 svos lemez jelzse
LCC03:	ld	(ix-03Dh),d		; meghajt paramter mentse
	ld	d,a			; D=0
	call	LCA97			; adott svon (0.) egy szektorfejlc beolvassa
	and	0A1h			; hibajelzk maszkolsa: ismeretlen parancs, fenntartott, nem zemksz
	ld	a,0BCh			; hibakd: .NRDY - a meghajt nem zemksz
	ret	nz			; visszatrs, ha a maszkolt bitek kzl brmelyik aktv
	exx				; a formzshoz szksges adattmb elksztse (kb. 6500 bjt):
	push	hl			; HL' a verembe (tviteli terlet cme)
	ld	de,0CD1Ch		; "tmrtett" adatblokkok cme a ROM-ban
	ld	b,005h			; 5 adatblokk bevezetsnek
	call	LCD0E			; adatblokkok kitertse HL' cmre
	ld	c,009h			; 9 szektor lesz
	ld	a,001h			; szektorsorszm
	ex	af,af'			; A reg. mentse
LCC1E:	ld	de,0CD26h		; "tmrtett" adatblokkok cme a ROM-ban
	ld	b,004h			; 4 adatblokk kvetkezik
	call	LCD0E			; adatblokkok kitertse HL' cmre folytatlagosan
	ex	af,af'			; A reg.-be vissza a szektorsorszm
	ld	(hl),a			; szektorsorszm letrolsa a blokk utn
	inc	hl			; cm nvelse
	inc	a			; szektorsorszm nvelse
	ex	af,af'			; A reg. mentse
	ld	b,00Ah			; kvetkez 10 blokk kicsomagolsa
	call	LCD0E
	dec	c			; ciklusszmll cskkentse
	jr	nz,LCC1E		; ismtls, a kvnt szektorszm elrsig
	ld	b,002h			; mg tovbbi 2 adatblokk kitertse
	call	LCD0E
	pop	hl			; tviteli terlet visszalltsa HL'-be
	exx
LCC3A:	call	LCC96			; lemez formzsa a 0. svtl a legbelsig (40 v. 80)
	ld	(iy-048h),a		; az egysgkezel lementett parancskdja = 0
	call	LCC96			; visszaolvas az sszes sv minden oldaln minden szektort
	ld	a,c			; "hordoz" bjt A reg.-be
	exx
	push	hl			; HL' a verembe (tviteli terlet cme)
	ld	c,a			; "hordoz" bjt C' reg.-be
	call	LC8C1			; formtumnak megfelel adatterlet elksztse (BOOT szektorhoz)
	ex	de,hl			; DE' = tviteli terlet cme + 11
	ld	hl,0CC8Fh		; 11 bjtnyi adat bemsolsa a ROM-bl az adatterlet elejre:
	ld	bc,0000Bh		; 0EBh,0FEh,090h,"VTDOS1.2"
	dec	de
	lddr
	ld	c,01Fh			; C = eltolsi rtk
	ex	de,hl
	add	hl,bc
	ld	(hl),0C9h		; 30. bjt = 0C9h
	ld	c,022h
	add	hl,bc
	ex	de,hl			; DE' = 64. bjt cme
	ld	hl,0CC90h		; 6 bjtnyi adat bemsolsa a ROM-bl DE cmre:
	ld	c,006h			; "VOL_ID"
	ldir
	inc	de			; DE' = 71. bjt cme
	push	iy
	pop	hl
	ld	bc,0FFA7h		; BC' = -89
	add	hl,bc			; HL' = 0D080h - 059h = 0D027h
	ld	bc,00004h		; 4 bjt lesz
	ldir				; 28 bites vletlenszm bemsolsa a 71. bjttl
	pop	hl			; tviteli terlet visszalltsa HL'-be
	exx
	push	bc			; BC mentse
	ld	de,00001h		; 1 szektor rsa a 0. oldal 0. sv 1. szektortl
	ld	c,d
	ld	l,e
	ld	(iy-048h),005h		; az egysgkezel lementett parancskdja = 5 (szektorok rsa)
	call	LCB26			; egysgkezel 4,5,6,8-as parancsnak vgrehajtsa hibajavtssal/jraprblkozssal
	pop	bc			; BC visszalltsa
	jr	nz,LCCD0		; ugrs, ha hiba volt (hibakd meghatrozsa)
	ret


;
LCC85:	.db	0EBh,0FEh,090h,"VTDOS1.2"
;
LCC90:	.db	"VOL_ID"


;
;
;	Meghajt sszes svjn s oldaln formzs vagy szektorok visszaolvassa (ellenrzs)
;	megj.:
;	- 2 oldalas lemez formzsa esetn ellenrzi, hogy a 0. sv 1. oldaln sikeres-e
;	  a mvelet vgrehajtsa. Ha nem, akkor megvltoztatja a "hordoz" bjt rtkt
;	  1 oldalas formtumra s ismt "meghvatja" magt a frutinbl.
;	- hiba esetn nem tr vissza a hv rutinhoz, hanem kzvetlenl annak meghvjhoz
;
;	in:
;	out:
;
LCC96:	pop	hl			; visszatrsi cm HL-be
	ld	e,000h
LCC99:	ld	a,c			; "hordoz" bjt A reg.-be
	and	001h
	ld	d,a			; D= oldalak szma
LCC9D:	push	hl			; visszatrsi cm ismt vissza a verembe
	push	de
	exx
	pop	bc
	push	hl			; tviteli terlet kezdcme a verembe
	bit	3,(iy-048h)		; az egysgkezel lementett parancskdja
	jr	z,LCCB7			; ugrs, ha nem formzs (parancskd < 8)
	ld	a,009h			; 9 szektor van
	ld	de,00098h		; az els szektor adathoz az eltolsi rtk
LCCAD:	add	hl,de			; HL'= az tviteli terleten a megfelel helyre mutat
	ld	(hl),c			; svszm belltsa
	inc	hl
	ld	(hl),b			; oldalszm belltsa
	ld	de,0028Fh
	dec	a
	jr	nz,LCCAD		; ismtls az sszes szektor belltsig
LCCB7:	pop	hl			; HL' megint az tviteli terlet elejre mutat
	push	hl
	exx
	push	bc
	push	de
	ld	l,009h			; L = 9 szektor
	bit	1,c			; "hordoz" bjt vizsglata
	jr	z,LCCC3			; ugrs, ha svonknt 9 szektor kell
	dec	l			; L = 8 szektor
LCCC3:	ld	c,d			; C = oldal szma (0,1)
	ld	d,e			; D = svszm
	ld	e,001h			; E = kezd szektor szma
	call	LCB26			; egysgkezel 4,5,6,8-as parancsnak vgrehajtsa hibajavtssal/jraprblkozssal
	pop	de			; elmentett regiszterek vissza
	pop	bc
	exx
	pop	hl			; HL' megint az tviteli terlet elejre mutat
	exx
	pop	hl			; visszatrsi cm HL-be
LCCD0:	jp	nz,LC9CE		; ugrs a hibakd meghatrozsra, ha DISKIO hiba trtnt
	call	LC123			; CTRL-ESC llapotjelz vizsglata
	ret	z			; visszatrs, ha felhasznli megszakts volt (az eredeti hv rutin fltti szintre)
	dec	d			; oldalszm cskkentse
	jp	p,LCC9D			; ugrs, ha a 0. oldal kvetkezik
	bit	0,c			; "hordoz" bjt vizsglata
	jr	z,LCD02			; ugrs, ha egyoldalas a lemez
	bit	3,(iy-048h)		; az egysgkezel lementett parancskdja
	jr	z,LCD02			; ugrs, ha nem formzs (parancskd < 8)
	ld	a,e
	or	e			; svszm vizsglata
	jr	nz,LCD02		; ugrs, ha nem a 0. svon van
	push	de
	push	bc
	ld	c,001h			; C= 1. oldal kivlasztsa
	call	LCA9D			; adott svon egy szektorfejlc beolvassa
	pop	bc
	pop	de
	jr	z,LCCFC			; ugrs, ha nincs hiba
	and	021h			; "fenntartott" s "nem zemksz" bitek maszkolsa
	jr	nz,LCCD0		; ugrs, ha hibt jeleznek
LCCF8:	dec	c			; tlltja a "hordoz" bjtot 1 oldalas formtumra
	jp	LCC3A			; ismt meghvatja nmagt
;
LCCFC:	ld	a,(iy-046h)		; lemezrl olvasott oldalszm (?) vizsglata
	dec	a
	jr	nz,LCCF8		; ugrs, ha nem 1 volt
LCD02:	ld	a,028h			; A reg. = 40
	bit	2,c			; "hordoz" bjt vizsglata
	jr	nz,LCD09		; ugrs, ha 40 svos lemez kell
	add	a,a			; A reg. = 80
LCD09:	inc	e			; svszm nvelse
	sub	e			; sszehasonlts a kvnt svszmmal
	jr	nz,LCC99		; ugrs, ha mg nem rte el
	jp	(hl)			; ugrs a visszatrsi cmre


;
;
;	Adatblokkok kitmrtse
;	in:   B - adatblokkok szma, minden blokk els bjtja megadja a blokk hosszt, msodik az adatbjtot
;	     DE - forrs terlet, B darab blokkal
;	     HL - cl terlet, az adatbjtbl a blokkhossznak megfelel darabszmt msol ide
;	out: BC - megrzdik
;	     DE,HL - az tmsolt blokkok utnra mutatnak (a forrs ill. a cl terleten)
;
LCD0E:	push	bc
	ld	a,(de)
	ld	b,a			; B= aktulis blokk hossza
	inc	de
	ld	a,(de)			; A= adatbjt
	inc	de
LCD14:	ld	(hl),a			; B darab adatbjt letrolsa HL cmre
	inc	hl
	djnz	LCD14
	pop	bc
	djnz	LCD0E			; kvetkez blokk "kicsomagolsa"
	ret


;
;	Tmrtett adatblokkok (egy sv formzsi adatterletnek elksztshez)
;
LCD1C:	.db	03Ch,04Eh,00Ch,000h,003h,0F6h,001h,0FCh,03Ch,04Eh
;
LCD26:	.db	00Ch,000h,003h,0F5h,001h,0FEh,002h,000h
;
	.db	001h,002h,001h,0F7h,016h,04Eh,00Ch,000h,003h,0F5h
	.db	001h,0FBh,000h,0E5h,000h,0E5h,001h,0F7h,054h,04Eh
;
	.db	000h,04Eh,0CCh,04Eh




;
;
;	FISH funkci vgrehajtsa
;
;	in:   A - funkcikd
;	out:  A - hibakd
;	     AF',BC',DE',HL',IY - megrzdik
;
LCD46:	cp	020h
LCD48:	jr	nc,LCD98		; ugrs, ha A>= 20h (1Fh a legnagyobb funkciszm)
	cp	00Fh
	jr	nc,LCD51		; ugrs, ha A>= 0Fh (nem kell reg. csere)
	push	de			; DE tkerl IX-be
	pop	ix
LCD51:	push	iy			; regiszterek mentse a verembe
	exx
	push	hl
	push	de
	push	bc
	add	a,a			; A reg.= funkciszm *2
	ld	c,a
	ld	b,000h			; BC = funkciszm *2
	ex	af,af'
LCD5C:	push	af			; AF' mentse
	ld	iy,0D080h
	ld	(iy+007h),b		; rs/olvass vezrl flag-jeinek nullzsa
	ld	(0D06Bh),sp		; veremmutat mentse a RAM-ba
	ld	hl,0CD9Ch		; HL= FISH funkcitbla bziscme
	add	hl,bc
	ld	e,(hl)
	inc	hl
	ld	d,(hl)			; DE-ben a funkci vgrehajtsi (memrialapozsos) cme
	ld	(0DB2Bh),de		; ezt a RAM-ba menti
	exx
	xor	a			; A reg. nullzsa
LCD75:	call	LDB28			; funkci meghvsa
	ld	sp,(0D06Bh)		; veremmutat visszalltsa
	ex	af,af'			; AF'= hibakd
	call	LC123			; CTL-ESC-t nyomtak?
	jr	nz,LCD86		; ugrs, ha nem
	xor	a
	ld	(0DFF4h),a		; CTRL-ESC jelz trlse, A'-ben a .STOP hibakd
LCD86:	xor	a
	ld	(0DFF7h),a		; FSH_PG = 0 (felhasznli RAM a 3. lapon)
	ld	(0DFF3h),a		; fjl nmagra msolst megakadlyoz flag trlse
	pop	af
	ex	af,af'			; AF' visszalltsa, A reg.-ben a hibakd
	exx
	pop	bc			; BC', DE', HL' visszalltsa
	pop	de
	pop	hl
	exx
	pop	iy			; IY visszalltsa
	or	a			; flag-ek belltsa a hibakdnak megfelelen
	ret
;
LCD98:	ld	a,0AEh			; hibakd belltsa
	or	a			; A=.ICALL - rvnytelen FISH funkciszm
	ret


;
;
;	FISH funkcitbla
;
	.dw	0CD98h		; 00h - hibajelzs
	.dw	0E010h		; 01h - tvonalnv-string elemzse
	.dw	0E038h		; 02h - Knyvtr-vltoztats
	.dw	0E060h		; 03h - Aktulis knyvtr beolvassa
	.dw	0E0A8h		; 04h - Els keresse
	.dw	0E0B7h		; 05h - Kvetkez keresse
	.dw	0E081h		; 06h - Fjl ltrehozsa
	.dw	0E078h		; 07h - Knyvtr ltrehozsa
	.dw	0E37Fh		; 08h - Trls
	.dw	0E429h		; 09h - tnevezs
	.dw	0E492h		; 0Ah - thelyezs
	.dw	0E567h		; 0Bh - Attribtumok vltoztatsa
	.dw	0E652h		; 0Ch - Fjl megnyitsa
	.dw	0E5A0h		; 0Dh - Fjl lezrsa
	.dw	0CE6Ch		; 0Eh - Pufferek trlse
	.dw	0E6B9h		; 0Fh - Olvass fjlbl
	.dw	0E6BAh		; 10h - rs fjlba
	.dw	0E6B8h		; 11h - rs 0-tltssel
	.dw	0E673h		; 12h - Abszolt szektor olvass
	.dw	0E674h		; 13h - Abszolt szektor rs
	.dw	0CECCh		; 14h - Login vektor beolvassa
	.dw	0CE91h		; 15h - Lemez-foglaltsgi informcik beolvassa
	.dw	0D208h		; 16h - Logikai meghajt konvertlsa fizikai meghajtv
	.dw	0CDE5h		; 17h - Lemez formattlsa
	.dw	0D1A7h		; 18h - MAPDISK (fizikai meghajtk egymshoz rendelse)
	.dw	0D1E2h		; 19h - ASSING (logikai s fizikai meghajtk sszerendelse)
	.dw	0CEE7h		; 1Ah - Rendszervltozk beolvassa/belltsa
	.dw	0EF37h		; 1Bh - Aktulis dtum beolvassa
	.dw	0EF70h		; 1Ch - Aktulis dtum belltsa
	.dw	0EFA1h		; 1Dh - Aktulis id beolvassa
	.dw	0EFACh		; 1Eh - Aktulis id belltsa
	.dw	0CDE1h		; 1Fh - Verziszm lekrdezse



;
;	Kls hibakezel fggvnyre ugr rutin
;	in:   B - hibakd
;	     HL - a kls hibakezel fggvny cme
;	out: -
;
LCDDC:	ld	a,(0D06Dh)		; A reg.= IGNORE vlasz felajnlsnak lehetsge: 0 - lehet 0FFh - nem lehet
	or	a
LCDE0:	jp	(hl)			; ugrs a kls hibakezel fggvnyre


;
;
;	FISH 1Fh: Verziszm lekrdezse
;
;	in: -
;	out: A - hibakd (0)
;	     B - f verziszm
;	     C - aktualizlsi szm
;
LCDE1:	ld	bc,00102h		; verziszm: 1.2
	ret


;
;
;	FISH 17h: Lemez formattlsa
;
;	in:  B - "hordoz" bjt a kvnt formtumhoz
;	     C - logikai egysgszm
;	    DE - pufferterlet (6500 bjt) cme
;	out: A - hibakd
;
LCDE5:	call	LCE53			; meghajt szektorbuffereinek felszabadtsa, idzt nullzsa
	ret	nz			; visszatrs, ha hiba trtnt
	push	bc
	ld	a,008h			; parancskd: 8 - lemez formzsa
	call	LC0FA			; egysgkezel funkcijnak meghvsa
	pop	bc
	jr	z,LCDF8			; ugrs, ha nem trtnt hiba
	cp	0BFh			; hibakd .ICMD ?
	ret	nz			; visszatrs, ha nem illeglis parancs miatt volt a hiba
	ld	a,0ABh			; j hibakd: .IDVR - rvnytelen meghajt
	ret
;
LCDF8:	call	LDB2E			; 1.lapon lv rutin hvsa (cm: 0D0B7h)
;
	.dw	0D0B7h			; lemezcsere ellenrzs, szektorbufferek felszabadtsa, UPB beolvassa, bels FCB pufferrel
;
	or	a
	ret	nz			; visszatrs, ha hiba trtnt
	push	hl			; HL a fizikai meghajt tblzatra mutat
	push	hl
	ld	de,0001Dh
	add	hl,de
	ld	c,(hl)			; C= mdia azonost ("hordozbjt") a meghajt tblzatbl
	ld	b,00Fh			; BC= belltand 12 bites FAT rtk 
	ld	h,c
	ex	(sp),hl			; HL a fizikai meghajt tblzatra mutat, hordozbjt a verembe
	ld	e,d			; DE= 0000h
	call	LDB2E			; 1.lapon lv rutin hvsa (cm: 0D512h)
;
	.dw	0D512h			; FAT elem belltsa (a 0. elem a hordozbjtot tartalmazza)
;
	inc	de			; DE= 00001h
	ld	bc,0FFFFh		; BC= 0FFFFh
	call	LDB2E			; 1.lapon lv rutin hvsa (cm: 0D512h)
;
	.dw	0D512h			; FAT elem belltsa (a 1. elem mindig 0FFFh)
;
LCE19:	inc	de			; DE= kvetkez klaszter azonost
	ld	bc,00000h		; BC= 00000h (szabad klaszter jelzse)
	call	LDB2E			; 1.lapon lv rutin hvsa (cm: 0D512h)
;
	.dw	0D512h			; FAT elem belltsa
;
	push	hl			; HL a fizikai meghajt tblzatra mutat
	ld	bc,00016h
	add	hl,bc
	ld	a,(hl)
	inc	hl
	ld	h,(hl)
	ld	l,a			; HL= max. klaszter szm
	dec	hl
	sbc	hl,de			; HL= max. klaszter szm - aktulisan belltott FAT elem
	pop	hl			; HL a fizikai meghajt tblzatra mutat
	jr	nz,LCE19		; ismtls, amg az sszes klaszterbejegyzst nem lltotta szabadra
	ld	bc,00012h
	add	hl,bc			; HL a meghajt tblzat adott elemre mutat
	ld	c,(hl)
	inc	hl
	ld	b,(hl)			; BC= fknyvtr kezd szektora
	inc	hl
	ld	e,(hl)
	inc	hl
	ld	d,(hl)			; DE= adatterlet kezdete
	ld	h,d
	ld	l,e
	sbc	hl,bc			; HL= adatterlet kezdete - fknyvtr kezd szektora
	pop	af			; A reg.= hordozbjt
	cp	0FEh			; sszehasonlts 1 oldal/8 szektor/ 40 sv formtummal
	ld	a,l			; A reg.= fknyvtr hossza szektorban
	pop	hl			; HL a fizikai meghajt tblzatra mutat
	dec	de			; DE= adatterlet kezdete -1
	jr	nc,LCE4D		; ugrs, ha a hordoz bjt 0FFh vagy 0FEh
	call	LDB2E			; 2.lapon lv rutin hvsa (cm: 0E310h)
;
	.dw	0E310h			; adott szektorterlet (fknyvtr) trlse
;
LCE4D:	call	LDB2E			; 1.lapon lv rutin hvsa (cm: 0D45Dh)
;
	.dw	0D45Dh			; HL-el adott meghajthoz tartoz szektorbufferek "megtiszttsa"
;
	ret


;
;
;	Meghajt szektorbuffereinek felszabadtsa, idzt nullzsa
;
LCE53:	push	de
	push	bc
	ld	b,002h			; funkcivlaszts: adott logikai meghajthoz tartoz fizikai meghajt szektorbuffereinek "megtiszttsa"
	call	LDB2E			; 1.lapon lv rutin hvsa (cm: 0D0BDh)
;
	.dw	0D0BDh			; lemezcsere ellenrzs, szektorbufferek felszabadtsa, UPB beolvassa
;
	pop	bc
	pop	ix
	or	a
	ret	nz			; visszatrs, ha hiba trtnt
	call	LDB2E			; 1.lapon lv rutin hvsa (cm: 0D46Dh)
;
	.dw	0D46Dh			; adott meghajthoz tartoz szektorbufferekben a meghajt azonost trlse
;
	call	LDB2E			; 1.lapon lv rutin hvsa (cm: 0D1D4h)
;
	.dw	0D1D4h			; meghajt idztjnek nullzsa, aktulis knyvtr a fknyvtr
;
	ret


;
;
;	FISH 0Eh: Pufferek trlse
;
;	in:  B  - meghajt szma (0-default  0FFh-mind)
;	     C  - 0-csak puffertrls  0FFh-pufferek trlse s rvnytelentse
;	out: A  - llapotkd
;
LCE6C:	ld	a,b			; vlasztott meghajt A reg.-be
	inc	b
	jr	z,LCE7F			; ugrs, ha minden meghajtra vonatkozik
	dec	b
	jr	nz,LCE76		; ugrs, ha nem a default meghajt
	ld	a,(0D021h)		; default meghajt A reg.-be
LCE76:	call	LC095			; logikai meghajt hozzrendelsi tblzatelemnek kiolvassa
	or	a			; A reg.-ben a fizikai meghajt sorszma
	jr	nz,LCE7F		; ugrs, ha nem nulla
	ld	a,0ABh			; hibakd: .IDRV - rvnytelen meghajt
	ret				; visszatrs
;
LCE7F:	ld	b,a			; meghajt sorszm mentse B reg.-be
	call	LDB2E			; 1.lapon lv rutin hvsa (cm: 0D45Eh)
;
	.dw	0D45Eh			; A reg.-ben adott meghajthoz tartoz szektorbufferek "megtiszttsa" 
;
	or	c			; C=0-csak puffertrls
	ret	z			; visszatrs, ha nem volt hiba s C=0 volt
	ld	a,b			; vlasztott meghajt A reg.-be
	call	LDB2E			; 1.lapon lv rutin hvsa (cm: 0D46Eh)
;
	.dw	0D46Eh			; A reg.-ben adott meghajthoz tartoz szektorbufferek felszabadtsa
;
	call	LC07A			; logikai meghajtk megjellse, hogy a bennk lv lemezt ellenrizni kell
	ret


;
;
;	FISH 15h: Lemez-foglaltsgi informcik beolvassa
;
;	in:  B  - logikai egysgszm
;	out: A  - llapotkd
;	     B  - szektorok szma alapegysgenknt
;	     DE - alapegysgek szma a lemezen
;	     HL - szabad alapegysgek szma (HL<DE)
;	     IX - az egysg-ler terlet cme
;
LCE91:	ld	c,b			; C= logikai egysgszm
	call	LDB2E			; 1.lapon lv rutin hvsa (cm: 0D0B7h)
;
	.dw	0D0B7h			; lemezcsere ellenrzs, szektorbufferek felszabadtsa, UPB beolvassa, bels FCB pufferrel
;
	or	a
	ret	nz			; visszatrs, ha hiba trtnt
	push	hl
	pop	ix			; IX a fizikai meghajt tblzatra mutat
	ld	e,(ix+016h)
	ld	d,(ix+017h)		; DE= max. klaszter szm
	push	de			; DE mentse a verembe
	ld	de,00002h		; DE= kezd klasztersorszm (0002h)
	ld	b,d			; BC= szabad klaszterek szma (0000h)
	ld	c,d
LCEA8:	push	de
	call	LDB2E			; 1.lapon lv rutin hvsa (cm: 0D4C8h)
;
	.dw	0D4C8h			; adott klaszterhez tartoz FAT bejegyzs kiolvassa
;
	ld	a,d
	or	e
	jr	nz,LCEB3		; ugrs, ha a kiolvasott rtk nem 0000h
	inc	bc			; szabad klaszterek szmlljnak nvelse
LCEB3:	pop	de			; DE= aktulis klasztersorszm
	inc	de			; klasztersorszm nvelse
	ex	(sp),hl			; HL= max. klaszter szm
	sbc	hl,de
	add	hl,de
	ex	(sp),hl			; max. klaszter szm vissza a verembe
	jr	nz,LCEA8		; ugrs, ha mg nem rte el a max. klaszter szmot
	ld	h,b
	ld	l,c			; HL= szabad klaszterek szma
	pop	de			; DE= max. klaszter szm
	dec	de
	dec	de			; DE= max. klaszter szm - az els kett nem hasznlt bejegyzs
	ld	bc,00008h
	add	ix,bc			; IX a fizikai meghajt tblzatnak 8. bjtjra mutat (ld. pdf 84. oldal)
	ld	b,(ix+002h)
	inc	b			; B= klaszterenknti szektorszm
	xor	a
	ret


;
;
;	FISH 14h: Login vektor beolvassa
;
;	in:     -
;	out: A  - llapotkd
;	     DE - a login vektor nagyobb helyirtk rsze
;	     HL - a login vektor kisebb helyirtk rsze
;
LCECC:	ld	h,a			; HL = 0
	ld	l,a
	ld	d,a			; DE = 0
	ld	e,a
	ld	b,010h			; 16 logikai meghajtt ellenriz
LCED2:	ld	a,b
	exx
	call	LC095			; logikai meghajt hozzrendelsi tblzatelemnek kiolvassa
	ld	a,(hl)			; HL a hozzrendelt fizikai meghajt tblzatnak cmre mutat
	inc	hl
	or	(hl)			; ha a meghajt tblzatnak cme nem nulla,
	add	a,0FFh			; akkor CY=1
	exx
	adc	hl,hl			; CY rtknek belptetse HL-be jobbrl, HL shiftelse balra
	rl	e			; legfels kilp bit belptetse DE-be
	rl	d
	djnz	LCED2			; ismtls, amg az sszes meghajtt nem ellenrizte
	xor	a			; hibakd trlse
	ret


;
;
;	FISH 1Ah : Rendszervltozk beolvassa/belltsa
;
;	in:  B  - ha B=0, akkor olvass, egybknt rs
;	     D  - j adat, ha rs
;	     E  - vltoz sorszma
;	out: A  - llapotkd
;	     D  - vltoz aktulis rtke
;	     HL - a vltozra mutat a diszk RAM-jban
;
LCEE7:	ld	a,e			; vltozsorszm ellenrzse
	cp	02Bh
	ld	a,099h			; hibakd: .VAR - nem ltez vltozsorszm
	ret	nc			; visszatr, ha sorszm > 02Ah
	ld	a,d			; A reg.= rand adat
	ld	hl,0D000h		; vltoz RAM cmnek kiszmtsa
	ld	d,000h
	add	hl,de			; cm HL-ben
	inc	b
	dec	b
	jr	z,LCEF9			; ugrs, ha csak olvass
	ld	(hl),a			; j rtk bersa
LCEF9:	ld	d,(hl)			; D= kiolvasott rtk
	xor	a			; hibakd trlse
	ret


	.org	0CFFFh			; kitlts 0-val a 4kB-os ROM lap vgig
	.db	000h


.end
