;
;
;	VT-DOS kompatibilis floppy diszk illeszt ver.1.2
;
;	1. ROM lap: FISH segdfunkcik, hibakezel rutinok, szvegkonstansok
;
;

;
;	RAM-ba msolt rutinok cmei (a fordthatsg miatt)
;
LDB2E	.equ	0DB2Eh



	.org	0C000h
;
	.db	"MOPS"
	.db	004h			; azonost nv hossza
	.db	"DISK"			; azonostnv
	.dw	0DB6Fh			; VT-DOS megszaktskiszolgl rutin cme
;
	.dw	00000h			; inicializl rutin cme
	.db	001h			; funkcik szma
	.dw	0DBC1h			; megszaktskiszolgl rutin cme


;
;
;	Lemezmvelet vgrehajtsa lemezcsere ellenrzssel
;	in:   A - funkciszm az egysgkezelnek (0..8)
;	      B - szektorok szma
;	     BC - 001FFh
;	     DE - szmtott rtk (szektorcm)
;	     HL - meghajt (vagy lemez) adattblzatra mutat
;	     IX - szektor adatterlet kezdete
;	out:  A - hibakd
;
LC010:	call	LC024			; lemezcsere ellenrzse
	call	LDB2E			; 0. lapon lv rutin hvsa (cm: 0C0FAh) 
;
	.dw	0C0FAh			; egysgkezel funkcijnak meghvsa 
;
LC018:	push	hl
	ex	(sp),ix
	ld	(ix+009h),064h		; meghajt idztjnek belltsa 100-ra
	ex	(sp),ix
	pop	hl
	or	a
	ret


;
;
;	Lemezcsere ellenrzse a 4-bjtos ktetazonost szm segtsgvel (ha engedlyezett)
;	in:  HL - meghajt (vagy lemez) adattblzat cme
;	out: AF,DE,HL - megrzdik
;
LC024:	push	af
	push	de
	push	hl
	ld	de,00009h		; DE= eltolsi rtk
	add	hl,de
	ld	a,002h
	cp	(hl)			; meghajt idztjnek ellenrzse
	pop	hl			; HL-be a belpskori rtk
	jr	c,LC04B			; ugrs, ha a meghajt idztje < 2 (mg nem volt inicializlva)
	push	bc
	call	z,LC04E			; DSK_CHK vltoz ellenrzse, ha a meghajt idztje = 2 (az elz mvelet utn lejrt)
	jr	z,LC04A			; ugrs, ha DSK_CHK vltoz kikapcsolva
	push	ix			; tviteli terlet cmnek mentse
LC039:	call	LC05F			; lemez UPB-jnek beolvassa
	call	LC072			; 4-bjtos azonost s "hordoz" bjt sszehasonltsa a memriban lvvel
	jr	z,LC048			; ugrs, ha megegyeznek
	ld	a,0B4h			; hibakd: .WDISK - wrong disk
	call	LCAA6			; hibakezel rutin hvsa (IGNORE nlkl, ABORT-nl nem tr vissza)
	jr	LC039			; ugrs az ismtlshez (RETRY-t vlasztottak)
LC048:	pop	ix
LC04A:	pop	bc
LC04B:	pop	de
	pop	af
	ret


;
;
;	DSK_CHK vltoz ellenrzse
;	in:  -
;	out: CY - 0- nincs UPB  1- van UPB, ZF rvnyes
;	     ZF - 0- DSK_CHK aktv  1- DSK_CHK kikapcsolva
;
LC04E:	ld	a,002h			; A reg. = 2. parancskd az egysgkezelnek (nem megvalstott DISKIO funkci)
	call	LDB2E			; 0. lapon lv rutin hvsa (cm: 0C0FAh) 
;
	.dw	0C0FAh			; egysgkezel funkcijnak meghvsa 
;
	dec	b			; B mindig 0 vagy 0FFh, CY=0
	ret	z
	inc	b
	ret	nz			; itt visszatr, ha nem volt UPB (B=0FFh)
	ld	a,(0D023h)		; DSK_CHK vltoz, 00h- bekapcsolva  0FFh- kikapcsolva
	inc	a			; ZF=1 ha kikapcsolva
	scf				; CY=1
	ret


;
;
;	Lemez UPB beolvassa
;	in:  HL - a fizikai meghajt tblzatra mutat
;	out: BC,DE,HL - megrzdik
;	     IX - a bels RAM-ban lv diszk tviteli terlet (512 bjt) elejre mutat
;
LC05F:	push	bc
	push	de
LC061:	ld	a,003h			; A reg. = "UPB adatok beolvassa a lemezrl" parancskd
	call	LDB2E			; 0. lapon lv rutin hvsa (cm: 0C0F6h) 
;
	.dw	0C0F6h			; egysgkezel funkci vgrehajtsa bels RAM-beli terleten
;
	jr	z,LC06F			; ugrs, ha nem trtnt hiba
	call	LCAA6			; hibakezel rutin hvsa (IGNORE nlkl, ABORT-nl nem tr vissza)
	jr	LC061			; ugrs az ismtlshez (RETRY-t vlasztottak)
LC06F:	pop	de
	pop	bc
	ret


;
;
;	Lemezrl olvasott BOOT szektor 4-bjtos ktetazonostjnak s "hordoz" bjtjnak
;	sszehasonltsa a meghajt tblzatban lvvel
;	in:  HL - a fizikai meghajt tblzatra mutat
;	     IX - adattviteli terlet cme (BOOT szektort tartalmazza)
;	out: DE - a 4 bjtos azonost szm utni cmre mutat a BOOT szektorban
;	     HL - megrzdik
;	     ZF - ZF=1 megegyeznek  ZF=0 klnbzek
;
LC072:	push	hl
	call	LC088			; VOL_ID rtk s 4-bjtos azonost szm keresse a boot szektorban
	ex	de,hl			; DE= a 4 bjtos azonost szmra mutat
	pop	hl			; HL= a fizikai meghajt tblzatra mutat
	push	hl
	ld	bc,00019h
	add	hl,bc			; HL= a meghajt tblzatban a ktetazonost bjtok cme
	call	LC0AD			; 4-bjtos azonost szmok sszehasonltsa
	jr	nz,LC086		; ugrs, ha nem egyenlek
	ld	a,(hl)			; A reg.= mdia azonost a tblzatbl
	cp	(ix+015h)		; mdia azonost ("hordoz") bjtok sszehasonltsa
LC086:	pop	hl
	ret


;
;
;	VOL_ID rtk s 4-bjtos azonost szm keresse a boot szektorban
;	in:  IX - adattviteli terlet cme
;	out: HL - a 4 bjtos azonost szmra mutat
;
LC088:	push	ix
	pop	hl
	ld	de,00040h		; VT-DOS-os lemez boot szektorban a VOL_ID szveg kezdete
	add	hl,de
	ld	de,0C0A2h		; "VOL_ID" szveg cme a ROM-ban
	ld	b,006h			; 6 karakter sszehasonltsa
LC094:	ld	a,(de)			; stringek sszehasonltsa karakterenknt
	cp	(hl)
	jr	nz,LC09E		; ugrs, ha nem egyeznek a karakterek
	inc	hl
	inc	de
	djnz	LC094
	inc	hl			; HL a 4 bjtos azonost szmra mutat
	ret
LC09E:	ld	hl,0C0A9h		; HL a 4 darab 0FFh bjtra mutat
	ret


;
LC0A2:	.db	"VOL_ID",00h
LC0A9:	.db	0FFh,0FFh,0FFh,0FFh


;
;
;	4-bjtos ktetazonost szmok sszehasonltsa
;	in:  DE - els azonost szm cme
;	     HL - msodik azonost szm cme
;	out: DE,HL - az azonostk utni cmekre mutatnak
;	     ZF - ZF=1 megegyeznek  ZF=0 klnbzek
;
LC0AD:	ld	b,004h			; 4 bjt sszehasonltsa
LC0AF:	ld	a,(de)			; aktulis bjtok kivonsa
	sub	(hl)
	ret	nz			; visszatrs, ha nem egyenlek
	inc	de			; kvetkez bjtok cme
	inc	hl
	djnz	LC0AF			; ismtls
	ret


;
;
;	Lemezcsere ellenrzs, szektorbufferek felszabadtsa, UPB beolvassa (adott meghajt elksztse (?))
;	in:   B - funkcivlaszts (?)
;	           0 - pl. az FCB-ben is frissti a ktetazonostt
;	           1 - pl. fjlolvassnl (ellenrzi a lemezcsert, s takartja a buffereket, ha szksges)
;	           2 - adott logikai meghajthoz tartoz fizikai meghajt szektorbuffereinek "megtiszttsa" (?)
;	      C - meghajt sorszma
;	     IX - FCB-re mutat
;	out:  A - hibakd
;	     HL - a fizikai meghajt tblzatra mutat
;	     IX - FCB-re mutat
;
LC0B7:	ld	b,000h			; B= a 0. funkci vlasztsa
	ld	ix,0D46Eh		; IX= bels FCB puffer
LC0BD:	ld	a,c			; A= meghajt sorszma
	call	LDB2E			; 0. lapon lv rutin hvsa (cm: 0C095h) 
;
	.dw	0C095h			; logikai meghajt hozzrendelsi tblzatelemnek kiolvassa
;
	ld	c,a			; C= fizikai meghajt sorszma
	ld	(0D06Eh),a		; ments a RAM-ba is
	ld	e,(hl)			; HL=fizikai meghajt tblzatelem cme
	inc	hl
	ld	d,(hl)			; DE a meghajt tblzatra mutat
	ld	a,d
	or	e			; DE=0 ?
	ld	a,0ABh			; hiba: .IDVR - nem ltez meghajt
	ret	z			; visszatrs, ha hiba volt
	push	de			; tblzat kezdcme a verembe
	ld	hl,00007h
	add	hl,de
	ld	e,(hl)			; tblzatbl a 7. paramter
	ld	d,000h
	ld	hl,0D0AAh
	add	hl,de
	ld	a,(hl)			; A=RAM(D0AAh + tblzat 7.paramtere) - adott meghajtban lv logikai lemez azonostja
	cp	c
	jr	z,LC0EC			; ugrs, ha A=C
	or	a
	jr	z,LC0EC			; ugrs, ha A=0
	call	LC45E			; adott meghajthoz tartoz szektorbufferek "megtiszttsa"
	ld	a,0B2h			; lemez behelyezs krse kd (Insert disk for drive ...)
	ex	(sp),hl			; HL= meghajt tblzat cme a verembl
	call	LCAA6			; hibakazel rutin (ez rja ki a szveget s vr a felhasznlra)
	ex	(sp),hl
LC0EC:	ld	(hl),c			; RAM(D0AAh + tblzat 7.paramtere) = C
	dec	b
	jr	nz,LC154		; ugrs, ha B reg. belpskori rtke <>1 volt
LC0F0:	push	ix
	pop	hl			; HL= FCB cme
	ld	bc,0002Ch
	add	hl,bc
	ex	de,hl			; DE= 4 bjtos ktetazonost cme az FCB-ben
	pop	hl			; HL= meghajt tblzat cme a verembl
	push	ix
	push	hl
	ld	c,009h			; BC= eltols a meghajt tblzaton bell (+9)
	add	hl,bc
	ld	a,(hl)			; meghajt idztjnek ellenrzse
	or	a
	jr	z,LC114			; ugrs, ha mg nem volt hozzfrs a lemezhez
	ld	c,010h
	add	hl,bc			; HL = 25. bjt cme (ktetazonost)
	ld	c,a			; C= idzt rtke
	push	de
	call	LC0AD			; 4-bjtos ktetazonost szmok sszehasonltsa
	pop	de
	jr	z,LC11D			; ugrs, ha megegyezik az FCB-ben lv a fizikai meghajtval
	ld	a,(0D06Eh)		; A reg.= fizikai meghajt sorszma
	call	LC45E			; adott meghajthoz tartoz szektorbufferek "megtiszttsa"
LC114:	pop	hl			; HL= meghajt tblzat cme a verembl
	call	LC05F			; lemez UPB beolvassa
	push	hl
	ld	c,001h			; C= idzt rtke (01h)-> inicializlni kell a meghajt tblzatot
	jr	LC130
;
LC11D:	pop	hl			; HL= meghajt tblzat cme a verembl
	push	hl
	dec	c			; C= idzt rtke - 1
	jr	z,LC12C			; ugrs, ha C=1 volt
	dec	c
	jr	nz,LC145		; ugrs, ha C>2 volt
	push	de			; DE= 4 bjtos ktetazonost cme az FCB-ben
	call	LC04E			; DSK_CHK vltoz ellenrzse
	pop	de
	jr	z,LC145			; ugrs, ha DSK_CHK kikapcsolva
LC12C:	call	LC05F			; lemez UPB beolvassa
	ld	c,h
LC130:	push	de
	call	LC088			; VOL_ID rtk s 4-bjtos ktetazonost szm keresse a boot szektorban
	pop	de
	call	LC0AD			; 4-bjtos ktetazonost szmok sszehasonltsa
	pop	hl			; HL= meghajt tblzat cme a verembl
	push	hl
	jr	nz,LC147		; ugrs, ha a ktetazonost szmok nem egyeznek meg
	dec	c
	jr	nz,LC145		; ugrs, ha nem a LC114 cmet rintve jutott ide a programvgrehajts
	call	LC225			; egysgler terlet kitltse az UPB alapjn
	call	LC46D			; adott meghajthoz tartoz szektorbufferek felszabadtsa (HL a meghajt adattblzatra mutat)
LC145:	jr	LC19C
;
LC147:	ld	a,0B3h			; A = hibakd: .WFILE - kicserltk a lemezt mikzben a fjl nyitva volt
	call	LCAA8			; hibakezel rutin hvsa (IGNORE-al)
	pop	hl
	jr	nz,LC186		; ugrs, ha nem RETRY
	pop	ix
	push	hl
	jr	LC0F0			; ugrs az ismtlshez
;
;
LC154:	pop	hl			; HL = meghajt tblzat kezdcme a verembl
	call	LC45D			; HL tblzatban lv meghajthoz tartoz szektorbufferek "megtiszttsa"
	xor	a			; hibakd trlse
	dec	b
	ret	z			; visszatrs, ha B=2 volt
	push	ix			; IX= az FCB-re mutat
	push	hl
	ld	bc,00009h
	add	hl,bc			; HL a meghajt tblzatban a +09h cmre mutat
	ld	a,(hl)
	sub	002h
	ld	d,a			; D= meghajt idztrtk -2
	pop	hl			; HL= meghajt tblzat kezdcme
	jr	c,LC174			; ugrs, ha 2-nl kisebb volt a meghajt idztrtke
	jr	nz,LC18C		; ugrs, ha nem 2 volt
	push	de			; D= 00h
	call	LC04E			; UPB s DSK_CHK vltoz ellenrzse
	pop	de
	jr	c,LC174			; ugrs, ha van UPB beolvasva
	jr	z,LC18C			; ugrs, ha az egysgkezel 2. funkcija 01h-val trt vissza (?)(DSK_CHK kikapcsolva(?))
LC174:	call	LC05F			; lemez UPB beolvassa
	inc	d
	inc	d
	jr	z,LC186			; ugrs, ha a meghajt idztrtk nulla volt (nem volt mg hasznlva)
	call	LC072			; lemez 4-bjtos ktetazonostjnak s "hordoz" bjtjnak sszehasonltsa a meghajt tblzatban lvvel
	jr	nz,LC186		; ugrs, ha nem egyeznek meg
	dec	de			; DE= a 4 bjtos azonost szm utols bjtjra mutat a BOOT szektorban
	ld	a,(de)			; A reg.-be az rtke
	bit	7,a
	jr	z,LC18C			; ugrs, ha rvnyes az azonost
LC186:	call	LC225			; meghajt tblzat kitltse az UPB alapjn
	call	LC46D			; HL-ben adott meghajthoz tartoz szektorbufferekben a meghajt azonost trlse
LC18C:	pop	de			; DE= az FCB-re mutat
	push	de
	push	hl			; meghajt tblzat cmnek mentse
	ld	bc,00019h
	add	hl,bc
	ex	de,hl			; DE= a meghajt tblzatban a 4 bjtos ktetazonostra mutat
	ld	c,02Ch
	add	hl,bc			; HL= az FCB-ben a ktetazonost cme
	ex	de,hl			; DE s HL felcserlve
	ld	c,004h
	ldir				; 4 bjtos ktetazonost msolsa a meghajt tblzatbl az FCB-be
LC19C:	pop	hl			; HL= meghajt tblzat cme
	pop	ix			; IX= az FCB-re mutat
	xor	a			; hibakd trlse
	jp	LC018			; ugrs a meghajt idztjnek belltsra, majd visszatrs a hvhoz
;
;
	pop	hl
	ld	a,098h
	ret


;
;
;	FISH 18h: MAPDISK (fizikai meghajtk egymshoz rendelse)
;
;	in:  B  - els fizikai egysgszm
;	     C  - msodik fizikai egysgszm
;	out: A  - llapotkd
;
LC1A7:	ld	hl,0D46Eh		; HL= bels puffer
	push	hl
	ld	a,c			; A reg. = msodik fizikai meghajt
	call	LDB2E			; 0.lapon lv rutin hvsa (cm: 0C0AAh)
;
	.dw	0C0AAh			; fizikai meghajt tblzatcmnek meghatrozsa
;
	ex	de,hl			; HL= msodik fizikai meghajt tblzatra mutat
	pop	de			; DE= bels puffer
	ld	a,098h			; hibakd: .IMAP - "Invalid mapdisk" (nemltez fizikai egysgszm)
	ret	z			; visszatrs, ha hiba trtnt
	push	de			; puffer cme a verembe is
	ld	a,b			; A reg. = els fizikai meghajt
	ld	bc,00008h		; 8 bjt lesz
	ldir				; msodik meghajt adatainak msolsa az tmeneti terletre
	push	af			; A reg. mentse (A reg. = els fizikai meghajt)
	call	LC45E			; A reg.-ben adott meghajthoz tartoz szektorbufferek "megtiszttsa"
	call	LC46E			; A reg.-ben adott meghajthoz tartoz szektorbufferek felszabadtsa
	pop	af			; A reg. visszalltsa
	call	LDB2E			; 1.lapon lv rutin hvsa (cm: 0C0AAh)
;
	.dw	0C0AAh			; fizikai meghajt tblzatcmnek meghatrozsa
;
	pop	hl			; HL= bels puffer
	ld	a,098h			; hibakd: .IMAP - "Invalid mapdisk" (nemltez fizikai egysgszm)
	ret	z			; visszatrs, ha hiba trtnt
	push	de			; DE= els fizikai meghajt tblzatra mutat
	ld	c,008h			; 8 bjtot msol
	ldir				; tmeneti terletrl az els meghajt adatterletre msols
	pop	hl			; HL= els fizikai meghajt tblzatra mutat
LC1D4:	push	hl
	ld	de,00009h		; DE= eltolsi rtk a meghajt tblzatban
	add	hl,de
	ld	(hl),d			; els meghajt idztje = 00h
	ld	e,015h
	add	hl,de
	ld	(hl),0FFh		; els meghajt aktulis knyvtr klasztere = 0FFh -> fknyvtr
	pop	hl			; HL = els meghajt adatterlete
	xor	a			; A=0 -> nem volt hiba
	ret


;
;
;	FISH 19h: ASSING (logikai s fizikai meghajtk sszerendelse)
;
;	in:  B  - els (logikai) egysgszm
;	     C  - msodik (fizikai) egysgszm
;	out: A  - llapotkd
;
LC1E2:	ld	hl,0D0DDh		; HL=logikai meghajtk hozzrendelsi tblzata
	ld	a,b
	or	a			; ha a logikai meghajt szma 0, akkor
	jr	z,LC1FF			; minden elz ASSIGN mvelet trldik
	cp	011h			; logikai meghajt sorszma > 16 ?
	ld	a,0ABh			; hibakd: .IDVR - "Invalid drive"
	ret	nc			; visszatrs, ha rvnytelen meghajt
	ld	e,b
	ld	d,000h
	add	hl,de			; HL=logikai meghajt hozzrendelsi tblzat beli cme
	ld	a,c			; fizikai meghajt sorszmnak ellenrzse
	or	a
	jr	z,LC1FC			; ha nulla, akkor a megadott logikai meghajtt nmaghoz rendeli
	cp	011h			; fizikai meghajt sorszma > 16 ?
	ld	a,0ABh			; hibakd: .IDVR - "Invalid drive"
	ret	nc			; visszatrs, ha rvnytelen meghajt
	ld	b,c			; fizikai meghajt B-be
LC1FC:	ld	(hl),b			; logikai meghajt hozzrendelse a B-ben adott fizikai meghajthoz
	xor	a			; hibajelzk trlse
	ret
;
LC1FF:	ld	(hl),a			; hozzrendelsek trlse: minden logikai meghajtt
	inc	hl			; az azonos sorszm fizikaihoz rendeli
	inc	a
	cp	011h			; 16 db. bejegyzst llt alaphelyzetbe
	jr	nz,LC1FF		; ismtls, amg nincs mindegyikkel kszen
	xor	a			; hibajelzk trlse
	ret


;
;
;	FISH 16h: Logikai meghajt konvertlsa fizikai meghajtv
;
;	in:  B  - bit7:     0- logikai  1- fizikai egysgszm
;	          bit6..0:  egysgszm
;	out: A  - llapotkd
;	     B  - fizikai meghajtszm
;	     C  - aktulis meghajtszm (DISKIO-nak)
;	     IX - az egysgler terlet cme
;
LC208:	ld	a,b			; egysgszm A reg-be
	bit	7,a
	jr	nz,LC212		; ugrs, ha fizikai meghajtszm
	call	LDB2E			; 0.lapon lv rutin hvsa (cm: 0C095h)
;
	.dw	0C095h			; logikai meghajt hozzrendelsi tblzatelemnek kiolvassa
;
LC212:	and	07Fh			; A reg.= fizikai meghajt (1..16)
	call	LDB2E			; 0.lapon lv rutin hvsa (cm: 0C0AAh)
;
	.dw	0C0AAh			; fizikai meghajt tblzatcmnek meghatrozsa
;
	ld	a,0ABh			; hibakd: .IDVR - "Invalid drive"
	ret	z			; visszatrs, ha a meghajt tblzatnak cme = 0000h
	ld	hl,00007h
	add	hl,de
	ld	c,(hl)			; C= aktulis egysgszm (0..16) a meghajt tblzatbl
	inc	hl
	ld	b,(hl)			; B= fizikai egysgszm (0..16) a meghajt tblzatbl
	xor	a			; hibakd trlse
	ret


;
;
;	Egysgler terlet (meghajt tblzat) kitltse az UPB alapjn
;	(ld. pdf 84. oldal, doksihoz kpes +8-as cmek)
;	in:  HL - meghajt adattblzata
;	     IX - adattviteli terlet cme (BOOT szektort tartalmazza)
;	out: HL, IX - vltozatlan
;
LC225:	push	hl
	ld	bc,0000Ah		; BC= kezdeti eltols (10)
	add	hl,bc
	ld	a,(ix+00Dh)		; A reg. = klaszterenknti szektorszm
	dec	a
	ld	(hl),a			; 10. bjt = alapegysg maszk (alapegysgenknti szektorszm - 1)
	inc	hl
	ld	c,0FFh
LC232:	inc	c			; A reg.-ben lv rtk 2-es alap logaritmusnak szmtsa
	rrca
	jr	c,LC232
	ld	(hl),c			; 11. bjt = alapegysg eltols
	inc	hl
	ld	e,(ix+00Eh)		; E = fenntartott szektorok a ktet elejn (als bjt)
	ld	(hl),e			; 12. bjt = az els FAT szektor szektorszma (als bjt)
	inc	hl
	ld	d,(ix+00Fh)		; D = fenntartott szektorok a ktet elejn (fels bjt)
	ld	(hl),d			; 13. bjt = az els FAT szektor szektorszma (fels bjt)
	inc	hl
	push	de
	ld	b,(ix+010h)
	ld	(hl),b			; 14. bjt = FAT pldnyok szma
	inc	hl
	ld	e,(ix+011h)		; DE = bejegyzsek szma a fknyvtrban
	ld	d,(ix+012h)
	ld	a,e
	and	00Fh
	ld	(hl),a			; 15. bjt = szabad bejegyzsek szma az utols (hasznlt fknyvtri) szektorban
	ld	a,004h
LC254:	srl	d			; DE = DE/16 -> fknyvtr szektorainak szma (16 bejegyzs van egy szektorban)
	rr	e
	dec	a
	jr	nz,LC254
	cp	(hl)			; sszehasonlts, hogy az als 4 bit nulla volt-e
	inc	hl
	ld	(hl),e			; 16. bjt = fknyvtr szektorainak szma (kivve, ha az als 4 bit nem nulla volt - bug)
	inc	hl
	jr	nc,LC262		; ugrs, ha az als 4 bit nulla volt
	inc	de
LC262:	ld	a,(ix+016h)
	ld	(hl),a			; 17. bjt = egy FAT pldny szektorainak szma
	inc	hl
	ex	(sp),hl			; 18. bjt cme a verembe, HL= fenntarott szektorok
	push	de			; fknyvtr szektorainak szma a verembe
	ld	e,a
	xor	a
	ld	d,a
LC26C:	add	a,e			; DE= egy FAT pldny szektorszma * pldnyok szma
	jr	nc,LC270
	inc	d
LC270:	djnz	LC26C
	ld	e,a
	add	hl,de
	ex	de,hl			; DE= fenntartott szektorok + FAT pldnyok ltal elfoglalt szektorok szma
	pop	hl
	add	hl,de			; HL= DE + fknyvtr szektorai => adatterlet kezdete
	ex	(sp),hl			; szmtott rtk a verembe, tblzat cm vissza HL-be
	ld	(hl),e			; 18. bjt = fknyvtr kezd szektora (als bjt)
	inc	hl
	ld	(hl),d			; 19. bjt = fknyvtr kezd szektora (fels bjt)
	inc	hl
	pop	de
	ld	(hl),e			; 20. bjt = adatterlet kezdete (als bjt)
	inc	hl
	ld	(hl),d			; 21. bjt = adatterlet kezdete (fels bjt)
	inc	hl
	push	hl			; 22. bjt cme a verembe
	ld	l,(ix+013h)		; HL = sszes szektor szma a ktetben
	ld	h,(ix+014h)
	or	a
	sbc	hl,de			; HL = adatterlet mrete (szektorban)
	inc	c			; C = alapegysg eltols + 1
LC28C:	dec	c			; HL osztsa a klaszterenknti szektorszmmal
	jr	z,LC295
	srl	h
	rr	l
	jr	LC28C
LC295:	inc	hl			; tovbbi 2 klaszter hozzadsa HL-hez (az els kt klaszter nem hasznlt)
	inc	hl
	ex	de,hl			; DE = legnagyobb klaszterszm
	pop	hl
	ld	(hl),e			; 22. bjt = adatalapegysgek szma +2 (als bjt)
	inc	hl
	ld	(hl),d			; 23. bjt = adatalapegysgek szma +2 (fels bjt)
	inc	hl
	push	hl			; 24. bjt cme a verembe
	call	LC088			; 4-bjtos ktetazonost szm kikeresse a boot szektorban
	pop	de
	dec	hl			; a ktetazonost eltti bjttl (piszkos diszk) kezdden tmsols a tblzatba
	ld	bc,00005h
	ldir
	ex	de,hl			; HL = 29. bjt cme
	ld	a,(ix+015h)
	ld	(hl),a			; 29. bjt = mdia azonost (v. "hordoz" bjt)
	pop	hl			; HL = tblzat kezdcme


;
;
;	Aktulis alknyvtr kezd klasztercmnek trlse az adott meghajt-tblzatban
;	in:  HL - a fizikai meghajt tblzatra mutat
;	out:  A - 00h
;	     BC,HL - megrzdik
;
LC2AE:	push	hl
	push	bc			; BC = 0000h (?)
	ld	bc,0001Fh
	add	hl,bc			; HL = 31. bjt cme
	pop	bc
	xor	a
	bit	7,(hl)			; 31. bjt 7. bit vizsglata
	jr	nz,LC2BD		; ugrs, ha fknyvtr
	ld	(hl),a			; 31. bjt = 0
	dec	hl
	ld	(hl),a			; 30. bjt = 0
LC2BD:	pop	hl			; HL = tblzat kezdcme
	ret


;
;
;	Adott szektorbuffert a lncolat legvgre helyezi
;	in:  HL - szektorbuffer cme
;	out: BC,DE,HL - az eredeti rtk
;
LC2BF:	ld	a,(hl)			; kvetkez buffer cmnek ellenrzse
	inc	hl
	or	(hl)
	dec	hl
	ret	z			; visszatrs, ha nincs kvetkez
	push	de
	push	bc
	push	hl
	ld	e,(hl)			; DE = kvetkez szektorbuffer cme
	inc	hl
	ld	d,(hl)
	push	de			; eredeti cm a verembe
	xor	a
	ld	(hl),a			; kvetkez lncolt buffer cmnek kinullzsa (nem lesz utna mr msik buffer)
	dec	hl
	ld	(hl),a
	ld	b,h			; BC = aktulis szektorbuffer cme
	ld	c,l
	ld	hl,0D067h		; HL = els szektorbuffer cme
	call	LC30B			; BC ltal mutatott buffer cmnek keresse a lncolatban
	ex	de,hl			; HL = az utols megvizsglt buffer cme
	pop	de			; DE = eredetileg lncolt buffer cme a verembl
	ld	(hl),e			; belncolja a tallt cmre (az aktulis helyre)
	inc	hl
	ld	(hl),d
	dec	hl			; a tallt buffertl folytatja a keresst (gy jut el biztosan az utols bufferig)
	call	LC30B			; BC ltal mutatott buffer cmnek keresse a lncolatban
LC2E0:	ex	de,hl			; DE-ben adott bufferhez hozzlncolja
	ld	(hl),c			; BC-ben adott buffert
	inc	hl
	ld	(hl),b
	pop	hl
	pop	bc
LC2E6:	pop	de
	ret


;
;
;	Az adott szektorbuffert belltja els szektorbuffernek. Eltte elmenti, ha piszkos.
;
;
LC2E8:	call	LC31A			; Hasznlt (v. "piszkos") szektorbuffer lemezre mentse
;
;
;	Az adott szektorbuffert belltja els szektorbuffernek.
;	A korbbi els buffert HL-ben adotthoz lncolja, mg a korbban a
;	HL-ben adotthoz lncolt buffert az adott buffer rgi helyre lncolja be.
;	in:  HL - szektorbuffer cme
;	out: BC,DE,HL megrzdik
;
LC2EB:	push	de
	ld	de,(0D067h)		; DE= els szektorbuffer
	or	a			; CY=0
	sbc	hl,de
	add	hl,de			; ZF-et az sszeads nem lltja
	jr	z,LC2E6			; visszatrs, ha HL=DE (HL az els szektorbufferre mutat)
	push	bc
	push	hl
	ld	(0D067h),hl		; a HL ltal mutatott buffer belltsa els szektorbuffernek
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc			; BC= korbban az aktulis bufferhez lncolt kvetkez szektorbuffer
	ld	(hl),d			; a korbbi els buffer hozzlncolsa az aktulishoz
	dec	hl
	ld	(hl),e
	ex	de,hl			; HL = a korbbi els bufferre mutat
	ld	b,d			; BC = az aktulis buffer cme
	ld	c,e
	call	LC30B			; ellenrzs, hogy BC szerepelt-e mr a lncolatban, ZF jelzi, DE=cm
	pop	bc			; BC = az aktulis bufferhez korbban lncolt buffer cme
	jr	LC2E0			; DE = a buffer cme, amihez korbban az aktulis lncolva volt


;
;
;	Buffer cmnek keresse a lncolatban
;	in:  BC - keresend buffercm
;	     HL - kezd szektorbuffer cme
;	out: DE - az utols megvizsglt buffer cme
;	     ZF - 0: megtallta  1: nincs tallat
;
LC30B:	ld	e,(hl)			; kiolvassa a HL ltal mutatott szektorbufferbl
	inc	hl			; a kvetkez buffer cmt
	ld	d,(hl)
	dec	hl
	ex	de,hl			; HL a kvetkez bufferre mutat
	ld	a,h
	or	l
	ret	z			; visszatr ZF=1 -el, ha a lncolat vgre rt
	sbc	hl,bc			; kvetkez buffer cmnek sszehasonltsa BC-vel
	add	hl,bc			; ZF-et az sszeads nem lltja
	jr	nz,LC30B		; folytatja a lncolat tvizsglst, ha nem azonos BC-vel
	or	a			; visszatrs ZF=0 -val
	ret


;
;
;	Mdostott adatterlet (v. "piszkos") szektorbuffer lemezre mentse
;	(utna "tisztnak" jelli)
;	in:   HL - szektorbuffer kezdcme
;	out:  BC,DE,HL,IX rtke megrzdik
;
;
LC31A:	set	2,(iy+022h)		; jelzs a knyvtrkezel rutinoknak, hogy a szektorbuffer tartalma vltozhatott
	push	hl			; szektorbuffer kezdcme a verembe
	inc	hl
	inc	hl
	ld	a,(hl)			; A= fizikai egysgszm, amihez a buffer tartozik
	or	a
	jr	z,LC38B			; ugrs, ha A=0 (szabad buffer)
	inc	hl
	bit	7,(hl)			; flag bjt, 7.bit
	jr	z,LC38B			; ugrs, ha nem mdostott ("tiszta")
	res	7,(hl)			; 7.bit nullzsa
	push	de			; megrzend regiszterek a verembe
	push	bc
	push	ix
LC330:	push	hl			; flag bjt cme a verembe (hibakezels esetn az ismtlshez kell majd)
	bit	6,(hl)
	inc	hl
	ld	e,(hl)			; DE= (abszol) szektorsorszm
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	b,(hl)			; B= +6. bjt ((hasznlhat) FAT pldnyok szma (?))
	inc	hl
	jr	z,LC346			; ugrs ha flag bjt 6.bit nulla
	ld	a,e
LC33D:	add	a,(hl)			; DE-hez 1 FAT pldny mretnek hozzadsa B-szer
	jr	nc,LC341
	inc	d			; D-t is nveli ha kell
LC341:	djnz	LC33D
	ld	e,a			; DE-ben az eredmny (az utols (hasznlhat?) FAT pldny utni els szektorra mutat)
	ld	b,001h			; B reg.: 1 db. szektor rs lesz
LC346:	push	de			; eredmny a verembe
	inc	hl
	inc	hl
	ld	e,(hl)			; +9. bjt (meghajt adattblzat cme als bjt)
	inc	hl
	ld	d,(hl)			; +10. bjt (meghajt adattblzat cme fels bjt)
	inc	hl
	ex	de,hl			; HL= meghajt (vagy lemez) adattblzat cme
	push	de
	pop	ix			; szektorbuffer adatterlet-kezdetnek cme IX-be
	ld	c,001h
	pop	de			; DE= szmtott rtk
LC354:	push	de
	push	bc
	ld	bc,001FFh		; B=1 -> 1 szektort kell tvinni
	call	LC38D			; VERIFY vltoz ellenrzse, A=5 ha inaktv, A=6 ha aktv
	call	LC010			; szektor rsa ( eltte lemezcsere ellenrzssel)
	pop	bc
	pop	de
	jr	nz,LC364		; ugrs, ha hiba trtnt
	inc	c
LC364:	cp	0AFh			; .NOUPB hiba ?
	jr	nz,LC36B		; ugrs, ha nem
	ld	bc,00101h		; B=1 -> kilp a ciklusbl C=1 -> hibakezels
LC36B:	push	af			; hibakd mentse
	ld	a,e
	add	a,(ix-004h)		; DE nvelse egy FAT pldny mretvel
	ld	e,a
	jr	nc,LC374		; ugrs, ha nincs tvitel az als bjtrl
	inc	d
LC374:	pop	af			; A= hibakd, CY=0
	djnz	LC354			; ismtls, amg a pldnyszmll nem lesz nulla
	dec	c
	jr	nz,LC384		; ugrs, ha nem volt hiba
	bit	1,(ix-008h)		; IX-8: flag bjt, 1.bit
	jr	nz,LC381
	scf				; CY=1 -> hibakezels IGNORE nlkl
LC381:	call	LCAA9			; Hibakezel rutin hvsa (CY=0 esetn IGNORE-al)
LC384:	pop	hl
	jr	z,LC330			; ugrs, ha RETRY-t vlasztottak
	pop	ix			; regiszterek helyrelltsa
	pop	bc
	pop	de
LC38B:	pop	hl
	ret


;
;
;	VERIFY vltoznak megfelel szektorrsi parancskd meghatrozsa
;	in:  -
;	out: A - parancskd az egysgkezelnek:
;	          A=5 ha az ellenrzs nincs bekapcsolva (VERIFY = 255)
;	          A=6 ha az ellenrzs be van kapcsolva (VERIFY = 0)
;
LC38D:	ld	a,(0D025h)		; VERIFY vltoz
	or	a
	ld	a,005h			; A=5 (szektorok rsa)
	ret	nz			; visszatr, ha nem nulla
	inc	a			; A=6 (szektorok rsa ellenrzssel)
	ret


;
;
;	Adott szektor beolvassa szektorbufferbe
;	  - ellenrzi az aktulis szektorbufferben
;	  - ha ott nincs, akkor keresi a tbbi szektorbufferben
;	  - ha ott sincs, akkor betlti az els vagy a msodik (?) bufferbe (ha B reg. 0. bit=1)
;	in:   B - 0.bit: 1 - ha nem tallja a bufferekben tltse be a lemezrl  0 - ha nincs meg, csak egy "res" buffert ad vissza
;	          1.bit: 1 - hibakezels esetn lehet IGNORE lehetsg
;	     DE - abszolt szektor sorszm
;	     IX - meghajt vagy lemez adattblzatra mutat
;	out:  A - hibajelz (mindig 0 (?))
;	     HL - a szektorbufferre mutat
;
LC396:	ld	b,001h			; B = IGNORE lehetsg tiltsa / szektor olvassa a lemezrl, ha nincs a bufferekben
	ld	a,(ix+00Eh)		; FAT pldnyok szma
	bit	0,(ix+018h)		; "piszkos diszk" jelz
	jr	z,LC3A6			; ugrs, ha tiszta
	dec	a			; cskkenti a FAT pldny azonostt
	jr	nz,LC3A6		; ugrs, ha nem nulla
LC3A4:	ld	a,001h			; egybknt 1
LC3A6:	ld	(0D0A7h),a		; (hasznlhat) FAT pldnyok szma
	ld	c,(ix+008h)		; C= fizikai egysgszm
	ld	hl,(0D069h)		; aktulis szektorbuffer cme
	ld	a,h
	sub	001h			; ha H=0 akkor nem hvja meg a kv.rutint
	call	nc,LC44B		; szektorbuffer ellenrzse
	ret	z			; visszatr, ha a kvnt szektor van a bufferben
	ld	hl,(0D067h)		; els szektorbuffer cme
	push	hl
LC3BA:	call	LC44B			; szektorbuffer ellenrzse
	jr	z,LC435			; ugrs, ha a memriban van a kvnt szektor
	ld	a,(hl)			; egybknt kvetkez buffer cme HL-be
	inc	hl
	ld	h,(hl)
	ld	l,a
	or	h
	jr	nz,LC3BA		; ugrs, ha nem 0000h a kvetkez buffer cme
	pop	hl			; HL = els buffer cme
	inc	hl
	inc	hl
	bit	7,(hl)
	dec	hl
	ld	a,(hl)			; A reg.-be kvetkez buffer fels bjtja
	dec	hl			; HL megint a buffer elejre mutat
	jr	z,LC3D2			; ugrs, ha a fizikai egysgszm 7. bitje 0
	ld	l,(hl)			; HL-be a kvetkez szektorbuffer cme
	ld	h,a
LC3D2:	call	LC31A			; hasznlt (v. "piszkos") szektorbuffer lemezre mentse
	push	hl
	inc	hl
	inc	hl
	ld	(hl),c			; az egysgler tblban adott fizikai meghajthoz rendeli a buffert
	inc	hl
	ld	a,b
	and	002h			; az 1. bit msolsa B reg.-bl
	ld	(hl),a			; flag bjt belltsa, az 1. biten kvl minden bit nulla
	inc	hl
	ld	(hl),e			; szektorsorszm belltsa
	inc	hl
	ld	(hl),d
	inc	hl
	ld	a,(iy+027h)		; A = (hasznlhat) FAT pldnyok szma
	ld	(hl),a			; msols a +6. bjtba
	inc	hl
	ld	c,(ix+011h)		; C = egy FAT pldny szektorainak szma
	ld	(hl),c			; msols a +7. bjtba
	inc	hl
	push	de			; DE mentse (flslegesen (??? bug?))
	inc	hl
	inc	hl
	inc	hl			; HL = adatterlet kezdete a szektorbufferben
	push	hl
	ex	(sp),ix			; IX = adatterlet kezdete, rgi rtk a verembe
	pop	hl			; HL = IX rgi rtke (meghajt tblzat cme)
	ld	(ix-002h),l		; szektorbuffer +9. s +10. bjtja a meghajt tblzat cme
	ld	(ix-001h),h
	pop	de			; DE visszalltsa (flslegesen volt mentve (??? bug?))
	bit	0,b
	jr	z,LC431			; ugrs, ha B reg. 0. bitje belpskor 0 volt
LC400:	push	bc
	push	de
	ld	b,(iy+027h)		; B = (hasznlhat) FAT pldnyok szma
	jr	LC40D
;
LC407:	ld	a,e			; A = szektorsorszm als bjtja
	add	a,c			; nvels egy FAT pldny szektorainak szmval
	ld	e,a			; vissza E-be a nvelt als bjt
	jr	nc,LC40D		; ugrs, ha nem volt tvitel
	inc	d			; D nvelse
LC40D:	push	de
	push	bc
	ld	bc,001FFh		; B = 1 szektort kell olvasni  C = kzmbs (?)
	ld	a,004h			; A = szektorok olvassa kd
	call	LC010			; lemezmvelet vgrehajtsa lemezcsere ellenrzssel
	pop	bc
	pop	de
	jr	z,LC42F			; ugrs, ha nem volt hiba
	cp	0AFh
	jr	z,LC421			; ugrs, ha .NOUPB hiba volt
	djnz	LC407			; egybknt ismtls, amg vannak tovbbi FAT pldnyok
LC421:	pop	de
	pop	bc
	or	a			; CY=0 -> lehet IGNORE
	bit	1,b
	jr	nz,LC429		; ugrs, ha B reg. 1. bitje belpskor 1 volt
	scf				; egybknt CY=1 -> nem lehet IGNORE
LC429:	call	LCAA9			; hibakezel rutin hvsa
	jr	z,LC400			; ugrs az ismtlsre, ha RETRY-t vlasztottak
	.db	0CAh			; a kvetkez 2 bjttal: "jp z,LC1D1" gy elfedi "pop de"-t s "pop bc"-t
LC42F:	pop	de
	pop	bc
LC431:	ex	(sp),hl			; HL megint a szektorbuffer elejre mutat
	pop	ix			; IX eredeti rtke (meghajt tblzat cme)
	.db	0FEh			; a kvetkez bjttal "cp 0C1h", gy tlpi a "pop bc"-t
LC435:	pop	bc
	set	2,(iy+022h)
	ld	(0D069h),hl		; aktulis szektorbuffer cmnek mentse
	call	LC2BF			; az aktulis szektorbuffert a lncolat legvgre helyezi
	xor	a			; hibajelzk trlse
	ret


;
;
;	Aktulis szektorbuffer "piszkos"-nak jellse
;	in: -
;	out: HL - az aktulis szektorbuffer flag bjtjra mutat (+3. bjt)
;
LC442:	ld	hl,(0D069h)		; HL = aktulis szektorbuffer cme
	inc	hl
	inc	hl
	inc	hl			; +3. bjt
	set	7,(hl)			; 7.bit: 1 ha a buffer hasznlatban (rtak bele(?)) van ("piszkos")
	ret


;
;
;	Szektorbufferben lv szektor cmnek sszehasonltsa a megadottal
;	in:   C - fizikai egysgszm
;	     DE - szektorsorszm
;	     HL - szektorbuffer kezdcme
;	out: ZF=1 ha megegyezik mind a hrom reg.
;
LC44B:	push	hl
	inc	hl
	inc	hl
	ld	a,(hl)		; tblzat +2. eleme
	sub	c
	jr	nz,LC45B
	inc	hl
	inc	hl
	ld	a,(hl)		; tblzat +4. eleme
	sub	e
	jr	nz,LC45B
	inc	hl
	ld	a,(hl)		; tblzat +5. eleme
	sub	d
LC45B:	pop	hl
	ret


;
;
;	Adott meghajthoz tartoz szektorbufferek "megtiszttsa"
;	in:   A - fizikai meghajt sorszma (LC45E cmen belpve)
;	     HL - meghajt adattblzatra mutat (LC45D cmen belpve)
;
LC45D:	.db	0F6h		; a kvetkez bjttal az rtelme: OR 037h -> CY-t 0-ra lltja, A reg. tartalma kzmbs
LC45E:	scf			; CY=1 - A reg. tartalmazza a meghajt sorszmt, HL tartalma kzmbs
	call	LC481		; adott sorszm meghajthoz tartoz szektorbufferek megjellse
	push	hl
LC463:	call	LC4B3		; a kvetkez megjellt szektorbuffer cmnek lekrdezse HL-be
	jr	z,LC4B1		; visszatr, ha vgigment a buffer-lncolaton s nem tallt jellt buffert
	call	LC31A		; hasznlt (v. "piszkos") szektorbuffer lemezre mentse
	jr	LC463		; ismtls a lncolat vgig


;
;
;	Adott meghajthoz tartoz szektorbufferekben a meghajt azonost trlse
;	Az gy felszabadtott bufferek a lncolat elejre kerlnek.
;	in:   A - fizikai meghajt sorszma (LC46E cmen belpve)
;	     HL - meghajt adattblzatra mutat (LC46D cmen belpve)
;
LC46D:	.db	0F6h		; a kvetkez bjttal az rtelme: OR 037h -> CY-t 0-ra lltja, A reg. tartalma kzmbs
LC46E:	scf			; CY=1 - A reg. tartalmazza a meghajt sorszmt, HL tartalma kzmbs
	call	LC481		; adott sorszm meghajthoz tartoz szektorbufferek megjellse
	push	hl
LC473:	call	LC4B3		; a kvetkez megjellt szektorbuffer cmnek lekrdezse HL-be
	jr	z,LC4B1		; visszatr, ha vgigment a buffer-lncolaton s nem tallt jellt buffert
	call	LC2EB		; a HL-ben adott szektorbuffert belltja els szektorbuffernek
	inc	hl
	inc	hl
	ld	(hl),000h	; meghajt sorszma=0
	jr	LC473		; ismtls a lncolat vgig


;
;
;	Adott sorszm meghajthoz tartoz szektorbufferek megjellse
;	Ha a keresett meghajt 0FFh, akkor mindet megjelli.
;	in:   A - fizikai meghajt (0FFh -> sszes meghajt) (rvnyes ha CY=1)
;	     HL - meghajt adattblzatra mutat (rvnyes ha CY=0)
;	     CY - mkdsi md: CY=1 - A reg. tartalmazza a meghajt sorszmt
;	                        CY=0 - HL+8 cmrl olvassa be a sorszmot
;	out:    -
;
LC481:	jr	c,LC48C			; ugrs, ha CY=1
	push	hl
	push	bc
	ld	bc,00008h
	add	hl,bc			; HL= meghajt adattblzat 8. eleme
	ld	a,(hl)			; betlti a meghajt sorszmt HL cmrl
	pop	bc
	pop	hl
LC48C:	push	hl
	push	de
	push	bc
	ld	b,a			; B= fizikai meghajt sorszma
	ld	hl,(0D067h)		; els szektorbuffer cme
LC493:	ld	e,(hl)
	inc	hl
	ld	d,(hl)			; DE= mutat a kvetkez szektorbufferre
	inc	hl
	ld	a,(hl)			; A= meghajt sorszma
	inc	hl
	res	0,(hl)			; flag bjt, 0.bit = 0
	or	a
	jr	z,LC4AA			; ugrs, ha meghajt sorszma=0 (nem hasznlt (?))
	cp	b
	jr	z,LC4A8			; ugrs, ha a meghajt sorszma megegyezik a keresettel
	rlca
	jr	c,LC4AA			; ugrs, ha a meghajt sorszm 7.bit =1
	ld	a,b			; A= keresett meghajt
	inc	a			; (0FFh -> sszes meghajt)
	jr	nz,LC4AA		; ugrs, ha nem az sszes meghajtra vonatkozik a vgrehajts
LC4A8:	set	0,(hl)			; flag bjt, 0.bit = 1 (megegyezik a keresett meghajtval)
LC4AA:	ld	a,d
	or	e
	ex	de,hl
	jr	nz,LC493		; ismtls az j cmen, amg DE-be olvasott mutat nem 0
	pop	bc
	pop	de
LC4B1:	pop	hl
	ret


;
;
;	A kvetkez megjellt szektorbuffer cmnek lekrdezse
;	out: HL - az els megtallt s megjellt szektorbuffer kezdcme
;	     ZF - 0: tallt szektorbuffert  1: a buffer-lncolat vgre rt s nincs tallat
;
LC4B3:	ld	hl,(0D067h)		; els szektorbuffer cme
LC4B6:	push	hl
	inc	hl
	inc	hl
	inc	hl
	bit	0,(hl)			; flag bjt, teszteli a 0.bitet, amit 0C48Ch rutin bellt
	res	0,(hl)			; 0.bit nullzsa -> feldolgozva
	pop	hl			; HL=aktulis szektorbuffer kezdete
	ret	nz			; visszatr, ha meg volt jellve
	ld	a,(hl)			; kvetkez szektorbuffer cmnek betltse HL-be
	inc	hl
	ld	h,(hl)
	ld	l,a
	or	h			; ellenrzi, hogy van-e kvetkez szektorbuffer
	jr	nz,LC4B6		; ismtls, amig nem r a buffer-lncolat vgre
	ret


;
;
;	Adott klaszterhez tartoz FAT bejegyzs kiolvassa
;	(hiba esetn felhasznli hibazenet kldse)
;	in:  DE - klasztersorszm
;	out: DE - kiolvasott FAT elem rtke, fjl vge esetn 0FFFFh
;
;
LC4C8:	call	LC56B			; DE-ben adott klaszterhez tartoz FAT elem kikeresse
	jr	z,LC4D6			; ugrs, ha sikeresen megtallta
LC4CD:	ld	a,0B0h			; hibakd: .IFAT - klasztercm kvl esik a lemez cmtartomnyn
	call	LCAA8			; felhasznli hibazenet kirsa (IGNORE lehetsggel)
	jr	z,LC4CD			; ismt kirja a hibazenetet, ha RETRY-t vlasztottak
	jr	LC4ED			; IGNORE esetn ugrs
LC4D6:	push	hl
	ld	a,(de)			; FAT elem als bjt kiolvassa
	ld	l,a
	inc	de
	ld	a,(de)			; FAT elem fels bjt kiolvassa
	jr	nc,LC4E2		; ugrs, ha pros klasztersorszm
	ld	h,a
	call	LC5CD			; HL balralptetse 4-el, eredmny A:H-ban
	ld	l,h
LC4E2:	and	00Fh			; fels 4 bit maszkolsa
	ld	h,a
	ex	de,hl			; DE-ben a kiolvasott rtk (12-bites)
	ld	hl,00FF7h		; ellenrzs, hogy nem-e fjl vge jelzst tartalmaz
	sbc	hl,de
	pop	hl
	ret	nc			; visszatrs, ha nem
LC4ED:	ld	de,0FFFFh		; fjl vge jelzse 0FFFFh rtkkel
	ret


;
;
;	Abszolt szektorcm kiszmtsa a klaszter sorszmbl
;	in:   A - klaszteren belli szektorsorszm
;	     DE - klaszter sorszma
;	     HL - a fizikai meghajt tblzatra mutat
;	out: BC - megrzdik
;	     DE - abszolt szektorcm
;	     HL - megrzdik
;
LC4F1:	push	hl			; meghajt tblzat kezdcme a verembe
	push	bc
	ld	bc,0000Bh		; a 11. elem kiolvassa
	add	hl,bc
	ld	b,(hl)			; B= klaszterenknti szektorszm 2 alap logaritmusa
	inc	b
	ex	de,hl			; HL= klasztersorszm
	dec	hl			; klasztersorszm cskkentse 2-vel
	dec	hl
	.db	0Eh			; a kvetkez bjttal: ld c,029h - elfedi add hl,hl-t
LC4FD:	add	hl,hl			; klasztersorszm szorozva a klaszterenknti szektorszmmal
	djnz	LC4FD
	add	a,l			; szektorcm eltolsa A-val (klaszteren belli szektor)
	ld	l,a
	ex	de,hl			; DE= szmtott szektorcm
	ld	c,009h
	add	hl,bc			; HL= meghajt tblzat 20. eleme
	ld	a,(hl)			; tblzatelem kiolvassa
	inc	hl
	ld	h,(hl)
	ld	l,a			; HL= lemez adatterlet kezdete
	add	hl,de			; HL= terlet kezdete + szmtott szektorcm
	ex	de,hl			; DE-be a tnyleges szektorcm
	pop	bc			; elmentett rtkek vissza
	pop	hl
	ret


;
;
;	FAT elem belltsa
;	in:  BC - belltand 12 bites rtk
;	     DE - klaszter sorszma
;	     HL - meghajt (vagy lemez) adattblzatra mutat
;	out: DE,HL,IX - megrzdik
;
LC50F:	call	LC5D7			; piszkos diszk megtiszttsa (mdostott FAT szektorok mentse, FAT pldnyok szinkronizlsa)
LC512:	push	de			; klaszter sorszm a verembe
	ld	a,b
	cp	010h
	jr	c,LC51B			; ugrs, ha a belltand rtk fels bjtja nem nagyobb 0Fh-nl
	ld	bc,00FFFh		; BC= FAT lnc vge jelzs
LC51B:	call	LC56B			; adott klasztersorszmhoz tartoz FAT bejegyzs kikeresse
	jr	z,LC529			; ugrs, ha sikerlt
LC520:	ld	a,0B0h			; A = hibakd: .IFAT - a hivatkozott klaszter a FAT-on kvl esik
	call	LCAA8			; hibakezels IGNORE-al
	jr	z,LC520			; ugrs, ha RETRY
	jr	LC569			; ugrs, ha IGNORE
;
LC529:	push	hl			; meghajt (vagy lemez) adattblzatnak cme a verembe
	jr	c,LC536			; ugrs, ha pratlan a klasztersorszm
	ld	a,c			; als bjt belltsa
	ld	(de),a
	inc	de
	ld	a,(de)			; fels bjt belltsa
	and	0F0h			; sszefsls a kvetkez bejegyzs als bjtjval
	or	b
	ld	(de),a
	jr	LC543
;
LC536:	ld	h,b			; HL= belltand rtk
	ld	l,c
	call	LC5CD			; pratlan sorszm 12 bites FAT elem balralptetse 4-el
	ld	a,(de)
	and	00Fh			; als 4 bit sszefslse a megelz bejegyzs fels 4 bitjvel
	or	l
	ld	(de),a
	inc	de
	ld	a,h
	ld	(de),a			; fels 8 bit kzvetlenl bellthat
LC543:	call	LC442			; aktulis szektorbuffer "piszkos"-nak jellse
	bit	0,(iy+022h)
	jr	z,LC568			; ugrs, ha a FAT elem nem lg t a szektorhatron
	ld	bc,00008h
	add	hl,bc			; HL az adatterlet kezdetre mutat
	ld	(hl),a			; tlg elem esetn most valsul meg a tnyleges bellts
	dec	de
	ld	a,(de)			; A = a korbban mr sszefslt als 4 bit
	ld	de,(0D0A3h)		; DE = a msik FAT szektor sorszma
	ex	(sp),ix			; IX = meghajt vagy lemez adattblzatra mutat
	push	af
	call	LC396			; adott FAT szektor beolvassa
	call	LC442			; szektorbuffer "piszkos"-nak jellse
	ld	bc,00207h
	add	hl,bc			; HL az adatterlet utols bjtjra mutat
	pop	af			; A = a korbban mr sszefslt als 4 bit
	ld	(hl),a			; most valsul meg a tnyleges bellts
	ex	(sp),ix			; IX-be ismt az eredeti rtke
LC568:	pop	hl			; meghajt (vagy lemez) adattblzatnak cme
LC569:	pop	de
	ret


;
;
;	Adott klasztersorszmhoz tartoz FAT bejegyzs kikeresse
;	in:  DE - klaszter sorszma
;	     HL - meghajt (vagy lemez) adattblzatra mutat
;	out:  A - pros (00h) v. pratlan (0FFh) a klasztersorszm
;	     DE - a keresett FAT elemre mutat
;	     ZF - ZF=1 - sikeres keress
;	     CY - pros (0) v. pratlan (1) a klasztersorszm
;
;
LC56B:	push	ix
	push	bc
	push	hl			; HL - meghajt (vagy lemez) adattblzatra mutat
	push	hl
	pop	ix
	res	0,(iy+022h)
	ld	l,(ix+016h)		; HL = max. klasztersorszm
	ld	h,(ix+017h)
	dec	hl
	xor	a
	sbc	hl,de			; DE = klaszter sorszma
	jr	c,LC5C8			; visszatrs, ha DE>HL
	ld	h,d			; cm szmtsa FAT12 szerint
	ld	l,e
	add	hl,hl
	add	hl,de			; HL = DE*3
	srl	h
	rr	l			; HL = (DE*3)/2
	push	af			; CY mentse
	push	hl
	ld	e,h			; 
	srl	e			; E = a megfelel FAT szektor sorszma (HL osztva 512-vel) 
	ld	d,a			; DE = FAT szektor sorszma 16 biten brzolva (D=0)
	ld	l,(ix+00Ch)
	ld	h,(ix+00Dh)		; HL = az els FAT szektor szektorszma
	add	hl,de
	ex	de,hl			; DE = FAT szektor sorszma
	call	LC396			; adott FAT szektor beolvassa
	ld	bc,0000Bh		; 11 bjtos bufferfejlc tlpse
	add	hl,bc			; HL - a szektorbuffer adatterletre mutat
	pop	bc			; korbban kiszmolt FAT elem cm BC-be
	ld	a,b			; als 9 bit maszkolsa (szektoron belli cm)
	and	001h
	ld	b,a
	add	hl,bc			; HL = FAT elem cme a bufferben
	add	a,c
	jr	nc,LC5C3		; ugrs, ha BC nem 01FFh (a FAT elem nem lg t a szektorhatron)
	ld	a,(hl)			; az tlg FAT elem als bjtja A reg.-be
	set	0,(iy+022h)
	ld	(0D0A3h),de		; DE = FAT szektor sorszma
	ld	(0D0A5h),a		; FAT elem egyik bjtja
	inc	de			; FAT szektor sorszm nvelse
	call	LC396			; adott FAT szektor beolvassa
	ld	bc,0000Bh
	add	hl,bc
	ld	a,(hl)			; az tlg FAT elem fels bjtja A reg.-be
	ld	(0D0A6h),a		; FAT elem msik bjtja
	ld	hl,0D0A5h		; HL a FAT elemre mutat
LC5C3:	ex	de,hl			; visszatrsi rtk DE-be
	pop	af			; CY visszalltsa: pros v. pratlan a klasztersorszm
	sbc	a,a			; A = 00h (ha CY=0) v. 0FFh (ha CY=1), CY marad az eredeti
	cp	a			; ZF=1 CY=0
	rrca				; CY megint az eredeti rtkkel, A reg. vltozatlan
LC5C8:	pop	hl
	pop	bc
	pop	ix
	ret


;
;
;	Pratlan sorszm 12 bites FAT elem balralptetse 4-el
;	in:  HL - FAT elem (klasztersorszm)
;	out:  A - fels 4 bit
;	     HL - als 12 bit balralptetve 4-el
;
LC5CD:	xor	a
	add	hl,hl
	rla
	add	hl,hl
	rla
	add	hl,hl
	rla
	add	hl,hl
	rla
	ret


;
;
;	Piszkos diszk megtiszttsa
;	  - ha a meghajt tblzatban tisztnak jellt, akkor nem csinl semmit
;	  - tbb FAT pldny esetn: mdostott FAT szektorok lemezre mentse, FAT pldnyok szinkronizlsa
;	  - minden esetben (1 vagy tbb FAT pldny): lemez BOOT szektornak beolvassa, "piszkos diszk" jelz tisztra lltsa
;	in:  HL - meghajt (vagy lemez) adattblzatra mutat
;	out: BC,DE,HL,IX - megrzdik
;
LC5D7:	push	hl
	ex	(sp),ix			; IX mentse, majd a fizikai meghajt tblzatra mutat
	bit	0,(ix+018h)		; "piszkos diszk" jelz
	jr	z,LC64B			; ugrs, ha tiszta
	xor	a			; A= 0 vezrlkd belltsa
	jr	LC5F4			; ugrs a "tisztt" rutinra


;
;
;	Az els FAT tbla szektorait tartalmaz sszes szektorbuffer felszabadtsa (elmenti ha piszkos a buffer),
;	ha az adott meghajt tiszta, van rvnyes ktetazonostja s 1-nl tbb FAT tblja van
;	in:  HL - meghajt (vagy lemez) adattblzatra mutat
;	out: BC,DE,HL,IX - megrzdik
;
LC5E3:	push	hl
	ex	(sp),ix			; IX mentse, majd a fizikai meghajt tblzatra mutat
	bit	7,(ix+019h)		; 4-bjtos ktetazonost legals bjtjnak 7.bitje
	jr	nz,LC64B		; ugrs, ha nincs rvnyes ktetazonostja a lemeznek
	bit	0,(ix+018h)		; "piszkos diszk" jelz
	jr	nz,LC64B		; ugrs, ha "piszkos"
	ld	a,001h			; A= 1 vezrlkd belltsa
;
LC5F4:	push	bc
	push	de
	ld	b,(ix+00Eh)		; B = FAT pldnyok szma
	dec	b
	jr	z,LC62B			; ugrs, ha csak 1 FAT pldny van
	ld	e,(ix+00Ch)		; DE = az els FAT szektor szektorszma
	ld	d,(ix+00Dh)
	ld	b,(ix+011h)		; B = egy FAT pldny szektorainak szma
LC605:	push	bc
	push	af
	dec	a			; A=0 vagy 1 (funkcivlaszts)
	ld	b,000h			; B=0 -> nem kell betlteni a szektort, ha nincs bufferben
	jr	nz,LC611		; ugrs, ha A <> 1
	call	LC3A4			; DE-ben adott szektor beolvassa szektorbufferbe
	jr	LC61E
LC611:	call	LC396			; adott FAT szektor beolvassa
	call	LC31A			; hasznlt (v. "piszkos") szektorbuffer lemezre mentse
	push	hl			; szektorbuffer kezdcme a verembe
	call	LC442			; aktulis szektorbuffer "piszkos"-nak jellse
	set	6,(hl)			; flag bjt 6.bit: az sszes FAT pldnyt lltani kell
	pop	hl			; szektorbuffer kezdcme vissza
LC61E:	call	LC2E8			; az adott szektorbuffert belltja els szektorbuffernek. Eltte elmenti, ha piszkos.
	inc	hl
	inc	hl
	ld	(hl),000h		; fizikai egysgszm = 0 (a buffer szabad)
	pop	af			; A= funkcivlaszts
	pop	bc
	inc	de
	djnz	LC605			; ismtls az FAT pldny sszes szektorra
	ld	b,a
LC62B:	ld	a,b			; ha csak 1 FAT pldny van A=0, egybknt a funkcivlaszt rtk
	cp	(ix+018h)		; "piszkos diszk" jelz (0-tiszta / 1-piszkos)
	jr	z,LC649			; ugrs, ha tiszta volt a meghajt, vagy 1-es funkci volt s piszkos volt
	push	bc
	ld	de,00000h		; 0. (BOOT) szektor
	ld	b,001h			; B = IGNORE lehetsg tiltsa / szektor olvassa a lemezrl, ha nincs a bufferekben
	call	LC3A4			; BOOT szektor beolvassa
	call	LC2EB			; a szektorbuffert belltja els szektorbuffernek
	call	LC442			; majd "piszkos"-nak jelli (visszatrskor HL a +3. bjtra mutat)
	ld	de,0004Eh
	add	hl,de			; HL = 70. bjt (46h) cme az adatterleten
	pop	bc
	ld	(hl),b			; "piszkos diszk" jelz lltsa a BOOT szektorban a krt rtk szerint (0-tiszta / 1-piszkos)
	ld	(ix+018h),b		; jelz lltsa a meghajt tblzatban is (0-tiszta / 1-piszkos)
LC649:	pop	de
	pop	bc
LC64B:	ex	(sp),ix			; IX = belpskori rtk
	pop	hl			; HL = meghajt tblzat cme
	ret


;
;
;	Belps az tvonalnv string vagy a keressi FCB ltal mutatott knyvtrba, a knyvtr els bejegyzsnek kikeresse
;	 - ha DE hasznlatlan FCB, akkor HL-nek egy tvonalnv stringre kell mutatnia
;	 - ha DE meghatrozott FCB, akkor HL-nek egy keressi FCB cmre kell mutatnia
;	 - ha HL keressi FCB-re mutat, a hozztartoz knyvtrbejegyzsnek alknyvtrnak kell lennie (egybknt hiba)
;	in:  DE - hasznlatlan vagy meghatrozott FCB
;	     HL - tvonal-nv string vagy keressi FCB (egy alknyvtrra mutat)
;	out:  A - hibakd (ha ZF=0) vagy a knyvtrbejegyzs els bjtja (ha ZF=1)
;	     BC - megrzdik
;	     HL - a fizikai meghajt tblzatra mutat
;	     DE - az els knyvtrbejegyzs kezdcme
;	     IX - meghatrozott FCB cme
;
LC64F:	ld	a,(de)			; FCB els bjtja A reg.-be
	inc	a			; 0FFh = hasznlatlan FCB
	jr	z,LC663			; ugrs, ha DE hasznlatlan FCB-re mutat
	call	LC679			; legutbb hasznlt knyvtrbejegyzs kikeresse (HL ltal mutatott keressi FCB alapjn)
	ret	nz			; visszatrs, ha hiba volt
	and	010h			; bejegyzs attribtumnak vizsglata
	cp	010h			; alknyvtr ?
	ld	a,0A8h			; hibakd: .IATTR - rvnytelen fjl attribtum
	ret	nz			; visszatrs, ha nem alknyvtrat tallt
	call	LC985			; belps az aktulis bejegyzs ltal mutatott knyvtrba
	jr	LC674			; ugrs, a folytatsra
;
LC663:	push	de
	pop	ix			; hasznlatlan FCB cme IX-be
	push	bc
	ex	de,hl			; DE= tvonalnv string
	ld	c,081h			; C= bels flag-ek: 7.bit =1 (knyvtrvltsok vgrehajtsa) 0.bit = 1 (fjlnv az tvonalban marad)
	call	LC6DD			; tvonalnv elemzse, feldolgozsa
	jr	nz,LC672		; ugrs, ha hiba trtnt
	or	c			; C reg. (utoljra feldolgozott karakter) ellenrzse
	ld	a,0AAh			; hibakd: .IPATH - rvnytelen tvonalnv string
LC672:	pop	bc
	ret	nz			; visszatrs, ha hiba trtnt vagy nem 00h-val vgzdtt az tvonalnv string
LC674:	call	LC9DE			; els knyvtrbejegyzs kikeresse
	cp	a			; ZF=1, A reg.= a knyvtrbejegyzs els bjtja
	ret


;
;
;	Keressi FCB-nek megfelel meghajt kivlasztsa, legutbb hasznlt knyvtrbejegyzs kikeresse
;	 + frissti a meghatrozott FCB ktetazonostjt a keressi FCB meghajtja szerintire
;	 + visszaadja a keressi FCB szerinti bejegyzs attribtum bjtjt s a bejegyzs kezdcmt
;	in:  DE - meghatrozott FCB
;	     HL - keressi FCB
;	out:  A - hibakd (ha ZF=0) vagy attribtum bjt (ha ZF=1)
;	     BC - megrzdik
;	     DE - keressi FCB szerinti knyvtr-bejegyzs kezdcme
;	     HL - a fizikai meghajt tblzatra mutat
;	     IX - meghatrozott FCB cme (DE belpskori rtke)
;	     ZF - ld. A reg.-nl
;
LC679:	ld	a,(de)			; FCB els bjtja A reg.-be
	cp	0FEh			; meghatrozott FCB?
	ld	a,0ACh			; hibakd: .IFCB - rvnytelen FCB
	ret	nz			; visszatrs, ha nem meghatrozott FCB
	push	de			; FCB kezdcm mentse
	ex	de,hl			; DE= keressi FCB
	call	LC6A6			; FCB-nek megfelel meghajt aktivlsa, aktulis knyvtrkezelsi vltozk belltsa
	pop	de
	ret	nz			; visszatrs ha hiba trtnt
	push	bc			; BC= tallati FCB puffer
	push	de			; DE= meghatrozott FCB
	push	hl			; HL= fizikai meghajt tblzata
	ld	bc,00019h		; BC eltolssal
	add	hl,bc			; adott elem kijellse a meghajt tblzatban
	ex	de,hl			; DE a meghajt 4 bjtos ktetazonostjra mutat
	ld	c,02Ch
	add	hl,bc			; elem kijellse a meghatrozott FCB-ben
	ex	de,hl			; DE= ktetazonost az FCB-ben  HL= ktetazonost a meghajt tblzatban
	ld	c,004h			; BC= 0004h
	ldir				; meghajt 4-bjtos ktetazonostjnak tmsolsa az FCB-be
	pop	hl			; HL= fizikai meghajt tblzata
	call	LC9FB			; a keressi FCB-ben adott (legutoljra hasznlt) knyvtrbejegyzs kikeresse
	push	hl			; meghajt tblzat cmnek mentse
	ld	hl,0000Bh
	add	hl,de			; HL a tallt knyvtrbejegyzs attribtumra mutat
	ld	a,(hl)			; A reg.= attribtum bjt
	pop	hl			; HL= fizikai meghajt tblzata
	pop	ix			; IX= meghatrozott FCB
	pop	bc			; BC= belpskori rtk
	cp	a			; ZF=1
	ret


;
;
;	Keressi FCB-nek megfelel meghajt aktivlsa, aktulis knyvtrkezelsi vltozk belltsa
;	in:  DE - keressi FCB
;	out:  A - hibakd
;	     BC - megrzdik
;	     HL - a fizikai meghajt tblzatra mutat
;	     IX - FCB cme (DE belpskori rtke)
;
LC6A6:	push	bc			; BC mentse
	push	de
	pop	ix			; FCB cme IX-be
	ld	c,(ix+007h)		; FCB-beli meghajt szm C reg.-be
	ld	b,001h			; B= funkcivlaszts: 1
	call	LC0BD			; lemezcsere ellenrzs, szektorbufferek felszabadtsa, UPB beolvassa
	or	a
	jr	nz,LC6BD		; ugrs, ha hiba trtnt
	push	hl			; meghajt tblzat a verembe
	call	LC6C3			; regiszterek belltsa FCB kezelshez
	ldir				; aktulis knyvtrkezelsi vltozk feltltse az FCB-bl
	pop	hl			; meghajt tblzat cm vissza HL-be
	xor	a			; hibakd trlse
LC6BD:	pop	bc
	set	2,(iy+022h)		; jelzs a knyvtrkezelnek, szektorbuffereket frissteni kell
	ret


;
;
;	Keressi FCB knyvtrkezelsi vltozinak kikeresse
;	in:  IX - FCB cme
;	out: BC - adatterlet hossza (12 bjt)
;	     DE - 'aktulis knyvtr klasztersorszma' RAM vltoz cme
;	     HL - knyvtrkezelsi vltozk cme az FCB-n bell
;	     IX - megrzdik
;
LC6C3:	ld	de,0D06Fh		; DE= 'aktulis knyvtr klasztersorszma' RAM vltoz cme
	push	ix
	pop	hl			; HL= FCB cme
	ld	bc,00017h		; BC= eltols az FCB-n bell
	add	hl,bc			; HL az FCB-n bell a knyvtrkezelsi vltozk kezdetre mutat
LC6CD:	ld	bc,0000Ch		; BC-be az adatterlet hossza
	ret


;
;
;	tvonalnv elemzse, feldolgozsa:
;	 - tvonalban vagy FCB-ben megadott, vagy ha nem, akkor default meghajt belltsa
;	 - meghajt aktivlsa (ha C reg. 7.bit=1)
;	 - meghajt tblzata szerinti aktulis knyvtr belltsa (ha C reg. 7.bit=1)
;	 - tvonalnv stringben megadott (feldolgozott) utols elem tmsolsa a bels nvpufferbe
;	 - tvonalnv stringnek megfelel knyvtr-vltoztats (az aktulis vagy fknyvtrtl, ha C reg. 7.bit=1)
;	 - utols elem kihagysa a knyvtr-vltsnl (ha C reg. 0.bit=0)
;	 - ktetnv attribtum esetn a meghajt nv utni 11 karaktert msolja a bels nvpufferbe (s az aktulis tvonalat lltja be, ha C reg. 7.bit=1)
;	/megj.: norml reg. kszlettel lp be, msodlagos reg. kszlettel tr vissza (?)/
;	in:   A - keressi attribtum (LC6D1 vagy LC6D3-nl belpve)
;	      B - fizikai meghajt    (LC6D3-nl belpve)
;	      C - bels flag-ek (?)
;	     DE - tvonalnv string kezdcme
;	     IX - FCB cme            (LC6DD-nl belpve)
;	out:  A - hibakd
;	      B - visszatrsi jelzbitek
;	      C - zrkarakter (utoljra feldolgozott karakter)
;	     DE - utoljra feldolgozott karakter cme
;	     HL - a fizikai meghajt tblzatra mutat (ha C reg. 7.bit=1 volt)
;	     IX - FCB cme
;
LC6D1:	ld	b,000h			; B'= default meghajt
LC6D3:	ld	ix,0D46Eh		; bels FCB cme
	ld	(ix+006h),a		; keressi attribtum
	ld	(ix+007h),b		; meghajt szm
LC6DD:	res	1,c			; C'=bels flagek
	exx
	ld	b,004h			; B reg.: visszatrsi jelzbitek (2.bit: van specifiklt meghajtnv)
	call	LC882			; DE' ltal mutatott karakter nagybetv vagy '\' jell  alaktsa
	jr	z,LC6FE			; ugrs, ha vge a stringnek, talaktott karakter A-ban
	call	LC84A			; 'A'..'Z' tartomny vizsglata A regiszteren
	jr	nz,LC6FB		; ugrs, ha nincs 'A'..'Z' tartomnyban
	sub	040h			; az 'A' betbl 1 lesz, 'B'-bl 2 stb.
	ld	c,a			; rtk mentse C-be
	call	LC882			; kvetkez karakter talaktsa
	jr	z,LC6FB			; ugrs, ha vge a stringnek
	cp	03Ah			; ':' vizsglata
	jr	z,LC70A			; ugrs, ha kettspont->meghajt nvvel kezddik
	call	LC89C			; DE' cskkentse eggyel, ez nem meghajt azonost volt
LC6FB:	call	LC89C			; DE' cskkentse eggyel, visszall a legels karakterre
LC6FE:	ld	a,(ix+007h)		; IX az FCB-re mutat, 07h->meghajt sorszma
	ld	c,(iy-05Fh)		; default meghajt (DEF_UNIT) sorszma C-be
	or	a
	jr	z,LC708			; ugrs, ha default meghajt
	ld	c,a			; egybknt meghajt sorszm az FCB-bl
LC708:	res	2,b			; jelzs, hogy nincs specifiklt meghajtnv
LC70A:	ld	(ix+007h),c		; meghajtsorszm FCB-be
	push	bc			; jelzbitek mentse
	xor	a
	ld	b,a
	exx
	bit	7,c			; 7. bit vizsglata a vezrl flag bjtban
	exx
	jr	z,LC719			; ugrs, ha a 7. bit =0 (pl. FISH 01h funkcinl)
	call	LC0BD			; lemezcsere ellenrzs, szektorbufferek felszabadtsa, UPB beolvassa
LC719:	pop	bc			; jelzbitek ismt B-ben, meghajtsorszm C-ben
	or	a
	ret	nz			; visszatrs, ha hiba trtnt
	bit	3,(ix+006h)		; attributum bjt az FCB-ben: 3bit->ktetnv jelz bit
	push	af
	jr	nz,LC72E		; ugrs, ha ktetnv
	call	LC882			; kvetkez karakter talaktsa
	jr	z,LC731			; ugrs, ha vge a stringnek
	cp	05Ch			; '\' jel?
	jr	nz,LC731
	set	0,b			; 0. jelzbit: a meghajt nven kvl ms kielemzett karakterek is vannak
LC72E:	set	1,b			; 1. jelzbit: van specifiklt knyvtr tvonal
	xor	a
LC731:	call	nz,LC89C		; DE' cskkentse eggyel (DE'-> az aktulis knyvtrtl belltand tvonalnv string)
	exx
	bit	7,c			; bels flagek
	exx
	call	nz,LC8A0		; ha C' 7.bit=1, az adott meghajt aktulis tvonalnak megfelel knyvtr belltsa
	exx
	ld	(0D09Ah),de		; DE' mentse 0D09Ah cmre (elemzs aktulis pozcija)
	exx
	pop	af			; ZF= ismt a ktetnv jelz bit
	jr	nz,LC77F		; ugrs, ha ktetnv
LC744:	call	LC7AD			; 8+3 karakter formtum fjlnv feldolgozsa (bels nvpufferbe)
	cp	05Ch			; utols karakter = '\' ?
	jr	nz,LC756		; ugrs, ha nem (ez mr az utols tvonal elem lesz)
	call	LC911			; belps a bels nvpufferben adott alknyvtrba (ha C' 7.bit=1)
	or	a
	jr	nz,LC763		; ugrs, ha hiba trtnt
	call	LC882			; kvetkez karakter talaktsa (DE'=DE'+1)
	jr	LC744
LC756:	xor	a			; A reg.-ben ksbbi hibajelzs trlse
	exx
	bit	0,c			; bels flagek  (0. bit=0 fjlnv msolsa az FCB-be)
	exx
	jr	z,LC763			; ugrs, ha nulla (->a zr nulla karakter az utols tvonal elem el fog kerlni, gy az kiesik az tvonal stringbl)
	ld	a,b			; visszatrsi jelzbitek vizsglata
	and	018h			; ha fjlnv vagy fjlnv kiterjeszts az utols elem,
	call	nz,LC911		; akkor belps a bels nvpufferben adott alknyvtrba (+ ha C' 7.bit=1)
LC763:	push	af			; A reg. mentse
	call	LC882			; kvetkez karakter talaktsa (DE'=DE'+1)
	call	nz,LC89C		; DE' cskkentse eggyel, ha mg nincs vge a stringnek
	ld	c,a			; utoljra feldolgozott karakter C-be
	pop	af			; A reg. vissza
	exx
	ld	b,000h
	bit	7,c			; bels flag-ek ellenrzse
	jr	z,LC776			; ugrs, ha C' 7.bit=0 (pl. FISH 01h esetn)
	ld	(hl),b			; aktulis tvonalnv string vgre 2 db. nulla karakter elhelyezse
	inc	hl
	ld	(hl),b
LC776:	ld	hl,(0D09Ah)		; HL'= utoljra feldolgozott elem utni karakter cme
	ld	(hl),b			; zr nulla karakter elhelyezse
	push	de			; DE' tmsolsa a 'norml' regiszterkszletbe
	exx
	pop	de			; DE= az utoljra feldolgozott karakter cme
	or	a			; A-ban a hibajelzsek
	ret
;
LC77F:	exx				; ktetnv feldolgozsa
	set	1,c			; flag belltsa C'-ben
	exx
	push	hl
	ld	hl,0D49Eh		; HL= bels nvpufferbe msol (11 bjt)
	ld	c,00Bh			; C= 11 karakter hossz lesz a kimeneti string
LC789:	inc	c
LC78A:	call	LC882			; DE' ltal mutatott karakter nagybetv vagy '\' jell  alaktsa
	jr	z,LC7A1			; ugrs, ha vge a stringnek, talaktott karakter A-ban
	cp	02Fh			; '/'
	jr	z,LC79E			; ugrs, ha '/'-t tall
	set	0,b			; visszatrsi jelzbitek belltsa
	set	3,b
	dec	c
	jr	z,LC789			; nincs msols, ha a megadott karakterszmot (11) mr elrte
	ld	(hl),a			; karakter msolsa a bels nvpufferbe
	inc	hl
	jr	LC78A			; ismtls
;
LC79E:	call	LC89C			; DE' cskkentse eggyel
LC7A1:	dec	c			; htralv helyek feltltse SPACE-el
	jr	z,LC7A9
	ld	(hl),020h		; SPACE-k bersa a nvpufferbe
	inc	hl
	jr	LC7A1			; ismtls a puffer vgig
LC7A9:	pop	hl
	xor	a			; hibakd trlse
	jr	LC763			; folytats a fgban


;
;
;	8+3 karakter formtum fjlnv feldolgozsa
;	A tallt fjlnv a bels nvpufferbe kerl SPACE-ekkel 8 karakterre kiegsztve + 3 karakter fjlnv kiterjeszts
;	in:   B - visszatrsi jelzbitek
;	     DE'- feldolgozand fjlnv
;	out:  A - utols feldolgozott karakter (00h vagy specilis karakter)
;	      B - visszatrsi jelzbitek
;	     DE - megrzdik
;	     HL - megrzdik
;
LC7AD:	push	de
	push	hl
	ld	hl,0D49Eh		; HL= bels nv puffer (11 bjt)
	ld	c,008h			; C= 8 karakter hossz lesz a kimeneti string
	ld	a,b			; fels 5 visszatrsi jelzbit nullzsa B-ben
	and	007h
	ld	b,a
	call	LC882			; DE' ltal mutatott karakter nagybetv vagy '\' jell  alaktsa
	jr	z,LC7FB			; ugrs, ha vge a stringnek, talaktott karakter A-ban
	cp	02Eh			; '.' vizsglata #1
	jr	nz,LC7F8		; ugrs, ha nem '.' (DE'= DE'-1)
	ld	d,001h			; D=1 -> jelzi, hny '.' karaktert tallt
	call	LC882			; DE' ltal mutatott karakter nagybetv vagy '\' jell  alaktsa
	jr	z,LC7E5			; ugrs, ha vge a stringnek
	call	LC855			; A reg. tartalma specilis karakter? 
	jr	nz,LC7F5		; ugrs, ha nem (DE'= DE'-2)
	cp	02Eh			; '.' vizsglata #2
	jr	nz,LC7E2		; ugrs, ha nem '.'
	set	7,b			; visszatrsi jelzbit: 7.- az utols elem ".."
	inc	d			; D=2
	call	LC882			; DE' ltal mutatott karakter nagybetv vagy '\' jell  alaktsa
	jr	z,LC7E5			; ugrs, ha vge a stringnek (j)
	call	LC855			; A reg. tartalma specilis karakter? 
	jr	nz,LC7F2		; ugrs, ha nem
	cp	02Eh			; '.' vizsglata #3
	jr	z,LC7F2			; ugrs, ha '.'
LC7E2:	call	LC89C			; DE' cskkentse eggyel
LC7E5:	ld	(hl),02Eh		; '.' karakterek rsa a kimenti pufferbe
	inc	hl
	dec	c
	dec	d			; "." vagy ".." D reg. rtknek megfelelen
	jr	nz,LC7E5
	ld	a,b			; visszatrsi jelzbitek belltsa: 0.=1  3.=1  6.=1
	or	049h
	ld	b,a
	jr	LC7FB
LC7F2:	call	LC89C			; DE' cskkentse eggyel
LC7F5:	call	LC89C			; DE' cskkentse eggyel
LC7F8:	call	LC89C			; DE' cskkentse eggyel
LC7FB:	call	LC814			; karakterlnc feldolgozsa
	dec	d			; D=1 ha volt feldolgozs
	jr	nz,LC803
	set	3,b			; visszatrsi jelzbit belltsa: 3.-fjlnv van az utols elemben
LC803:	cp	02Eh			; utols karakter = '.' ?
	jr	nz,LC80C		; ugrs, ha nem
	set	4,b			; visszatrsi jelzbit belltsa: 4.-fjlnv kiegszts van az utols elemben
	call	LC882			; DE' ltal mutatott karakter nagybetv vagy '\' jell  alaktsa
LC80C:	ld	c,003h			; mg 3 karaktert feldolgoz (fjlnv kiterjesztse)
	call	LC814			; karakterlnc feldolgozsa
	pop	hl
	pop	de
	ret


;
;
;	Karakterlnc feldolgozsa
;	- specilis karakter esetn vagy ha zr 00h bjtot tall (mieltt elri a feldolgozand hosszt)
;	  attl a pozcitl a kimeneti puffert SPACE-el tlti ki (a megadott hosszban)
;	- akkor tr vissza, ha elrte a karakterlncot zr 00h bjtot vagy specilis karaktert tallt
;	in:   B - visszatrsi jelzbitek
;	      C - feldolgozand hossz
;	     HL - kimeneti puffer kezdete
;	     DE'- feldolgozand karakterlnc
;	out:  A - utols feldolgozott karakter (00h vagy specilis karakter)
;	      B - visszatrsi jelzbitek
;	      C - C=0
;	      D - 0: nem volt feldolgozs   1: volt feldolgozott karakter
;	     HL - a kimenti puffer utols karaktere utni cmre mutat
;	     DE'- a bemeneti stringben a zr 00h karakterre vagy specilis karakter esetn a spec. karakterre mutat (pl. '\')
;
LC814:	ld	d,000h			; D=0 - jelzi, hogy mg egy karaktert sem dolgozott fel
LC816:	inc	c
LC817:	call	LC882			; DE' ltal mutatott karakter nagybetv vagy '\' jell  alaktsa
	jr	z,LC843			; ugrs, ha vge a stringnek, talaktott karakter A-ban
	call	LC855			; A reg. tartalma specilis karakter? 
	jr	z,LC840			; ugrs, ha igen
	cp	02Ah			; '*' - joker karakterek vizsglata
	jr	z,LC836
	cp	03Fh			; '?'
	jr	nz,LC82B
LC829:	set	5,b			; visszatrsi jelzbitek lltsa
LC82B:	set	0,b
	ld	d,001h			; D=1 - legalbb mr 1 karaktert feldolgozott
	dec	c
	jr	z,LC816			; nincs msols, ha a megadott karakterszmot mr elrte
	ld	(hl),a			; karakter tmsolsa a kimeneti pufferbe
	inc	hl
	jr	LC817			; ismtls
;
LC836:	ld	a,c			; htralv helyek feltltse '?'-el
LC837:	ld	c,a
	dec	a
	jr	z,LC829
	ld	(hl),03Fh		; '?' karakter bersa
	inc	hl
	jr	LC837
;
LC840:	call	LC89C			; DE' cskkentse eggyel
LC843:	dec	c			; htralv helyek feltltse SPACE-el
	ret	z			; visszatrs, ha ksz
	ld	(hl),020h
	inc	hl
	jr	LC843


;
;
;	Megvizsglja, hogy A reg. tartalma 'A'..'Z' tartomnyban van-e?
;	in:   A - vizsgland karakter
;	out: ZF - 0: nincs a tartomnyban  1: a tartomnyban van
;
LC84A:	cp	041h			; 'A' bet
	ret	c			; visszatr, ha kisebb, ZF=0
	cp	05Bh
	jr	nc,LC853		; ugrs, ha nagyobb 'Z'-nl
	cp	a			; ZF=1
	ret
LC853:	or	a			; ZF=0
	ret


;
;
;	Megvizsglja, hogy A reg. tartalma specilis karakter-e?
;	in:   A - vizsgland karakter
;	out: ZF - 0: nem specilis  1: specilis karakter
;
LC855:	cp	020h			; SPACE
	jr	nc,LC85B		; ugrs, ha A reg.> 20h
	cp	a			; ZF=0 - nem specilis karakter
	ret
LC85B:	push	hl
	push	bc
	ld	bc,00013h		; 19 specilis karaktert vizsgl t
	jr	LC867
	push	hl			; nem hasznlt belpsi pont (?)
	push	bc
	ld	bc,00002h
LC867:	ld	hl,LC86F
	cpir				; sszehasonlts, amg nem tall A-val megegyez karaktert
	pop	bc
	pop	hl
	ret				; ZF=1 ha specilis karakter
;
LC86F:					; specilis karakterek tblzata
	.db	20h,09h,3Ah,3Bh		; SPACE TAB ':' ';'
	.db	2Eh,2Ch,3Dh,2Bh		; '.' ',' '=' '+'
	.db	23h,5Ch,21h,27h		; '#' '\' '!' '''
	.db	3Ch,3Eh,7Ch,2Fh		; '<' '>' '|' '/'
	.db	22h,5Bh,5Dh		; '"' '[' ']'


;
;
;	DE' mutatta karaktert nagybetv, vagy a "!" s "'" jeleket "\"-r alakt rutin
;	in:  DE'- az talaktand karakterre mutat
;	out: ZF - 1 ha a mutatott karakter 00h volt	
;
LC882:	exx
	ld	a,(de)
	or	a			; eredmny az A regiszterben
	jr	z,LC89A			; ugrs, ha A=0
	inc	de
	bit	1,c			; C=fjlnv flag, 1.bit->rejtett fjl
	jr	nz,LC89A		; ugrs, ha rejtett
	call	LCFEC			; nagybetv alakts
	cp	021h			; '!' bet
	jr	z,LC897
	cp	027h			; ''' bet
	jr	nz,LC899
LC897:	ld	a,05Ch			; ezeket '\' jell alaktja
LC899:	or	a			; CY trlse, ZF A reg. rtkt tkrzi
LC89A:	exx
	ret


;
; 	DE' cskkentse eggyel
;
LC89C:	exx
	dec	de
	exx
	ret


;
;
;	Meghajt tblzat aktulis tvonalnak megfelel knyvtr belltsa
;	in:   B - visszatrsi jelzbitek (az eddigi elemzsek eredmnyei)
;	     HL - a fizikai meghajt tblzatra mutat
;	      C'- bels flag-ek
;	     IX - FCB-re mutat
;	out:  A - hibakd
;	     HL - megrzdik
;	     BC',DE',IX - megrzdik
;
LC8A0:	push	hl			; HL mentse
	bit	1,b
	jr	nz,LC8E9		; ugrs, ha nem volt knyvtr-tvonal megadva (->fknyvtr)
	ld	de,0001Eh		; DE= eltolsi rtk a meghajt tblzatban
	add	hl,de			; HL a kvnt elemre mutat
	ld	e,(hl)
	inc	hl
	ld	d,(hl)			; DE= aktulis knyvtr klasztere
	bit	7,d
	jr	nz,LC8E9		; ugrs ha fknyvtr
	ld	a,d
	or	e			; DE vizsglata -> ZF=1 ha DE=0000h
	ex	(sp),hl			; HL ismt a meghajt tblzat elejre mutat, az elz cm a verembe
	exx
	pop	hl			; meghajt tblzatbeli cm HL'-be
	push	hl			; majd jra a verembe
	push	bc			; tbbi regiszter mentse
	push	de
	inc	hl
	ex	de,hl			; DE' a meghajt tblzatban az aktulis tvonal stringre mutat
	set	7,c			; C' reg. 7. bitje=1
	jr	z,LC8C0			; ugrs, ha az aktulis knyvtr klasztere = 0000h
	res	7,c			; egybknt C' reg. 7. bitje=0
LC8C0:	exx
	push	bc			; BC mentse a verembe
	push	de
	call	LC8E8			; kiindulsknt a fknyvtr belltsa
	pop	de
LC8C7:	call	LC7AD			; 8+3 karakter formtum fjlnv feldolgozsa (a bels nvpufferbe kerl)
	call	LC91D			; belps a bels nvpufferben adott alknyvtrba, aktulis tvonalnv string frisstse
	or	a
	jr	nz,LC8D6		; ugrs, ha hiba trtnt (ekkor a fknyvtrra tr vissza)
	call	LC882			; DE' ltal mutatott karakter nagybetv vagy '\' jell  alaktsa
	jr	nz,LC8C7		; ismtls, ha nem zr karakter volt
	.db	0C2h			; a kvetkez bjtokkal: jp nz,LFF16 - elfedi ld d,0FFh-t
LC8D6:	ld	d,0FFh			; D reg.  belltsa fknyvtr jelzsre
	pop	bc			; BC helyrelltsa
	exx
	pop	de			; DE' helyrelltsa
	pop	bc			; BC' helyrelltsa
	exx
	ex	(sp),hl			; meghajt tblzatbeli cm vissza HL-be, tblzat kezdcme a verembe
	ld	(hl),d			; aktulis knyvtr klaszternek belltsa a meghajt tblzatban
	dec	hl
	ld	(hl),e
	jr	z,LC8F8			; ugrs, ha nem trtnt hiba az tvonalnv feldolgozsa sorn
	inc	hl
	inc	hl
	ld	(hl),000h		; egybknt res stringet llt be a meghajt aktulis tvonalnak (fknyvtr)
	pop	hl			; HL a fizikai meghajt tblzatra mutat
LC8E8:	push	hl
LC8E9:	exx
	push	de			; DE' mentse
	ld	hl,0D4EBh
	ld	(hl),03Ah		; ':' karakter bersa HL' mutatta cmre (puffer vge jelzs)
	ld	de,0FFBFh		; DE'= -65
	add	hl,de			; HL'= 0D4AAh
	pop	de			; DE' visszalltsa
	exx
LC8F6:	ld	d,0FFh			; D= 0FFh -> fknyvtr jelzse
LC8F8:	ld	(0D06Fh),de		; aktulis knyvtr klasztersorszmnak belltsa
	exx
	bit	2,c			; bels flag-ek vizsglata
	exx
	jr	z,LC90E			; ugrs, ha C' 2.bitje nulla
	ld	hl,(0D09Dh)		; HL= thelyezend alknyvtr els klasztersorszma
	or	a
	sbc	hl,de
	jr	nz,LC90E		; ugrs, ha nem egyenlek
	set	6,(iy+01Ch)
LC90E:	xor	a			; hibajelzs trlse
	pop	hl			; HL a fizikai meghajt tblzatra mutat
	ret


;
;
;	Belps a bels nvpufferben adott alknyvtrba,
;	s az aktulis tvonalnv string frisstse ennek megfelelen
;	- "."-nl az tvonalstring nem vltozik, ".."-nl egy knyvtrnvvel visszalpteti
;	  majd az adott specilis alknyvtr bejegyzst keresi ki s azok kezd klasztert lltja be (mint brmely ms alknyvtr esetn)
;	- LC911-nl belpve ha C' 7.bitje =0, akkor nem csinl semmit (csak DE'-t menti a RAM vltozba)
;	in:   B - visszatrsi jelzbitek
;	     HL - a fizikai meghajt tblzatra mutat
;	      C'- bels flag-ek
;	     DE'- tvonalnv pozci (csak LC911-nl belpve)
;	     HL'- aktulis tvonalnv string jelenlegi vge
;	out:  A - hibakd
;	      B - visszatrsi jelzbitek
;	     DE - megrzdik, ha C' 7.bitje nulla (ilyenkor csak az tvonalnv stringet mdostja)
;	     HL - megrzdik
;	     BC',DE' - megrzdik
;	     HL'- tvonalnv string puffer frisstett pozcija (utols utni karakter cme)
;
LC911:	xor	a			; hibajelzs trlse
	set	1,b			; volt specifiklt knyvtr tvonal jelzse
	exx
	bit	7,c			; bels flag ellenrzse
	ld	(0D09Ah),de		; DE' mentse
	exx
	ret	z			; visszatrs, ha C' 7.bitje nulla
LC91D:	push	de			; DE mentse
	ld	de,0D49Eh		; DE= bels nvpuffer cme (11 bjt)
	ld	a,b			; visszatrsi jelzbitek A reg.-be
	exx
	push	bc
	push	de
	ex	de,hl			; DE'= tvonalnv string puffer aktulis pozcija (els res karakter)
	ld	c,a			; visszatrsi jelzbitek C' reg.-be
	bit	6,c
	jr	z,LC940			; ugrs, ha az tvonalnv utols eleme nem "." vagy ".."
	bit	7,c
	jr	z,LC959			; ugrs, ha az tvonalnv utols eleme "."
LC92F:	dec	de			; tvonalnv string pozci tlltsa az elz knyvtr neve utni els karakterre
	ld	a,(de)			; elz karakter vizsglata
	cp	05Ch			; '\' jel?
	jr	z,LC959			; ugrs, ha igen
	or	a
	jr	nz,LC92F		; ismtls, amg rvnyes karaktert tall
LC938:	ex	de,hl
	pop	de
	pop	bc
LC93B:	ld	a,0AAh			; hibakd: .IPATH - rvnytelen tvonalnv (pl. tl hossz)
	exx
	pop	de
	ret
;
LC940:	exx
	push	de			; DE a verembe (nvpuffer cme)
	exx
	pop	hl			; HL'= bels nvpuffer cme (11 bjt)
	ld	b,009h			; 8+1 karakter msolsa (az els a '\' lesz)
	ld	a,05Ch			; A reg.-be a kezd karakter: '\'
	call	LC99B			; fjlnv tmsolsa az aktulis tvonalnv stringbe
	jr	z,LC938			; ugrs, ha elrte a puffer vgt (hiba: tl hossz tvonalnv)
	bit	4,c			; visszatrsi jelzbitek vizsglata
	ld	a,02Eh			; A reg.-be a kezd karakter: '.'
	ld	b,004h			; 3 karakteres fjlnvkiterjeszts +1 a kezd karakter
	call	nz,LC99B		; fjlnvkiterjeszts tmsolsa az aktulis tvonalnv stringbe, ha van
	or	a			; A reg. ellenrzse
	jr	z,LC938			; ugrs, ha elrte a puffer vgt (hiba: tl hossz tvonalnv)
LC959:	ex	de,hl			; HL'= tvonalnv string puffer aktulis pozcija
	ld	a,c			; visszatrsi jelzbitek A reg.-be
	pop	de			; DE' a meghajt tblzat aktulis tvonal stringjben a mr feldolgozott rsz utnra mutat
	pop	bc			; C'= bels flag-ek
	and	028h			; visszatrsi jelzbitek maszkolsa
	sub	008h			; fjlnv van az utols elemben ?
	jr	nz,LC93B		; ugrs (hiba), ha nem fjlnv van az utols elemben vagy szerepelnek joker karakterek (?,*)
	bit	7,c			; bels flag-ek vizsglata
	exx
	pop	de			; DE-be a belpskori rtke
	ret	z			; visszatrs, ha C' 7.bitje nulla
	call	LC9DE			; els knyvtrbejegyzs kikeresse
LC96B:	jr	z,LC982			; ugrs, ha res knyvtrbejegyzs
	push	hl			; regiszterek mentse
	push	bc
	ld	hl,0D49Eh		; HL= bels nv puffer (11 bjt)
	call	LC9A5			; knyvtrbejegyzs fjlnevnek sszehasonltsa a keressi fjlnvvel
	pop	bc			; elmentett rtkek visszalltsa
	pop	hl
	jr	nc,LC97D		; ugrs, ha nem egyezik meg a keresett fjlnvvel
	bit	4,a			; bejegyzs attribtum bjtjnak vizsglata
	jr	nz,LC985		; ugrs, ha alknyvtrt tallt
LC97D:	call	LCA04			; knyvtr kvetkez bejegyzsnek kikeresse
	jr	nc,LC96B		; ugrs, ha mg nem rte el a knyvtr vgt
LC982:	ld	a,0A0h			; hibakd A reg.-be: .NODIR - a knyvtr nem tallhat
	ret


;
;
;	Belps az aktulis bejegyzs ltal mutatott knyvtrba
;	in:  DE - a knyvtrt tartalmaz bejegyzsre mutat
;	      C'- bels flag-ek
;	out:  A - hibajelzs (0)
;	     DE - els klaszter sorszma
;	     BC,HL - megrzdik
;
LC985:	push	hl			; HL mentse
	ld	hl,0001Ah
	add	hl,de			; HL az els klaszter cmre mutat a knyvtrbejegyzsben
	ld	e,(hl)
	inc	hl
	ld	d,(hl)			; DE= els klaszter sorszma
	ld	a,d			; DE ellenrzse
	or	e
	jp	nz,LC8F8		; ugrs az aktulis knyvtr belltsra, ha DE nem nulla
	jp	LC8F6			; egybknt a fknyvtrt lltja be aktulisnak


;
;
;	Fjlnv tmsolsa az aktulis tvonalnv stringbe
;	(SPACE karaktereket kihagyja)	
;	in:   A - kezd karakter (ha belps LC99B cmen, pl. '\')
;	      B - tvonalnv stringbe msoland karakterek szma
;	     DE - tvonalnv string puffer aktulis pozcijra mutat
;	     HL - forrs nvpuffer cme
;	out:  A - A=00h ha elrte a puffer vgt
;	     HL - forrs nvpuffer aktulis pozcijra mutat
;	     DE - tvonalnv string puffer aktulis pozcijra mutat
;	     ZF - ZF=1  ha elrte a puffer vgt
;
LC995:	ld	a,(hl)			; kvetkez msoland karakter A reg.-be
	inc	hl
	cp	020h			; a SPACE karaktereket nem msolja t
	jr	z,LC9A1			; ugrs, ha SPACE
LC99B:	ld	(de),a			; karakter msolsa az aktulis tvonal stringbe
	inc	de
	ld	a,(de)			; a kvetkez karakter vizsglata a clpufferben
	sub	03Ah			; a puffer vgt ':' karakter jelzi
	ret	z			; visszatrs, ha A reg.-ben ':' volt
LC9A1:	djnz	LC995
	or	a
	ret


;
;
;	Knyvtrbejegyzs fjlnevnek sszehasonltsa a keressi fjlnvvel
;	in:  DE - knyvtr-bejegyzs kezdcme
;	     HL - bels nv puffer (11 bjt)
;	     IX - FCB-re mutat
;	out:  A - bejegyzs attribtum bjtja CY=1 esetn
;	     DE - megrzdik
;	     CY - CY=1 ha megfelel a keressi fjlnvnek
;	     ZF - ZF=1 res vagy trlt bejegyzs, ha CY=0
;
LC9A5:	ld	a,(de)			; A reg. = bejegyzs els bjtja
	or	a
	ret	z			; visszatrs, ha res bejegyzs
	cp	0E5h			; trltsg jelzs ellenrzse
	ret	z			; visszatrs, ha trlt bejegyzs
	push	de			; bejegyzs kezdcme a verembe
	cp	005h			; 05h az els karakter ?
	jr	nz,LC9B2		; ugrs, ha nem
	ld	a,0E5h			; egybknt trs a helyes rtkre
LC9B2:	ld	c,(ix+006h)		; C= attribtum bjt
	ld	b,00Bh			; 11 karaktert hasonlt ssze
LC9B7:	bit	3,c			; ktetnv bit ellenrzse
	jr	nz,LC9CC		; ugrs, ha ktetnv
	push	de
	call	LCFEC			; kisbetbl nagybetv alakts
	ld	e,a			; talaktott karakter E-be
	ld	a,(hl)			; A reg.-be a kvetkez karakter a nv pufferbl
	call	LCFEC			; kisbetbl nagybetv alakts
	cp	e			; karakterek sszehasonltsa
	pop	de
	jr	z,LC9CC			; ugrs, ha megegyeznek
	sub	03Fh			; A reg. = '?' (joker karakter)
	jr	nz,LC9DB		; ugrs, ha nem -> nem egyeznek meg
LC9CC:	inc	hl			; mutatk kvetkez karakterre lltsa
	inc	de
	ld	a,(de)			; A reg.= knyvtrbejegyzs kvetkez karaktere
	djnz	LC9B7			; ismtls mind a 11 karakterre
	ex	de,hl			; HL= attribtum bjt cme a knyvtrbejegyzsben
	ld	a,c			; C= attribtum bjt az FCB-bl
	xor	(hl)			; az azonos bitek nullk lesznek
	and	008h
	jr	nz,LC9DB		; ugrs, ha a ktetnv bit nem a vrt rtk volt
	ld	a,(hl)			; bejegyzs attribtum bjtja A reg.-be
	scf				; CY=1
	.db	06h			; a kvetkez bjttal: ld b,0B7h (elfedi or a -t)
LC9DB:	or	a			; CY=0
	pop	de			; DE= bejegyzs kezdcme a verembl
	ret


;
;
;	Els knyvtrbejegyzs kikeresse
;	in:  HL - a fizikai meghajt tblzatra mutat
;	out:  A - a knyvtrbejegyzs els bjtja
;	     BC - megrzdik
;	     DE - a keresett knyvtr-bejegyzs kezdcme
;	     HL - megrzdik
;	     ZF - ZF=1 ha a knyvtrbejegyzs res (els bjtja 00h)
;
LC9DE:	ld	de,(0D06Fh)		; DE= aktulis (al)knyvtr klasztersorszma
	bit	7,d
	jr	z,LCA3E			; ugrs, ha nem fknyvtr
	push	bc
	push	hl			; tblzat kezdcme a verembe
	ld	bc,0000Fh		; BC= eltolsi rtk
	add	hl,bc			; HL= meghajt tblzaton belli cm
	ld	c,(hl)			; C= szabad bejegyzsek szma az utols (hasznlt fknyvtri) szektorban
	inc	hl
	ld	a,(hl)			; A= fknyvtr szektorainak szma
	inc	hl
	inc	hl
	ld	e,(hl)
	inc	hl
	ld	d,(hl)			; DE= fknyvtr kezd szektora
	pop	hl			; tblzat kezdcme vissza
	ld	b,0FFh			; BC az j rtkkel tbbszrsen a verembe
	push	bc
	push	bc
	jr	LCA58			; ugrs a folytatsra


;
;
;	Knyvtr aktulis (legutoljra hasznlt) bejegyzsnek kikeresse
;	/megj.: (iy+022h) 2.bit=1 -nek kell lennie, hogy jra beolvassa a knyvtrszektort/
;	in:  DE - aktulis knyvtr-bejegyzs (felttelezett)kezdcme
;	     HL - a fizikai meghajt tblzatra mutat
;	out: BC - megrzdik
;	     DE - knyvtr-bejegyzs kezdcme
;	     HL - megrzdik
;	     CY - CY=1 elrte a knyvtr vgt
;	     ZF - ZF=1 ha a knyvtrbejegyzs res (els bjtja 00h)
;
LC9FB:	inc	(iy-008h)		; 0D078h cm nvelse: htralv bejegyzsek az aktulis knyvtrszektorban
	push	bc			; BC mentse
	ld	bc,00000h		; BC= eltolsi rtk (0000h-> a DE-ben kijellt bejegyzst adja vissza, ha a szektorbufferek rendben vannak)
	jr	LCA08			; ugrs a folytatshoz


;
;
;	Knyvtr kvetkez bejegyzsnek kikeresse
;	- szksg esetn beolvassa a knyvtr kvetkez szektort:
;	    alknyvtr esetn ez jelentheti az aktulis klaszteren belli kvetkez szektort, vagy ha kell veszi a kvetkez klasztert
;	    fknyvtr esetn vgigmegy a fknyvtr szektorain, az utols szektorbl csak a megengedett szm bejegyzst hasznlja
;	in:  DE - aktulis knyvtr-bejegyzs kezdcme
;	     HL - a fizikai meghajt tblzatra mutat
;	out: BC - megrzdik
;	     DE - a kvetkez knyvtr-bejegyzs kezdcme
;	     HL - megrzdik
;	     CY - CY=1 elrte a knyvtr vgt
;	     ZF - ZF=1 ha a knyvtrbejegyzs res (els bjtja 00h)
;
LCA04:	push	bc			; BC mentse
	ld	bc,00020h		; BC= egy bejegyzs hossza (32 bjt)
LCA08:	push	hl
	ex	de,hl
	add	hl,bc			; HL a kvetkez knyvtrbejegyzsre mutat
	ld	de,(0D075h)		; DE= knyvtr aktulis szektora
	ld	a,(0D078h)		; A= htralv bejegyzsek a knyvtrszektorban
	dec	a
	jr	z,LCA1E			; ugrs, ha ez volt az utols bejegyzs
	bit	2,(iy+022h)
	jp	z,LCA9D			; ugrs, ha a megfelel knyvtrszektor van a szektorbufferben s DE rtke helyes
	jr	LCA7D			; egybknt jra beolvassa az aktulis szektort
;
LCA1E:	ex	(sp),ix			; IX a fizikai meghajt tblzatra mutat, rgi rtke a verembe
	call	LC3A4			; DE-ben adott szektor beolvassa szektorbufferbe (B=0 -> ha nincs beolvasva szektorbufferbe, csak egy "res" buffert ad vissza)
	call	LC2EB			; HL-ben adott szektorbuffert belltja els szektorbuffernek
	ex	(sp),ix			; IX helyrelltsa
	pop	hl			; meghajt tblzat cme jra HL-ben
	inc	de			; szektorsorszm nvelse
	ld	a,(0D077h)		; A= htralv szektorok szma
	dec	a
	jr	nz,LCA65		; ugrs, ha mg van htra knyvtrszektor
	cp	(iy-006h)		; ha fknyvtr, akkor az utols szektorban lv bejegyzsek szma
	jr	nz,LCA67		; ugrs, ha vannak bejegyzsek
	ld	de,(0D073h)		; DE= kvetkez klaszter (alknyvtr esetn)
	bit	7,d			; ZF=1 ha van mg (al)knyvtr klaszter htra
	scf				; CY=1 visszatrs esetn a knyvtr vgt jelzi majd
	pop	bc			; BC belpskori rtknek visszalltsa
	ret	nz			; visszatrs, ha fknyvtr vagy az alknyvtr utols klasztere volt
;
LCA3E:	push	bc			; visszatrsi jelzbitek a verembe
	push	de			; klasztersorszm a verembe
	call	LC4C8			; adott klaszterhez tartoz FAT bejegyzs kiolvassa
	ld	b,d			; BC= kiolvasott rtk
	ld	c,e
	pop	de			; DE= kiindul klaszter a verembl
	push	de
	xor	a			; A= klaszteren belli szektorsorszm (0)
	call	LC4F1			; abszolt szektorcm kiszmtsa a klaszter sorszmbl
	push	de			; szektorcm a verembe
	ex	de,hl			; DE= meghajt tblzat kezdcme
	ld	hl,0000Ah		; eltols a meghajt tblzaton bell
	add	hl,de
	ld	a,(hl)			; A reg. = klaszterenknti szektorszm - 1
	inc	a
	ex	de,hl			; HL= meghajt tblzat kezdcme
	pop	de			; DE= szektorcm a verembl
	push	bc			; BC= kvetkez klaszter
	ld	c,000h
LCA58:	ld	(iy-006h),c		; C= szabad bejegyzsek szma az utols (hasznlt fknyvtri) szektorban
	pop	bc			; B= 0FFh C= szabad bejegyzsek
	ld	(0D073h),bc
LCA60:	pop	bc			; B= 0FFh C= szabad bejegyzsek / szlknyvtr klasztersorszma (?)
	ld	(0D071h),bc		; elmenti a RAM-ba
LCA65:	ld	b,010h			; B= 16 bejegyzs lehet egy knyvtrszektorban
LCA67:	or	a
	jr	nz,LCA71		; ugrs, ha nem az utols knyvtrszektornl jr
	ld	b,(iy-006h)		; B= az utols knyvtrszektorban lv bejegyzsek szma
	ld	(0D07Ah),a		; RAM vltoz trlse (A=00h)
	inc	a			; A reg. = 01h
LCA71:	ld	(0D077h),a		; htralv szektorok szmnak mentse
	ld	(0D075h),de		; knyvtr aktulis szektor sorszmnak mentse
	ld	(iy-007h),b		; bejegyzsek szmnak mentse
	ld	a,b
	push	hl			; meghajt tblzat kezdcme a verembe
LCA7D:	ex	(sp),ix			; IX a meghajt tblzat cme, rgi rtke a verembe
	push	af
	ld	b,001h			; B= 1 - ha nem tallja a bufferekben tltse be a lemezrl
	call	LC3A4			; DE-ben adott szektor beolvassa bufferbe
	pop	bc
	ex	(sp),ix			; IX visszalltsa
	ld	de,0FFEBh		; DE= -015h
	add	hl,de			; HL= szektorbuffer kezdcm - 015h
	ld	a,(0D079h)		; A= sszes bejegyzs
	inc	a
	sub	b			; A= aktulis bejegyzs sorszma +1
	ld	de,00020h		; DE= egy knyvtrbejegyzs hossza (32 bjt)
LCA94:	add	hl,de			; HL= szektorbuffer adatterlet kezdcme + ((A reg.-1) * 020h) 
	dec	a
	jr	nz,LCA94		; ismtls a kvnt bejegyzsig
	ld	a,b			; A= htralv knyvtrbejegyzsek az aktulis szektorban
	res	2,(iy+022h)		; DE rtke helyes s a knyvtrszektoron bellre mutat jelzs
LCA9D:	ld	(0D078h),a		; htralv knyvtrbejegyzsek szmnak mentse
	ex	de,hl			; DE= a keresett knyvtr-bejegyzs kezdcme (a szektorbufferben)
	pop	hl			; HL= meghajt tblzat kezdcme
	pop	bc			; BC= belpskori rtk
	ld	a,(de)			; knyvtrbejegyzs els bjtja A reg.-be
	or	a			; ZF belltsa A reg. szerint
	ret


;
;
;	Hibakezel rutin (hibazenet megjelentse, felhasznli beavatkozsra vrakozs)(pdf - 91. oldal)
;	in:   A - hibakd (ld. pdf dokumentci 120. oldal)
;	     HL - meghajt tblzat cme
;	out:  A - felhasznl ltal vlasztott hibakezelsi md sorszma (0 - retry, 1 - ignore)
;	     ZF - ZF=1 - retry
;
LCAA6:	scf
	.db	30h			; a kvetkez bjttal: JR NC,LCA60  -> elfedi OR A -t
LCAA8:	or	a			; itt belpve nullzza CY-t -> lehet IGNORE
LCAA9:	push	hl
	push	de
	push	bc
	push	ix
	ld	b,a			; A reg. mentse
	sbc	a,a			; A= 0FFh, ha LCAA6-nl lp be
	ld	(0D06Dh),a		; IGNORE vlasz felajnlsnak lehetsge: 0 - lehet 0FFh - nem lehet
	ld	de,00008h
	add	hl,de			; HL= meghajt tblzat cme + 8
	ld	c,(hl)
	inc	hl
	ld	a,(hl)			; meghajt tblzat + 9
	or	a
	jr	z,LCABF
	ld	(hl),001h
LCABF:	ld	a,b			; A reg. belpsi rtknek visszalltsa
	cp	0F5h			; bejv hibakd: .STOP - CTRL-ESC-t nyomtak
	jr	z,LCAE0			; ugrs, ha "stop" llapot van (kilpes "abort" hibval)
	cp	0AFh			; bejv hibakd: .NOUPB
	ld	a,002h			; ezt "retry"-al prblja javtani
	jr	z,LCAE2			; visszatrs a hv rutinhoz
	push	bc			; BC veremre mentse
	ld	hl,(0DFF8h)		; HL = kls hibakezel fggvny cme
	ld	a,h
	or	l
	jr	z,LCAD7			; ugrs, ha HL=0000h
	call	LDB2E			; 0. lapon lv rutin hvsa (cm: 0CDDCh) 
;
	.dw	0CDDCh			; a 0. lapon HL ltal mutatott cmre ugrik, eltte teszteli XD06D adatt
;
LCAD7:	pop	hl			; H= hibakd L= fizikai meghajt sorszma
	or	a			; ha nincs kls hibakezel fggvny, vagy van s A=0-val trt vissza
	call	z,LCB01			; hiba szvegnek kirsa, vrakozs a felhasznli beavatkozsra
	cp	004h			; A reg. < 3 ?
	jr	c,LCAE2			; ugrs, ha megfelel hibakezelsi kd rkezett
LCAE0:	ld	a,001h			; ismeretlen kd esetn "abort"-ot llt be
LCAE2:	pop	ix
	pop	bc
	pop	de
	dec	a
	jr	z,LCAEC			; ugrs, ha "abort"-ot vlasztott a felhasznl
	pop	hl
	dec	a			; A reg. rtke 0 (retry) vagy 1 (ignore)
	ret
;
LCAEC:	ld	(iy-05Ah),h		; ABB_ERR vltoz belltsa
	pop	hl
	call	LC46D
	ld	a,0ADh			; hibakd: .ABORT - "Disk operation aborted"
	ld	hl,00000h		; HL = 0
	ld	b,h			; BC = 0
	ld	c,l
	ld	d,h			; DE = 0
	ld	e,l
	call	LDB2E			; 0. lapon lv rutin hvsa (cm: 0CD78h)
;
	.dw	0CD78h			; FISH funkci vgrehajtsbl val kilps (mr nem tr ide vissza)


;
;
;	Hibazenet kirsa a kpernyre, felhasznli beavatkozs krse
;	in:  H - hibakd (ld. pdf dokumentci 120. oldal)
;	out: A - felhasznl ltal vlasztott hibakezelsi md sorszma (1,2,3 - abort, retry, ignore)
;
LCB01:	call	LCBC6			; soremels a kpernyn
	ld	a,h			; A= belpsi rtk
	cp	0B2h
	ld	a,008h			; A reg.-be szvegazonost: "Insert disk for",00h
	jr	z,LCB24			; ugrs, ha A= 0B2h funkci feldolgozsa (lemezbehelyezs krse)
	ld	a,h
	ld	de,0D42Dh		; DE= default cm, ha nem szerepel a keresett szveg a tbzatban
	call	LCFD5			; adott azonostszm szveg kezdcmnek kikeresse
	jr	nc,LCB1E		; ugrs, ha megtallta a szveget
	ld	a,00Ah			; "Error ",00h
	call	LCBEC			; szvegkirs
	ld	a,h
	call	LCC0D			; A reg. szmrtknek kirsa a kpernyre
	scf				; CY belltsa a kvetkez szubrutinhvs tlpshez
LCB1E:	call	nc,LCBF2		; kezdcmmel adott szveg kirsa a kpernyre
	ld	a,001h			; " --",00h
	or	a			; ZF=0
LCB24:	push	af			; ZF mentse
	call	LCBEC			; szvegkirs
	ld	a,002h			; " drive ",00h
	call	LCBEC			; szvegkirs
	ld	a,l
	add	a,040h			; meghajt betjele: 'A'-1 + meghajt sorszma
	call	LCBCD			; karakter kirsa
	ld	a,03Ah			; ':'
	call	LCBCD			; karakter kirsa
	call	LCBC6			; soremels
LCB3B:	pop	af
	push	af
	ld	a,009h			; "Press RETURN to continue... ",00h
	jr	z,LCB4B			; ugrs, ha A=0B2h funkcit hajtja vgre
	ld	a,(0D06Dh)
	or	a
	ld	a,003h			; "Abort, Retry or Ignore (A/R/I)? ",00h
	jr	z,LCB4B
	ld	a,004h			; "Abort or Retry (A/R)? ",00h
LCB4B:	call	LCBEC			; szvegkirs
	call	LCB92			; egy karakter beolvassa a billentyzetrl, vrakozssal
	pop	bc			; verem tmeneti felszabadtsa (eredetileg AF rtke)
	ld	a,001h			; A= abort
	ret	nz			; visszatrs, ha hiba trtnt
	push	bc			; adat vissza a verembe
	ld	a,h			; A= beolvasott karakter
	cp	020h
	call	nc,LCBCD		; karakter kirsa a kpernyre, ha nem vezrlkarakter
	call	LCBC6			; soremels
	pop	af			; ZF visszatltse
	push	af
	jr	nz,LCB6C		; ugrs, ha nem A=0B2h funkcit hajtja vgre
	ld	a,h			; A= beolvasott karakter
	cp	00Dh
	jr	nz,LCB3B		; ugrs, ha nem RETURN-t nyomtak
	pop	af			; verem kitakartsa
	ld	a,002h			; A= retry
	ret
LCB6C:	ld	l,000h			; L jelzi, hogy melyik hibakezelst vlasztottk (abort/retry/ignore)
	ld	a,005h			; "Aa",00h
	call	LCB82			; H reg.-ben lv karakter keresse az adott azonostj szvegben
	ld	a,006h			; "Rr",00h
	call	nc,LCB82		; H reg.-ben lv karakter keresse, ha elzleg nem volt tallat
	ld	a,007h			; "Ii",00h
	call	nc,LCB82		; H reg.-ben lv karakter keresse, ha elzleg nem volt tallat
	jr	nc,LCB3B		; karakter bekrs megismtlse, ha nem a vrt karakterek kzl vlasztottak
	pop	af			; verem kitakartsa
	ld	a,l			; A= vlasztott hibakezels sorszma (1,2,3)
	ret


;
;
;	H reg.-ben lv karakter keresse az adott azonostj szvegben
;	in:   A - azonostszm
;	      H - keresett karakter
;	out:  L - L=L+1
;	     CY - 0: nincs tallat  1: van tallat
;
LCB82:	inc	l
	ld	de,0D42Dh		; DE= default cm, ha nem szerepel a keresett szveg a tbzatban
	call	LCFD5			; adott azonostszm szveg kezdcmnek kikeresse
LCB89:	ld	a,(de)
	or	a
	ret	z			; visszatrs, ha a szveg vgre rt
	inc	de
	cp	h
	jr	nz,LCB89		; ismtls, amg H-ban adott karaktert meg nem tallta
	scf				; CY jelzi a tallatot
	ret


;
;
;	Egy karakter beolvassa a billentyzetrl, kzben a kurzor villogtatsa
;	in:   -
;	out:  A - hibakd
;	      H - beolvasott karakterkd
;	     ZF - 0: nincs hiba  1: hiba trtnt
;
LCB92:	call	LDB2E			; 0. lapon lv rutin hvsa (cm: 0C767h)
;
	.dw	0C767h			; eredeti memrialapozs (P_SAVE) s INT vektor visszalltsa
;
	ld	h,07Fh			; ngyzetes kurzor karaktere
LCB99:	ld	c,h
	rst	30h			; funkcihvs
	.db	21h			; ED_CHOUT - karakterkiklds
	ld	c,013h			; kurzor pozci balra lptetse eggyel
	rst	30h			; funkcihvs
	.db	21h			; ED_CHOUT - karakterkiklds
	ld	de,00400h		; DE a vrakozsi idt szmolja (egy kurzor villans)
LCBA3:	push	de
	rst	30h			; funkcihvs
	.db	93h			; KBD_STATUS - billentyzetllapot olvass
	pop	de
	jr	nz,LCBC0		; ugrs, ha hiba trtnt
	or	c			; C-ben a billentyzetllapot jelz
	jr	nz,LCBB7		; ugrs, ha beolvashat a karakter
	dec	de			; szmll cskkentse
	ld	a,d
	or	e
	jr	nz,LCBA3		; ismtls amg DE nem nulla
LCBB1:	ld	a,h			; kurzor karakter megvltoztatsa: 07Fh vagy 020h
	xor	05Fh
	ld	h,a
	jr	LCB99			; jabb kurzorperidus szmllsa
;
LCBB7:	bit	6,h			; megvizsglja, milyen az aktulis kurzor karakter
	jr	nz,LCBB1		; ugrs, ha nem 020h (SPACE)
	rst	30h
	.db	91h			; KBD_CHIN - karakterbeolvass
	jr	nz,LCBC0		; ugrs, ha hiba trtnt
	ld	h,c			; H-ba a beolvasott karakter
LCBC0:	call	LDB2E			; 0. lapon lv rutin hvsa (cm: 0C741h)
;
	.dw	0C741h			; P_SAVE mentse a bels RAM-ba, INT vektor belltsa a floppy-ra
;
	ret


;
;
;	Soremels karakterek (0Dh,0Ah) kirsa a kpernyre
;	in:   -
;	out:  A = 0
;
LCBC6:	ld	a,00Dh
	call	LCBCD
	ld	a,00Ah

;
;
;	Egy karakter kirsa a kpernyre
;	in:   A - karakterkd
;	out:  A - hibakd (0)
;	     BC,DE - megrzdik
;
LCBCD:	push	de
	push	bc
	call	LDB2E			; 0. lapon lv rutin hvsa (cm: 0C767h)
;
	.dw	0C767h			; eredeti memrialapozs (P_SAVE) s INT vektor visszalltsa
;
	ld	c,a
	rst	30h			; funkcihvs
;
	.db	21h			; ED_CHOUT - karakterkiklds
;
LCBD7:	call	LDB2E			; 0. lapon lv rutin hvsa (cm: 0C741h)
;
	.dw	0C741h			; P_SAVE mentse a bels RAM-ba, INT vektor belltsa a floppy-ra
;
	pop	bc			; elmentett regiszterek visssza
	pop	de
	xor	a			; hibakd trlse
	ret


;
;
;	Egy karakter kirsa a nyomtatra (BASIC CLI hasznlja)
;	in:   A - karakterkd
;	out:  A - hibakd (0)
;	     BC,DE - megrzdik
;
LCBE0:	push	de
	push	bc
	call	LDB2E			; 0. lapon lv rutin hvsa (cm: 0C767h)
;
	.dw	0C767h			; eredeti memrialapozs (P_SAVE) s INT vektor visszalltsa
;
	ld	c,a
	rst	30h			; funkcihvs
;
	.db	041h			; PAR_CHOUT - karakterkiklds a nyomtatra
;
	jr	LCBD7


;
;
;	Adott azonostszm szveg kirsa a kpernyre
;	in:   A - azonostszm
;	out:  -
;
LCBEC:	ld	de,0D42Dh		; DE= default cm, ha nem szerepel a keresett szveg a tbzatban
	call	LCFD5			; adott azonostszm szveg kezdcmnek kikeresse


;
;	Kezdcmmel adott szveg kirsa a kpernyre
;	in:   DE - szveg kezdcme
;	out:  -
;
LCBF2:	ld	a,(de)			; aktulis karakter A reg.-be
	or	a
	ret	z			; visszatr, ha kirta a teljes szveget
	inc	de
	call	LCBCD			; egy karakter kirsa a kpernyre
	jr	LCBF2			; ismtls a szveg vgig


;
;
;	Kezdcmmel adott szveg karaktereinek tadsa egyesvel a CLI karakteres outputjnak
;	in:   A - azonostszm
;	out:  -
;
LCBFB:	ld	de,0D42Dh		; DE= default cm, ha nem szerepel a keresett szveg a tbzatban
	call	LCFD5			; adott azonostszm szveg kezdcmnek kikeresse
	ret	c			; visszatrs, ha nincs tallat
LCC02:	ld	a,(de)			; aktulis karakter A reg.-be
	or	a
	ret	z			; visszatr, ha a szveg vgre rt
	inc	de
	call	LDB2E			; 3. lapon lv rutin hvsa (cm: 0FCD8h)
;
	.dw	0FCD8h			; CLI karakteres output (callback fggvny)
;
	jr	LCC02			; ismtls a szveg vgig


;
;
;	A reg. kirsa a kpernyre 3-jegy decimlis egsz szmknt
;	in:  A - kirand rtk
;	out: -
;
LCC0D:	ld	bc,00064h		; 100-asok kirsa, ha nulla, akkor nem rja ki
	call	LCC1B			; oszt rutin
	ld	c,00Ah			; 10-esek kirsa, ha nulla, akkor nem rja ki
	call	LCC1B			; oszt rutin
	ld	bc,03001h		; 1-esek kirsa, akkor is ha nulla


;
;	A reg. osztsa C-vel, egsz rsz kirsa a kpernyre
;	in:  A - osztand
;	     B - alap ASCII karakter (pl. 30h; vagy 00h ha nem akarja kiratni a 0 eredmnyt)
;	     C - oszt
;	out: A - maradk
;
LCC1B:	ld	d,0FFh
LCC1D:	sub	c			; C reg. kivonsa A reg.-bl
	inc	d			; kzben D-ben szmolja a kivonsokat, ez CY-t nem vltoztatja
	jr	nc,LCC1D		; ismtls, amg A>=C
	ld	e,a			; E-ben az alulcsordult maradk
	ld	a,d			; A= az oszts egsz rsze
	jr	z,LCC27			; ugrs, ha az egsz rsz nulla
	ld	b,030h			; B= ASCII '0'
LCC27:	or	b			; ASCII szm kpzse az egsz rszbl
	call	nz,LCBCD		; karakter kirsa a kpernyre, ha nem nulla az eredmny
	ld	a,e
	add	a,c			; A reg. = maradk
	ret


;
;
;	Lenyomott billentyk beolvassa (BASIC CLI hasznlja)
;	megj.: kitakartja a billentyzet puffert (?)
;	in:  -
;	out:  A - hibakd (0)
;	     BC,DE - megrzdik
;
LCC2E:	push	de
	push	bc
	call	LDB2E			; 0.lapon lv rutin hvsa (cm: 0C767h)
;
	.dw	0C767h			; eredeti memrialapozs (P_SAVE) s INT vektor visszalltsa
;
LCC35:	rst	30h			; funkcihvs
;
	.db	093h			; KBD_STATUS - bill. llapot beolvassa
;
	or	c
	jr	z,LCBD7			; ugrs, ha nincs beolvasand karakter
	rst	30h			; funkcihvs
;
	.db	91h			; KBD_CHIN - karakter beolvassa
;
	jr	LCC35			; ugrs az ismtlsre


;
;
;	zenetek s szvegkonstansok
;	/ hossz, azonost, szveg, lezr nulla karakter /
;
LCC3E:	.db	09h,0BCh,"Not ready",00h
	.db	0Ch,0BAh,"Verify error",00h
	.db	0Ah,0B9h,"Data error",00h
	.db	10h,0B8h,"Sector not found",00h
	.db	14h,0B7h,"Write protected disk",00h
	.db	10h,0B6h,"Unformatted disk",00h
	.db	0Eh,0B5h,"Not a DOS disk",00h
	.db	11h,0B1h,"Incompatible disk",00h
	.db	03h,001h," --",00h
	.db	07h,002h," drive ",00h
	.db	20h,003h,"Abort, Retry or Ignore"
	.db	" (A/R/I)? ",00h				; az elz sor folytatsa
	.db	16h,004h,"Abort or Retry (A/R)? ",00h
	.db	02h,005h,"Aa",00h
	.db	02h,006h,"Rr",00h
	.db	02h,007h,"Ii",00h
	.db	0Fh,008h,"Insert disk for",00h
	.db	1Ch,009h,"Press RETURN to continue... ",00h
	.db	06h,00Ah,"Error ",00h
	.db	10h,0F5h,"CTRL-ESC pressed",00h
	.db	16h,0ADh,"Disk operation aborted",00h
	.db	14h,091h,"Unrecognised command",00h
	.db	0Eh,0A1h,"File not found",00h
	.db	13h,0A0h,"Directory not found",00h
	.db	0Dh,0ABh,"Invalid drive",00h
	.db	0Ch,097h,"Invalid date",00h
	.db	0Ch,096h,"Invalid time",00h
	.db	09h,0A3h,"Disk full",00h
	.db	11h,08Eh,"Invalid parameter",00h
	.db	1Ch,08Dh,"Invalid number of parameters",00h
	.db	13h,08Bh,"No VT-DOS cartridge",00h
	.db	1Ch,08Ah,"Cannot copy file onto itself",00h
	.db	0Eh,00Bh,"VT-DOS CLI 1.2",00h
	.db	02h,00Ch,"Yy",00h
	.db	02h,00Dh,"Nn",00h
	.db	04h,00Eh,"*** ",00h
	.db	10h,00Fh,"Current date is ",00h
	.db	0Eh,010h,"Enter new date",00h
	.db	03h,011h,"Mon",00h
	.db	03h,012h,"Tue",00h
	.db	03h,013h,"Wed",00h
	.db	03h,014h,"Thu",00h
	.db	03h,015h,"Fri",00h
	.db	03h,016h,"Sat",00h
	.db	03h,017h,"Sun",00h
	.db	17h,018h,"Erase all files (Y/N)? ",00h
	.db	0Dh,019h,"Directory of ",00h
	.db	05h,01Ah," byte",00h
	.db	04h,01Bh," in ",00h
	.db	05h,01Ch," file",00h
	.db	02h,01Dh,"  ",00h
	.db	04h,01Eh,"    ",00h
	.db	05h,01Fh," free",00h
	.db	14h,020h,"Enter VT-DOS (Y/N)? ",00h
	.db	10h,021h,"Destroy data on ",00h
	.db	08h,022h," (Y/N)? ",00h
	.db	27h,023h,"Press ESC to exit CLI.\r\n"
	.db	"Commands are:\r\n",00h				; az elz sor folytatsa
	.db	10h,024h,"Current time is ",00h
	.db	0Eh,025h,"Enter new time",00h
	.db	0Ah,026h,"Volume in ",00h
	.db	0Ch,027h," has no name",00h
	.db	04h,028h," is ",00h
	.db	0FFh


;
;	Adott azonostszm szveg kezdcmnek kikeresse
;	in:   A - azonostszm
;	out: DE - kezdcm
;	     CY - 1: nincs tallat
;
LCFD5:	push	hl
	push	bc
	ld	hl,LCC3E		; tblzat kezdete
	ld	bc,00000h
LCFDD:	add	hl,bc
	ld	c,(hl)			; els bjt a hossz
	inc	c
	scf
	jr	z,LCFE9			; ha C=0FFh, visszatr
	inc	hl
LCFE4:	cp	(hl)			; msodik bjt az azonostszm
	inc	hl
	jr	nz,LCFDD
LCFE8:	ex	de,hl			; cm DE-be
LCFE9:	pop	bc
	pop	hl
	ret


;
;	Kisbetbl nagybetv alakts
;	in:  A - talaktand karakter
;	out: A - nagybetv alaktott karakter
;
LCFEC:	cp	061h			; 'a' bet
	ret	c			; visszatr, ha kisebb
	cp	07Bh			; kisbetk fels hatra
	jr	c,LCFFC			; ugrs, ha kisbet ->talakts nagybetv
	cp	090h
	ret	c			; visszatr, ha 7Bh-nl nagyobb s 90h-nl kisebb
	cp	099h
	ret	nc			; vissaztr, ha 99h-nl nagyobb vagy egyenl
	sub	010h			; kezetes kisbetk nagybetv alaktsa
	ret
LCFFC:	sub	020h			; kezet nlkli kisbet talaktsa nagybetv
	ret


	.org	0CFFFh			; kitlts 0-val a 4kB-os ROM lap vgig
	.db	000h


.end
