;
;
;	VT-DOS kompatibilis floppy diszk illeszt ver.1.2
;
;	2. ROM lap: FISH funkcik, DISKIO, ISR frutin
;
;

;
;	RAM-ba msolt rutinok cmei (a fordthatsg miatt)
;
LDB2E	.equ	0DB2Eh




	.org	0C000h
;
	.db	"MOPS"
	.db	004h			; azonost nv hossza
	.db	"DISK"			; azonostnv
	.dw	0DB6Fh			; VT-DOS megszaktskiszolgl rutin cme
;
	.dw	00000h			; inicializl rutin cme
	.db	001h			; funkcik szma
	.dw	0DBC1h			; megszaktskiszolgl rutin cme



;
;
;	FISH 01h: tvonalnv-string elemzse
;
;	in:  C  - fjlnv flag: 0-fjlnv msolsa az FCB-be  1-fjlnv az tvonalban marad
;	     DE - az inicializland FCB
;	     HL - tvonalnv string
;	out: A  - llapotkd
;	     HL - j aktulis knyvtr string
;
LC010:	push	hl
	push	bc
	res	2,c			; C reg.-ben tovbbi bels flag-ek trlse
	res	7,c
	ex	de,hl			; DE= kielemezend string cme
	call	LDB2E			; 1.lapon lv rutin hvsa (cm: 0D6DDh)
;
	.dw	0D6DDh			; tvonalnv elemzse, valamint fjlnv vagy ktetnv tmsolsa a bels nvpufferbe
;
	pop	hl			; bemeneti BC rtk HL-be
	jr	nz,LC036		; ugrs, ha hiba trtnt
	bit	0,l			; fjlnevet t kell msolni az FCB-be?
	jr	nz,LC035		; ugrs, ha nem kell
	exx
	push	ix
	pop	hl			; FCB cme HL-be
	ld	bc,00008h
	add	hl,bc			; HL+8 cmre msol
	ex	de,hl
	ld	hl,0D49Eh		; bels nv puffer cme, ahol a feldolgozott fjlnv v. ktetnv tallhat
	ld	bc,0000Bh		; 11 karakter msolsa (8+3)
	ldir
	exx
LC035:	xor	a			; hibajelzsek trlse
LC036:	pop	hl			; HL= a bemeneti tvonalnv els karakterre mutat
	ret


;
;
;	FISH 02h : Knyvtr-vltoztats
;
;	in:  HL - tvonalnv string
;	out: A  - llapotkd
;	     HL - j aktulis knyvtr string
;
LC038:	ex	de,hl			; DE= kielemzend string cme
	xor	a			; A reg. = keressi attribtum (00h)
	ld	c,081h			; C= bels flag-ek: 7.bit =1 (ld. FISH 01h) 0.bit = 1 (fjlnv az tvonalban marad)
	call	LDB2E			; 1.lapon lv rutin hvsa (cm: 0D6D1h)
;
	.dw	0D6D1h			; tvonalnv elemzse, feldolgozsa
;
	ret	nz			; visszatrs, ha hiba trtnt
	or	c			; utoljra feldolgozott karakter
	ld	a,0AAh			; hibakd: .IPATH - "Invalid pathname string"
	ret	nz			; visszatrs, ha nem nullval vgzdtt az tvonal string
	ld	bc,0001Eh		; BC eltols a meghajt tblzatban
	add	hl,bc			; HL= az aktulis meghajt tblzatnak elemre mutat
	ld	de,(0D06Fh)		; DE= aktulis knyvtr klasztersorszma
	ld	(hl),e			; aktulis knyvtr klaszternek belltsa a meghajt tblzatban
	inc	hl
	ld	(hl),d
	inc	hl
	ex	de,hl			; DE= aktulis tvonal cme a meghajt tblzatban
	call	LC05C			; aktulis tvonalnv cmnek betltse HL-be
LC056:	ld	a,(hl)			; szveg msolsa a zr 00h bjtig
	ldi
	or	a
	jr	nz,LC056
LC05C:	ld	hl,0D4ABh		; HL= aktulis tvonalnv string puffer cme
	ret


;
;
;	FISH 03h: Aktulis knyvtr beolvassa
;
;	in:  B  - meghajt sorszma
;	out: A  - llapotkd
;	     HL - aktulis tvonal string
;
LC060:	ld	a,b
	call	LDB2E			; 0. lapon lv rutin hvsa (cm: 0C095h)
;
	.dw	0C095h			; logikai meghajt hozzrendelsi tblzatelemnek kiolvassa
;
	ld	b,a			; B = hozzrendelt fizikai meghajt
	or	a
	ld	a,0ABh			; hiba: .IDVR - nem ltez meghajt
	ret	z			; visszatrs, ha hiba volt
	xor	a			; A reg. = keressi attribtum (00h)
	ld	c,080h			; C= bels flag-ek: 7.bit =1 (->aktulis knyvtr aktivlsa)
	ld	de,0DB6Eh		; bemeneti res tvonalnv string kezdcme (egy nulla bjt a bels RAM-ban)
	call	LDB2E			; 1.lapon lv rutin hvsa (cm: 0D6D3h)
;
	.dw	0D6D3h			; tvonalnv elemzse, feldolgozsa (B reg.-ben megadott fizikai meghajtra)
;
	jr	LC05C			; ugrs a funkci befejezshez


;
;
;	FISH 07h: Knyvtr ltrehozsa
;
;	in:  BC - hely az FCB szmra (48 bjt)
;	     DE - hasznlatlan vagy meghatrozott FCB
;	     HL - tvonal-nv string vagy keressi FCB
;	     IX - FCB (u.a. mint DE (?))
;	out: A  - llapotkd
;	     BC - u.a. a cm meghatrozott FCB-vel
;	     DE - u.a. az FCB (aktualizlva)
;	     HL - teljes tvonal string
;
LC078:	bit	3,(ix+006h)		; FCB attribtum bjtjnak vizsglata
	ld	a,0A8h			; hibakd: .IATTR - rvnytelen fjl-attribtumok
	ret	nz			; visszatrs, ha ktetnv van megadva
	ld	a,010h			; A= vezrl flag-ek, a funkci folytatsa megegyezik a "fjl ltrehozsval"


;
;
;	FISH 06h: Fjl ltrehozsa
;
;	in:   A - vezrl flag-ek
;	     BC - hely az FCB szmra (48 bjt)
;	     DE - hasznlatlan vagy meghatrozott FCB
;	     HL - tvonal-nv string vagy keressi FCB
;	     IX - FCB (u.a. mint DE (?))
;	out: A  - llapotkd
;	     BC - u.a. a cm meghatrozott FCB-vel
;	     DE - u.a. az FCB (aktualizlva)
;	     HL - teljes tvonal string
;
LC081:	ex	af,af'			; A reg. mentse
	push	hl			; regiszterek mentse
	push	bc
	call	LC090			; FCB-ben lv fjlnv ellenrzse specilis knyvtrnvre
	pop	bc			; regiszterek vissza
	pop	hl
	call	nz,LC161		; ha nem specilis knyvtrnv, akkor az FCB-ben lv fjlnv rvnyessgnek ellenrzse
	ret	nz			; visszatrs, ha hiba trtnt (nem megengedett karakterek a fjlnvben)
	ex	af,af'			; A reg.= vezrl flag-ek
	jr	LC0AA			; funkci folytatsa az "els keresse" funkcinl (A reg. flag-jei hatrozzk meg a pontos mkdst)


;
;
;	FCB-ben lv fjlnv ellenrzse specilis knyvtrnvre
;	in:  DE - FCB-re mutat
;	out: ZF - ZF=1 ha "." vagy ".." knyvtrnv szerepel az FCB-ben
;
LC090:	ld	hl,00008h		; HL= eltolsi rtk
	add	hl,de			; HL a fjl nevre mutat az FCB-ben
	ld	a,02Eh			; A reg.= '.'
	cp	(hl)			; fjlnv els karakternek ellenrzse
	ret	nz			; visszatrs, ha nem '.'-al kezddik
	inc	hl			; HL a fjlnv kvetkez karakterre mutat
	cp	(hl)
	ld	a,020h			; A reg.= SPACE
	jr	z,LC0A0			; ugrs, ha a msodik karakter is '.'
	cp	(hl)
	ret	nz			; visszatrs, ha a msodik karakter nem SPACE
LC0A0:	ld	b,009h			; B= a fjlnv htralv karaktereinek szma (11-2=9)
LC0A2:	inc	hl			; kvetkez karakter vizsglata
	cp	(hl)
	ret	nz			; visszatrs, ha nem SPACE
	djnz	LC0A2			; ismtls az sszes karakterre
	ret


;
;
;	FISH 04h: Els keresse
;
;	in:  BC - hely az FCB szmra (48 bjt)
;	     DE - hasznlatlan vagy meghatrozott FCB
;	     HL - tvonal-nv string vagy keressi FCB
;	out: A  - llapotkd
;	     BC - u.a. a cm meghatrozott FCB-vel
;	     DE - u.a. az FCB (most keressi FCB)
;	     HL - teljes tvonal string
;
LC0A8:	ld	a,080h			; keresst jelz flag (?)
LC0AA:	ld	(0D09Ch),a		; vezrl flag-ek mentse a RAM vltozba
	call	LDB2E			; 1.lapon lv rutin hvsa (cm: 0D64Fh)
;
	.dw	0D64Fh			; belps a HL ltal mutatta knyvtrba, a knyvtr els bejegyzsnek kikeresse
;
	ret	nz			; visszatrs, ha hiba trtnt
	or	a			; CY=0
	push	bc			; BC-ben adott FCB buffer cmnek mentse
	jr	LC0C7			; ugrs a folytatshoz


;
;
;	FISH 05h: Kvetkez keresse
;
;	in:  BC - hely az FCB szmra (48 bjt)
;	     DE - keressi FCB
;	out: A  - llapotkd
;	     BC - u.a. a cm meghatrozott FCB-vel
;	     DE - u.a. az a keressi FCB (aktualizlva)
;	     HL - teljes tvonal string
;
LC0B7:	ld	(iy+01Ch),080h		; 0D09Ch cmen lv keresst jelz flag
	call	LDB2E			; 1.lapon lv rutin hvsa (cm: 0D6A6h)
;
	.dw	0D6A6h			; DE-ben adott keressi FCB-nek megfelel meghajt aktivlsa, aktulis knyvtrkezelsi vltozk belltsa
;
	ret	nz			; visszatrs, ha hiba trtnt
	push	bc
	call	LDB2E			; 1.lapon lv rutin hvsa (cm: 0DA04h)
;
	.dw	0DA04h			; knyvtr kvetkez bejegyzsnek kikeresse
;
LC0C7:	call	LC21C			; fjlnv keresse az aktulis knyvtrban (FCB cme IX-ben)(s els res bejegyzs cmnek megjegyzse)
	jr	c,LC0D9			; ugrs, ha megtallta
	bit	7,(iy+01Ch)		; keress flag ellenrzse
	ld	a,0A1h			; hibakd: .NOFIL - a fjl nem tallhat
	call	z,LC24E			; ha nem csak keress van, akkor az els res vagy trlt knyvtrbejegyzs pozcjnak belltsa a bels vltozkba
	jr	nz,LC112		; ugrs, ha hiba trtnt vagy csak keressi funkci volt
	jr	LC0F7			; egybknt ugrs a fjl vagy knyvtrbejegyzs ltrehozshoz
;
LC0D9:	bit	7,(iy+01Ch)		; flag ellenrzse
	jr	nz,LC130		; ugrs, ha csak keressi funkci volt
	bit	2,a			; tallt bejegyzs attribtumnak vizsglata
	jr	nz,LC0F0		; ugrs, ha rendszer fjl (SYSTEM)
	and	010h			; knyvtr bit maszkolsa (s CY=0)
	ld	a,09Ch			; hibakd A reg.-be: .DIRX - a knyvtr ltezik
	jr	nz,LC131		; visszatrs, ha a tallt bejegyzs knyvtr
	bit	4,(iy+01Ch)		; knyvtr ltrehozsa vezrl flag
	ld	a,09Bh			; hibakd A reg.-be: .FILEX - a fjl ltezik
	.db	0DAh			; a kvetkez bjtokkal: jp c,L9D3E - elfedi ld	a,09Dh-t
LC0F0:	ld	a,09Dh			; hibakd A reg.-be: .SYSX - a rendszerfjl ltezik
	call	z,LC3BD			; ha ZF=1, knyvtrbejegyzshez tartoz fjl trlse
	jr	nz,LC131		; visszatrs, ha hiba trtnt vagy rendszer fjl vagy knyvtr ltrehozsa funkci volt
;
LC0F7:	ld	a,(ix+008h)		; A reg.= fjlnv els karaktere az FCB-bl
	cp	02Eh
	ld	a,0A7h			; hibakd: .DOT - illeglis mvelet a "." vagy ".." knyvtrral
	jr	z,LC152			; ugrs, ha a fjlnv els karaktere '.'
	ld	a,(0D09Ch)		; A reg.= keresst vezrl bjt
	and	010h			; knyvtr ltrehozsa flag
	ld	b,a			; BC=0000h, ha nem knyvtrat hozunk ltre
	ld	c,a
	set	5,a			; A reg.= archv bit belltsa az attribtum bjtban
	jr	z,LC116			; ugrs, ha nem knyvtr ltrehozsa funkci van
	set	2,(iy+007h)		; "alknyvtr klaszter ltehozsa" jelzs (a "." s ".." bejegyzsek elksztse)
	call	LC285			; egy darab klaszter lefoglalsa a nem hasznlt lemezterleten
LC112:	jr	nz,LC152		; ugrs, ha hiba trtnt
	ld	a,010h			; A reg.= knyvtr attribtum bjt
LC116:	push	af			; A reg. mentse
	call	LDB2E			; 1.lapon lv rutin hvsa (cm: 0D9FBh)
;
	.dw	0D9FBh			; knyvtr aktulis (legutoljra hasznlt) bejegyzsnek kikeresse
;					; DE= knyvtrbejegyzs kezdcme
	push	ix
	pop	hl			; HL= FCB kezdcme
	pop	af			; A reg. visszallsa
	push	bc			; BC= bvt FAT lncolat kezdete vagy 0000h
	ld	b,a
	ld	a,(ix+006h)		; A reg.= attribtum bjt az FCB-bl
	and	008h			; ktetazonost bit
	or	b			; A reg.-ben az attribtum a ktetazonost bittel kiegsztve
	ld	bc,00008h
	add	hl,bc			; HL a fjlnvre mutat az FCB-ben
	pop	bc			; BC helyrelltsa
	call	LC1A7			; knyvtrbejegyzs ltrehozsa
LC130:	xor	a			; hibakd trlse
LC131:	pop	hl			; HL= j FCB buffer cme (belpskor BC-ben volt megadva)
	push	hl			; cm ismt a verembe
	push	af			; hibakd mentse a verembe
	push	de			; DE= tallt knyvtrbejegyzs kezdcme
	push	ix
	pop	de			; DE= meghatrozott FCB cme (keresett fjlnevet tartalmazza)
	ld	(hl),0FEh		; j FCB tpusa: meghatrozott FCB
	inc	hl
	inc	de
	ld	bc,00007h		; a kvetkez 7 bjt tmsolsa a DE-ben adott bemeneti FCB-bl
	ex	de,hl			; DE az j FCB-re mutat, HL a keresett fjlnevet tartalmazra
	ldir				; msols
	pop	hl			; HL= tallt knyvtrbejegyzs kezdcme
	ld	a,(hl)			; A reg.= tallt fjlnv els karaktere
	cp	005h
	jr	nz,LC14A		; ugrs, ha nem 05h
	ld	a,0E5h			; karakterkd kicserlse a helyes rtkre
LC14A:	ld	(de),a			; els karakter tmsolsa az j FCB-be
	inc	hl
	inc	de
	ld	c,01Fh			; a knyvtrbejegyzs htralev 31 bjtjt
	ldir				; vltoztats nlkl tmsolja az j FCB-be
	pop	af			; elmentett hibakd visszalltsa
LC152:	call	LDB2E			; 1.lapon lv rutin hvsa (cm: 0D6C3h)
;
	.dw	0D6C3h			; IX-ben adott keressi FCB knyvtrkezelsi vltozinak kikeresse
;
	ex	de,hl			; DE= knyvtrkezelsi vltozk cme az FCB-n bell  HL= bels RAM vltozk cme
	ldir				; aktulis vltozrtkek tmsolsa az FCB-be
	push	ix
	pop	de			; FCB cme DE-be (keressi FCB)
	pop	bc			; BC helyrelltsa
	jp	LC05C			; ugrs a befejezshez (HL az tvonalnv stringre fog mutatni)


;
;
;	FCB-ben lv fjlnv rvnyessgnek ellenrzse
;	(a megengedett karaktereket tartalmazza-e)
;	megj.: ktetazonost esetn nem ellenriz semmit, csak hiba nlkl visszatr
;	in:  IX - FCB-re mutat
;	out:  A - hibakd
;	     BC,HL - megrzdik
;
LC161:	bit	3,(ix+006h)		; attribtum bjt az FCB-ben
	jr	nz,LC198		; ugrs, ha ktetazonost (visszatrs hiba nlkl -> brmilyen karakter mengengedett)
	push	bc			; BC mentse
	push	ix
	ex	(sp),hl			; HL= FCB kezdcme, rgi rtke a verembe
	ld	bc,00008h
	add	hl,bc			; HL a fjlnvre mutat az FCB-ben
	ld	b,008h			; B= 8 karakter lesz
	ld	a,020h			; A reg.= SPACE kdja
	call	LC17E			; fjlnv rvnyessgnek ellenrzse
	ld	b,003h			; B= 3 karaktert ellenriz
	call	z,LC17E			; fjlnv-kiterjeszts rvnyessgnek ellenrzse
	pop	hl			; regiszterek visszalltsa
	pop	bc
	ret


;
;
;	Fjlnv rvnyessgnek ellenrzse (a megengedett karaktereket tartalmazza-e)
;	in:   A - karakterkd az els karakter ellenrzshez (pl. SPACE)
;	      B - ellenrzend hossz
;	     HL - ellenrzend fjlnv(rszlet) kezdete
;	out:  A - hibakd
;	     HL - utols ellenrztt karakter utni cm
;
LC17E:	cp	(hl)			; els karakter ellenrzse
	jr	z,LC1A3			; ugrs, ha A reg.-ben adott karakterrel kezddik (hiba)
LC181:	ld	a,(hl)			; els karakter A reg.-be
	inc	hl			; HL a kvetkez karakterre mutat
	cp	020h
	jr	z,LC19C			; ugrs, ha SPACE
	call	LDB2E			; 1.lapon lv rutin hvsa (cm: 0D855h)
;
	.dw	0D855h			; megvizsglja, hogy A reg. specilis karaktert tartalmaz-e?
;
	jr	z,LC1A3			; ugrs, ha specilis karakter (hiba)
	cp	03Fh
	jr	z,LC1A3			; ugrs, ha '?' (hiba)
	cp	02Ah
	jr	z,LC1A3			; ugrs, ha '*' (hiba)
	djnz	LC181
LC198:	xor	a			; hibajelzs trlse
	ret
;
LC19A:	ld	a,(hl)			; kvetkez karakter A reg.-be
	inc	hl			; cm nvelse
LC19C:	sub	020h			; A reg. cskkentse (a SPACE kdjval)
	jr	nz,LC1A3		; ugrs, ha nem SPACE volt
	djnz	LC19A			; a fjlnv htralv karaktereinek ellenrzse
	ret				; visszatrs (a htralv karakterek mind SPACE-k voltak, A reg.=00h)
;
LC1A3:	ld	a,0A9h			; hibakd A reg.-be: .IFNM - rvnytelen fjlnv
	or	a
	ret


;
;
;	Knyvtrbejegyzs ltrehozsa
;	in:   A - fjl attributum
;	     BC - klaszter sorszma
;	     DE - adatterlet (knyvtrbejegyzs) kezdete
;	     HL - fjlnv (11 karakter)
;	out: DE - megrzdik
;
LC1A7:	push	de
	push	bc
	ld	b,a
	ld	a,(hl)			; A= fjlnv els karaktere
	cp	0E5h			; megegyezik a trltsg jelzssel?
	jr	nz,LC1B1		; ugrs, ha nem
	ld	a,005h			; egybknt helyettests 05h-val
LC1B1:	ld	(de),a			; karakter msolsa a szektor adatterletre
	ld	a,b			; A= belpskori rtk
	inc	hl			; forrs s clmutatk lptetse
	inc	de
	ld	bc,0000Ah		; tovbbi 10 karaktert msol
	ldir
	ld	(de),a			; a 11 karakter utn A-ban adott rtk eltrolsa (attributum bjt)
	ex	de,hl			; HL= clmutat
	ld	b,014h			; a htralev 20 bjt kinullzsa
LC1BE:	inc	hl
	ld	(hl),c			; C=0 bersa a szektor adatterletre
	djnz	LC1BE			; ismtls a htralev bjtokra
	pop	de			; DE= klaszter sorszma
	bit	7,d
	jr	z,LC1C9			; ugrs, ha kisebb 08000h-nl
	ld	d,b			; DE= 0000h
	ld	e,b
LC1C9:	ld	bc,0FFFCh		; BC= -4
	add	hl,bc			; HL cskkentse 4-el
	ld	(hl),d			; fjl els klaszternek belltsa a bejegyzsben (fels bjt)
	dec	hl
	ld	(hl),e			; fjl els klaszternek belltsa a bejegyzsben (als bjt)
	pop	de			; DE= adatterlet kezdete
	ex	af,af'

;
;
;	Fjl utols mdosts idejnek s dtumnak belltsa
;	in:  DE - knyvtrbejegyzs kezdete
;	out: BC,DE,HL - megrzdik
;
LC1D2:	push	hl
	push	bc
	push	de
	ld	hl,00016h
	add	hl,de			; HL a 22. bjtra mutat
	call	LC1E5			; rs idpontjnak s dtumnak belltsa
	call	LDB2E			; 1.lapon lv rutin hvsa (cm: 0D442h)
;
	.dw	0D442h			; aktulis szektorbuffer "piszkos"-nak jellse
;
	pop	de			; regiszterek visszalltsa
	pop	bc
	pop	hl
	ret


;
;
;	Knyvtrbejegyzs rsi idpontjnak s dtumnak belltsa
;	in:  HL - idbejegyzs memriacmre mutat
;	out: -
;
LC1E5:	push	hl
	call	LDB2E			; 2.lapon lv rutin hvsa (cm: 0EFA1h)
;
	.dw	0EFA1h			; aktulis rendszerid lekrdezse
;
	ld	a,l			; A reg. = percek
	add	a,a			; lptets balra 2 bittel (0..59 lehet a perc rtk)
	add	a,a
	ld	b,003h			; tovbbi lptets balra 3 bittel
LC1F0:	add	a,a			; percek shiftelse
	rl	h			; rk shiftelse (s A-bl kilp bitek belptetse H-ba)
	djnz	LC1F0			; ismtls
	srl	d			; D= D/2 (msodpercek, 2-es lpskzzel)
	add	a,d			; A-ban a percek als 3 bitje (bit 5..7) s a msodpercek/2 (bit 0..4) 
	ld	c,h			; C-ben az rk (bit 3..7) s percek fels bitjei (bit 0..2)
	pop	hl			; HL= belpskori rtk
	ld	(hl),a			; idpont als bjtja
	inc	hl
	ld	(hl),c			; idpont fels bjtja
	inc	hl
	push	hl			; dtum cmnek mentse a verembe
	call	LDB2E			; 2.lapon lv rutin hvsa (cm: 0EF37h)
;
	.dw	0EF37h			; aktulis dtum lekrdezse
;
	ld	bc,0F844h		; BC= -1980
	add	hl,bc			; HL= relatv vszm
	ld	a,d			; A= hnap (1..12)
	or	a			; CY=0
	rra				; als bitek tmozgatsa a fels pozcikba (CY-n keresztl)
	rra
	rra
	rra				; A reg. bit 5..7 = hnap als 3 bit
	rl	l			; L reg. bit 0= hnap fels 1 bit   bit 1..7 = relatv v (1980..2107)
	add	a,e			; A reg. bit 0..4 = napok
	ld	c,l			; fels bjt C-be
	pop	hl			; dtum cme vissza a verembl
	ld	(hl),a			; dtum als bjtja
	inc	hl
	ld	(hl),c			; dtum fels bjtja
	ret


;
;
;	Fjlnv keresse az aktulis knyvtrban, els res bejegyzs cmnek megjegyzse
;	- ha (iy+01Ch) bjt 0.bit=0 akkor az els tallt res vagy trlt knyvtrbejegyzs
;	  pozcijt elmenti a keressi RAM vltozk utni terletre, majd a bitet 1-be lltja
;	in:  DE - aktulis knyvtr-bejegyzs kezdcme
;	     HL - a fizikai meghajt tblzatra mutat
;	     IX - meghatrozott FCB cme (keresett fjlnevet tartalmazza)
;	out:  A - hibakd (ha CY=0) vagy a tallt egyez bejegyzs attribtum bjtja (ha CY=1)
;	     DE - tallt knyvtr-bejegyzs kezdcme
;	     HL - megrzdik
;	     CY - CY=1 tallt egyez bejegyzst
;
LC217:	call	LDB2E			; 1.lapon lv rutin hvsa (cm: 0DA04h)
;
	.dw	0DA04h			; knyvtr kvetkez bejegyzsnek kikeresse
;
LC21C:	jr	c,LC238			; ugrs, ha elrte a knyvtr vgt (CY=1)
	push	ix
	ex	(sp),hl			; FCB cme HL-be, rgi rtke a verembe
	ld	bc,00008h
	add	hl,bc			; HL a keresett fjlnvre mutat az FCB-n bell
	call	LDB2E			; 1.lapon lv rutin hvsa (cm: 0D9A5h)
;
	.dw	0D9A5h			; knyvtrbejegyzs fjlnevnek sszehasonltsa a keressi fjlnvvel
;
	pop	hl			; HL helyrelltsa
	ret	c			; visszatrs, ha a bejegyzs megfelel a keresett fjlnvnek (CY=1) 
	jr	nz,LC217		; kvetkez bejegyzs vizsglata, ha nem res vagy trlt bejegyzst tallt
	bit	0,(iy+01Ch)		; vezrl flag ellenrzse
	call	z,LC23A			; ha nulla, akkor a szabad bejegyzs pozcijnak elmentse
	or	a
	jr	nz,LC217		; kvetkez bejegyzs vizsglata, ha nem res bejegyzs volt
LC238:	xor	a			; hibajelzk trlse, CY=0 (nem volt tallat)
	ret


;
;
;	Msolat ksztse a knyvtrkezelsi RAM vltozkrl
;	(pl. a tallt szabad bejegyzs pozcijnak elmentsere)
;	in:  IX - FCB cme
;	out: DE,HL,IX - megrzdik
;
LC23A:	push	hl			; regiszterek mentse
	push	de
	call	LDB2E			; 1.lapon lv rutin hvsa (cm: 0D6C3h)
;
	.dw	0D6C3h			; knyvtrkezelsi vltozk kezdcme DE-be, tmb hossza BC-be
;
	ld	h,d			; HL= 'aktulis knyvtr klasztersorszma' RAM vltoz cme
	ld	l,e
	add	hl,bc			; HL a knyvtrkeressi vltozk terlete utni cmre mutat
	ex	de,hl			; DE= vltozk utni terlet  HL= vltozk kezdete
	ldir				; vltozk tmsolsa
	set	0,(iy+01Ch)		; flag belltsa (legkzelebb nem hvja meg ezt a rutint (?))
	pop	de			; regiszterek vissza
	pop	hl
	ret


;
;
;	Els res vagy trlt knyvtrbejegyzs pozcjnak belltsa a bels vltozkba
;	- ha az aktulis knyvtr betelt s alknyvtr, akkor egy klaszterrel bvti
;	in:  HL - meghajt (vagy lemez) adattblzatra mutat
;	     IX - FCB cme (keressi, de lehet msmilyen is)
;	out:  A - hibakd
;	     HL - megrzdik
;
LC24E:	set	2,(iy+022h)		; frissteni kell a knyvtrkezels ltal hasznland szektorbuffereket
	bit	0,(iy+01Ch)		; tallati flag ellenrzse
	jr	z,LC266			; ugrs, ha keress kzben nem tallt res vagy trlt bejegyzst
	push	hl			; HL mentse
	call	LDB2E			; 1.lapon lv rutin hvsa (cm: 0D6C3h)
;
	.dw	0D6C3h			; keressi FCB knyvtrkezelsi vltozinak kikeresse
;
	ld	h,d			; DE= bels knyvtrkeressi RAM vltozk cme
	ld	l,e
	add	hl,bc			; HL= keressi vltozk utni cm  BC= vltoz terlet hossza
	ldir				; lementett keressi vltozk visszamsolsa a munkaterletre
	pop	hl			; HL vissza
	xor	a			; hibajelzk trlse
	ret
;
LC266:	ld	de,(0D071h)		; DE= knyvtr aktulis klasztere
	bit	7,d
	ld	a,0A4h			; hibakd: .DRFUL - a fknyvtr megtelt
	ret	nz			; visszatrs, ha a fknyvtr az aktulis knyvtr
	call	LC285			; 1 klaszternyi j FAT lncolat ltrehozsa
	ret	nz			; visszatrs, ha hiba trtnt
	push	bc			; BC mentse
	call	LDB2E			; 1.lapon lv rutin hvsa (cm: 0D50Fh)
;
	.dw	0D50Fh			; FAT elem belltsa (a knyvtr aktulis klaszterhez fzi az j klasztert)
;
	pop	bc			; BC= lefoglalt lncolat kezdete
	ld	(0D073h),bc		; "alknyvtr kvetkez klasztere" RAM vltozba az j klaszter
	call	LDB2E			; 1.lapon lv rutin hvsa (cm: 0DA04h)
;
	.dw	0DA04h			; knyvtr kvetkez bejegyzsnek kikeresse
;
	xor	a			; hibajelzk trlse
	ret


;
;
;	Egy darab klaszter lefoglalsa a nem hasznlt lemezterleten
;	in:  HL - a fizikai meghajt tblzatra mutat
;	out:  A - hibakd
;	     BC - lncolat kezdete
;	     DE - megrzdik
;	     HL - megrzdik
;
LC285:	ld	bc,00001h		; BC= 1 darab klaszter kell
	set	1,(iy+007h)		; flag: 0-val kell kitlteni az res szektorokat

;
;
;	Adott szm elembl ll FAT lncolat ltrehozsa a nem hasznlt lemezterleten,
;	a lncolathoz tartoz klaszterek adatterletnek feltltse 0-val, ha (iy+7) 1.bit =1
;	in:  BC - FAT lncolat hossza (klaszterben)
;	     HL - a fizikai meghajt tblzatra mutat
;	out:  A - hibakd
;	     BC - lncolat kezdete
;	     DE - megrzdik
;	     HL - megrzdik
;
LC28C:	push	de
	ld	de,00001h		; a lemez els FAT bejegyzst olvassa ki
	call	LDB2E			; 1.lapon lv rutin hvsa (cm: 0D4C8h)
;
	.dw	0D4C8h			; adott klaszterhez tartoz FAT bejegyzs kiolvassa
;
	push	de			; kiolvasott rtk mentse a verembe
	ld	de,00001h
LC299:	push	bc
	push	de
LC29B:	inc	de			; vgigvizsglja a FAT-ot az els res jelzs klaszterig
	push	hl			; fizikai meghajt tblzat cme a verembe
	ld	bc,00016h
	add	hl,bc			; HL = max. klaszterszm cme a tblzatban
	ld	a,(hl)
	inc	hl
	ld	h,(hl)
	ld	l,a			; HL= max. klaszter szm
	sbc	hl,de
	pop	hl
	jr	z,LC2E3			; ugrs, ha DE elrte a max. klasztersorszmot
	push	de
	call	LDB2E			; 1.lapon lv rutin hvsa (cm: 0D4C8h)
;
	.dw	0D4C8h			; adott klaszterhez tartoz FAT bejegyzs kiolvassa
;
	ld	a,d
	or	e
	pop	de
	jr	nz,LC29B		; ismtls, amg a kiolvasott rtk nem 0000h
	ld	b,d			; BC= az els res klaszter sorszma
	ld	c,e
	pop	de			; DE= az elzleg tallt res bejegyzs (v. els krben 00001h)
	push	bc
	call	LDB2E			; 1.lapon lv rutin hvsa (cm: 0D50Fh)
;
	.dw	0D50Fh			; FAT elem belltsa
;
	pop	de			; DE= az els res klaszter sorszma
	push	de
	ld	b,d			; BC= az els res klaszter sorszma
	ld	c,e
	bit	1,(iy+007h)		; vezrl flag-ek ellenrzse
	call	nz,LC2FD		; klaszter adatterletnek trlse (kinullzsa), ha szksges
	pop	de			; DE= az els res klaszter sorszma
	pop	bc			; BC= rand klaszterszm
	dec	bc			; rand klaszterszm cskkentse
	ld	a,b
	or	c
	jr	nz,LC299		; ismtls, ha mg nem nulla
	ld	bc,0FFFFh		; fjl vge jelzs
	call	LDB2E			; 1.lapon lv rutin hvsa (cm: 0D512h)
;
	.dw	0D512h			; FAT elem belltsa (piszkos diszk megtiszttsa nlkl)
;
	ld	de,00001h		; az els bejegyzs kiolvassa
	call	LDB2E			; 1.lapon lv rutin hvsa (cm: 0D4C8h)
;
	.dw	0D4C8h			; adott klaszterhez tartoz FAT bejegyzs kiolvassa
;
	xor	a			; hibakd trlse (nincs hiba)
	jr	LC2ED
LC2E3:	pop	de			; verem kitakartsa
	pop	de
	ld	de,00001h
	call	LC364			; eddig kialaktott FAT lncolat trlse
	ld	a,0A3h			; hibakd: .DKFUL - a lemez megtelt
LC2ED:	pop	bc			; BC= az els bejegyzs eredeti rtke
	push	af			; hibakd mentse
	push	de			; DE= a most kialaktott lncolat els eleme (amit tmeneteileg az els elemben trolt)
	ld	de,00001h		; az els elem visszalltsa az eredeti rtkre
	call	LDB2E			; 1.lapon lv rutin hvsa (cm: 0D512h)
;
	.dw	0D512h			; FAT elem belltsa (piszkos diszk megtiszttsa nlkl)
;
	pop	bc			; BC= a most kialaktott lncolat els eleme
	pop	af			; hibakd visszalltsa
	or	a
	pop	de			; DE= belpskori rtk
	ret


;
;
;	Adott klaszter adatterletnek trlse
;	(s feltltse default knyvtrbejegyzsekkel, ha knyvtr-klaszter(?) (iy+7) 2.bitje = 1)
;	in:  BC - klaszter sorszma
;	     HL - a fizikai meghajt tblzatra mutat
;	out: BC - megrzdik, ha (iy+7) 2.bitje = 0
;	     HL - megrzdik
;
LC2FD:	push	bc			; klaszter sorszma a verembe
	ld	d,b			; s DE-be is
	ld	e,c
	push	hl			; meghajt tblzat kezdcme a verembe
	ld	bc,0000Ah		; a 10. elem kiolvassa
	add	hl,bc
	ld	b,(hl)			; B= alapegysg maszk (klaszter szektorszmnak megfelel)
	pop	hl			; tblzat kezdcme vissza
	ld	a,b			; A= klaszteren belli szektorsorszm (az utols szektor)
	call	LDB2E			; 1.lapon lv rutin hvsa (cm: 0D4F1h)
;
	.dw	0D4F1h			; abszolt szektorcm kiszmtsa a klaszter sorszmbl
;
	ld	a,b			; A= klaszteren belli szektorsorszm
	inc	a			; szektorsorszm nvelse (s ZF=0)
	pop	bc			; BC= belpskori rtk
LC310:	push	hl			; meghajt tblzat kezdcme a verembe
	ex	(sp),ix			; tblzatcm IX-be, rgi rtke a verembe
	push	bc			; BC belpskori rtke megint a verembe
	ld	b,a			; B= klaszteren belli szektorok szma +1
LC315:	push	bc
	jr	nz,LC31D		; ugrs, ha ez az els ciklus (ZF jelzi)
	call	LDB2E			; 1.lapon lv rutin hvsa (cm: 0D2EBh)
;
	.dw	0D2EBh			; HL-ben adott szektorbuffert belltja els szektorbuffernek.
;
LC31D:	ld	b,00h			; B - ha nincs meg a szektor, csak egy "res" buffert ad vissza, s nem lehet IGNORE
	call	LDB2E			; 1.lapon lv rutin hvsa (cm: 0D3A4h)
;
	.dw	0D3A4h			; DE-ben adott szektor beolvassa (1 FAT pldnyt hasznlva)
;
	push	hl			; olvasott szektorbuffer cme a verembe
	ld	bc,0000Bh
	add	hl,bc			; HL a buffer adatterletre mutat
	xor	a
LC32A:	ld	(hl),a			; adatterlet kinullzsa (256 * 2 bjt)
	inc	hl
	ld	(hl),a
	inc	hl
	djnz	LC32A
	call	LDB2E			; 1.lapon lv rutin hvsa (cm: 0D442h)
;
	.dw	0D442h			; aktulis szektorbuffer "piszkos"-nak jellse
;
	pop	hl			; HL= olvasott szektorbuffer cme
	pop	bc			; B= klaszteren belli szektorsorszm
	dec	de			; szektorcm cskkentse
	xor	a			; ZF=1
	djnz	LC315			; ismtls, a klaszter sszes szektorra
	pop	bc			; BC= belpskori rtk
	bit	2,(iy+007h)
	jr	z,LC360			; ugrs, ha nem kell knyvtrbejegyzseket ltrehozni
	ld	de,0000Bh		; DE= eltols az adatterlet kezdethez
	add	hl,de
	ex	de,hl			; DE a buffer adatterletre mutat
	ld	hl,0DB63h		; HL a bels RAM-ban egy fjlnvre (aktulis knyvtr-> ".")
	ld	a,012h			; A= fjl attribtum: DIRECTORY|HIDDEN
	call	LC1A7			; knyvtrbejegyzs ltrehozsa
	ld	hl,00020h		; HL= egy bejegyzs hossza (32 bjt)
	add	hl,de			; HL a kvetkez bejegyzs kezdcmre mutat
	ex	de,hl			; cm DE-be
	ld	hl,0DB62h		; HL a bels RAM-ban egy fjlnvre (szlknyvtr-> "..")
	ld	bc,(0D06Fh)		: BC= szlknyvtr klasztersorszma (?)
	ld	a,012h			; A= fjl attribtum: DIRECTORY|HIDDEN
	call	LC1A7			; knyvtrbejegyzs ltrehozsa
LC360:	ex	(sp),ix			; IX helyrelltsa
	pop	hl			; HL helyrelltsa
	ret


;
;
;	FAT lncolat trlse
;	in:  DE - lncolat kezd klasztere
;	     HL - meghajt (vagy lemez) adattblzatra mutat
;	out: DE - utols trlt klaszter eredeti rtke (0 v. 0FFFFh)
;	     HL - megrzdik
;
LC364:	push	de
	call	LDB2E			; 1.lapon lv rutin hvsa (cm: 0D4C8h)
;
	.dw	0D4C8h			; adott klaszterhez tartoz FAT bejegyzs kiolvassa
;
	pop	bc
	push	de			; kiolvasott rtk a verembe
	ld	d,b			; DE= belpskori FAT elem sorszm
	ld	e,c
	ld	bc,00000h		; BC= szabad klaszter jelzse
	call	LDB2E			; 1.lapon lv rutin hvsa (cm: 0D512h)
;
	.dw	0D512h			; FAT elem belltsa (piszkos diszk megtiszttsa nlkl)
;
	pop	de			; DE= kiolvasott rtk
	ld	a,d
	or	e
	ret	z			; visszatrs, ha mr eredetileg is szabad klaszter volt
	bit	7,d			; DE >= 08000h ?
	jr	z,LC364			; ismtls, amg nem rt a lncolat vgre
	ret


;
;
;	FISH 08h: Trls
;
;	in:  DE - meghatrozott FCB
;	     HL - keressi FCB
;	out: A  - llapotkd
;
LC37F:	ld	b,h			; HL mentse BC-be
	ld	c,l
	call	LDB2E			; 1.lapon lv rutin hvsa (cm: 0D679h)
;
	.dw	0D679h			; keressi FCB-nek megfelel meghajt kivlasztsa, legutbb hasznlt knyvtrbejegyzs kikeresse
;
	ret	nz			; visszatrs, ha hiba trnt
	bit	4,a			; bejegyzs attribtum bjtjnak vizsglata
	jr	z,LC3B8			; ugrs, ha nem knyvtrbejegyzs
	call	LC410			; adott knyvtrbejegyzs specilis alknyvtr-e
	ret	c			; visszatrs, ha igen (hibakd: .DOT )
	call	LDB2E			; 1.lapon lv rutin hvsa (cm: 0D985h)
;
	.dw	0D985h			; belps az aktulis bejegyzs ltal mutatott knyvtrba
;
	call	LDB2E			; 1.lapon lv rutin hvsa (cm: 0D9DEh)
;
	.dw	0D9DEh			; els knyvtrbejegyzs kikeresse
;
LC399:	jr	z,LC3A8			; ugrs, ha a knyvtrbejegyzs res (ZF=1)
	call	LC410			; adott knyvtrbejegyzs specilis alknyvtr-e
	ld	a,09Eh			; hibakd: .DIRNE - a knyvtr nem res
	ret	nz			; visszatrs, ha a bejegyzs nem res ??????
	call	LDB2E			; 1.lapon lv rutin hvsa (cm: 0DA04h)
;
	.dw	0DA04h			; knyvtr kvetkez bejegyzsnek kikeresse
;
	jr	nc,LC399		; ugrs, ha mg nem rte el a knyvtr vgt
LC3A8:	push	ix
	pop	de			; DE= FCB cme
	ld	h,b			; HL= keressi FCB (belpskori rtk)
	ld	l,c
	call	LDB2E			; 1.lapon lv rutin hvsa (cm: 0D679h)
;
	.dw	0D679h			; keressi FCB-nek megfelel meghajt kivlasztsa, legutbb hasznlt knyvtrbejegyzs kikeresse
;
	ret	nz			; visszatrs, ha hiba trtnt
	call	LDB2E			; 1.lapon lv rutin hvsa (cm: 0D2AEh)
;
	.dw	0D2AEh			; aktulis alknyvtr kezd klasztercmnek trlse az adott meghajt-tblzatban
;
LC3B8:	call	LDB2E			; 1.lapon lv rutin hvsa (cm: 0D5E3h)
;
	.dw	0D5E3h			; ha tiszta a lemez, akkor az els FAT tbla szektorait tartalmaz sszes szektorbuffer felszabadtsa

;
;
;	Knyvtrbejegyzshez tartoz fjl trlse
;	in:  DE - knyvtr-bejegyzs (felttelezett)kezdcme
;	     HL - a fizikai meghajt tblzatra mutat
;	out:  A - hibakd
;	     DE - a trlt knyvtrbejegyzsre mutat
;	     BC,HL - megrzdik
;
LC3BD:	call	LDB2E			; 1.lapon lv rutin hvsa (cm: 0D9FBh)
;
	.dw	0D9FBh			; knyvtr aktulis (legutoljra hasznlt) bejegyzsnek kikeresse
;
	push	hl			; HL mentse
	ld	hl,0000Bh
	add	hl,de			; HL a bejegyzs attribtumbjtjra mutat
	ld	a,(hl)			; A reg.= attribtum
	bit	0,a			; READ ONLY bit ellenrzse
	ld	a,09Ah			; hibakd: .FILRO - csak olvashat fjl
	pop	hl			; HL visszalltsa
	ret	nz			; visszatrs, ha "csak olvashat" a fjl
	push	de			; regiszterek mentse
	push	hl
	ld	hl,0001Ah
	add	hl,de			; HL a fjl els klaszternek cmre mutata a bejegyzsben
	ld	e,(hl)
	inc	hl
	ld	d,(hl)			; DE= a fjl els klasztere
	ld	a,(0DFF3h)
	or	a
	jr	z,LC3EC			; ugrs, ha (DFF3h)=00h (nem fjl mozgatsa parancs (?))
	ld	a,(0D06Eh)		; A reg.= fizikai meghajt sorszma
	cp	(iy+01Fh)		; cl meghajt (?)
	jr	nz,LC3EC
	ld	hl,(0D0A0h)		; cl klasztersorszm (?)
	sbc	hl,de
	jr	z,LC40A			; ugrs, ha megegyeznek a klasztersorszmok
LC3EC:	pop	hl			; HL= a fizikai meghajt tblzatra mutat
	ld	a,d			; fjl els klasztersorszmnak vizsglata
	or	e
	call	nz,LC364		; ha DE nem 0000h, akkor FAT lncolat trlse
	pop	de
	call	LDB2E			; 1.lapon lv rutin hvsa (cm: 0D9FBh)
;
	.dw	0D9FBh			; knyvtr aktulis (legutoljra hasznlt) bejegyzsnek kikeresse
;
	push	hl			; HL mentse
	ld	hl,0000Ch
	add	hl,de			; HL a knyvtrbejegyzs fenntartott bjtjra mutat
	ld	a,(de)			; A reg. = a fjlnv eredeti els karaktere
	ld	(hl),a			; eredeti karakter elmentse a fenntartott bjtra
	ld	a,0E5h			; trltsg jelz kd A reg.-be
	ld	(de),a			; knyvtrbejegyzs els btjnak belltsa trlt jelzsre
	call	LDB2E			; 1.lapon lv rutin hvsa (cm: 0D442h)
;
	.dw	0D442h			; aktulis szektorbuffer "piszkos"-nak jellse
;
	pop	hl			; HL helyrelltsa
	xor	a			; hibakd trlse
	ret
;
LC40A:	ld	a,08Ah			; hibakd: .ICOPY - a fjl nem msolhat nmagra
	pop	hl
	pop	de
	or	a
	ret


;
;
;	Adott knyvtrbejegyzs specilis alknyvtr-e
;	in:  DE - knyvtr-bejegyzs kezdcme
;	     IX - FCB-re mutat
;	out:  A - elksztett hibakd (0A7h)
;	     BC,DE,HL,IX - megrzdik
;	     CY - CY=1 ha a bejegyzs specilis alknyvtr ("." vagy "..")
;	     ZF - ZF=1 res vagy trlt bejegyzs, ha CY=0
;
LC410:	push	hl
	push	bc
	ld	hl,0DB63h		; HL a bels RAM-ban a "." stringre mutat
	call	LDB2E			; 1.lapon lv rutin hvsa (cm: 0D9A5h)
;
	.dw	0D9A5h			; knyvtrbejegyzs fjlnevnek sszehasonltsa a keressi fjlnvvel
;
	jr	z,LC424			; ugrs, ha res vagy trlt bejegyzs
	ld	hl,0DB62h		; HL a bels RAM-ban a ".." stringre mutat
	call	LDB2E			; 1.lapon lv rutin hvsa (cm: 0D9A5h)
;
	.dw	0D9A5h			; knyvtrbejegyzs fjlnevnek sszehasonltsa a keressi fjlnvvel
;
LC424:	pop	bc
	pop	hl
	ld	a,0A7h			; hibakd elksztse: .DOT - illeglis mvelet a "." vagy ".." knyvtrral
	ret


;
;
;	FISH 09h: tnevezs
;
;	in:  BC - hasznlatlan FCB az j nvvel
;	     DE - meghatrozott FCB
;	     HL - keressi FCB
;	out: A  - llapotkd
;
LC429:	push	hl			; HL mentse
	call	LDB2E			; 1.lapon lv rutin hvsa (cm: 0D679h)
;
	.dw	0D679h			; keressi FCB-nek megfelel meghajt kivlasztsa, legutbb hasznlt knyvtrbejegyzs kikeresse
;
	jr	nz,LC490		; ugrs, ha hiba trtnt
	bit	4,a			; knyvtrbejegyzs attribtum bjtjnak vizsglata
	jr	z,LC43A			; ugrs, ha nem alknyvtr
	call	LDB2E			; 1.lapon lv rutin hvsa (cm: 0D2AEh)
;
	.dw	0D2AEh			; aktulis alknyvtr kezd klasztercmnek trlse az adott meghajt-tblzatban
;
LC43A:	call	LC410			; adott knyvtrbejegyzs specilis alknyvtr-e
	jr	c,LC490			; ugrs, ha a bejegyzs specilis alknyvtr (CY=1)
	push	bc			; BC a verembe
	exx
	push	ix
	pop	hl			; HL'= belpskori meghatrozott FCB cme (DE-bl)
	ld	bc,00007h
	add	hl,bc			; HL' a meghajt szmra mutat az FCB-ben
	ex	de,hl			; meghajt szm cme DE'-be
	pop	hl			; HL' az j nevet tartalmaz FCB-re mutat
	add	hl,bc			; HL' is a meghajt szmra mutat, de az j FCB-ben
	ld	a,(de)			; A reg.= meghatrozott FCB meghajt szma
	cp	(hl)			; sszehasonlts az j FCB-jvel
	ld	a,0ABh			; hibakd: .IDVR - rvnytelen meghajt
	jr	nz,LC490		; ugrs, ha a kt meghajt szm nem egyezik meg
	ld	b,00Bh			; 11 karakter feldolgozsa lesz
LC453:	inc	de			; mutat nvelse a meghatrozott FCB-ben
	inc	hl			; mutat nvelse az j FCB-ben
	ld	a,(hl)			; A reg.= karakter az j FCB-bl
	cp	03Fh			; sszahasonlts '?'-el
	jr	z,LC45B			; ugrs, ha krdjel (brmi lehet a helyn)
	ld	(de),a			; karakter tmsolsa a meghatrozott FCB-be
LC45B:	djnz	LC453			; ismtls
	exx
	call	LC161			; IX mutatta FCB-ben lv fjlnv rvnyessgnek ellenrzse
	jr	nz,LC490		; ugrs, ha rvnytelen karaktereket is tartalmaz
	call	LDB2E			; 1.lapon lv rutin hvsa (cm: 0D9DEh)
;
	.dw	0D9DEh			; els knyvtrbejegyzs kikeresse
;
	call	LC21C			; IX mutatta FCB-ben lv (tnevezett) fjlnv keresse az aktulis knyvtrban
	pop	hl			; HL= keressi FCB (belpskori rtk)
	ld	a,0A2h			; hibakd: .DUPF - dupliklt fjlnv
	ret	c			; visszatrs, ha tallt egyez bejegyzst (CY=1)
	push	ix
	pop	de			; DE az tnevezett FCB-re mutat
	call	LDB2E			; 1.lapon lv rutin hvsa (cm: 0D679h)
;
	.dw	0D679h			; keressi FCB-nek megfelel meghajt kivlasztsa, legutbb hasznlt knyvtrbejegyzs kikeresse
;
	ret	nz			; visszatrs, ha hiba trtnt
	push	ix
	pop	hl			; HL= meghatrozott FCB cme
	ld	bc,00008h
	add	hl,bc			; HL az tnevezett fjlnvre mutat az FCB-ben
	ld	a,(hl)			; els karakter vizsglata
	cp	0E5h
	jr	nz,LC486		; ugrs, ha nem 0E5h karakterrel kezddik
	ld	a,005h			; egybknt helyettests 005h-val
LC486:	ld	(de),a			; javtott kezdbet bersa a keressi FCB szerinti knyvtrbejegyzs els karakterbe
	inc	hl			; meghatrozott FCB beli nvmutat nvelse
	inc	de			; knyvtrbejegyzs beli nvmutat nvelse
	ld	c,00Ah			; BC=000Ah -> a htralv 10 karakter msolsa
	jp	LC594			; ugrs a befejez rutinra
;
LC48E:	ld	a,0A8h			; hibakd: .IATTR - rvnytelen fjl attribtumok
LC490:	pop	hl			; hiba esetn verem takartsa
	ret


;
;
;	FISH 0Ah: thelyezs
;
;	in:  BC - j tvonalnv string
;	     DE - meghatrozott FCB
;	     HL - keressi FCB
;	out: A  - llapotkd
;
LC492:	push	hl			; HL mentse
	call	LDB2E			; 1.lapon lv rutin hvsa (cm: 0D679h)
;
	.dw	0D679h			; keressi FCB-nek megfelel meghajt kivlasztsa, legutbb hasznlt knyvtrbejegyzs kikeresse
;
	jr	nz,LC490		; ugrs, ha hiba trtnt
	bit	3,(ix+006h)		; meghatrozott FCB attribtum bjtjnak vizsglata
	jr	nz,LC48E		; ugrs, ha ktetazonost
	bit	3,a			; aktulis knyvtrbejegyzs attribtumnak vizsglata
	jr	nz,LC48E		; ugrs, ha ktetazonost
	push	bc			; tvonalnv kezdcm mentse
	ld	c,081h			; C= bels flag-ek tvonalnv elemzshez
	bit	4,a			; aktulis knyvtrbejegyzs attribtumnak vizsglata
	jr	z,LC4C1			; ugrs, ha nem alknyvtr
	set	2,c			; sszehasonltsi funkci engedlyezse
	push	hl
	ld	hl,0001Ah
	add	hl,de			; HL az aktulis knyvtrbejegyzsben az els klaszter cmre mutat
	ld	a,(hl)
	ld	(iy+01Dh),a		; fjl els klaszternek sorszmt tmsolja 0D09Dh RAM vltozba
	inc	hl
	ld	a,(hl)
	ld	(iy+01Eh),a
	pop	hl
	call	LDB2E			; 1.lapon lv rutin hvsa (cm: 0D2AEh)
;
	.dw	0D2AEh			; aktulis alknyvtr kezd klasztercmnek trlse az adott meghajt-tblzatban
;
LC4C1:	call	LC410			; az aktulis knyvtrbejegyzs specilis alknyvtr-e
	pop	de			; DE= tvonalnv string
	jr	c,LC490			; ugrs, ha specilis alknyvtr ("." vagy "..")
	ld	(iy+01Ch),000h		; sszes keressi flag nullzsa
	ld	a,(ix+007h)		; A reg.= meghatrozott FCB meghajt szma
	ex	af,af'
	call	LDB2E			; 1.lapon lv rutin hvsa (cm: 0D6DDh)
;
	.dw	0D6DDh			; tvonalnv elemzse, feldolgozsa
;
	jr	nz,LC490		; ugrs, ha hiba trtnt
	or	c			; ha A reg. vagy C reg. nem nulla -> ZF=0
	ld	a,0AAh			; hibakd: .IPATH
	jr	nz,LC490		; visszatrs, ha hiba trtnt vagy a zrkarakter nem 00h volt
	ex	af,af'			; A reg.= belpskori meghatrozott FCB meghajt szma
	cp	(ix+007h)		; IX ltal mutatott FCB-ben most az tvonalnv stringbl szrmaz meghajt szm van
	ld	a,0ABh			; hibakd: .IDVR - rvnytelen meghajt
	jr	nz,LC490		; ugrs, ha nem egyezik a kt meghajt szma
	bit	6,(iy+01Ch)		; az aktulis knyvtr klasztersorszma megegyezik az thelyezni kvnt alknyvtr kezd klasztervel ?
	ld	a,09Fh			; hibakd: .DIRE - rvnytelen knyvtrthelyezs
	jr	nz,LC490		; ugrs, ha az egyezsget jelz bit 1
	call	LDB2E			; 1.lapon lv rutin hvsa (cm: 0D9DEh)
;
	.dw	0D9DEh			; els knyvtrbejegyzs kikeresse
;
	call	LC21C			; fjlnv keresse az aktulis knyvtrban, els res bejegyzs cmnek megjegyzse
	ld	a,0A2h			; hibakd: .DUPF - dupliklt fjlnv
	jr	c,LC490			; ugrs, ha tallt egyez bejegyzst (CY=1)
	call	LC24E			; els res vagy trlt knyvtrbejegyzs pozcjnak belltsa a bels vltozkba
	jr	nz,LC490		; ugrs, ha hiba trtnt
	call	LC23A			; msolat ksztse a knyvtrkezelsi RAM vltozkrl
	pop	hl			; HL= a (belpskori) keressi FCB
	push	ix
	pop	de			; DE= meghatrozott FCB
	call	LDB2E			; 1.lapon lv rutin hvsa (cm: 0D679h)
;
	.dw	0D679h			; keressi FCB-nek megfelel meghajt kivlasztsa, legutbb hasznlt knyvtrbejegyzs kikeresse
;
	ret	nz			; visszatrs, ha hiba trtnt
	bit	4,a			; a keressi FCB szerinti knyvtrbejegyzs attribtumnak vizsglata
	push	af			; attribtum s alknyvtr jelz bit a verembe
	jr	z,LC513			; ugrs, ha nem alknyvtr
	call	LDB2E			; 1.lapon lv rutin hvsa (cm: 0D2AEh)
;
	.dw	0D2AEh			; aktulis alknyvtr kezd klasztercmnek trlse az adott meghajt-tblzatban
;
LC513:	push	hl			; HL mentse
	ld	hl,0D46Eh		; HL-be a bels FCB puffer cme, br most csak a knyvtrbejegyzst menti ide
	push	hl
	push	de			; DE= keressi FCB szerinti knyvtr-bejegyzs kezdcme
	ex	de,hl
	ld	bc,00020h		; 32 bjt (a teljes knyvtrbejegyzs)
	ldir				; tmozgatsa a bels FCB pufferbe
	pop	hl			; HL= keressi FCB szerinti knyvtr-bejegyzs kezdcme
	ld	(hl),0E5h		; az els karakterbe trltsg jelzs belltsa
	call	LDB2E			; 1.lapon lv rutin hvsa (cm: 0D442h)
;
	.dw	0D442h			; aktulis szektorbuffer "piszkos"-nak jellse
;
	pop	de			; DE= a bels FCB puffer cme
	pop	hl			; HL= a fizikai meghajt tblzatra mutat
	push	de			; DE mentse
	call	LC24E			; els res vagy trlt knyvtrbejegyzs pozcjnak visszamsolsa a bels vltozkba
	call	LDB2E			; 1.lapon lv rutin hvsa (cm: 0D9FBh)
;
	.dw	0D9FBh			; knyvtr aktulis (legutoljra hasznlt) bejegyzsnek kikeresse
;
	ex	(sp),hl			; HL= a bels FCB puffer cme, rgi rtk a verembe
	ld	bc,00020h		; 32 bjt msolsa lesz
	push	de			; DE= knyvtrbejegyzs kezdcme
	ldir				; tmozgatand bejegyzs tmsolsa a pufferbl a knyvtrszektorba
	call	LDB2E			; 1.lapon lv rutin hvsa (cm: 0D442h)
;
	.dw	0D442h			; aktulis szektorbuffer "piszkos"-nak jellse
;
	pop	de			; DE= knyvtrbejegyzs kezdcme
	pop	hl			; HL= a fizikai meghajt tblzatra mutat
	pop	af			; tmozgatott bejegyzs attribtuma s alknyvtr jelz bit a verembl
	ld	a,b			; A=00h (nincs hiba)
	ret	z			; visszatrs, ha nem alknyvtrat mozgattunk
	ld	bc,(0D06Fh)		; BC= aktulis knyvtr klasztersorszma (ahova mozgattunk)
	push	bc
	ld	ix,0DB5Ah		; IX= olyan bels FCB cm, aminek a fjlnv kezdete 0DB62h cmre esik ("..")
	call	LDB2E			; 1.lapon lv rutin hvsa (cm: 0D985h)
;
	.dw	0D985h			; belps az aktulis bejegyzs ltal mutatott knyvtrba
;
	call	LDB2E			; 1.lapon lv rutin hvsa (cm: 0D9DEh)
;
	.dw	0D9DEh			; els knyvtrbejegyzs kikeresse
;
	call	LC21C			; fjlnv keresse az aktulis knyvtrban, els res bejegyzs cmnek megjegyzse
	pop	bc			; BC= knyvtr klasztersorszma, ahova mozgattunk
	ret	nc			; visszatrs, ha nem tallta meg a ".." knyvtrbejegyzst
	and	010h			; az attribtum bjtjt is ellenrzi
	ret	z			; visszatrs, ha nem alknyvtr
	ld	hl,0001Ah
	add	hl,de			; HL a tallt knyvtrbejegyzsben a kezd klaszter cmre mutat
	ld	(hl),c			; j szlknyvtr kezd klaszterrtkek belltsa
	inc	hl
	ld	(hl),b
	jr	LC596			; ugrs a funkci befejezsre


;
;
;	FISH 0Bh: Attribtumok vltoztatsa
;
;	in:  DE - meghatrozott FCB
;	     HL - keressi FCB
;	out: A  - llapotkd
;
LC567:	push	de			; DE mentse
	call	LDB2E			; 1.lapon lv rutin hvsa (cm: 0D679h)
;
	.dw	0D679h			; keressi FCB-nek megfelel meghajt kivlasztsa, legutbb hasznlt knyvtrbejegyzs kikeresse
;
	pop	hl			; HL= meghatrozott FCB
	ret	nz			; visszatrs, ha hiba trtnt
	ld	bc,00013h
	add	hl,bc
	ex	de,hl			; DE a fjl attribtum bjtra mutat az FCB-ben
	ld	c,00Bh
	add	hl,bc			; HL= keressi FCB szerinti knyvtrbejegyzs attribtum bjt cme
	dec	b			; B= 0FFh (nem megvltoztathat attribtumok maszkja)
	bit	3,a			; knyvtrbejegyzs attribtumnak vizsglata
	jr	nz,LC584		; ugrs, ha ktetazonost
	ld	b,0FDh			; B= 0FDh
	bit	4,a			; attribtum tovbbi vizsglata
	jr	nz,LC584		; ugrs, ha alknyvtr
	ld	b,0D8h			; B= 0D8h
LC584:	ld	a,(de)			; A reg.= attribtum bjt a meghatrozott FCB-bl
	ld	c,a			; bjt mentse C-be
	xor	(hl)			; kizr VAGY a knyvtrbejegyzs attribtumval (A reg.-ben a megvltoz bitek helyn 1 lesz)
	and	b			; nem megvltoztathat bitek maszkolsa
	ld	a,0A8h			; hibakd: .IATTR - rvnytelen fjl attribtumok
	ret	nz			; visszatrs, ha nem megvltoztathat bitet akartunk tlltani
	ld	(hl),c			; attribtum bjt kzvetlen tmsolsa a knyvtrbejegyzsbe
	ld	bc,0000Bh
	add	hl,bc
	ex	de,hl			; DE az id cmre mutat a knyvtrbejegyzsben
	add	hl,bc			; HL az id cmre mutat az FCB-ben
	ld	c,004h			; 4 bjtot kell msolni (idpont s dtum)
LC594:	ldir				; bjtok (karakterek) msolsa
LC596:	call	LDB2E			; 1.lapon lv rutin hvsa (cm: 0D442h)
;
	.dw	0D442h			; aktulis szektorbuffer "piszkos"-nak jellse
;
	xor	a			; hibakd trlse
	ret

;
;
LC59D:	ld	a,0A1h			; hibakd: .NOFIL - a fjl nem tallhat
	ret				; vissszatrs a "fjl lezrsa" funkcibl

;
;
;	FISH 0Dh: Fjl lezrsa
;
;	in:  DE - nyitott FCB
;	out: A  - llapotkd
;	     DE - u.a. a nyitott FCB
;
LC5A0:	ld	hl,0C66Fh		; kzbens visszatrsi cm a verembe: LC66F
	push	hl
	ld	e,(ix+01Fh)		; DE= nem dokumentlt bjtok a nyitott FCB-ben
	ld	d,(ix+020h)
	bit	6,d			; jelzbit ellenrzse
	ret	z			; visszatrs, ha csak olvass volt a fjlbl
	res	6,d			; zavar jelzbitek kinullzsa
	res	5,d
	ld	(0D06Fh),de		; fjlt tartalmaz knyvtr kezd klasztersorszma
	ld	c,(ix+007h)		; C= meghajt szm az FCB-bl
	ld	b,001h			; B= vezrlkd
	call	LDB2E			; 1.lapon lv rutin hvsa (cm: 0D0BDh)
;
	.dw	0D0BDh			; meghajt elksztse (lemezcsere ellenrzs, szektorbufferek felszabadtsa, UPB beolvassa)
;
	or	a
	ret	nz			; visszatrs, ha hiba trtnt
LC5C1:	call	LDB2E
;
	.dw	0D9DEh			; fjlt tartalmaz knyvtr els knyvtrbejegyzsnek kikeresse
;
	call	LC21C			; fjlnv keresse az aktulis knyvtrban
	jr	nc,LC59D		; ugrs, ha nem tallt egyez bejegyzst
	and	007h			; attribtum bjt vizsglata
	ld	a,0A8h			; hibakd: .IATTR - rvnytelen fjl attribtumok
	ret	nz			; visszatrs, ha READ_ONLY vagy HIDDEN vagy SYSTEM a fjl attribtuma
	call	LC1D2			; fjl utols mdosts idejnek s dtumnak belltsa
	push	de
	push	ix
	ex	(sp),hl			; HL= FCB cme, fizikai meghajt tblzat cme a verembe
	ld	bc,00017h
	add	hl,bc
	ex	de,hl			; DE a fjlmretre mutat a nyitott FCB-ben
	ld	c,00Bh
	add	hl,bc			; HL az attribtum bjtra mutat a knyvtrbejegyzsben
	set	5,(hl)			; ARCHIVE bit belltsa
	ld	c,00Fh
	add	hl,bc			; HL a fjl els klaszterre mutat a knyvtrbejegyzsben
	ld	a,(ix+021h)		; A reg.= fjl els klasztere als bjt a nyitott FCB-bl
	ld	(hl),a			; tmsols a knyvtrbejegyzsbe
	inc	hl
	ld	a,(ix+022h)		; A reg.= fjl els klasztere fels bjt
	ld	(hl),a			; tmsols a knyvtrbejegyzsbe
	inc	hl
	ex	de,hl			; DE a fjl mretre mutat a knyvtrbejegyzsben, HL pedig az FCB-ben
	ld	c,004h
	ldir				; 4 bjtos fjlmret msolsa az FCB-bl a knyvtrbejegyzsbe
	pop	hl			; HL a fizikai meghajt tblzatra mutat
	call	LDB2E			; 1.lapon lv rutin hvsa (cm: 0D45Dh)
;
	.dw	0D45Dh			; HL-ben adott meghajthoz tartoz szektorbufferek "megtiszttsa"
;
	pop	de			; DE= fjl knyvtrbejegyzsnek kezdcme
	call	LDB2E			; 1.lapon lv rutin hvsa (cm: 0D9FBh)
;
	.dw	0D9FBh			; fjl bejegyzsnek kikeresse a szektorbufferben
;
	ld	b,000h			; nem "READ ONLY" fjl jelzse

;
;
;	Nyitott FCB kitltse a fjl knyvtrbejegyzse alapjn
;	in:   B - fjl attribtum bjtja (csak "READ ONLY" flag az rdekes)
;	     DE - fjl knyvtrbejegyzsnek kezdcme
;	     IX - nyitott FCB cme
;	out:  A - 00h (hibakd)
;	     HL - +26h cmre mutat a nyitott FCB-ben
;	     IX - megrzdik
;
LC601:	push	bc			; BC mentse
	push	ix
	pop	hl			; HL= nyitott FCB cme
	ld	bc,00017h
	add	hl,bc
	ex	de,hl			; DE a fjlmretre mutat a nyitott FCB-ben
	ld	c,01Ch
	add	hl,bc			; HL a fjlmretre mutat a knyvtrbejegyzsben
	ld	c,004h			; BC= 0004h
	push	hl
	ldir				; fjlmret tmsolsa a knyvtrbejegyzsbl az FCB-be
	pop	hl
	dec	hl			; HL a fjl els klaszterre mutat a knyvtrbejegyzsben
	ld	b,(hl)			; BC= fjl els klasztere
	dec	hl
	ld	c,(hl)
	push	bc			; BC mentse a verembe
	ld	(0D0A0h),bc		; BC bersa a bels RAM vltozba is
	ld	a,(0D06Eh)		; A reg.= fizikai meghajt sorszma
	ld	(0D09Fh),a		; meghajt szmnak tmsolsa (?)
	dec	hl
	dec	hl
	ldi				; dtum tmsolsa a nyitott FCB-be
	ldi
	dec	hl
	dec	hl
	dec	hl
	dec	hl
	ldi				; utols mdostsa idejnek tmsolsa a nyitott FCB-be
	ldi
	ex	de,hl			; HL a 01Fh cmre mutat a nyitott FCB-ben (fenntartott, nem dokumentlt bjtok)
	pop	bc			; BC= fjl els klasztere
	ld	de,(0D06Fh)		; DE= aktulis knyvtr klasztersorszma
	res	6,d			; klasztersorszmban az 5. s 6. bit jelz bit lesz
	res	5,d
	pop	af			; A reg.= fjl attribtum bjtja
	bit	0,a			; "READ ONLY" flag
	jr	z,LC641			; ugrs, ha nem csak olvashat a fjl
	set	5,d			; jelz bit belltsa
LC641:	ld	(hl),e			; aktulis knyvtr klasztersorszm mentse a nyitott FCB nem dokumentlt helyre
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c			; fjl els klasztere
	inc	hl
	ld	(hl),b
	inc	hl
	ld	(hl),c			; fjl aktulis klasztere
	inc	hl
	ld	(hl),b
	inc	hl
	xor	a			; A reg.= 00h
	ld	(hl),a			; fjl aktulis klaszternek sorszma (a fjl FAT lncolatban)-> a legels (vagyis a nulladik)
	inc	hl
	ld	(hl),a
	ret


;
;
;	FISH 0Ch: Fjl megnyitsa
;
;	in:  DE - meghatrozott FCB
;	     HL - keressi FCB
;	out: A  - llapotkd
;	     DE - u.a. az FCB (megnyitva, ha nincs hiba)
;
LC652:	ld	bc,0C66Fh		; kzbens visszatrsi cm a verembe: LC66F
	push	bc
	call	LDB2E			; 1.lapon lv rutin hvsa (cm: 0D679h)
;
	.dw	0D679h			; keressi FCB-nek megfelel meghajt kivlasztsa, legutbb hasznlt knyvtrbejegyzs kikeresse
;
	ret	nz			; visszatrs, ha hiba trtnt
	ld	b,a			; knyvtrbejegyzs attribtum bjtja B reg.-be
	and	018h			; attribtum ellenrzse
	ld	a,0A8h			; hibakd: .IATTR - rvnytelen fjl attribtumok
	ret	nz			; visszatrs, ha alknyvtr vagy ktetazonost a hivatkozott bejegyzs
	call	LC601			; nyitott FCB kitltse a fjl knyvtrbejegyzse alapjn
	inc	hl
	inc	hl			; HL= a fjlmutat cme a nyitott FCB-ben
	ld	(hl),a			; 4 bjtos fjlmutat nullzsa (A reg.= 00h)
	inc	hl
	ld	(hl),a
	inc	hl
	ld	(hl),a
	inc	hl
	ld	(hl),a
	ret
;
LC66F:	push	ix			; kzbens visszatrsi rutin
	pop	de			; a fjl megnyitsi vagy lezrsi funkcik mindig ezen a kdrszleten keresztl trnek vissza
	ret


;
;
;	FISH 12h: Abszolt szektor olvass
;
;	in:  DE - logikai szektorszm
;	      H - olvasand szektorok szma
;	      L - meghajt szma
;	     IX - diszk tviteli cm
;	out:  A - llapotkd
;	     DE - kvetkez logikai szektorszm
;	      H - olvasott szektorok szma
;	      L - u.a. a meghajt szm
;	     IX - aktualizlt memriacm
;
LC673:	inc	a			; A reg.-ben az olvassi irnynak megfelel rtk (01h)

;
;
;	FISH 13h: Abszolt szektor rs
;
;	in:  DE - logikai szektorszm
;	      H - rand szektorok szma
;	      L - meghajt szma
;	     IX - diszk tviteli cm
;	out:  A - llapotkd
;	     DE - kvetkez logikai szektorszm
;	      H - rt szektorok szma
;	      L - u.a. a meghajt szm
;	     IX - aktualizlt memriacm
;
LC674:	ld	(0D087h),a		; tviteli irny (rs=00h /olvass =01h ) belltsa a flag bjtban (iy+007h)
	ld	(0D096h),de		; kezd logikai szektorszm belltsa a RAM vltozba
	push	hl
	push	ix
	pop	bc			; BC= diszk tviteli cm
	ld	(0D088h),bc		; lemezes tvitel (rs/olvass) kezd memriacme
	ld	a,b
	add	a,h			; szektorok szmnak hozzadsa az tviteli memriacm fels bjtjhoz
	jr	c,LC688			; ugrs, ha mr ekkor is tlcsordul
	add	a,h			; szektorszm hozzadsa mgegyszer (egy szektor 512 bjtos)
LC688:	ld	a,0A6h			; hibakd: .OV64K
	jr	c,LC6AC			; ugrs, ha brmelyik sszeadsnl tlcsorduls volt
	ld	c,l			; C= meghajt szma
	call	LDB2E			; 1.lapon lv rutin hvsa (cm: 0D0B7h)
;
	.dw	0D0B7h			; meghajt elksztse (lemezcsere ellenrzs, szektorbufferek felszabadtsa, UPB beolvassa)
;
	or	a
	jr	nz,LC6AC		; ugrs, ha hiba trtnt
	call	LDB2E			; 1.lapon lv rutin hvsa (cm: 0D45Dh)
;
	.dw	0D45Dh			; HL-ben adott meghajthoz tartoz szektorbufferek "megtiszttsa"
;
	call	LDB2E			; 1.lapon lv rutin hvsa (cm: 0D46Dh)
;
	.dw	0D46Dh			; HL-ben adott meghajthoz tartoz szektorbufferekben a meghajt azonost trlse
;
	pop	bc			; B= tvivend szektorok szma
	push	bc
	call	LC7CF			; egy blokkban lv szektorok rsa vagy olvassa
	call	LDB2E			; 1.lapon lv rutin hvsa (cm: 0D46Dh)
;
	.dw	0D46Dh			; HL-ben adott meghajthoz tartoz szektorbufferekben a meghajt azonost trlse
;
	pop	hl			; HL visszatrsi rtknek belltsa (gyakorlatilag u.a. mint belpskor)
	xor	a			; hibakd trlse
	.db	011h			; a kvetkez bjtokkal: ld de,026E1h  s nop ;elfedve: pop hl  s ld h,00h
LC6AC:	pop	hl
	ld	h,000h			; hiba esetn az tvitt szektorok szma 0
	ld	ix,(0D088h)		; IX az tvitt blokk utni els memriacmre mutat
	ld	de,(0D096h)		; DE= kvetkez logikai szektorszm
	ret


;
;
;	FISH 11h: rs 0-tltssel
;
;	in:  BC - rand bjtok szma
;	     DE - megnyitott FCB
;	     IX - diszk tviteli cm
;	out: A  - llapotkd
;	     BC - rt bjtok szma
;	     DE - ugyanaz az FCB
;	     IX - aktualizlt memriacm
;
	inc	a			; A reg. nvelse (FISH 11h esetn a flag bjtba 02h rdik)

;
;
;	FISH 0Fh: Olvass fjlbl
;
;	in:  BC - olvasand bjtok szma
;	     DE - megnyitott FCB
;	     IX - diszk tviteli cm
;	out: A  - llapotkd
;	     BC - olvasott bjtok szma
;	     DE - ugyanaz az FCB
;	     IX - aktualizlt memriacm
;
	inc	a			; A reg. nvelse (FISH 0Fh esetn A=01h lesz)

;
;
;	FISH 10h: rs fjlba
;
;	in:  BC - rand bjtok szma
;	     DE - megnyitott FCB
;	     IX - diszk tviteli cm
;	out: A  - llapotkd
;	     BC - rt bjtok szma
;	     DE - ugyanaz az FCB
;	     IX - aktualizlt memriacm
;
	ld	(0D087h),a		; tviteli irny (rs/olvass) belltsa a flag bjtban (iy+007h)
	xor	a
	ld	(0D08Ch),a		; tvitt bjtok szma = 0 (als bjt)
	ld	(0D08Dh),a		; tvitt bjtok szma = 0 (fels bjt)
	ld	(0D08Ah),bc		; lemezes tvitel hossza
	push	de
	ex	(sp),ix			; DE tmsolsa IX-be
	pop	hl			; IX korbbi tartalma HL-be
	ld	(0D088h),hl		; tviteli cm mentse
	call	LC6FE			; fjl rsa vagy olvassa a fjlmutattl
	ld	bc,(0D08Ch)		; BC-be az tvitt bjtok szma
	ld	hl,(0D088h)		; megnvelt tviteli cm vissza HL-be
	push	hl
	ex	(sp),ix			; majd IX-be
	pop	de			; DE-be vissza az FCB cm
	ex	af,af'			; hibakd mentse
	push	hl
	ld	hl,00028h		; HL= fjlmutat cme az FCB-ben
	add	hl,de
	ld	a,(hl)
	add	a,c			; 4 bjtos fjlmutat nvelse az tvitt hosszal
	ld	(hl),a
	inc	hl
	ld	a,(hl)
	adc	a,b
	ld	(hl),a
	jr	nc,LC6F2		; ugrs, ha nincs tlcsorduls az als kt bjtrl
	inc	hl
	inc	(hl)			; kvetkez bjt nvelse, ha szksges
	jr	nz,LC6F2		; ugrs, ha nincs tlcsorduls az als hrom bjtrl
	inc	hl
	inc	(hl)			; legfels bjt nvelse, ha szksges
LC6F2:	pop	hl			; visszatrsi rtkek helyrelltsa
	ex	af,af'			; hibakd visszalltsa
	or	a
	ret	nz			; visszatrs, ha nem volt hiba
	bit	7,(iy+007h)		; olvassnl j hossz rtket szmolt (tbbet akartunk olvasni a fjl hossznl)
	ret	z			; ha a bit nulla, akkor hiba nlkl tr vissza
	ld	a,0ECh			; MOPS hibakd: .EOF - end of file hiba
	ret


;
;
;	Fjl rsa vagy olvassa
;	in:  BC - tviteli hossz
;	     HL - tviteli memriacm
;	     IX - nyitott FCB
;	out:  A - hibakd
;
LC6FE:	ld	a,b
	or	c			; tviteli hossz ellenrzse
	ret	z			; visszatrs, ha BC=0
	dec	bc
	add	hl,bc			; HL= utols tvitt bjt cme
	ld	a,0A6h			; hibakd: .OV64K - 64kB-os memriahatr megsrtse
	ret	c			; visszatrs, ha memriahatr srts van
	ld	c,(ix+007h)		; C= meghajt sorszma az FCB-bl
	ld	b,001h
	call	LDB2E			; 1.lapon lv rutin hvsa (cm: 0D0BDh)
;
	.dw	0D0BDh			; meghajt elksztse (lemezcsere ellenrzs, szektorbufferek felszabadtsa, UPB beolvassa)
;
	or	a
	ret	nz			; visszatrs, ha hiba trtnt
	call	LC9D5			; tviteli hossz sszehasonltsa a fjl hosszval (ZF=1 ha j)
	ld	de,(0D08Eh)		; DE= a fjlmutat klaszter sorszma a file FAT lncolatban
	call	z,LCB17			; ha a hossz megfelel, fjl lncolaton belli klasztersorszm tnyleges klaszterazonostv konvertlsa
	ld	(0D094h),de		; tnyleges klasztersorszm mentse
	ret	nz			; visszatrs, ha az elz kt szubrutin brmelyiknl hiba trtnt
	ld	bc,(0D091h)		; BC= fjlmutat szektoron belli bjtcme
	ld	a,b
	or	c			; ha BC nem a szektor elejre mutat, akkor
	call	nz,LC7A6		; egy "rsz" szektor tvitele a fjlmutat (klaszteres) pozcijtl
	ret	nz			; visszatrs, ha hiba trtnt
LC72B:	ld	c,(iy+00Bh)		; C= lemezes tvitel (mg htralv) hossza, fels bjt
	srl	c			; C osztsa 2-vel -> teljes szektorok szma
	jr	z,LC78A			; ugrs, ha 0 a teljesen tvivend szektorok szma
	call	LC8BC			; fjlmutat kvetkez szektorra lltsa
	ret	nz			; visszatrs, ha hiba trtnt
	sub	(iy+010h)		; A= 0 - fjlmutat szektorsorszma a klaszteren bell
	ld	b,a			; szmtott rtk B-be
	ld	de,(0D094h)		; DE= fjlmutat tnyleges klaszterazonostja
	call	LC8F2			; fjlmutat abszolt szektorcmnek kiszmtsa
LC741:	ld	a,b
	add	a,(iy+013h)		; A reg. nvelse a klaszterenknti szektorszmmal
	ld	b,a			; B= az eddigi klaszterekben lv szektorok szma
	cp	c			; sszehasonlts az sszes teljes szektor szmval
	jr	nc,LC76A		; ugrs, ha az olvasand szektorok mind az eddig "feltrkpezett" klasztereken bell vannak
	push	de			; klaszterszm a verembe
	call	LDB2E			; 1.lapon lv rutin hvsa (cm: 0D4C8h)
;
	.dw	0D4C8h			; adott klaszterhez tartoz FAT bejegyzs kiolvassa
;
	ex	(sp),hl			; HL= korbbi klasztersorszm, rgi rtke a verembe
	or	a
	inc	hl			; klasztersorszm nvelse
	sbc	hl,de
	jr	nz,LC761		; ugrs, ha a fjl kvetkez klasztere nem kzvetlenl az elz utn helyezkedik el a lemezen (vagy fjl vge)
	inc	(iy+00Eh)		; fjlmutat klaszter sorszm nvelse (als bjt)
	jr	nz,LC75E		; ugrs, ha nincs tvitel
	inc	(iy+00Fh)		; fjlmutat klaszter sorszm nvelse (fels bjt)
LC75E:	pop	hl			; HL helyrelltsa
	jr	LC741			; ismtls
;
LC761:	add	hl,de
	ex	de,hl			; HL= a kvetkez klaszter
	dec	de			; DE= az utols klaszter ami mg egy tmbben van
	pop	hl			; HL helyrelltsa
	ld	a,(0D093h)		; A reg.= klaszterenknti szektorszm
	jr	LC770
;
LC76A:	ld	a,(0D093h)		; A reg.= klaszterenknti szektorszm
	sub	b
	add	a,c			; A= az utols klaszterben lv olvasand szektorok szma
	ld	b,c			; B= htralv teljes szektorok szma
LC770:	dec	a			; fjlmutat belltsa az utols olvasott szektorra:
	ld	(0D090h),a		; fjlmutat szektorsorszma a klaszteren bell
	ld	(0D094h),de		; fjlmutat tnyleges klaszterazonostja
	push	bc
	call	LC7CF			; egy blokkban lv szektorok rsa vagy olvassa
	pop	bc
	sla	b
	ld	c,000h			; BC= tvitt bjtok szma
	call	LC9C3			; tvitt hossz s htralv bjtok szmnak mdostsa
	set	6,(iy+007h)		; fjlmutat kvetkez szektorra lptetsnek engedlyezse
	jr	LC72B			; ugrs a kvetkez egy blokkban lv szektorok olvassra
;
LC78A:	ld	bc,00000h		; BC= fjlmutat szektoron belli bjtcme
	call	LC7A6			; egy "rsz" szektor rsa/olvassa a fjlmutat (klaszteres) pozcijtl
	ret	nz			; visszatrs, ha hiba trtnt
	ld	de,(0D094h)		; DE= fjlmutat tnyleges klaszterazonostja
	ld	(ix+023h),e		; tnyleges klasztersorszm frisstse az FCB-ben
	ld	(ix+024h),d
	ld	de,(0D08Eh)		; DE= fjlmutat klaszter sorszma a file FAT lncolatban
	ld	(ix+025h),e		; fjlon belli klasztersorszm frisstse az FCB-ben
	ld	(ix+026h),d
	ret


;
;
;	Egy "rsz" szektor rsa/olvassa a fjlmutat (klaszteres) pozcijtl
;	in:  BC - fjlmutat szektoron belli bjtcme
;	     HL - a fizikai meghajt tblzatra mutat
;	out:  A - hibakd
;
LC7A6:	push	hl			; HL mentse a verembe
	ld	hl,00200h		; HL= egy szektor hossza (512 bjt)
	or	a
	sbc	hl,bc
	ex	de,hl			; DE= htralv bjtok a szektorban
	ld	hl,(0D08Ah)		; HL= lemezes tvitel (rs/olvass) hossza
	sbc	hl,de
	jr	nc,LC7B8		; ugrs, ha az tvivend bjtok kilgnak a szektorbl
	add	hl,de
	ld	e,l			; DE= a szektorban lv tvivend bjtok szma
	ld	d,h
LC7B8:	ld	a,d
	or	e
	pop	hl			; HL-ben a belpskori rtke
	ret	z			; visszatrs, ha DE=0
	call	LC8BC			; fjlmutat kvetkez szektorra lltsa
	ret	nz			; visszatrs, ha hiba trtnt
	call	LC8F2			; fjlmutat abszolt szektorcmnek kiszmtsa
	call	LC905			; fjl rs vagy olvass egy szektoron bell
	set	6,(iy+007h)		; fjlmutat kvetkez szektorra lptetsnek engedlyezse
	call	LC9C3			; tvitt hossz s htralv bjtok szmnak mdostsa 
	xor	a			; hibajelz trlse
	ret


;
;
;	Egy blokkban lv szektorok rsa vagy olvassa
;	Megj.:
;	  - a 3. memrialapon lv szektorokat egyessvel viszi t szektorbufferen keresztl
;	  - a fjlmutat abszolt szektorcmt hasznlja
;	  - olvassnl a blokkba es "piszkos" szektorbuffereket msolja az tviteli terletre
;	  - rsnl a blokkba es, az adott meghajthoz tartoz szektorbuffereket felszabadtja
;	in:   B - tvivend teljes szektorok szma
;	     HL - a fizikai meghajt tblzatra mutat
;	out: -
;
LC7CF:	xor	a
	cp	b			; htralv szektorok szmnak ellenrzse
	ret	z			; visszatrs, ha B=0
	push	hl			; HL mentse
	ld	de,(0D088h)		; DE= lemezes tvitel (rs/olvass) kezd memriacme
	ld	a,(0DFF7h)		; A= a 3. memrialap lapozsa: 0-> felhasznli RAM
	or	a
	ld	hl,0FE00h		; fels memriahatr, ha bels RAM van belapozva
	jr	nz,LC7E3		; ugrs, ha bels RAM
	ld	hl,0BE00h		; fels memriahatr U3 lapozsa esetn
LC7E3:	sbc	hl,de
	jr	c,LC84F			; ugrs, ha az tvivend terlet a hatr fltt kezddik
	ld	a,h			; A= a hatr s kezdcm kztti terlet 256 bjtos lpsekben
	srl	a			; A=A/2 -> 512 bjtos lpsekben
	inc	a			; A-ban az gy szmtott szektorok szma
	cp	b			; sszehasonlts a bejv paramterrel
	jr	c,LC7EF			; ugrs, ha kevesebb mint a B reg.-ben krt
	ld	a,b			; egybknt limitls a krt mennyisgre
LC7EF:	ld	c,a			; C= tvivend szektorok
	pop	hl			; HL visszalltsa
	sub	b			; A= most tvivend - krt szektorok szma
	neg
	ld	b,a			; B= most t nem vitt (htralv) szektorok szma
	push	bc			; szmtott rtkek mentse a verembe
	ld	b,c			; B= tvivend szektorok szma
	ld	c,0FFh			; C reg. jelzs hibakezels esetre
	push	bc
LC7FA:	push	bc
	push	de			; DE= lemezes tvitel (rs/olvass) kezd memriacme
	push	de
	ex	(sp),ix			; tviteli terlet cme IX-be, rgi rtke a verembe
	ld	a,004h			; A reg.= egysgkezel parancskdja: 4 - szektorok olvassa
	bit	0,(iy+007h)		; rs 0/olvass 1 (?)
	jr	nz,LC80C		; ugrs, ha olvass
	call	LDB2E			; 1.lapon lv rutin hvsa (cm: 0D38Dh)
;
	.dw	0D38Dh			; VERIFY vltoznak megfelel szektorrsi parancskd meghatrozsa
;
LC80C:	ld	de,(0D096h)		; DE= fjlmutat abszolt szektorcme
	push	de			; szektorcm a verembe
	dec	c
	inc	c
	jr	z,LC81A			; ugrs, ha C=0 (ZF=1 -> nem jelez majd hibt)
	call	LDB2E			; 1.lapon lv rutin hvsa (cm: 0D010h)
;
	.dw	0D010h			; lemezmvelet vgrehajtsa (lemezcsere ellenrzssel)
;
LC81A:	ex	af,af'			; hibakd mentse
	pop	de			; DE= fjlmutat abszolt szektorcme
	pop	ix			; IX eredeti rtke
	push	hl			; HL mentse
	ld	l,b
	ld	h,000h			; HL= tvitt szektorok
	add	hl,de			; fjlmutat szektorcmnek nvelse
	ld	(0D096h),hl		; j rtk mentse a RAM vltozba
	pop	hl			; HL visszalltsa
	pop	de			; DE= lemezes tvitel (rs/olvass) kezd memriacme
	ld	a,d
	add	a,b
	add	a,b
	ld	d,a			; DE nvelse az tvitt szektorok hosszval
	ld	a,b			; A reg.= tvitt szektorok
	pop	bc			; B= szmtott tvivend szektorok szma
	sub	b
	neg
	ld	b,a			; B= szmtott tvivend - tnylegesen tvitt szektorok szma
	ex	af,af'			; hibakd vissza A reg.-be
	jr	z,LC840			; ugrs, ha nem trtnt hiba
	call	LDB2E			; 1.lapon lv rutin hvsa (cm: 0DAA8h)
;
	.dw	0DAA8h			; hibakezel rutin, IGNORE lehetsggel
;
	jr	z,LC83E			; ugrs, ha RETRY
	ld	c,000h			; C=0 hatsra tlpi a lemezmvelet vgrehajtst az ismtlsnl s ZF=1 lesz (IGNORE)
LC83E:	jr	LC7FA			; ugrs az ismtlsre
;
LC840:	pop	bc			; B= szmtott tvivend szektorok szma
	call	LC865			; a folytonos szektorblokkba es szektorbufferek ellenrzse
	pop	bc			; B= htralv szektorok szma  C= tvitt szektorok szma
	ld	a,(iy+009h)		; A reg.= lemezes tvitel kezd memriacme (fels bjt)
	add	a,c
	add	a,c			; memriacm nvelse az tvitt szektoroknak megfelel hosszal
	ld	(iy+009h),a		; megnvelt cm mentse
LC84D:	jr	LC7CF			; ugrs az elejre, ahol ellenrzi, hogy tvitte-e mr az sszes szektort
;
LC84F:	pop	hl			; HL visszalltsa
	dec	b			; tvivend teljes szektorok szmnak cskkentse eggyel
	push	bc			; rtk a verembe
	ld	de,00200h		; DE= a szektorban lv tvivend bjtok szma (512)
	ld	b,e			; BC= fjlmutat szektoron belli bjtcme (0000h)
	ld	c,e
	call	LC905			; fjl rs vagy olvass egy szektoron bell
	pop	bc			; BC visszalltsa
	inc	(iy+016h)		; fjlmutat abszolt szektorcme +1 (als bjt)
	jr	nz,LC863		; ugrs, ha nincs tvitel
	inc	(iy+017h)		; fjlmutat fels bjt nvelse
LC863:	jr	LC84D			; ugrs az ellenrzsre


;
;
;	Szektorbufferek ellenrzse folytonos szektorblokk tvitele utn.
;	Megvizsglja az adott meghajthoz tartoz szektorbuffereket,
;	s ha egy buffer az tvitt szektorblokkba esik:
;	 - olvass esetn a "piszkos" szektorbuffer adatval mdostja az tviteli
;	   terletre beolvasott adatokat
;	 - rs esetn a szektorbuffert felszabadtja s a buffer-lncolat elejre helyezi
;	(Megj.: a fjlmutatnak az tvitt szektorblokk utnra kell mutatnia)
;	in:   B - az egy blokkban tvitt szektorok szma
;	     HL - a fizikai meghajt tblzatra mutat
;	     DE - lemezes tvitel aktulis kezd memriacme (az tvitt blokk utnra mutat)
;	out: BC - megrzdik
;	     HL - megrzdik
;	     DE - megrzdik
;
LC865:	call	LDB2E			; 1.lapon lv rutin hvsa (cm: 0D483h)
;
	.dw	0D483h			; HL-ben adott tblzat meghajthoz tartoz szektorbufferek megjellse
;
LC86A:	push	bc			; BC a verembe (hogy BC'-be lehessen msolni)
	exx
	call	LDB2E			; 1.lapon lv rutin hvsa (cm: 0D4B3h)
;
	.dw	0D4B3h			; a kvetkez megjellt szektorbuffer cmnek lekrdezse
;
	jr	z,LC8B9			; ugrs, ha a buffer-lncolat vgre rt s nincs tallat
	ld	bc,00004h		; BC'= eltols az abszolt szektorcm elemhez
	add	hl,bc			; HL'= szektorbuffer abszolt szektorcmre mutat
	ld	e,(hl)
	inc	hl
	ld	d,(hl)			; DE'= szektorbuffer abszolt szektorcme
	ex	de,hl			; szektorcm HL-be
	ld	bc,(0D096h)		; BC'= fjlmutat abszolt szektorcme
	sbc	hl,bc			; HL'= szektorbuffer cme - fjlmutat szektorcme
	pop	bc			; BC'-be BC a verembl
	ld	a,h
	inc	a
	jr	nz,LC89D		; ugrs, ha H' nem 0FFh (a szektor biztosan nem az tvitt tartomnyba esik)
	ld	a,l
	add	a,b			; klnbsg als bjtjnak nvelse az tvitt szektorszmmal
	jr	nc,LC89D		; ugrs, ha az tvitt szektorszm kisebb a cmek klnbsgnl (a szektor nincs a tartomnyban)
	dec	de
	dec	de
	ex	de,hl			; HL' a szektorbuffer flag bjtjra mutat, DE' a szektorcmek klnbsge
	bit	0,(iy+007h)		; 0.bit: rs 0/olvass 1 (?)
	jr	nz,LC8A0		; ugrs, ha olvass volt
	dec	hl			; HL' a szektorbuffer fizikai egysgszmra mutat
	ld	(hl),000h		; buffer felszabadtsa
	dec	hl
	dec	hl			; HL' a szektorbuffer elejre mutat
	call	LDB2E			; 1.lapon lv rutin hvsa (cm: 0D2EBh)
;
	.dw	0D2EBh			; az adott szektorbuffert belltja els szektorbuffernek
;
LC89D:	exx
	jr	LC86A			; ugrs a ciklus elejre
LC8A0:	bit	7,(hl)			; flag bjt ellenrzse
	jr	z,LC89D			; ugrs, ha a buffert nem mdostottk (nem "piszkos")
	exx
	push	de			; DE a verembe (tvitel aktulis kezd memriacme)
	exx
	ld	bc,00008h
	add	hl,bc			; HL' a szektorbuffer adatterletre mutat
	ex	(sp),hl			; DE bemsolsa HL'-be, adatterlet cme a verembe
	ld	d,e			; DE'= szektorbuffer cme - fjlmutat szektorcme (als bjt)
	ld	e,b			; E=0
	add	hl,de			; DE'-ben negatv szm van (!)
	add	hl,de			; HL= tvitel memriacme megnvelve az aktulis szektornak megfelel pozcival
	ex	de,hl			; memriacm DE-be
	pop	hl			; HL= szektorbuffer adatterlete
	ld	bc,00200h		; BC= 512 bjtot msol
	ldir				; buffer tmsolsa a memriba
	jr	LC89D			; ugrs a folytatshoz
;
LC8B9:	exx
	pop	bc			; verem kitakartsa
	ret


;
;
;	Fjlmutat kvetkez szektorra lltsa
;	in:  HL - a fizikai meghajt tblzatra mutat
;	out:  A - hibakd
;	     DE - megrzdik
;	     HL - megrzdik
;
LC8BC:	xor	a			; hibakd trlse
	bit	6,(iy+007h)		; fjlmutat kvetkez szektorra lptetsnek engedlyezse
	ret	z			; visszatrs, ha nem engedlyezett
	res	6,(iy+007h)		; tovbbiakban lptets tiltsa
	ld	a,(0D090h)		; A= fjlmutat szektorsorszma a klaszteren bell
	inc	a			; szektorsorszm nvelse
	cp	(iy+013h)		; klaszterenknti szektorszm
	jr	nz,LC8ED		; ugrs, ha nem az utols szektor volt a klaszteren bell
	push	de			; DE mentse
	ld	de,(0D08Eh)		; DE= fjlmutat klaszter sorszma a file FAT lncolatban
	inc	de			; klasztersorszm nvelse,
	ld	(0D08Eh),de		; majd az j rtk elmentse
	ld	de,(0D094h)		; DE= fjlmutat tnyleges klaszterazonostja
	call	LDB2E			; 1.lapon lv rutin hvsa (cm: 0D4C8h)
;
	.dw	0D4C8h			; adott klaszterhez tartoz FAT bejegyzs kiolvassa
;
	ld	(0D094h),de		; j klaszterazonost elmentse
	bit	7,d
	pop	de			; DE belpskori rtknek visszalltsa
	ld	a,0A5h			; hiba: .FILE - hibs FAT lncolat
	ret	nz			; visszatrs, ha a kiolvasott klaszterazonost >= 08000h
	xor	a			; A reg. = klaszteren belli szektorsorszm
LC8ED:	ld	(0D090h),a		; fjlmutat j szektorsorszmnak elmentse
	xor	a			; hibajelzs trlse
	ret


;
;
;	Fjlmutat abszolt szektorcmnek kiszmtsa
;	in:  HL - a fizikai meghajt tblzatra mutat
;	out: DE - megrzdik
;	     HL - megrzdik
;
LC8F2:	push	de			; DE mentse
	ld	a,(0D090h)		; A= fjlmutat szektorsorszma a klaszteren bell
	ld	de,(0D094h)		; DE= fjlmutat tnyleges klaszterazonostja
	call	LDB2E			; 1.lapon lv rutin hvsa (cm: 0D4F1h)
;
	.dw	0D4F1h			; abszolt szektorcm kiszmtsa a klaszter sorszmbl
;
	ld	(0D096h),de		; abszolt szektorcm mentse
	pop	de			; DE visszalltsa
	ret


;
;
;	Fjl rs vagy olvass egy szektoron bell (szektorbufferen keresztl)
;	in:  BC - fjlmutat szektoron belli bjtcme (0..511)
;	     DE - a szektorban lv tvivend bjtok szma (0..512)
;	     HL - a fizikai meghajt tblzatra mutat
;	out: BC - tvitt bjtok
;	     HL - megrzdik
;	     IX - megrzdik
;
LC905:	push	hl			; HL mentse
	ex	(sp),ix			; IX= meghajt tblzatcme, rgi rtk a verembe
	push	de			; tvivend bjtok szma a verembe
	push	bc			; fjlmutat a verembe
	bit	0,(iy+007h)		; rs 0/olvass 1 (?)
	jr	nz,LC935		; ugrs, ha olvass
	bit	1,d
	jr	nz,LC938		; ugrs, ha az rand bjtok szma >= 511 (a teljes szektort rni kell)
	bit	1,(iy+007h)		; 1 - klaszter adatterlett inicializlni kell (???)
	jr	nz,LC935		; ugrs, ha igen
	push	de			; DE mentse
	ld	hl,(0D08Ah)		; HL= lemezes tvitel (rs) hossza
	ld	de,(0D098h)		; DE= rshoz szksges fjlmret-nvels bjtokban
	or	a
	sbc	hl,de			; HL= az eredeti fjlmreten bell rand bjtok szma
	pop	de			; DE visszalltsa
	jr	c,LC932			; ugrs, ha tbb bjttal kell nvelni a fjl mrett, mint amit rni akarunk (lesz nem hasznlt rs)
	ld	a,b
	or	c
	jr	nz,LC935		; ugrs, ha BC nem nulla
	sbc	hl,de			; HL= a fjlon belli bjtok - a most tvivend bjtok
	jr	c,LC938			; ugrs, ha a jelenleg tvivend bjtok nem frnek a fjlba
	jr	LC935			; ugrs
LC932:	add	hl,bc			; HL= a fjlon belli bjtok + fjlmutat szektoron belli bjtcme
	jr	nc,LC938
LC935:	ld	b,003h			; B= hibakezels esetn lehet IGNORE; ha nem tallja a bufferekben tltse be a lemezrl
	.db	021h			; a kvetkez bjtokkal: ld hl,00206h (elfedi ld b,2 -t)
LC938:	ld	b,002h			; B= hibakezels esetn lehet IGNORE; ha nincs beolvasva a szektorbuffer, csak egy "res" buffert ad vissza
	ld	de,(0D096h)		; DE= fjlmutat abszolt szektorcme
	call	LDB2E			; 1.lapon lv rutin hvsa (cm: 0D3A4h)
;
	.dw	0D3A4h			; DE-ben adott szektor beolvassa (szektorbufferbe)
;
	pop	de			; DE= fjlmutat szektoron belli bjtcme
	add	hl,de
	ld	bc,0000Bh
	add	hl,bc			; HL a szektorbuffer adatterletn a fjlmutat pozcijban
	pop	bc			; BC= a szektorban lv tvivend bjtok szma
	push	de
	push	bc
	ld	de,(0D088h)		; DE= lemezes tvitel (rs/olvass) kezd memriacme
	push	de			; memriacm a verembe
	push	bc
	push	hl			; szektoron belli fjlmutat mentse
	ld	a,(0DFF7h)		; A reg.= a 3. memrialap lapozsa (ld. pdf 94. oldal)
	or	a
	ld	hl,0FFFFh
	jr	nz,LC95F		; ugrs, ha a csatol bels RAM-ja van kivlasztva
	ld	hl,0BFFFh
LC95F:	sbc	hl,de
	jr	c,LC986			; ugrs, ha a kezd cm a megengedett terlet felett van
	dec	bc			; BC= tvivend bjtok szma -1
	sbc	hl,bc
	jr	nc,LC96B		; ugrs, ha az tvivend adathossz mg belefr a memriba
	add	hl,bc
	ld	b,h			; tviteli hossz limitlsa a memriamretre
	ld	c,l
LC96B:	inc	bc			; tviteli hossz nvelse eggyel (a kezd bjtra kerl mg egy bjt)
	pop	hl			; HL= fjlmutat a szektoron bell
	push	bc			; limitlt tviteli hossz a verembe
	bit	0,(iy+007h)		; rs 0/olvass 1 (?)
	jr	nz,LC975		; ugrs, ha olvass
	ex	de,hl			; cl s forrs felcserlse
LC975:	ldir				; adatok mozgatsa a szektorbuffer s a "memria" kztt
	jr	nz,LC97A		; ugrs, ha olvass
	ex	de,hl			; cl s forrs visszacserlse
LC97A:	pop	bc			; BC= limitlt tviteli hossz a verembl
	ex	(sp),hl			; HL= belpskori tviteli hossz, rgi rtk a verembe
	or	a
	sbc	hl,bc
	ld	b,h			; BC= t nem vitt bjtok szma
	ld	c,l
	pop	hl			; HL visszalltsa (fjlmutat)
	jr	z,LC9A0			; ugrs, ha minden bjtot tvitt
	push	bc			; t nem vitt bjtok szma a verembe
	push	hl			; fjlmutat a verembe
LC986:	pop	hl			; fjlmutat vissza HL-be
	res	7,d			; memriacm fels kt bitjnek nullzsa (0. lapra mutat)
	res	6,d
	di				; megszaktsok tiltsa
	ld	a,0F8h			; lapozs: U3,U1,U2,EXT
	out	(002h),a		; memrialapoz regiszter rsa
	bit	0,(iy+007h)		; rs 0/olvass 1 (?)
	jr	nz,LC997		; ugrs, ha olvass
	ex	de,hl			; cl s forrs felcserlse
LC997:	ldir				; adatok mozgatsa a szektorbuffer s az U3 memria kztt
	ld	a,(0DFFFh)		; A reg.= P_SAVE msolata
	out	(002h),a		; memrialapozs helyrelltsa
	ei				; megszaktsok engedlyezse
	pop	bc			; BC= legutbb tvitt bjtok szma
LC9A0:	pop	hl			; HL= kezd memriacm a verembl
	pop	bc			; BC= sszes tvitt bjtok szma
	add	hl,bc			; tviteli memriacm nvelse az tvitt bjtok szmval
	ld	(0D088h),hl		; j tviteli memriacm letrolsa a bels vltozba
	bit	0,(iy+007h)		; rs 0/olvass 1 (?)
	jr	nz,LC9B1		; ugrs, ha olvass
	call	LDB2E			; 1.lapon lv rutin hvsa (cm: 0D442h)
;
	.dw	0D442h			; aktulis szektorbuffer "piszkos"-nak jellse
;
LC9B1:	pop	hl			; HL= fjlmutat szektoron belli bjtcme
	add	hl,bc			; fjlmutat nvelse az tvitt bjtok szmval
	bit	1,h
	jr	z,LC9BF			; ugrs, ha nem nagyobb 511-nl
	ld	hl,(0D069h)		; HL= aktulis szektorbuffer cme
	call	LDB2E			; 1.lapon lv rutin hvsa (cm: 0D2E8h)
;
	.dw	0D2E8h			; HL-ben adott szektorbuffert elmenti, ha piszkos, s belltja els szektorbuffernek
;
LC9BF:	ex	(sp),ix			; IX helyrelltsa
	pop	hl			; HL= meghajt tblzatcme
	ret


;
;
;	tvitt hossz s htralv bjtok szmnak mdostsa 
;	in:  BC - tvitt bjtok
;	out: BC - megrzdik
;	     HL - megrzdik
;
LC9C3:	push	hl			; HL mentse
	ld	hl,(0D08Ch)		; HL= eddig a lemezrl beolvasott hossz
	add	hl,bc			; hossz nvelse a most tvitt bjtok szmval
	ld	(0D08Ch),hl		; j rtk mentse
	ld	hl,(0D08Ah)		; HL= lemezes tvitel (rs/olvass) hossza
	sbc	hl,bc			; htralv bjtok szmnak cskkentse
	ld	(0D08Ah),hl		; j rtk mentse
	pop	hl			; HL visszalltsa
	ret


;
;
;	Olvasand/rand hossz ellenrzse, fjlmutatnak megfelel klaszter/szektor/bjt cm kiszmtsa
;	(max. 08000h klaszter hosszsg fjlokat kezel)
;	  - olvassnl: ha max. 64kB-al akartunk tbbet olvasni, mdostja az olvassi hosszt
;	                s nem jelez hibt
;	  - rsnl: ha fjl vge utn is tart az rs, kibvti a fjl FAT lncolatt
;	             a szksges klaszterszmmal, s a fjl mrett megnveli az FCB-ben
;	in:  HL - a fizikai meghajt tblzatra mutat
;	     IX - nyitott FCB
;	out:  A - hibakd
;	     HL - megrzdik
;
LC9D5:	push	hl			; HL mentse	
	ld	c,(ix+028h)		; DE:BC tartalmazza a fjlmutatt az FCB-bl
	ld	b,(ix+029h)
	ld	e,(ix+02Ah)
	ld	d,(ix+02Bh)
	push	de			; 32 bites fjlmutat a verembe
	push	bc
	call	LCAE1			; fjlmutat konvertlsa klaszter/szektor/bjt cmzsre
	jr	nz,LCA07		; ugrs, ha nem megengedett cm keletkezett
	ld	(0D08Eh),de		; DE= klaszter sorszma a file FAT lncolatban
	ld	(0D090h),a		; A = szektorsorszm a klaszteren bell
	ld	(0D091h),bc		; BC= szektoron belli bjtcm (<512)
	pop	hl			; HL= fjlmutat als szava
	ld	de,(0D08Ah)		; DE= lemezrl olvasand/rand hossz
	dec	de
	add	hl,de			; fjlmutat als szavnak nvelse a hosszal-1 (utols olvasand bjt)
	ex	(sp),hl			; fjlmutat fels sz HL-be
	pop	bc			; megnvelt als sz BC-be
	ex	de,hl			; HL= hossz-1 DE= fjlmutat eredeti fels szava
	ex	(sp),hl			; hossz-1 mentse a verembe, HL-be a belpskori rtk
	jr	nc,LCA02		; ugrs ha nincs tvitel a fjlmutat als szavnak nvelsekor
	inc	de			; fels sz nvelse, ha szksges
LCA02:	push	de			; utols bjt 32 bites cme a verembe
	push	bc
	call	LCAE1			; utols bjt cmnek konvertlsa klaszter/szektor/bjt cmzsre
LCA07:	jr	nz,LCA6F		; ugrs, ha nem megengedett cm keletkezett
	push	de			; zr klaszter sorszm mentse
	ld	c,(ix+017h)		; fjlmret betltse DE:BC-be
	ld	b,(ix+018h)
	ld	e,(ix+019h)
	ld	d,(ix+01Ah)
	ld	a,b			; fjlmret cskkentse eggyel
	or	c			; BC vizsglata
	dec	bc			; BC cskkentse eggyel, nem lltja a jelzbiteket
	jr	nz,LCA1E		; ugrs, ha az eredeti als sz nem nulla (a fels szt nem kell cskkenteni)
	or	d
	or	e			; DE vizsglata
	dec	de			; DE cskkentse
LCA1E:	push	de			; fjlmret-1 a verembe
	push	bc
	call	nz,LCAE1		; fjlmret-1 konvertlsa a klaszterben adott hossz meghatrozshoz, ha a fjlmret nem nulla
	exx
	pop	hl			; DE':HL'= fjlmret-1
	pop	de
	exx
	pop	bc			; BC= utols olvasand bjt klaszternek sorszma
	jr	nz,LCA6F		; ugrs, ha nem megengedett cm keletkezett a fjlmretbl
	exx
	pop	bc			; BC'= utols bjt cmnek als szava
	xor	a			; CY nullzsa a kivonshoz
	sbc	hl,bc			; utols bjt cm als szavnak kivonsa a fjlmretbl
	ex	(sp),hl			; als szavak klnbsge a verembe
	ex	de,hl			; HL'= fjlmret-1 fels szava DE'= utols bjt cmnek fels szava
	sbc	hl,de			; HL'= fels szavak klnbsge, CY=1 ha utols bjt cme > (fjlmret-1)
	exx
	bit	7,d			; D reg. 7. bitjnek tesztelse, CY-t nem vltoztatja
	ex	af,af'			; flag-ek ments
	bit	0,(iy+007h)		; rs vagy olvass jelzse (?)
	jp	nz,LCAC2		; ugrs, ha olvass (?)
	bit	5,(ix+020h)		; bit tesztels az FCB 20h-ik bjtjban (nem dokumentlt bjt)
	ld	a,09Ah			; hibakd: .FILRO - "csak olvashat" fjlt akartunk rni vagy trlni
	jr	nz,LCA70		; ugrs, ha "csak olvashat" a fjl (?)
	set	6,(ix+020h)		; bit bellts az FCB 20h-ik bjtjban (nem dokumentlt bjt)
	push	hl			; HL belpskori rtknek mentse
	ld	h,b			; HL= az utols rand bjt klaszternek sorszm
	ld	l,c
	inc	de			; DE= (fjlmret-1)-bl szmtott zr klaszter sorszm +1
	or	a			; CY nullzsa
	sbc	hl,de
	ld	c,l			; BC= utols rand bjt klaszternek sorszm - fjlmret klasztersorszm
	ld	b,h
	inc	bc
	pop	hl			; HL-be a belpskori rtk
	jr	c,LCA85			; ugrs, ha a fjlmret klaszterszm >= az utols rand bjt klasztersorszma
	call	LC28C			; BC-ben adott szm elembl ll FAT lncolat ltrehozsa
	jr	nz,LCA70		; ugrs, ha hiba trtnt
	dec	de			; DE= (fjlmret-1)-bl szmtott zr klaszter sorszm
	bit	7,d
	jr	nz,LCA73		; ugrs, ha a klaszterek szma >= 08000h
	push	bc			; BC mentse
	call	LCB17			; fjl lncolaton belli klasztersorszm tnyleges klaszterazonostv konvertlsa
	pop	bc			; BC= bvt FAT lncolat kezdete  DE= a fjl jelenlegi utols klasztere
	jr	nz,LCA70		; ugrs, ha hiba trtnt
	call	LDB2E			; 1.lapon lv rutin hvsa (cm: 0D512h)
;
	.dw	0D512h			; FAT elem belltsa (piszkos diszk megtiszttsa nlkl)
;					; a fjl korbbi FAT lncolathoz hozzfzi a bvt lncolatot
	jr	LCA85			; ugrs a fjlmret belltsra
LCA6F:	pop	de			; hiba esetn a verem kitiszttsa
LCA70:	pop	de
	pop	de
	ret
;
LCA73:	ld	(ix+021h),c		; FCB-beli klasztermutatk belltsa
	ld	(ix+022h),b		; kezd klaszter= bvt FAT lncolat kezdete
	ld	(ix+023h),c		; aktulis klaszter= bvt FAT lncolat kezdete
	ld	(ix+024h),b
	ld	(ix+025h),a		; aktulis klaszter sorszma= 0000h
	ld	(ix+026h),a
LCA85:	exx
	ex	af,af'			; elmentett jelzbitek visszalltsa
	jr	nz,LCA8B		; ugrs, ha a klaszterben adott fjlhossz >08000h (D reg. korbbi rtknek 7. bitje nem nulla volt)
	jr	nc,LCA9D		; ugrs, ha utols bjt cme <= (fjlmret-1)
LCA8B:	inc	bc			; BC'= utols bjt cmnek als szava +1
	ld	a,b			; /DE'= utols bjt cmnek fels szava/
	or	c
	jr	nz,LCA91		; ugrs ha nem volt tvitel BC nvelsekor
	inc	de			; DE' nvelse, ha szksges
LCA91:	ld	(ix+017h),c		; j fjlmret belltsa az FCB-ben
	ld	(ix+018h),b
	ld	(ix+019h),e
	ld	(ix+01Ah),d
LCA9D:	pop	bc			; BC'= (fjlmret-1 - utols bjt cm) als szava
	pop	de			; DE'= rand hossz-1
	ld	a,b			; /HL'= fels szavak klnbsge/
	or	c
	dec	bc			; HL':BC'-ben lv klnbsg cskkentse 1-el
	jr	nz,LCAA5		; ugrs, ha nincs alulcsorduls az als szrl
	dec	hl
LCAA5:	bit	7,h			; H' reg. 7 bitje (alulcsordulsnl 1-be vlt)
	jr	z,LCAB9			; ugrs, ha biztosan nem trtnt alulcsorduls (utols bjt cme < fjlmret-1)
	ld	a,h
	and	l
	inc	a
	ld	hl,0FFFFh		; 64kB-nl nagyobb klnbsg jelzse - pl. a fjlrs a vals fjlmret utn kezddik
	jr	nz,LCABC		; ugrs, ha a cskkents utn HL' nem 0FFFFh volt
	inc	hl			; HL'=0000h
	sbc	hl,bc			; BC'=-BC' az rshoz szksges bvts bjtszma
	jr	nz,LCABC		; ugrs, ha nem nulla
	dec	hl			; HL'=0FFFFh
	jr	LCABC
LCAB9:	ld	hl,00000h
LCABC:	ld	(0D098h),hl		; rshoz szksges fjlmret-nvels bjtokban
	exx
	xor	a			; hibakd trlse
	ret
;
LCAC2:	ex	af,af'			; fjlolvass esetn: elmentett jelzbitek visszalltsa
	pop	de			; DE= (fjlmret-1 - utols bjt cm) als szava
	ex	(sp),hl			; HL=olvasand hossz-1, HL belpskori rtknek mentse
	jr	nz,LCACE		; ugrs, ha a klaszterben adott fjlhossz >08000h (D reg. korbbi rtknek 7. bitje nem nulla volt)
	jr	nc,LCADE		; ugrs, ha utols bjt cme <= (fjlmret-1), A=0
	exx
	ld	a,h			; HL'= (fjlmret-1 - utols bjt cm) fels szava
	and	l			; 0FFFFh -nak kell lennie (max. 64kB-al akartunk tbbet olvasni)
	inc	a			; ebben az esetben A=00h, ZF=1
	exx
LCACE:	ld	a,0ECh			; MOPS hibakd: .EOF - end of file hiba
	jr	nz,LCADE		; ugrs, ha ZF hibt jelez (ZF=0)
	add	hl,de			; HL= (olvasand hossz-1) - amennyivel tbbet akartunk olvasni a fjl hossznl (DE-ben negatv szm van)
	jr	nc,LCADE		; ugrs, ha tovbbra is negatv rtk addik-> a hiba nem kezelhet
	inc	hl			; nveli HL-et, mert eddig olvasand hossz-1 -el szmolt
	ld	(0D08Ah),hl		; a hiba javtva: j olvasand hossz rtk (csak a fjl vgig olvas)
	set	7,(iy+007h)		; jelzs
	xor	a			; hibakd trlse
LCADE:	pop	hl			; HL belpskori rtknek visszalltsa
	or	a
	ret


;
;
;	Fjlmutat konvertlsa klaszter/szektor/bjt cmzsre
;	in:  BC - fjlmutat als sz
;	     DE - fjlmutat fels sz
;	     HL - a fizikai meghajt tblzatra mutat
;	out:  A - szektorsorszm a klaszteren bell
;	     BC - szektoron belli bjtcm (<512)
;	     DE - klaszter sorszma a file FAT lncolatban (?)
;	     HL - belpskori rtk megrizve
;	     ZF - 0: hiba trtnt
;
LCAE1:	push	hl			; HL mentse
	ld	a,b			; fjlmutat osztsa 512-vel
	srl	d
	rr	e
	rra				; eredmny DE:A regiszterhrmasban (szektor cm)
	ld	b,000h
	rl	b			; maradk BC-ben
	push	bc			; maradk a verembe
	ld	bc,0000Ah
	add	hl,bc
	push	af
	and	(hl)			; maszkols a klaszter szektorszmnak megfelelen
	ld	c,a			; eredmny C-be
	ld	a,(hl)
	inc	a			; a maszk eggyel nvelve megadja a klaszterenknti szektorszmot
	ld	(0D093h),a		; klaszterenknti szektorszm mentse (?)
	pop	af
	inc	hl
	ld	b,(hl)			; B= klaszterenknti szektorszm 2 alap logaritmusa(?)
	inc	b			; B nvelse eggyel a DJNZ utastshoz
	jr	LCB04			; ugrs a ciklus tesztfelttelre
LCAFF:	srl	d			; DE:A regiszterhrmas jobbralptetse B-szer
	rr	e			; (oszts a klaszterenknti szektorszmmal)
	rra
LCB04:	djnz	LCAFF
	inc	d
	dec	d
	jr	nz,LCB12		; ugrs, ha D nem nulla
	bit	7,e
	jr	nz,LCB12		; ugrs, ha E regiszter legfels bitje sem nulla
	ld	d,e			; DE= klaszter sorszma a file FAT lncolatban (?)
	ld	e,a
	ld	a,c			; A= szektorsorszm a klaszteren bell
;
	.db	021h			; a kvetkez 2 bjttal ezt az utastst adja:ld hl,0A53Eh
;
LCB12:	ld	a,0A5h			; hibakd bellts, ha az LCB12 cmre ugrik: .FILE - srlt FAT lncolat
	pop	bc			; BC szektoron belli bjtcm (<512)
	pop	hl			; HL visszalltsa
	ret


;
;
;	Fjl lncolaton belli klasztersorszm tnyleges klaszterazonostv konvertlsa
;	in:  DE - fjl FAT lncolatn belli klaszter sorszm
;	     HL - a fizikai meghajt tblzatra mutat
;	     IX - nyitott FCB
;	out: DE - a FAT tblzaton belli klaszter sorszm
;	     HL - megrzdik
;	     IX - megrzdik
;
LCB17:	push	hl
	ex	de,hl			; HL= keresett sorszm
	ld	e,(ix+023h)		; DE= ? fjl aktulis klasztere
	ld	d,(ix+024h)
	ld	a,d
	or	e
	jr	z,LCB44			; ugrs, ha DE= 0000h
	ld	c,(ix+025h)		; BC= ? fjl aktulis klaszternek sorszma (a fjl FAT lncolatban)
	ld	b,(ix+026h)
	sbc	hl,bc
	jr	nc,LCB34		; ugrs ha a cl sorszm >= az aktulis sorszmmal
	add	hl,bc			; egybknt a fjl elejrl indul
	ld	e,(ix+021h)		; DE= ? a fjl els klasztere
	ld	d,(ix+022h)
LCB34:	ex	(sp),hl			; HL a fizikai meghajt tblzatra mutat
	pop	bc			; BC= klaszterek szma
LCB36:	ld	a,b			; ciklusszmll (BC) ellenrzse
	or	c
	ret	z			; visszatrs, ha BC= 0000h
	dec	bc			; ciklusszmll cskkentse
	call	LDB2E			; 1.lapon lv rutin hvsa (cm: 0D4C8h)
;
	.dw	0D4C8h			; adott klaszterhez tartoz FAT bejegyzs kiolvassa
;
	bit	7,d
	jr	z,LCB36			; ismtls, ha mg nincs fjl vge jelzs (valjban: DE>=08000h)
	.db	03Eh			; a kvetkez bjttal: ld a,0E1h (elfedi pop hl-t)
LCB44:	pop	hl
	ld	a,0A5h			; hiba: .FILE - a FAT lncolat rvidebb mint, ami a fjl mretbl addik
	or	a
	ret



;
;
;	DISKIO belpsi pont
;	in:   A - parancskd
;	      B - meghajt kivlasztsa vagy meghajt maszk (0. parancs)
;	      C - oldal szma
;	      D - sv szma
;	      E - szektor szma
;	      H - floppy vezrl paramterbjt
;	      L - (tvivend) szektorok szma
;	     IX - diszk tviteli cm
;	out:  A - hibajelz bitek
;	      F - jelzbitek "OR A" utastssal belltva
;	      B - vltozatlan (kivve 7. parancs)
;	      L - t nem vitt szektorok szma vagy meghajt tpusa (8. parancs)
;	     sszes tbbi regiszter (norml s msodlagos) - megrzdik
;
LCB49:	push	iy			; rgi adatterlet bziscmnek mentse
	ld	iy,0D080h		; j adatterlet-bziscm belltsa
	ld	(iy-04Ah),06Eh		; bels idzt (SEL_TIME) belltsa 110-re
	ld	(iy-04Fh),a		; belpsi paramterek lementse
	ld	(iy-04Dh),c
	ld	(iy-04Bh),e
	ld	(iy-04Ch),d
	push	de
	push	ix
	pop	de			; DE= diszk tviteli cm
	push	de
	push	bc
	ld	c,(iy-055h)		; C= floppy illeszt krtya csatlakoz szma (alap I/O port cm)
	or	a
	jr	z,LCB86			; ugrs, ha A=0
	sub	007h
	jp	c,LCBFC			; ugrs, ha A<7
	jr	z,LCB81			; ugrs, ha A=7
	dec	a
	jr	z,LCBB3			; ugrs, ha A=8
LCB75:	ld	a,080h			; hibajelz: ismeretlen parancs
	ld	l,000h
LCB79:	pop	bc
LCB7A:	pop	ix
	pop	de
	pop	iy
	or	a			; flag-ek belltsa
	ret				; visszatrs a hvhoz


;
;
;	DISKIO: 7. parancs (nem hasznlt)
;
LCB81:	pop	bc
	ld	b,a			; B= 00h
	ld	l,a			; L= 00h
	jr	LCB7A			; ugrs a befejezsre (A reg.= 00h)


;
;
;	DISKIO: 0. parancs - diszk-rendszer reset
;	in:  B - meghajt maszk
;	out: -
;
LCB86:	ld	a,b			; A reg.= meghajt maszk
	and	00Fh			; csak az als 4 bit meghagysa -> minden bit egy meghajt
	push	iy
LCB8B:	srl	a			; aktulis meghajt maszk-bitjnek kilptetse CY-be
	jr	nc,LCB93		; ugrs, ha nem kell reset-elni
	ld	(iy-053h),0FFh		; aktulis sv belltsa "hatrozatlan" rtkre
LCB93:	inc	iy
	jr	nz,LCB8B		; ismtls, ha van mg htra meghajt
	pop	iy
	in	a,(c)			; A reg.= FDC llapotregiszter
	rrca
	jr	nc,LCBA2		; ugrs, ha a BUSY jel nem aktv
	ld	a,0D0h			; A reg.= befejezs interrupt nlkl parancs
	out	(c),a			; parancs az FDC-nek
LCBA2:	xor	a
	cp	b			; meghajtmaszk ellenrzse
	jr	nz,LCB79		; visszatrs a funkcibl, ha B nem 0 volt
	xor	a
	set	2,c			; C= paramter regiszter cme
	out	(c),a			; regiszter kinullzsa (egy meghajt sincs kivlasztva)
	ld	(0DFFBh),a		; rtk bellts a RAM vltozba
	ld	(iy-054h),a		; s a 0D02Ch cmre is
	jr	LCB79			; visszatrs a funkcibl


;
;
;	DISKIO: 8. parancs - meghajt vizsglata
;	in:   B - kivlasztott meghajt (1,2,4,8) vagy 0 ha a meghajtk szmnak vizsglata kell
;	out:  A - hibakd vagy 0 ha egy meghajt van s <>0 ha kett
;
LCBB3:	ld	(iy-04Eh),040h		; motor bekapcsolt llapot jelzse a flag bjtban (0D032h)
	ld	a,b			; A reg.= meghajtt kivlaszt kd
	neg				; A reg.= 0 - A reg.
	and	b			; csak a legkisebb sorszm meghajtt hagyja meg, ha tbb bit is aktv lett volna
	and	00Fh
	jr	z,LCBEB			; ugrs, ha nincs meghajt megadva
	call	LCDE0			; A reg.-ben adott meghajt alaphelyzetbe lltsa (fej a 0. svra)
	call	LCE47			; vrakozs
	ld	d,032h			; D= 50 svot fog befel lptetni
LCBC7:	ld	b,058h			; B= FDC Step In (fej mozgatsa a kvetkez nagyobb sorszm svra)
	call	LCDF7			; parancs vgrehajtsa
	dec	d
	jr	nz,LCBC7		; ismtls 50-szer
	call	LCE47			; vrakozs
LCBD2:	ld	b,078h			; B= FDC Step Out (fej mozgatsa a kvetkez kisebb sorszm svra)
	call	LCDF7			; parancs vgrehajtsa
	jr	nz,LCBE0		; ugrs, ha elrte a 0. svot
	inc	d
	jr	nz,LCBD2		; ismtls legfeljebb 256-szor
	ld	a,001h			; hibakd: a meghajt nem zemksz
	jr	LCBF6			; ugrs a befejezsre
;
LCBE0:	ld	l,000h			; 40 svos meghajt jelzse L-ben
	ld	a,d			; A reg.= kilptetsek szma
	sub	031h			; A reg.= A reg. - 49
	ld	a,l			; hibakd: nincs hiba
	jr	c,LCBF6			; ugrs, ha 49-nl kevesebbszer kellett kifel lptetni (L= 000h)
	dec	l			; L= 0FFh -> 80 svos a meghajt
	jr	LCBF6			; ugrs a befejezsre
;
LCBEB:	inc	a			; A reg.= 001h (A: meghajt)
	call	LCDE0			; adott meghajt alaphelyzetbe lltsa
	sub	002h
	ld	a,002h			; A reg.= 002h (B: meghajt)
	call	z,LCDE0			; ha volt A: meghajt, akkor B: meghajt alaphelyzetbe lltsa
LCBF6:	call	LCE47			; vrakozs
	jp	LCB79			; visszatrs a funkcibl


;
;
;	DISKIO: 1.-6. parancs
;	in:   B - meghajtt kivlaszt kd (1,2,4,8)
;	      C - floppy illeszt alap I/O cme
;	     DE - diszk tviteli cm
;	      H - floppy vezrl paramterbjt
;	      L - szektorok szma
;	out:  A - hibajelz bitek
;	      L - t nem vitt szektorok szma
;
LCBFC:	ld	a,(0DFFBh)		; A reg.= paramter regiszter msolata
	and	040h			; motorvezrl bit meghagysa
	ld	(iy-04Eh),a		; kezdrtk a flag bjtba is (0D032h)
	ld	a,b			; A reg.= meghajtt kivlaszt kd
	neg
	and	b			; csak a legkisebb sorszmt hagyja meg, ha tbb bit is aktv lett volna
	and	00Fh			; sszesen 4 meghajtt kezel, ami az als 4 biten van trolva
	jp	z,LCB75			; ha nulla, akkor visszatrs a funkcibl, hibajelzs: nincs megadva meghajt
	push	de			; diszk tviteli cm a verembe
	ld	e,a			; meghajt bit E-be
	push	iy
	pop	ix			; IX= 0D080h
LCC13:	inc	ix			; IX eltolsa a kivlasztott meghajtnak megfelelen (1..4)
	rrca
	jr	nc,LCC13
	ld	d,(ix-054h)		; D= meghajt aktulis sv sorszma (0D02Dh..0D030h cmrl)
	bit	0,(iy-04Dh)		; oldal szm ellenrzse
	jr	z,LCC23			; ugrs, ha a 0. oldal kell
	set	7,e			; 7.bit belltsa E-ben
LCC23:	bit	5,h			; 5.bit tmsolsa a paramterbjtbl (dupla srsg md)
	jr	z,LCC29
	set	5,e
LCC29:	set	6,e			; 6.bit belltsa E-ben: motor bekapcsolsa
	ld	a,e			; paramter regiszterbe rand rtk A reg.-be is
	ld	(0DFFBh),a		; port msolatnak mentse a RAM vltozba
	set	2,c			; C a paramter regiszter cmre mutat (x4h)
	out	(c),a			; paramter regiszter belltsa
	res	2,c			; C visszalltsa az alap I/O cmre
	xor	(iy-054h)		; 0D02Ch cm als 4 bitjnek invertlsa a kivlasztott meghajtval
	and	00Fh
	jr	z,LCC42			; ugrs, ha korbban is az aktulis meghajt volt kivlasztva
	inc	(iy-04Eh)		; fej felemels jelzse a flag bjt 0. bitjn (0D032h)
	ld	(iy-054h),e		; aktulis paramter regiszter mentse a 0D02Ch cmre is
LCC42:	inc	d			; meghajt aktulis svszmnak nvelse
	jr	nz,LCC4C		; ugrs, ha nem 0FFh volt
	inc	d			; D= 001h (megrzdik a szubrutin-hvsok utn)
	call	LCDF5			; FDC restore: fej mozgatsa a 0. svra
	call	LCE47			; vrakozs
LCC4C:	dec	d			; D= ismt a meghajt aktulis svszma
	ld	a,(iy-04Ch)		; A reg.= belltand svszm
	ld	e,a			; belltand svszm E-be is
	inc	a
	jr	nz,LCC55		; ugrs, ha nem 0FFh a megadott svszm
	ld	e,d			; aktulis svszm msolsa E-be
LCC55:	push	de			; aktulis s belltand svszm a verembe
	bit	3,h			; duplaplya jelz bit vizsglata a megadott paramterbjtban
	jr	z,LCC5E			; ugrs, ha nem kell
	sla	d			; svszmok szorzsa 2-vel
	sla	e
LCC5E:	inc	c			; I/O cm nvelse
	out	(c),d			; FDC sv regiszter rsa az aktulis svszmmal
	inc	c			; I/O cm nvelse
	ld	a,(iy-04Bh)		; A reg.= szektor (0D035h)
	out	(c),a			; FDC szektor regiszter rsa
	inc	c			; I/O cm nvelse
	out	(c),e			; FDC adat regiszter rsa a belltand svszmmal
	dec	c
	dec	c
	dec	c			; C vissza az alap I/O cmre
	ld	a,d
	cp	e			; svszmok sszehasonltsa
	jr	z,LCC75			; ugrs, ha megegyeznek
	set	2,(iy-04Eh)		; flag bjtban (0D032h) a 2.bit belltsa
LCC75:	ld	b,018h			; B= FDC Seek (fej mozgatsa az adat regiszterben lv svra)
	call	LCDF7			; TYPE I Parancs vgrehajtsa
	pop	de			; svszmok visszatltse a verembl
	inc	c			; I/O cm nvelse
	out	(c),e			; FDC sv regiszter rsa az j svszmmal
	dec	c
	ld	(ix-054h),e		; j svszm bersa az aktulis meghajt tblzatba
	ld	a,(iy-04Fh)		; A reg.= lementett parancskd (0D031h)
	ld	d,a			; parancskd D-be is
	sub	004h
	cp	002h
	jr	nc,LCC8E		; ugrs, ha 1,2,3,6 -os parancs volt
	ld	l,001h			; szektorszm belltsa 1-re
LCC8E:	ld	b,l			; szektorszm B-be is
	ex	(sp),hl			; HL= tviteli memriacm, a mdostott szektorszm a verembe
	call	LCE4F			; megszaktsok tiltsa
	push	af			; CY mentse
LCC94:	ld	a,082h			; FDC parancskd kialaktsa A reg.-ben: 82h- olvass, oldal ellenrzssel
	bit	0,(iy-04Dh)		; oldal szma (0D033h)
	jr	z,LCC9E			; ugrs, ha 0. oldal
	set	3,a			; 1. oldal blltsa az FDC parancskdban
LCC9E:	dec	d			; DISKIO parancskd cskkentse
	jr	z,LCCB8			; ugrs, ha 1. parancs volt (szektorok olvassa)
	add	a,020h			; rsflag belltsa az FDC parancskdban
	dec	d
	jr	z,LCCEA			; ugrs, ha 2. parancs volt (szektorok rsa)
	sub	020h			; rsflag trlse
	dec	d
	jp	z,LCD15			; ugrs, ha 3. parancs volt (szektorok ellenrzse)
	dec	d
	ld	a,0F8h			; A reg.= write track
	jr	z,LCCEA			; ugrs, ha 4. parancs volt (sv formzsa)
	dec	d
	ld	a,0E8h			; A reg.= read track
	jr	z,LCCB8			; ugrs, ha 5. parancs volt (sv olvassa)
	ld	a,0C8h			; 6. parancs (cm olvassa)

;
;
;	1.(szektorok olvassa), 5.(sv olvassa) s 6.(cm olvassa) parancs vgrehajtsa
;
LCCB8:	call	LCDB6			; parancs kiadsa az FDC-nek
	jp	nz,LCD46		; ugrs, ha nem sikerlt
	set	2,c			; I/O cm belltsa a hardver llapotregiszterre (x4h)
	ld	de,09B93h		; DE= vrakozsi id a parancs vgrehajtsnak elkezdshez
LCCC3:	jr	LCCC5			; a pontos idztshez kell (?)
LCCC5:	in	a,(c)			; llapotregiszter olvassa
	jp	m,LCCDA			; ugrs, ha a 7.bit=1 (DRQ)
	dec	de			; idzt cskkentse
	in	a,(c)			; llapotregiszter olvassa
	jp	m,LCCDA			; ugrs, ha a 7.bit=1 (DRQ)
	ld	a,d			; idzt ellenrzse
	or	e
	jp	z,LCD46			; ugrs, ha letelt a megengedett id
	in	a,(c)			; llapotregiszter olvassa
	jp	p,LCCC3			; ugrs, ha a 7.bit=0 (nincs DRQ)
LCCDA:	dec	c			; C az FDC adatregiszterre mutat
	in	a,(c)			; adat beolvassa A reg.-be
	ld	(hl),a			; adat trolsa
	inc	hl			; memriacm nvelse
	inc	c			; I/O cm visszalltsa az llapotregiszterre
LCCE0:	in	a,(c)			; llapotregiszter olvassa
	jr	z,LCCE0			; ugrs, ha 0 (nincs INTRQ s nincs DRQ)
	jp	m,LCCDA			; ugrs, ha a 7.bit=1 (DRQ)
	jp	LCD5C			; ugrs a parancs befejezsre (INTRQ volt)

;
;
;	2.(szektorok rsa) s 4.(sv formzsa) parancs vgrehajtsa
;
LCCEA:	call	LCDB6			; parancs kiadsa az FDC-nek
	jr	nz,LCD46		; ugrs, ha nem sikerlt
	set	2,c			; I/O cm belltsa a hardver llapotregiszterre (x4h)
	ld	de,0DF82h		; DE= vrakozsi id a parancs vgrehajtsnak elkezdshez
LCCF4:	dec	de			; idzt cskkentse
	ld	a,d			; idzt ellenrzse
	or	e
	jr	z,LCD46			; ugrs, ha letelt a megengedett id
	in	a,(c)			; llapotregiszter olvassa
	jp	m,LCD02			; ugrs, ha a 7.bit=1 (DRQ)
	jr	nz,LCD46		; ugrs, ha a 0.bit=1 (INTRQ)
	jr	LCCF4			; ugrs a vrakozs folytatsra
;
LCD02:	dec	c			; C az FDC adatregiszterre mutat
	ld	e,c			; cm E-be is
LCD04:	inc	c			; I/O cm visszalltsa az llapotregiszterre
	ld	d,(hl)			; rand adat D-be
	inc	hl			; memriacm nvelse
LCD07:	in	a,(c)			; llapotregiszter olvassa
	jr	z,LCD07			; ugrs, ha 0 (nincs INTRQ s nincs DRQ)
	ld	c,e			; adatregiszter cme C-be
	out	(c),d			; adat rsa
	jp	m,LCD04			; ugrs, ha a 7.bit=1 volt (DRQ)
	inc	c			; C az llapotregiszterre mutat
	dec	hl			; memriacm visszalltsa
	jr	LCD5C			; ugrs a parancs befejezsre (INTRQ volt)

;
;
;	3.(szektorok ellenrzse) parancs vgrehajtsa
;
LCD15:	call	LCDB6			; parancs kiadsa az FDC-nek
	jr	nz,LCD46		; ugrs, ha nem sikerlt
	set	2,c			; I/O cm belltsa a hardver llapotregiszterre (x4h)
	ld	de,09B93h		; DE= vrakozsi id a parancs vgrehajtsnak elkezdshez
LCD1F:	jr	LCD21			; a pontos idztshez kell (?)
LCD21:	in	a,(c)			; llapotregiszter olvassa
	jp	m,LCD35			; ugrs, ha a 7.bit=1 (DRQ)
	dec	de			; idzt cskkentse
	in	a,(c)			; llapotregiszter olvassa
	jp	m,LCD35			; ugrs, ha a 7.bit=1 (DRQ)
	ld	a,d			; idzt ellenrzse
	or	e
	jr	z,LCD46			; ugrs, ha letelt a megengedett id
	in	a,(c)			; llapotregiszter olvassa
	jp	p,LCD1F			; ugrs, ha a 7.bit=0 (nincs DRQ)
LCD35:	dec	c			; C az FDC adatregiszterre mutat
	in	a,(c)			; adat beolvassa A reg.-be
	inc	c			; I/O cm visszalltsa az llapotregiszterre
	cp	(hl)			; adat sszehasonltsa a memriban lvvel
	jr	nz,LCD52		; ugrs, ha nem egyeznek meg
	inc	hl			; memriacm nvelse
LCD3D:	in	a,(c)			; llapotregiszter olvassa
	jr	z,LCD3D			; ugrs, ha 0 (nincs INTRQ s nincs DRQ)
	jp	m,LCD35			; ugrs, ha a 7.bit=1 volt (DRQ)
	jr	LCD5C			; ugrs a parancs befejezsre (INTRQ volt)

;
;
;	Idtllpsi hibk kezelse
;
LCD46:	ld	d,001h			; D= hibakd: nem zemksz
	set	2,c			; I/O cm belltsa a hardver llapotregiszterre (x4h)
	in	a,(c)			; llapotregiszter olvassa
	and	001h			; INTRQ bit vizsglata
	jr	nz,LCD5E		; ugrs, ha az FDC megszaktskrse aktv
	jr	LCD54			; egybknt az aktulis parancs befejezse

;
;
;	Szektor ellenrzsi hiba
;
LCD52:	ld	d,002h			; D= hibakd: hiba az adat-ellenrzsnl
LCD54:	ld	a,0D0h			; A reg.= Forced Interrupt parancs (befejezi az aktulis parancs vgrehajtst)
	res	2,c			; C visszalltsa az alap I/O cmre
	out	(c),a			; FDC parancsregiszter rsa
	jr	LCD80

;
;
;	Hibtlan parancsvgrehajts
;
LCD5C:	ld	d,000h			; D= hibakd: nincs hiba
LCD5E:	res	2,c			; C visszalltsa az alap I/O cmre
	in	a,(c)			; FDC llapotregiszternek olvassa (megszaktskrs nyugtzsa)
	and	0DCh			; sttuszbitek maszkolsa
	jr	nz,LCD7F		; ugrs, ha valamelyik vizsglt bit aktv
	or	d			; D-ben lv hibakd ellenrzse s bemsolsa A reg.-be
	jr	nz,LCD7F		; ugrs, ha volt hiba
	dec	b			; szektorszmll cskkentse
	jr	z,LCD7F			; ugrs, ha minden szektort tvitt
	inc	c
	inc	c			; C az FDC szektorregiszterre mutat
	in	a,(c)			; szektorcm beolvassa
	inc	a			; szektorcm nvelse
	out	(c),a			; nvelt rtk visszarsa
	dec	c
	dec	c			; C visszalltsa az alap I/O cmre
	ld	(iy-04Eh),040h		; 0D032h 6.bit=1 -> motor bekapcsolva
	ld	d,(iy-04Fh)		; lementett parancskd vissza D-be (0D031h)
	jp	LCC94			; parancs vgrehajtsa a kvetkez szektoron

;
;
;	Parancs befejezse
;
LCD7F:	ld	d,a			; hibakd vagy sttuszbitek D-be
LCD80:	ld	a,(iy-04Fh)		; lementett parancskd A reg.-be (0D031h)
	sub	002h
	jr	z,LCD8D			; ugrs ha a 2. parancs volt (szektorok rsa)
	sub	002h
	jr	nz,LCD90		; ugrs ha nem a 4. parancs volt (sv formzsa)
	ld	a,0BFh			; A reg.= vrakozsi rtk
LCD8D:	dec	a			; A reg. cskkentse, amg nem lesz nulla
	jr	nz,LCD8D
LCD90:	ld	(iy-04Ah),06Eh		; SEL_TIME (0D036h) belltsa 110-re
	pop	af			; megszaktsok letiltsnl kapott CY rtk visszalltsa
	jr	c,LCD98			; ugrs, ha CY=1 volt (nem volt korbban engedlyezve a megszakts (?))
	ei				; megszaktsok engedlyezse
LCD98:	pop	hl			; szektorszm vissza L-be
	ld	a,l			; tervezett szektorszm A reg.-be
	sub	b			; tnylegesen tvitt szektorok szmnak kivonsa
	ld	l,a			; t nem vitt szektorszm L-be
	ld	a,(iy-049h)		; vletlenszm cmszmllja A reg.-be (0D037h)
	inc	(iy-049h)		; szmll nvelse
	and	003h			; az als kt bit megtartsa (4 bjtos a vletlenszm)
	ld	c,a			; aktulis cm BC-be
	ld	b,000h
	push	iy
	pop	ix			; adatterlet bziscmnek betltse IX-be
	add	ix,bc			; vletlenszm aktulis cmnek hozzadsa
	ld	a,r			; R regiszter A reg.-be (7 bites vletlenszm)
	ld	(ix-059h),a		; szm trolsa a 0D027h..0D02Ah cmen
	ld	a,d			; hibakd A reg.-be
	jp	LCB79			; ugrs a hvhoz val visszatrsre


;
;
;	TYPE II v. III Parancs kiadsa az FDC-nek
;	in:   A - FDC parancskd
;	      C - I/O bziscm
;	out:  A - hibakd: 0FFh - hiba trtnt
;	     BC - megrzdik
;	     HL - megrzdik
;
LCDB6:	ld	de,02925h		; DE= vrakozsi id (kb. 275ms)
	bit	6,(iy-04Eh)		; 0D032h flagbjt 6.bit: motor
	jr	nz,LCDC2		; ugrs, ha a motor be van kapcsolva
	ld	de,0B24Eh		; vrakozsi id megnvelse (kb. 1180ms)
LCDC2:	push	af			; FDC parancskd mentse
LCDC3:	ex	(sp),hl			; vrakozs (+19 rajel)
	ex	(sp),hl			; vrakozs (+19 rajel)
	dec	de			; idzt cskkentse
	ld	a,d
	or	e
	jr	z,LCDDC			; ugrs, ha letelt a vrakozsi id
	in	a,(c)			; FDC llapotregiszter olvassa
	jp	m,LCDC3			; ugrs, ha a 7.bit=1 (not ready)
	pop	af			; parancskd vissza A reg.-be
	bit	2,(iy-04Eh)		; flag bjt (0D032h) 2.bit viszglata: svszmok eltrnek
	jr	z,LCDD8			; ugrs, ha nem
	set	2,a			; 15ms-os ksleltets belltsa a parancskdban
LCDD8:	out	(c),a			; parancs regiszter rsa
	xor	a			; hibakd trlse
	ret
;
LCDDC:	pop	af			; verem kitakartsa
	xor	a
	dec	a			; A reg.= 0FFh  ZF=0
	ret


;
;
;	Adott meghajt alaphelyzetbe lltsa
;	in:   A - meghajtt kivlaszt rtk
;	out:  -
;
LCDE0:	ld	b,a			; meghajtkd B-be
	xor	a			; A reg.= 0. parancs -> diszk-rendszer reset
	call	LCB49			; reset vgrehajtsa a DISKIO frutin meghvsval
	ld	a,(0DFFBh)		; A reg.= paramter regiszter korbbi rtke
	xor	b			; fels 4 bit el-invertlsa a paramterknt adott rtkkel
	and	0F0h			; als bitek trlse
	xor	b			; ismtelt invertls, gy vgl csak az als 4 bit vltozik meg
	ld	(0DFFBh),a		; paramter regiszter j rtknek mentse a RAM-ba is
	set	2,c
	out	(c),a			; paramter regiszter rsa
	res	2,c
;
LCDF5:	ld	b,008h			; B= FDC parancs: restore (fej mozgatsa a 0. svra)


;
;
;	TYPE I Parancs vgrehajtsa, fejleengedssel a parancs kezdetekor (h= 1)
;	in:   B - TYPE I FDC parancs:
;	           008h - Restore  (fej mozgatsa a 0. svra)
;	           018h - Seek     (fej mozgatsa az adat regiszterben lv svra)
;	           058h - Step In  (fej mozgatsa a kvetkez nagyobb sorszm svra)
;	           078h - Step Out (fej mozgatsa a kvetkez kisebb  sorszm svra)
;	      C - I/O bziscm
;	      H - bit1..0 - fejlptetsi sebessg
;	out:  A - TRACK00 bit a sttusz regiszterbl (az 1.biten)
;	      C - megrzdik
;	      D - megrzdik
;	     HL - megrzdik
;
LCDF7:	push	hl			; HL mentse
	ld	a,h
	and	003h			; A reg.= fejlptetsi sebessg
	or	b			; parancskd sszelltsa
	out	(c),a			; parancs regiszter rsa
	ld	e,(iy-04Eh)		; flag bjt (0D032h) E-be
	ld	a,(iy-04Fh)		; A reg.= a DISKIO lementett parancskdja (0D031h)
	res	1,a
	dec	a
	jr	z,LCE35			; ugrs, ha 1.(szektorok olvassa) vagy 3.(szektorok ellenrzse) parancs
	bit	0,e
	jr	z,LCE16			; ugrs, ha a fej mr le volt engedve
	res	0,e			; fej leengeds jelzse
	ld	b,022h			; vrakozs kb. 34 * 256 * 16 gpi ciklusig (~ 45 ms)
LCE11:	dec	a
	jr	nz,LCE11
	djnz	LCE11
LCE16:	bit	6,e
	jr	nz,LCE34		; ugrs, ha a motor bekapcsolt llapotban van
	set	6,e			; motor bekapcsols jelzse
	in	b,(c)			; FDC sttusz beolvassa B-be
	ld	hl,0B631h		; HL= vrakozsi id kezdrtke
LCE21:	in	a,(c)			; FDC sttusz beolvassa A reg.-be
	xor	b
	rlca				; zemksz bit kilptetse CY-e
	jr	nc,LCE2F		; ugrs, ha nem vltozott
	in	b,(c)			; j FDC sttusz beolvassa B-be
	ld	a,00Ch			; eddig eltelt vrakozsi id vizsglata
	cp	h
	jr	nc,LCE2F		; ugrs, ha H kisebb 13-nl
	ld	h,a			; htralv vrakozsi id lecskkentse (H=12)
LCE2F:	dec	hl			; szmll cskkentse
	ld	a,h
	or	l
	jr	nz,LCE21		; ismtls, amg a vrakozsi id le nem telt
LCE34:	.db	021h			; a kvetkez bjtokkal: LD HL,093CBh -> elfedi RES 2,E -t
LCE35:	res	2,e
	ld	(iy-04Eh),e		; llapotjelzk elmentse (0D032h)
LCE3A:	ld	(iy-04Ah),06Eh		; SEL_TIME = 110 (0D036h)
	in	a,(c)			; FDC sttusz beolvassa A reg.-be
	rrca				; legals (BUSY) bit belptetse CY-be
	jr	c,LCE3A			; ismtls, amg az FDC foglalt (BUSY=1)
	pop	hl			; HL helyrelltsa
	and	002h			; TRACK00 bit megtartsa a sttuszbl A reg.-ben (korbban A reg.-et jobbra lptette)
	ret


;
;
;	Vrakoz rutin (kb. 30 ms)
;	in:   E - els ciklus hossza
;	out:  B - 000h
;	      E - 000h
;
LCE47:	ld	b,018h			; B= kls ciklusok szmllja
LCE49:	dec	e
	jr	nz,LCE49		; bels ciklus
	djnz	LCE49			; kls ciklus
	ret

;
;
;	Megszaktsok tiltsa
;	in:  -
;	out:  CY - CY=1 -> korbban nem volt engedlyezve a megszakts
;
LCE4F:	xor	a			; A reg. nullzsa
	push	af			; rtk trolsa a veremben
	pop	af			; veremmutat visszalltsa a visszatrsi cmre
	ld	a,r			; IFF2 bit bemsolsa a PF flag-be
	di				; megszaktsok tiltsa: IFF2 <- 0
	ret	pe			; visszatrs, ha korbban az IFF2 bit 1 volt (engedlyezett volt a megszakts)
	dec	sp			; veremmutat tlltsa a rutin elejn letrolt AF rtkre
	dec	sp
	pop	af			; korbban letrolt rtk visszatltse
	or	a
	ret	nz			; visszatrs, ha a veremtartalom megvltozott (?)
	scf				; CY belltsa
	ret

;
;
;	-------- Eddig tart a DISKIO --------
;
;




;
;
;	MOPS megszaktskezel (0.funkci) ROM-ban fut rsze
;
;	els hvskor:
;	- EXT2 ellenrzse, ha mg nem hasznlt s megfelel a BASIC verzi, EXT2-t belltja a sajt kd cmre
;	- EXT2 sikeres belltsa esetn a MOPS megszaktskezel rutin CALL utastsnak paramtert trja,
;	  hogy legkzelebb csak az idztk frisstse legyen meghvva
;	minden megszaktskor:
;	- idzt vltozk frisstse
;
LCE5D:	ld	hl,(00025h)		; EXT2 cme az USRTAB -ban
	ld	a,h
	or	l
	jr	nz,LCE84		; ugrs, ha mr foglalt
	ld	hl,00E98h		; PROGID (programazonost) cme (csak a BASIC 1.3 verzitl)
	ld	b,011h			; 17 karakter sszehasonltsa
	call	LCEA1			; "TV COMPUTER BASIC" szveg ellenrzse
	jr	z,LCE78			; ugrs, ha megegyezik
	ld	hl,00100h		; egybknt az ASCII kperny memriaterletn prblkozik
	ld	b,003h			; de most csak 3 karaktert ellenriz
	call	LCEA1			; "TV " szveg ellenrzse
	jr	nz,LCE84		; ugrs, ha ez sem egyezik
LCE78:	ld	hl,0EE84h
	ld	(0DBCCh),hl		; 0EE84h cm bersa a RAM-ba (legkzelebbi megszaktskor mr csak ez a programrszlet kerl meghvsra)
	ld	hl,(0DB26h)		; HL= a krtya azonost neve (VT-DOS) utni bjt cme (az U0 RAM eljn lv "krtyapufferben")
	ld	(00025h),hl		; cm belltsa EXT2-nek

;
;	EXT2 cmnek belltsa utn mr csak ez a programrsz hvdik meg a megszaktskor
;
LCE84:	ld	hl,0DB1Eh		; bels STOP_FLAG
	ld	a,(00B16h)		; A reg.= STOP_FLAG ( 0FFH: CTRL+ESC-et nyomtak)
	cp	(hl)
	jr	z,LCE91			; ugrs, ha megegyezik az op. rendszer stop flag-je a sajt bels flag-el
	ld	(hl),a			; egybknt tmsols a bels STOP_FLAG-be
	ld	(0DFF4h),a		; s a msik bels RAM vltozba is
LCE91:	ld	a,(00003h)		; A ref.= P_SAVE (elmentett felhasznli memrialapozs)
	ld	(0DFFFh),a		; P_SAVE mentse a bels RAM-ba
	call	LCEC0			; idztsi vltozk frisstse
	ld	a,(0DFFFh)		; P_SAVE visszalltsa
	ld	(00003h),a
	ret				; visszatrs a f megszaktsi rutinba


;
;
;	TVC BASIC verzi ellenrzse
;	in:   B - sszehasonlts hossza
;	     HL - ellenrzend szveg kezdcme
;	out: DE - aktulis pozci a sajt szvegben
;	     HL - aktulis pozci az ellenrzend szvegben
;	     ZF - ZF=1 ha megegyezik a sajt szveggel
;
LCEA1:	ld	de,LCEAC		; DE= sajt letrolt szveg kezdete
LCEA4:	ld	a,(de)
	cp	(hl)			; aktulis karakterek sszehasonltsa
	ret	nz			; visszatrs, ha nem egyeznek meg (ZF=0)
	inc	de			; karakterpozcik nvelse
	inc	hl
	djnz	LCEA4			; ismtls a kvnt hossz elrsig
	ret


LCEAC:	.db	"TV COMPUTER BASIC 1."


;
;
;	Idztsi vltozk frisstse
;	  - rendszer id s dtum lptetse
;	  - meghajtk tblzatbeli szmlljnak cskkentse
;	  - DISKIO bels szmlljnak cskkentse, sszes meghajt "deszelektlsa" ha nulla
;	in:  -
;	out: -
;
LCEC0:	ld	hl,0DB24h		; HL= rendszerid szzadmsodperc memriacme
	inc	(hl)
	ld	b,064h			; hatrrtk: 100
	call	LCF2F			; szzadmsodperc nvelse eggyel, vagy nullzsa, ha elrte B rtkt
	inc	hl			; HL= rendszerid msodperc memriacme
	ld	b,03Ch			; hatrrtk: 60
	call	nc,LCF2F		; ha a szzadmsodperc "tfordult", a msodperc szmll nvelse
	ld	hl,0DB22h		; HL= rendszerid perc memriacme
	call	nc,LCF2F		; ha a msodperc "tfordult", a perc szmll nvelse
	inc	hl			; HL= rendszerid ra memriacme
	ld	b,018h			; hatrrtk: 24
	call	nc,LCF2F		; ha a perc "tfordult", az ra szmll nvelse
	jr	c,LCEFE			; ugrs, ha nem telt el 24 ra
	ld	a,(0DB1Fh)		; v (1980-hoz kpest relatv) (0..99)
	ld	l,a
	ld	a,(0DB21h)		; hnap (1..12)
	ld	d,a
	call	LCFD7			; adott hnapon belli napok szmnak meghatrozsa (B-ben az rtk)
	ld	hl,0DB20h		; HL= nap (1..31) memriacme
	call	LCF2F			; napok szmnak nvelse
	jr	c,LCEFE			; ugrs, ha nem rte el a hnap vgt
LCEF0:	inc	(hl)			; ha elrte, nvelni kell a nap szmt (0-val nem kezddik hnap)
	inc	hl			; HL= hnap (1..12) memriacme
	ld	b,00Ch			; hatrrtk: 12 (???)
	call	LCF2F			; hnapok szmnak nvelse
	jr	c,LCEFE			; ugrs, ha nem rte el az v vgt
	inc	(hl)			; egybknt az 1. hnap kvetkezik
	ld	hl,0DB1Fh		; HL= v memriacme
	inc	(hl)			; vszm nvelse
LCEFE:	ld	hl,0D0BDh		; 1. fizikai meghajt tblzatcmnek cme a bels RAM-ban
	ld	b,010h			; 16 db. meghajt van
LCF03:	ld	e,(hl)
	inc	hl
	ld	d,(hl)			; DE= meghajt tblzat kezdcme
	inc	hl
	ld	a,d			; tblzat cm ellenrzse
	or	e
	jr	z,LCF18			; ugrs, ha nem hasznlt meghajt
	ld	a,009h			; meghajt tblzat 9. bjtjnak megcmzse
	add	a,e
	ld	e,a
	jr	nc,LCF12
	inc	d
LCF12:	ld	a,(de)			; A reg.= 9. bjt rtke
	cp	003h			; CY=1 ha a szmll kisebb mint 3 (0,1,2)
	adc	a,0FFh			; szmll cskkentse, ha nagyobb 2-nl
	ld	(de),a			; j rtk visszarsa
LCF18:	djnz	LCF03			; ismtls az sszes meghajtra
	ld	a,(0D036h)		; DISKIO bels idztjnek cskkentse
	or	a
	ret	z			; visszatrs, ha mr korbban lejrt
	dec	a
	ld	(0D036h),a		; egybknt a cskkentett rtk bersa
	ret	nz			; visszatrs, ha mg most sem lett nulla
	ld	b,a			; A=0 (reset parancskd) s B=0 (sszes meghajt deszelektlsa)
	call	LDB2E			; 2.lapon lv rutin hvsa (cm: 0EB49h)
;
	.dw	0EB49h			; DISKIO hvsa
;
	xor	a			; A reg.= 00h
	ld	(0D036h),a		; DISKIO bels idzt ismtelt nullzsa (a hvs 110-re lltotta)
	ret


;
;
;	HL ltal mutatott memria cm nvelse eggyel, vagy nullzsa, ha elrte B rtkt
;	in:   B - hatrrtk
;	     HL - memriacm
;	out:  A - aktulis rtk
;	     CY - CY=0 a szmll "tfordult"
;
LCF2F:	ld	a,(hl)
	ld	(hl),000h
	inc	a
	cp	b
	ret	nc
	ld	(hl),a
	ret


;
;
;	FISH 1Bh: Aktulis dtum beolvassa
;	in: -
;	out:  A - hibakd (0)
;	      C - a ht napja (0..6, 0-> vasrnap)
;	      D - hnap (1..12)
;	      E - nap (1..31)
;	     HL - vszm (1980..2079)
;
LCF37:	di
	ld	a,(0DB1Fh)		; A= (relatv) v
	ld	de,(0DB20h)		; DE= hnap/nap
	ei
	ld	c,a
	ld	b,000h			; BC= relatv vszm
	ld	hl,007BCh		; HL= eltolsi rtk (1980)
	add	hl,bc			; HL= vszm (1980..2079)
	ld	a,d
	cp	003h			; CY=1 ha a hnap<3 (az els kt hnapban nem szmt a szknap)
	ld	a,c			; A= (relatv) v
	sbc	a,0FCh			; A= A-(-4)-CY -> A=A+4 ha hnap>=3 vagy A=A+3 ha hnap<3
	and	0FCh			; als 2 bit trlse
	rrca				; jobbra lptets 2-szer (oszts 4-el)
	rrca
	add	a,c			; A= 1.25 * (relatv v) + 1 ha a hnap>=3
	push	hl			; vszm mentse a verembe
	ld	hl,LCF64 - 1		; HL a ROM-beli tblzatra mutat (-1)
	ld	c,d			; BC= hnap (1..12)
	add	hl,bc			; HL a hnapnak megfelel elemre mutat
	add	a,(hl)			; A reg. nvelse a tblzat rtkvel
	pop	hl			; vszm vissza HL-be
	add	a,e			; napok hozzadsa A-hoz
LCF5B:	sub	007h			; oszts 7-el, a maradk meghatrozshoz
	jr	nc,LCF5B		; ismtls, amg nincs alulcsorduls
	add	a,007h
	ld	c,a			; C= a ht napja (0..6)
	xor	a
	ret


;
;	Tblzat a ht napjnak meghatrozshoz
;
LCF64:	.db	001h,004h,004h,007h,009h,00Ch,00Eh,011h,014h,016h,019h,01Bh


;
;
;	FISH 1Ch: Aktulis dtum belltsa
;	in:   D - hnap (1..12)
;	      E - nap (1..31)
;	     HL - vszm (1980..2079)
;	out:  A - hibakd
;
LCF70:	ld	bc,007BCh		; BC= eltolsi rtk (1980)
	xor	a
	sbc	hl,bc			; vszmbl 1980 kivonsa
	jr	c,LCF9E			; ugrs, ha a megadott v kisebb volt mint 1980
	or	h			; relatv vszm felsbjt ellenrzse (az vszm csak egy bjtos lehet)
	ld	a,l			; A reg.= als bjt
	ld	b,064h			; a relatv vszm fels hatra 100
	call	z,LCFD3			; A reg. < B reg. ?
	jr	nz,LCF9E		; ugrs, ha az vszm fels bjtja nem nulla vagy A reg. nem kisebb 100-nl
	ld	a,d			; A reg.= hnap
	ld	b,00Dh			; B= 13
	call	z,LCFD0			; 0 < A reg. < B reg. ?
	jr	nz,LCF9E		; ugrs, ha a hnap nem esik a megadott tartomnyba
	call	LCFD7			; hnapon belli napok szmnak meghatrozsa (eredmny B reg.-ben)
	ld	a,e			; A reg.= nap
	call	LCFD0			; 0 < A reg. < B reg. ?
	jr	nz,LCF9E		; ugrs, ha a nap nem esik a megadott tartomnyba
	di
	ld	a,l
	ld	(0DB1Fh),a		; relatv vszm belltsa a RAM vltozba
	ld	(0DB20h),de		; hnap s nap   belltsa a RAM vltozba
	ei
	xor	a			; hibakd trlse
	ret
;
LCF9E:	ld	a,097h			; hibakd: .IDATE - rvnytelen dtum
	ret


;
;
;	FISH 1Dh: Aktulis id beolvassa
;	in: -
;	out: A - hibakd (0)
;	     H - ra (0..23)
;	     L - perc (0..59)
;	     D - msodperc (0..59)
;	     E - szzadmsodperc (0..99)
;
LCFA1:	di
	ld	hl,(0DB22h)		; HL= ra/perc
	ld	de,(0DB24h)		; DE= msodperc/szzadmsodperc
	ei
	xor	a
	ret


;
;
;	FISH 1Eh: Aktulis id belltsa
;	in:  H - ra (0..23)
;	     L - perc (0..59)
;	     D - msodperc (0..59)
;	     E - szzadmsodperc (0..99)
;	out: A - hibakd
;
LCFAC:	ld	a,e			; A reg.= szzadmsodperc
	ld	b,064h			; B= limit (100)
	call	LCFD3			; A reg. < B reg. ?
	ld	a,d			; A reg.= msodperc
	ld	b,03Ch			; B= limit (60)
	call	z,LCFD3			; A reg. < B reg. ? (ha korbban mg nem volt hiba)
	ld	a,l			; A reg.= perc
	call	z,LCFD3			; A reg. < B reg. ? (ha korbban mg nem volt hiba)
	ld	a,h			; A reg.= ra
	ld	b,018h			; B= limit (24)
	call	z,LCFD3			; A reg. < B reg. ? (ha korbban mg nem volt hiba)
	ld	a,096h			; hibakd: .ITIME
	ret	nz			; visszatrs, ha valamelyik rtk nem volt a hatron bell
	di
	ld	(0DB22h),hl		; ra/perc belltsa
	ld	(0DB24h),de		; msodperc/szzadmsodperc  belltsa
	ei
	xor	a			; hibakd trlse
	ret


;
;
;	A regiszter tartalmnak ellenrzse 0 s B reg.-ben adott hatrok kztt
;	in:   A - ellenrzend rtk
;	      B - fels hatrrtk
;	out:  A - 00h vagy 0FFh
;	     ZF - ZF=1 ha 0 < A reg. < B reg.
;	          LCFD3-nl belpve: ZF=1 ha A reg. < B reg.
;
LCFD0:	or	a			; CY=0
	jr	z,LCFD4			; ugrs, ha A reg.= 00h
LCFD3:	cp	b			; sszehasonlts B-vel
LCFD4:	ccf				; CY komplementlsa
	sbc	a,a
	ret


;
;
;	Adott hnapon belli napok szmnak meghatrozsa
;	in:   D - hnap (1..12)
;	     HL - relatv vszm 1980-hoz kpest (0..255)
;	out:  B - napok szma az adott hnapban +1
;	     DE,HL - megrzdik
;
LCFD7:	push	hl			; regiszterek mentse
	push	de
	ld	a,l			; A= relatv vszm
	ld	hl,LCFF0 - 1		; HL= tblzat kezdete-1
	and	003h			; A= mod (vszm / 4)
	ld	e,d			; DE= hnap (1..12)
	ld	d,000h
	add	hl,de			; HL a hnapnak megfelel tblzatelemre mutat
	sub	001h			; CY=1 ha A reg.= 00h (szkv)
	ld	a,(hl)			; A reg.= hnapnak megfelel tblzatelem
	bit	7,a
	jr	z,LCFEC			; ugrs, ha a hnap nem februr
	adc	a,09Dh			; A reg. + 128 + 29 + CY
LCFEC:	ld	b,a			; B= a tblzatbl kiolvasott rtk vagy februr esetn a szmolt napok
	pop	de			; regiszterek visszalltsa
	pop	hl
	ret


;
;	Hnapokon belli napok szmt tartalmaz tblzat
;
LCFF0: .db	020h,080h,020h,01Fh,020h,01Fh,20h,20h,1Fh,020h,01Fh,020h


	.org	0CFFFh			; kitlts 0-val a 4kB-os ROM lap vgig
	.db	000h


.end
