;
;
;	VT-DOS kompatibilis floppy diszk illeszt ver.1.2
;
;	3. ROM lap: BASIC CLI
;
;


;
;	RAM-ba msolt rutinok cmei (a fordthatsg miatt)
;
LDB2E	.equ	0DB2Eh



	.org	0C000h
;
	.db	"MOPS"
	.db	004h			; azonost nv hossza
	.db	"DISK"			; azonostnv
	.dw	0DB6Fh			; VT-DOS megszaktskiszolgl rutin cme
;
	.dw	00000h			; inicializl rutin cme
	.db	001h			; funkcik szma
	.dw	0DBC1h			; megszaktskiszolgl rutin cme


;
;
;
;-----------------------------------------------
;	CLI parancs vgrehajtsa
;-----------------------------------------------
;  in:  C - I/O vlaszts
;      DE - egy parancssorra mutat
; out:  A - hibakd
;      BC - a pufferben lv karakterek szma
;      DE - a puffer elejre mutat
;-----------------------------------------------
;
LC010:	ld	a,c
	ld	(00D6Dh),a		; I/O vlaszts mentse (csak nem interaktv mdban rdekes)
	call	LDB2E			; 0.lapon lv rutin hvsa (cm: 0C741h)
;
	.dw	0C741h			; memrialapozs mentse, sajt megszaktsi rutin belltsa
;
	ld	(00D7Eh),sp		; SP mentse az U0 RAM-ba a kazetta munkaterletre
	xor	a
	ld	(00D7Ch),a		; tovbbi vltozk kinullzsa a kazetta munkaterleten
	ld	(00D7Dh),a		; interaktv md jelzse (00h)
	ld	(00D80h),a		; a CLI pufferbe rt karakterek szma (0000h)
	ld	(00D81h),a
	ld	a,(de)			; A reg.= parancssor hosszbjtja
	or	a
	jr	z,LC040			; ugrs, ha a parancssor egy res string (interaktv md)
	ld	hl,00D7Dh		; HL= parancsmd/interaktvmd flag vltoz cme
	dec	(hl)			; 0FFh -> nem interaktv md jelzse
	ld	a,(de)			; A reg.= parancssor hosszbjtja
	ld	c,a			; hosszbjt C-be is
	and	080h			; hosszbjt vizsglata
	jp	nz,LC0C4		; ugrs, ha a parancssor hosszabb 128 bjtnl
	xor	a
	ld	b,a			; BC= parancssor hossza
	inc	de
	ex	de,hl			; HL= parancssor els karakternek cme
	jp	LC0CE			; ugrs a folytatsra (parancssor bemsolsa a sajt munkaterletre, s kirtkelse)

;
;
;	Interaktv md belpsi pontja
;
LC040:	ld	iy,(0DFF5h)		; IY belltsa a kezdeti rtkre (0D080h)
	xor	a
	ld	(00D6Dh),a		; I/O vlaszts nullzsa (kpernyre r)
	call	LCD2D			; soremels a vlasztott output eszkzn
	ld	a,00Bh			; szvegazonost: "VT-DOS CLI 1.2"
	call	LCD42			; az 1.lapon trolt adott azonostj szveg kiratsa
	call	LCD2D			; soremels a vlasztott output eszkzn
LC053:	ld	hl,0C2A8h		; HL karaktermtrix cme a ROM-ban
	ld	de,00D7Bh		; DE a kazetta munkaterletre mutat
	ld	bc,0000Ah
	lddr				; 10 darab bjt tmsolsa a ROM-bl az U0 RAM-ba cmcskkentssel
	inc	de			; DE az utoljra msolt bjtra mutat (0D71h)
	ld	c,0DFh			; karakterkd: 223 (az utols definilhat karakter)
	call	LDB2E			; 0.lapon lv rutin hvsa (cm: 0C767h)
;
	.dw	0C767h			; eredeti memrialapozs (P_SAVE) s INT vektor visszalltsa
;
	rst	30h			; funkcihvs
;
	.db	00Bh			; DEFC - karakter definilsa (sajt '>' karakter 0DFh ASCII kddal)
;
	call	LDB2E			; 0.lapon lv rutin hvsa (cm: 0C741h)
;
	.dw	0C741h			; P_SAVE mentse a bels RAM-ba, INT vektor belltsa a floppy-ra
;
	ld	c,(iy-062h)		; C= CD_PROMPT vltoz
	ld	b,(iy-05Fh)		; B= DEF_UNIT  vltoz
	ld	hl,0DC0Fh
	ld	(0DFF8h),hl		; ERV_ADDR: kls hibakezel fggvny cme
	inc	c
	dec	c			; ZF belltsa CD_PROMPT vltoz szerint (?)
	push	bc			; beolvasott vltoz rtkek a verembe
	ld	a,(00D6Dh)		; I/O vlaszts A reg.-be
	and	001h			; lltja ZF-et (?)
	ld	(00D6Dh),a		; csak a CLI puffer vagy a kperny lehet az output
	ld	a,003h			; parancskd: aktulis knyvtr beolvassa
	jr	nz,LC08D		; ugrs, ha a CLI puffer van kivlasztva (bug?)
	call	LDB2E			; 0.lapon lv rutin hvsa (cm: 0CD46h)
;
	.dw	0CD46h			; FISH funkci vgrehajtsa
;
LC08D:	pop	bc			; B= DEF_UNIT  vltoz
	ld	c,a			; hibakd mentse C-be
	ld	a,b			; A reg.= DEF_UNIT  vltoz
	add	a,040h			; meghajt sorszm eltolsa, gy az 1. meghajt az 'A' ASCII kdot adja
	call	LCCD8			; karakter kirsa a vlasztott outputra
	or	c
	jr	nz,LC0A6		; ugrs, ha korbban a FISH lemez-mveletnl hiba trtnt
	ld	a,03Ah			; A reg.= ':'
	call	LCCD8			; karakter kirsa a vlasztott outputra
	ld	a,05Ch			; A reg.= '\'
	call	LCCD8			; karakter kirsa a vlasztott outputra
	ex	de,hl			; DE az aktulis tvonal-stringre mutat
	call	LCD48			; nullval lezrt karakterlnc kirsa a vlasztott outputra
LC0A6:	ld	a,0DFh			; A reg.= sajt '>' karakter
	call	LCCD8			; karakter kirsa a vlasztott outputra
	ld	hl,00000h
	ld	(0DFF8h),hl		; ERV_ADDR: kls hibakezel fggvny cmnek nullzsa
	call	LCD75			; parancssor beolvassa a billentyzetrl
	jp	nz,LC10F		; ugrs, ha MOPS hiba trtnt
	jp	c,LC14D			; ugrs, ha ESC-et nyomtak
	ld	a,(00BF5h)		; A reg. = parancssor hossza
	or	a
	jr	z,LC053			; ugrs, ha nincs beolvasott karakter
	cp	07Fh
	jr	nz,LC0C8		; ugrs, ha nem telt be a 128 bjtos parancssor
LC0C4:	ld	a,090h			; hibakd: .BUFUL - tl hossz parancs, vagy betelt a CLI puffer
	jr	LC10F			; ugrs, a folytatsra
;
LC0C8:	ld	c,a			; C= parancssor hossza
	xor	a			; A reg.= 0
	ld	b,a			; B= 0
	ld	hl,00BF6h		; HL= parancssor els karakterre mutat
LC0CE:	ld	de,00BF5h		; az els kirtkelend karakter ezen a cmen fog elhelyezkedni
	push	de
	ldir				; parancssor htralv rsznek elremozgatsa
	ld	(de),a
	pop	hl			; HL az els kirtkelend karakterre mutat
	call	LCC8C			; kvetkez kirtkelhet karakter olvassa a stringbl
	inc	hl
LC0DA:	jp	z,LC053			; ugrs, ha A reg.=0 vagy elrte a parancssor vgt
	cp	02Ah
	jr	z,LC0DA			; ugrs, ha A reg.= '*'
	ld	b,a			; legels karakter mentse B-be
	ld	a,(hl)			; kvetkez karakter beolvassa A reg.-be
	cp	03Ah
	jr	nz,LC108		; ugrs, ha a kvetkez karakter nem ':'
	inc	hl			; tovbblp a kvetkez karakterre
	call	LCC8C			; kvetkez kirtkelhet karakter olvassa a stringbl
	ld	a,091h
	jp	nz,LC10F		; ugrs, ha mg nem rt a parancssor vgre s A reg. nem 0
	ld	a,b			; legels karakter A reg.-be
	call	LC1D3			; angol kisbet nagybetv alaktsa
	sub	040h			; karakterbl meghajt sorszm ksztse (A->1 B->2 ..)
	ld	b,a			; B= meghajt sorszm
	push	bc			; B mentse a verembe
	ld	a,003h			; parancskd: aktulis knyvtr beolvassa (a B-ben adott meghajtn)
	call	LDB2E			; 0.lapon lv rutin hvsa (cm: 0CD46h)
;
	.dw	0CD46h			; FISH funkci vgrehajtsa
;
	pop	bc			; B= meghajt sorszm a verembl
	jr	nz,LC10F		; ugrs, ha hiba trtnt
	ld	a,b
	ld	(iy-05Fh),a		; meghajt sorszm bersa DEF_UNIT vltozba
	jr	LC12F			; ugrs a folytatsra
;
LC108:	dec	hl			; karakter-mutat visszalltsa a legels karakterre
	call	LC165			; az aktulis parancs beazonostsa s vgrehajtsa
	or	a
	jr	z,LC12F			; ugrs, ha nem trtnt hiba
LC10F:	push	af			; hibakd mentse
	ld	hl,00D6Dh		; HL= CLI karakteres output vlaszt bjt cme
	res	1,(hl)			; nyomtatra klds tiltsa
	ld	hl,00D7Dh		; HL az interaktvmd/parancsmd jelz flag-re mutat
	bit	0,(hl)
	jr	nz,LC147		; ugrs, ha kzvetlen CLI parancs vgrehajts volt
	sub	0F5h
	jr	nz,LC12B		; ugrs, ha a hibakd nem .STOP (CTRL-ESC) volt
	call	LCD2D			; soremels a vlasztott output eszkzn (s A reg.=00h)
	ld	(00B16h),a		; STOP_FLAG = 00h
	call	LDB2E			; 1.lapon lv rutin hvsa (cm: 0DC2Eh)
;
	.dw	0DC2Eh			; billentyzet puffer kitakartsa (?)
;
LC12B:	pop	af			; hibakd visszalltsa a verembl
	call	LCEBD			; hibazenet kirsa a vlasztott karakteres outputra
LC12F:	call	LC13C			; sszes szektorpuffer felszabadtsa
	ld	hl,00D7Dh		; HL az interaktvmd/parancsmd jelz flag-re mutat
	bit	0,(hl)
	jr	nz,LC150		; ugrs, ha kzvetlen CLI parancs vgrehajts volt
	jp	LC053			; egybknt ugrs az interaktv md elejre
;
;
;	sszes szektorpuffer felszabadtsa
;
LC13C:	ld	bc,0FFFFh		; minden meghajtra vonatkozik a parancs
	ld	a,00Eh			; parancskd: szektorpufferek trlse s rvnytelentse
	call	LDB2E			; 0.lapon lv rutin hvsa (cm: 0CD46h)
;
	.dw	0CD46h			; FISH funkci vgrehajtsa
;
	ret
	
;
LC147:	call	LC13C			; sszes szektorpuffer felszabadtsa
	pop	af			; hibakd visszalltsa a verembl
	jr	LC156			; ugrs a befejez programrszre
;
LC14D:	call	LCD2D			; soremels kirsa
LC150:	xor	a			; hibakd trlse
	jp	LC156			; ugrs a befejez programrszre
;
	ld	a,08Eh			; hibakd: .IPARM - rvnytelen paramter (?? nem hasznlt belpsi pont ???)
LC156:	call	LDB2E			; 0.lapon lv rutin hvsa (cm: 0C767h)
;
	.dw	0C767h			; eredeti memrialapozs (P_SAVE) s INT vektor visszalltsa
;
	ld	hl,(00D80h)		; HL= a CLI pufferbe rt karakterek szma
	push	hl
	pop	bc			; BC= a CLI pufferbe rt karakterek szma
	ld	de,(00BF0h)		; DE a CLI puffer elejre mutat
	ret


;
;
;	Az aktulis parancs beazonostsa s vgrehajtsa
;	in:  HL - karakterlnc elejre mutat
;	out:  A - hibakd
;	     HL - a kvetkez kirtkelhet karakterre mutat
;
LC165:	dec	hl			; HL a legels karakter eltti bjtra mutat (pl. 0BF4h)
	xor	a
	ld	(hl),a			; bjt nullzsa (hosszbjt)
	push	hl			; cm mentse
	ld	b,0FFh			; B a tallt karaktereket szmolja
LC16B:	inc	b			; karakterszmll nvelse
	inc	hl			; HL a kvetkez kirtkelend karakterre mutat
	call	LCC5C			; HL mutatta szveg kvetkez karakternek beolvassa (A reg.-be)
	jr	nz,LC16B		; ugrs, ha nem 00h vagy SPACE vagy TAB
	pop	de			; DE= az egybefgg string-rszlet kezdcme
	push	hl			; aktulis karakterpozci mentse
	ex	de,hl			; HL= az egybefgg string-rszlet kezdcme (hosszbjt)
	ld	a,b
	ld	(hl),a			; string hossznak belltsa a szmolt hosszra
	ex	de,hl			; DE a string hosszbjtjra mutat
	ld	ix,00C79h		; IX-ben a bziscm belltsa (FCB1)
	ld	a,001h
	ld	(00D6Fh),a
	xor	a			; A reg.= 00h  ZF=1
	ld	(ix+006h),a
	ld	(ix+007h),a
	ld	(ix+000h),0FFh
	ld	hl,00D6Bh
	res	4,(hl)
	ld	hl,LC1DC - 2		; HL= a ROM-ban letrolt els parancs karakterlncnak cme -2
LC194:	jr	nz,LC1B5		; ugrs, ha a ROM-ban lv string hosszabb volt (sszehasonlts utn)
	inc	hl			; a karakterlnc utni cmbjtok tlpse
	inc	hl
	ld	a,(hl)			; A reg.= ROM-ban trolt kvetkez karakterlnc hosszbjtja
	or	a
	jr	z,LC1B5			; ugrs, ha ez a tblzatot zr nulla bjt
	call	LC1B9			; karakterlncok sszehasonltsa
	jr	c,LC194			; ugrs, ha nem egyeznek meg a stringek
	ld	a,(hl)			; karakterlnc utni cmbjtok betltse
	inc	hl
	ld	h,(hl)
	ld	l,a
	ex	de,hl			; DE= beazonostott parancsot vgrehajt rutin cme
	pop	hl			; HL= aktulis parancssori karakterpozci
	push	de			; parancsot vgrehajt rutin cme a verembe (a RET utasts hatsra ide ugrik)
	call	LCBBE			; BC s DE belltsa az FCB adatterletekre
	call	LCC8C			; kvetkez kirtkelhet karakter olvassa a parancssori stringbl
	xor	a			; A reg.= 00h  CY=0
	ld	(00D71h),a		; a sajt '>' karakter mtrixnak 1. bjtja (?) = 00h
	ld	c,a			; C= 00h
	dec	a			; A reg.= 0FFh
	ret				; ugrs a beazonostott parancsot vgrehajt rutinra
;
LC1B5:	ld	a,091h			; hibakd: .BADCMD - ismeretlen parancs
	pop	de			; verem kitakartsa
	ret				; visszatrs a hv rutinra


;
;
;	Karakterlncok sszehasonltsa
;	in:   B - a parancssori string hossza
;	     DE - a parancssori string kezdkarakter-1 cmre mutat
;	     HL - a ROM-ban trolt string hosszbjtjra mutat
;	out:  A - 00h ha nem egyeznek meg a stringek  01h ha megegyeznek
;	     BC,DE - megrzdik
;	     HL - a ROM-beli karakterlnc utols karakterre mutat
;	     CY - CY=1 ha nem egyeznek meg a stringek  CY=0 ha megegyeznek
;	     ZF - ZF=0 s CY=1 -> a ROM-ban lv string hosszabb
;
LC1B9:	push	bc			; regiszterek mentse
	push	de
	ld	a,b			; A reg.= parancssori string hossza
	ld	b,(hl)			; B= ROM-ban trolt karakterlnc hossza
	cp	b
	jr	c,LC1D0			; ugrs, ha a ROM-ban lv string hosszabb
	inc	b			; hosszbjt nvelse, s CY=0 (mert egyik ROM-beli hosszbjt sem 0FFh)
LC1C1:	jr	c,LC1C6			; ugrs, ha az elz bjtprok egyike nem egyezett meg (ha CY egyszer 1-be kerlt, akkor vgig 1 marad)
	sub	(hl)
	add	a,0FFh			; CY=1 ha A reg. tartalma s HL mutatta bjt nem azonos
LC1C6:	inc	hl			; HL a kvetkez ROM-beli karakterre mutat
	inc	de			; DE a kvetkez parancssori karakterre mutat
	ld	a,(de)			; A reg.= a kvetkez parancssori karakter
	call	LC1D3			; angol kisbet nagybetv alaktsa
	djnz	LC1C1			; ismtls az sszes karakter feldolgozsig
	sbc	a,a			; ha CY=1 akkor A reg.= 0FFh egybknt 00h
	inc	a			; A reg.= 00h (CY=1) vagy 01h (CY=0)
LC1D0:	pop	de			; regiszterek visszalltsa
	pop	bc
	ret


;
;
;	Angol kisbet nagybetv alaktsa
;	in:   A - ASCII karakterkd
;	out:  A - kisbetv alaktott karakter ha A < 128
;	     CY - vltozatlan marad
;
LC1D3:	bit	7,a
	ret	nz
	bit	6,a
	ret	z
	res	5,a
	ret


;
;
;	Parancs-azonostk karakterlncai s vgrehajtsi cmk
;
LC1DC:	.db	002h,"CD"
	.dw	0C2A9h
;
	.db	002h,"MD"
	.dw	0C333h
;
	.db	002h,"RD"
	.dw	0C2D2h
;
	.db	003h,"DEL"
	.dw	0C2D3h
;
	.db	003h,"ERA"
	.dw	0C2D3h
;
	.db	003h,"VOL"
	.dw	0C557h
;
	.db	003h,"DIR"
	.dw	0C416h
;
	.db	003h,"DOS"
	.dw	0CA24h
;
	.db	003h,"REN"
	.dw	0C34Bh
;
	.db	003h,"CLS"
	.dw	0CA0Bh
;
	.db	003h,"VAR"
	.dw	0C740h
;
	.db	004h,"LDIR"
	.dw	0C413h
;
	.db	004h,"COPY"
	.dw	0C7A5h
;
	.db	004h,"DATE"
	.dw	0C59Bh
;
	.db	004h,"HELP"
	.dw	0CA47h
;
	.db	004h,"TIME"
	.dw	0C66Eh
;
	.db	004h,"MOVE"
	.dw	0C348h
;
	.db	004h,"TYPE"
	.dw	0C79Fh
;
	.db	005h,"LTYPE"
	.dw	0C79Ch
;
	.db	005h,"MVDIR"
	.dw	0C347h
;
	.db	005h,"RNDIR"
	.dw	0C34Ah
;
	.db	005h,"CHDIR"
	.dw	0C2A9h
;
	.db	005h,"ERASE"
	.dw	0C2D3h
;
	.db	005h,"MKDIR"
	.dw	0C333h
;
	.db	005h,"RMDIR"
	.dw	0C2D2h
;
	.db	005h,"ERASE"
	.dw	0C2D3h
;
	.db	006h,"FORMAT"
	.dw	0C3ACh
;
	.db	006h,"RENAME"
	.dw	0C34Bh
;
	.db	000h			; tblzatot zr nulla bjt


;
;
;	Karaktermtrixot meghatroz 10 bjt karakterdefinilshoz
;	( a '>' karakter a 223 ASCII kdra definilva)
;
LC29F:	.db	000h,030h,018h,00Ch,006h
	.db	00Ch,018h,030h,000h,000h
;


;
;-----------------------------------------------------
;	CLI parancsok megvalstsa
;-----------------------------------------------------
;
;	in:   A - 0FFh
;	     BC - FCB2-re mutat
;	     DE - FCB1-re mutat
;	     HL - aktulis parancssori karakterpozci
;	     IX - FCB1-re mutat
;	     CY - 0
;	out:  A - hibakd
;-----------------------------------------------------
;

;
;	"CD" s "CHDIR" belpsi pontja
;
LC2A9:	ld	c,001h			; fjlnv az tvonalban maradjon jelzs
	call	LCB4E			; tvonalnv elemzse
	call	LCA95			; htralv karakterlncban szveg keresse
	ret	nz			; visszatrs, ha volt mg hasznos szveg (nem csak SPACE s TAB)
	bit	0,b			; 0. jelzbit ellenrzse
	ld	a,002h			; A reg.= knyvtrvltoztatsi funkci kdja
	jp	nz,LCB38		; ugrs a FISH funkci vgrehajtsra (ide mr nem tr vissza), ha a meghajt nven kvl ms is volt megadva
	ld	b,(ix+007h)		; B= meghajt sorszm FCB1-bl
	ld	a,003h			; A reg.= aktulis knyvtr beolvassa funkci kdja
	call	LCB38			; FISH funkci vgrehajtsa
	ret	nz			; visszatrs, ha hiba trtnt
	ld	de,0CD2Dh
	push	de
	ex	de,hl			; DE az aktulis tvonalnv string  HL
LC2C7:	call	LCD36			; aktulis meghajt betjelnek kirsa az output-ra
	ld	a,05Ch			; '\'
	call	LCCD8			; karakter kirsa az output-ra
	jp	LCD48			; ugrs a befejezsre: nullval lezrt karakterlnc kirsa a vlasztott outputra
;
;
;	"RD" s "RMDIR" belpsi pontja
;
LC2D2:	scf
;
;
;	"DEL", "ERA" s "ERASE" belpsi pontja
;
LC2D3:	call	LCBDC			; parancssorban megadott tvonalnv s az azt kvet opcionlis paramterek feldolgozsa
	call	z,LCA95			; htralv karakterlncban szveg keresse
	ret	nz			; visszatrs, ha volt mg hasznos szveg
	ld	a,(00D6Fh)		; opcionlis paramterek flagbjtja A reg.-be
	and	0FEh			; 0.bit trlse (?)
	ld	(00D6Fh),a		; visszars a vltozba
	call	LCAB7			; parancssorban adott fjl kikeresse (eredmnyek a bels FCB-kben)
	ret	c			; visszatrs, ha hiba trtnt
	ld	hl,00C81h		; HL a fjlnvre mutat FCB1-ben
	ld	b,00Bh			; max. 11 karaktert ellenriz
	ld	a,03Fh			; '?'
LC2ED:	cp	(hl)
	jr	nz,LC2FB		; ugrs, ha nem tbbrtelm a fjlnv adott karaktere
	inc	hl
	djnz	LC2ED			; ismtls a max. karakterszmig
LC2F3:	ld	a,018h			; A reg.-ben a "Erase all files (Y/N)? " azonostja
	call	LC30C			; az 1.lapon trolt adott azonostj szveg kiratsa
	jr	nc,LC2F3		; ismtls, ha nem megengedett bett vlasztottak
	ret	nz			; visszatrs ha 'N'-t vlasztottak
LC2FB:	ld	hl,00C79h		; HL= FCB1-re mutat
	ld	de,00CA9h		; DE= FCB2-re mutat
	ld	a,008h			; A= trls funkcikd
	call	LCB38			; FISH funkci vgrehajtsa IX mentsvel
	call	nc,LCB8F		; ha nem volt hiba, kvetkez knyvtrbejegyzs keresse FCB1 alapjn
	jr	nc,LC2FB		; ismtls, ha van tovbbi knyvtrbejegyzs s nem volt lemezes hiba
	ret
;
;
;	Az 1.lapon trolt adott azonostj szveg kiratsa,
;	majd vrakozs az 'Y' vagy 'N' gomb lenyomsra
;	in:   A - azonostszm
;	out:  A - 0 ha, 'Y'-t vagy 'N'-t nyomtak
;	     ZF - 0 ha, nem 'Y'-t nyomtak  1 ha 'Y'-t nyomtak
;	     CY - 1 ha, 'Y'-t vagy 'N'-t nyomtak
;
LC30C:	call	LCD42
	call	LDB2E			; 1.lapon lv rutin hvsa (cm: 0DB92h)
;
	.dw	0DB92h			; egy karakter beolvassa a billentyzetrl, kzben a kurzor villogtatsa
;
	ret	 nz
	ld	a,h			; beolvasott karakterkd A reg.-be is
	cp	020h
	call	nc,LCCD8		; karakter kirsa a vlasztott outputra, ha nem vezrlkarakter
	call	LCD2D			; Soremels a vlasztott output eszkzn
	ld	a,00Dh			; A reg.-ben az "Nn" szveg azonostja
	call	LDB2E			; 1.lapon lv rutin hvsa (cm: 0DB82h)
;
	.dw	0DB82h			; H reg.-ben lv karakter keresse az adott azonostj szvegben
;
	sbc	a,a
	ld	a,000h
	ret	nz			; visszatrs, ha volt tallat (CY=1 volt)
	ld	a,00Ch			; A reg.-ben az "Yy" szveg azonostja
	call	LDB2E			; 1.lapon lv rutin hvsa (cm: 0DB82h)
;
	.dw	0DB82h			; H reg.-ben lv karakter keresse az adott azonostj szvegben
;
	sbc	a,a
	inc	a			; A reg.= 0 'Y'-t nyomtak
	ret
;
;
;	"MD" s "MKDIR" belpsi pontja
;
LC333:	call	LCB4E			; tvonalnv elemzse
	call	LCA8A			; hibakd belltsa A reg.-ben, ha nincs megfelel tvonalnv megadva
	push	hl
	call	z,LCA95			; ha megfelel az tvonalnv, akkor a htralv karakterlncban szveg keresse
	pop	hl
	ret	nz			; visszatrs, ha nincs megfelel tvonalnv vagy ha volt mg tovbbi parancssori szveg
	call	LCBBE			; BC s DE belltsa az FCB adatterletekre
	ld	a,007h			; A reg.-be a FISH funkcikd: knyvtr ltrehozsa
	jp	LCB38			; ugrs a folytatsra s befejezsre: FISH funkci vgrehajtsa IX mentsvel
;
;
;	"MVDIR" belpsi pontja
;
LC347:	scf
;
;
;	"MOVE" belpsi pontja
;
LC348:	inc	a			; A= 00h
	.db	006h			; a kvetkez bjttal: ld b,037h  -> elfedi SCF-t
;
;
;	"RNDIR" belpsi pontja
;
LC34A:	scf
;
;
;	"REN" s "RENAME" belpsi pontja
;
LC34B:	call	LCBDC			; parancssorban megadott tvonalnv s az azt kvet opcionlis paramterek feldolgozsa
	ret	nz			; visszatrs, ha hibs a megadott parancssor
	push	bc
	push	de
	call	LCAB7			; parancssorban adott fjl kikeresse
	pop	hl			; HL a parancssort zr karakterre mutat
	pop	bc
	ret	c			; visszatrs, ha hiba trtnt
	ld	(hl),c			; kiindulsi fjlnv utni parancssori karakter visszarsa
	push	hl
	call	LCBCA			; IX belltsa FCB3-ra, FCB3 inicializlsa hasznlatlan FCB-nek
	ld	a,(ix-059h)		; A reg.= FCB1 meghajt sorszma
	ld	(ix+007h),a		; FCB3 meghajt sorszm belltsa
	push	de
	exx
	pop	hl			; HL' FCB3-ra mutat
	exx
	pop	hl			; HL a parancssori cl fjlnvre/tvonalnvre mutat
	call	LCC8C			; kvetkez kirtkelhet karakter olvassa a stringbl
	ld	c,000h			; C= 00h - tnevezs esetn (fjlnv flag FISH_01 funkcihoz)
	ex	af,af'			; belpskori jelzbitek vissza
	jr	nz,LC371		; ugrs, ha tnevezsi parancs vgrehajtsa van
	ld	c,001h			; egybknt C= 01h - mozgats esetn
LC371:	ex	af,af'			; flag-ek vissza
	call	LCB4E			; tvonalnv elemzse, FCB3 inicializlsa
	call	z,LCA95			; htralv karakterlncban paramter keresse
	ret	nz			; visszatrs, ha volt mg hasznos szveg
	ld	ix,00C79h		; IX FCB1-re mutat
	ex	af,af'
	push	af			; belpskori jelzbitek a verembe
	ex	af,af'
	pop	af			; belpskori jelzbitek az aktv regiszterekbe is
	jr	nz,LC389		; ugrs, ha tnevezsi parancs vgrehajtsa van
	push	hl
	exx
	pop	hl			; HL' a parancssori cl tvonalnvre mutat
	exx
	jr	LC391			; ugrs a folytatsra
;
LC389:	bit	1,b			; tvonalnvelemzs jelzbitjeinek ellenrzse
	ld	a,08Eh			; hibakd: .IPARM - rvnytelen paramter
	call	z,LCA8A			; ha nem volt specifiklt knyvtrtvonal, akkor hibakd belltsa A reg.-ben, ha nincs megfelel tvonalnv megadva
	ret	nz			; visszatrs, ha tvonalnv volt megadva
LC391:	call	LCBBE			; BC s DE belltsa az FCB adatterletekre
LC394:	ex	af,af'			; belpskori jelzbitek
	ld	l,00Ah			; L= thelyezsi funkcikd
	jr	z,LC39A			; ugrs, ha mozgatsi parancs vgrehajtsa van
	dec	l			; L= tnevezsi funkcikd
LC39A:	ex	af,af'			; flag-ek vissza
	ld	a,l			; funkcikd A reg.-be
	ex	de,hl			; HL= FCB1 cme
	ld	e,c			; DE= FCB2 cme
	ld	d,b
	exx
	push	hl
	exx
	pop	bc			; BC= FCB3 cme tnevezsnl, vagy a parancssori cl tvonalnvre mutat mozgatsnl
	call	LCB38			; FISH funkci vgrehajtsa IX mentsvel
	call	nc,LCB8F		; ha nincs hiba, kvetkez knyvtrbejegyzs keresse FCB1 alapjn
	jr	nc,LC394		; ismtls, ha van mg kvetkez knyvtrbejegyzs
	ret
;
;
;	"FORMAT" belpsi pontja
;
LC3AC:	set	3,(ix+006h)		; FCB1 keressi attribtumban ktetnv bit belltsa
	call	LCB4E			; tvonalnv elemzse, IX ltal mutatott FCB inicializlsa
	push	bc
	ld	hl,0C40Ch		; HL= a keresend opcionlis paramterek tblzatcme
	call	LCBFD			; opcionlis paramterek feldolgozsa
	call	z,LCA95			; ha nincs hiba, a htralv karakterlncban szveg keresse
	jr	nz,LC3CC		; ugrs, ha rvnytelen paramter vagy tovbbi ismeretlen karakterek voltak
	ld	hl,(00BF2h)		; HL= CLI puffer mrete
	ld	de,01964h
	and	a			; CY= 0
	sbc	hl,de			; CLI puffer mretnek sszehasonltsa 6500-al
	ld	a,08Eh			; hibakd: .IPARAM - rvnytelen paramter
	jr	nc,LC3D6		; ugrs, ha a CLI puffer >= 6500 bjt
LC3CC:	pop	bc
	ret	nz			; visszatrs, ha rvnytelen paramter volt, vagy kicsi a CLI puffer, vagy a format FISH funkcinl hiba trtnt
	ld	a,b			; A reg.= tvonalnvelemzs visszatrsi jelzbitjei (csak a FISH format funkci sikeres vgrehajtsa utn kerl ide a vezrls)
	and	001h
	ret	z			; visszatrs, ha a meghajtnven kvl ms karakterek nem voltak az tvonalban
	ld	a,b			; A reg.= tvonalnvelemzs visszatrsi jelzbitjei
	jp	LC563			; ugrs a ktetnv belltsi funkcira (A reg. 0. bitje 1)
;
LC3D6:	exx
	ld	a,c			; opcionlis flag bjt A reg.-be
	or	a			; CY= 0
	rra				; flag-ek jobbra lptetse
	xor	0F9h			; adott bitek neglsa: 0F9h = 1111 1001
	ld	b,a			; eredmny B'-be (formzshoz szksges hordozbjt)
	exx
	ld	a,(00D6Dh)		; A reg.-be CLI karakteres output vlaszt bjt
	bit	0,a
	jr	nz,LC3F9		; ugrs, ha a CLI pufferbe kerlne az output is
LC3E5:	ld	a,021h			; A reg.-be a szvegazonost: "Destroy data on "
	call	LCD42			; az 1.lapon trolt adott azonostj szveg kiratsa
	ld	a,(ix+007h)		; A reg.= meghajt sorszm FCB1-bl (flsleges utasts, bug)
	call	LCD36			; aktulis meghajt betjelnek kirsa az output-ra FCB1-bl
	ld	a,022h			; A reg.-be a szvegazonost: " (Y/N)? "
	call	LC30C			; az 1.lapon trolt adott azonostj szveg kiratsa, vrakozs a billentylenyomsra
	jr	nc,LC3E5		; ismtls, ha nem megengedett bett vlasztottak
	jr	nz,LC3CC		; ugrs, ha 'N'-t vlasztottak
LC3F9:	exx
	ld	a,b			; elkezelt opcionlis flag-ek A reg.-be
	exx
	ld	b,a			; flag-ek B-be (hordoz bjt)
	ld	a,(ix+007h)
	ld	c,a			; C = meghajt sorszm FCB1-bl
	ld	de,(00BF0h)		; DE= CLI puffer kezdcme
	ld	a,017h			; A reg.= lemezformzs funkcikdja
	call	LCB38			; FISH funkci vgrehajtsa IX mentsvel
	jr	LC3CC			; ugrs a hibakezelsre s a parancs befejez szakaszra
;
;
;	FORMAT parancs opcionlis paramtereinek tblzata
;
LC40C:	.db	'1',002h
	.db	'H',008h
	.db	'8',004h
	.db	000h

;
;
;	"LDIR" belpsi pontja
;
LC413:	call	LCCCB			; az aktulis kimenet belltsa a nyomtatra
;
;
;	"DIR" belpsi pontja
;
LC416:	ld	(00D71h),a		; a sajt '>' karakter mtrixnak els bjtja= 0FFh
	call	LCB44			; knyvtr/fjlmd belltsa, tvonalnv elemzse, IX ltal mutatott FCB inicializlsa
	push	hl
	push	bc
	ld	hl,0C54Eh		; HL= a keresend opcionlis paramterek tblzatcme
	call	LCBFD			; opcionlis paramterek feldolgozsa
	call	z,LCA95			; ha nincs hiba, a htralv karakterlncban szveg keresse
	jr	nz,LC437		; ugrs, ha rvnytelen paramter vagy tovbbi ismeretlen karakterek voltak
	ld	hl,00D7Ch
	set	3,(ix+006h)		; FCB1 keressi attribtumban ktetnv bit belltsa
	call	LC563			; ktetnv keresse s kiratsa (A=0)
	res	3,(ix+006h)		; FCB1 keressi attribtumban ktetnv bit trlse
LC437:	pop	bc
	pop	hl
	ret	nz			; visszatrs, ha rvnytelen a parancssor vagy FISH hiba trtnt
	exx
	bit	7,c			; opcionlis flag bjt ellenrzse
	jr	nz,LC447		; ugrs, ha "szles" megjelents (?)
	ld	a,c			; opcionlis flag bjt A reg.-be
	and	0F3h			; flag-ek maszkolsa (S s T opcik trlse)
	or	010h			; knyvtr-flag (?)
	ld	(00D6Fh),a		; flag bjt visszarsa
LC447:	ld	b,001h
	ld	a,(00D6Dh)		; A reg.= CLI karakteres output vlaszts
	bit	0,a			; CLI puffer a kimenet ?
	jr	nz,LC456		; ugrs, ha igen
	ld	a,(00B73h)		; A reg.= vide zemmd
	or	a
	jr	nz,LC45C		; ugrs, ha nem 2-szn md
LC456:	ld	a,00Ch			; S s T opcik engedlyezse -> a fjl minden adata megjelenik
	ld	b,004h			; B'= az egy sorba kirhat knyvtrbejegyzsek szma (csak "szles" md esetn)
	jr	LC46B
;
LC45C:	dec	a
	jr	nz,LC46A		; ugrs, ha nem 4-szn md
	ld	b,002h
	ld	a,c			; opcionlis flag bjt A reg.-be
	and	004h			; T flag ellenrzse
	jr	nz,LC46A		; ugrs, ha aktv
	or	008h			; egybknt S flag belltsa
	jr	LC46B
;
LC46A:	ld	a,c			; opcionlis flag bjt A reg.-be
LC46B:	ld	(00D6Eh),a		; mdostott flag bjt mentse
	ld	c,000h			; C' trlse (az egy sorba kirt knyvtrbejegyzseket szmolja)
	exx
	ld	a,019h			; A reg.-be a szvegazonost: "Directory of "
	call	LCD42			; az 1.lapon trolt adott azonostj szveg kiratsa
	call	LCAB7			; parancssorban adott fjl kikeresse
	jr	z,LC480			; ugrs, ha nem volt hiba
	cp	0A1h			; .NOFIL hiba ellenrzse
	ret	nz			; visszatrs, ha msfle hiba trtnt
	xor	a			; hibakd trlse
	scf				; CY=1
LC480:	ex	af,af'			; hibakd s flag-ek mentse
	call	LCD2D			; soremels a vlasztott output eszkzn
	call	LCD2D			; + mgegyszer
	ld	hl,00C75h		; HL= 4 bjtos puffer cme binris->decimlis konverzihoz
	ld	(hl),a			; puffer nullzsa (A reg.= 00h)
	inc	hl			; itt szmolja a knyvtrban lv fjlok sszestett mrett
	ld	(hl),a
	inc	hl
	ld	(hl),a
	inc	hl
	ld	(hl),a
	ex	af,af'			; hibakd s flag-ek vissza
LC492:	jr	c,LC506			; ugrs, ha hiba volt
	call	LCBBE			; BC s DE belltsa az FCB adatterletekre
	call	LCDB0			; fjlnv kirsa FCB2-bl az outputra
	ld	hl,00CCDh		; HL FCB2-ben a fjlmretre (+024h) mutat
	push	hl			; cm mentse
	ld	de,00C75h		; DE= 4 bjtos puffer cme binris->decimlis konverzihoz
	call	LCF4E			; HL mutatta 4-bjtos binris szm hozzadsa a pufferhez
	pop	de			; DE FCB2-ben a fjlmretre (+024h) mutat
	ld	a,(00D6Fh)		; A reg.= parancssorban megadott opcionlis paramterek flagbjtja
	and	080h
	jr	nz,LC4F1		; ugrs ha "szles" md (W)
	call	LCDE3			; SPACE kirsa az outputra
	ld	c,(ix+043h)		; C= FCB2 attribtum bjtja
	bit	0,c			; ZF= "csak olvashat" bit
	ld	a,072h			; A reg.= 'r'
	call	LCDE1			; A reg.-ben lv karakter (ZF=0) vagy SPACE (ZF=1) kirsa
	bit	1,c			; ZF= "rejtett fjl"
	ld	a,068h			; A reg.= 'h'
	call	LCDE1			; A reg.-ben lv karakter (ZF=0) vagy SPACE (ZF=1) kirsa
	ld	a,(00D6Eh)		; A reg.= mdostott opcionlis flag-eket tartalmaz bjt
	bit	3,a
	jr	z,LC4D9			; ugrs, ha S nem aktv (nem kell fjlmretet kirni)
	bit	4,(ix+043h)		; FCB2 attribtum bjt vizsglata
	jr	nz,LC4D3		; ugrs, ha alknyvtr
	ld	a,020h			; A reg.= bevezet nullk helyett kirand karakter (SPACE)
	call	LCEF5			; DE mutatta 4-bjtos szm kirsa decimlis ASCII formtumban a vlasztott outputra
	xor	a			; ZF=0
LC4D3:	ld	de,0C545h		; DE a "<dir>  " szvegre mutat
	call	nz,LCD48		; ha alknyvtr, DE mutatta nullval lezrt karakterlnc kirsa a vlasztott outputra
LC4D9:	ld	a,(00D6Eh)		; A reg.= mdostott opcionlis flag-eket tartalmaz bjt
	bit	2,a
	jr	z,LC4EC			; ugrs, ha T nem aktv (nem kell dtumot s idt kirni)
	ld	hl,00CC9h		; HL FCB2-ben a dtumra (+20h) mutat
	call	LCE66			; dtum kirsa az outputra
	ld	hl,00CC8h		; HL FCB2-ben az id fels bjtjra (+1Fh) mutat
	call	LCE25			; id kirsa az outputra (ra:perc)
LC4EC:	call	LCD2D			; soremels
	jr	LC501			; ugrs, a folytatshoz
;
LC4F1:	exx				; "szles" md
	inc	c			; az adott sorba kirt bejegyzsek szmnak nvelse
	ld	a,c
	sub	b
	jr	nz,LC4FB		; ugrs, ha mg nem rte el a max. rtket
	ld	c,a			; C'= 00h
	call	LCD2D			; soremels
LC4FB:	exx
	ld	a,01Eh			; A reg.-be a szvegazonost: "    "
	call	nz,LCD42		; ha nem volt soremels, az 1.lapon trolt adott azonostj szveg kiratsa
LC501:	call	LCB8F			; kvetkez knyvtrbejegyzs keresse FCB1 alapjn
	jr	LC492			; ismtls a kvetkez bejegyzs feldolgozsval
;
LC506:	ret	nz			; visszatrs, ha egy bejegyzst sem tallt
	exx
	or	c			; C ellenrzse (A reg.= 00h)
	call	nz,LCD2D		; soremels, ha volt kirs az adott sorban ("szles" md)
	call	LCDE3			; SPACE kirsa az outputra
	ld	hl,00C75h		; HL= 4 bjtos szm puffer cme
	call	LCDE7			; elfoglalt lemezterlet kirsa az outputra
	ld	a,01Bh			; A reg.-be a szvegazonost: " in "
	call	LCD42			; az 1.lapon trolt adott azonostj szveg kiratsa
	ld	hl,(00D69h)		; HL= a knyvtrban tallt fjlok szma
	ld	a,01Ch			; A reg.-be a szvegazonost: " file"
	call	LCDFA			; HL-ben adott szm kirsa a megadott szveg kisretben
	ld	a,01Dh			; A reg.-be a szvegazonost: "  "
	call	LCD42			; az 1.lapon trolt adott azonostj szveg kiratsa
	ld	b,(ix+007h)		; B= meghajt sorszm FCB1-bl
	ld	a,015h			; A reg.= lemezfoglaltsgi informcik beolvassa funkcikd
	call	LCB38			; FISH funkci vgrehajtsa IX mentsvel
	ret	nz			; visszatrs, ha hiba volt
	.db	03Eh			; a kvetkez bjttal: ld a,029h -> elfedi ADD HL,HL-t
LC531:	add	hl,hl			; HL (szabad klaszterek szma) szorzsa a klaszterenknti szektorszmmal
	srl	b			; B jobbra lptetse 1-el (klaszterenknti szektorszm)
	jr	nz,LC531		; ugrs, ha nem nulla
	srl	h			; HL osztsa 2-vel -> szabad szektorok szma
	rr	l
	call	LCEE8			; 16 bites binris szm kirsa decimlis ASCII formtumban a vlasztott outputra
	call	LCCD6			; 'K' karakter kirsa az outputra
	ld	a,01Fh			; A reg.-be a szvegazonost: " free"
	jp	LCD2A			; ugrs a befejezsre: az 1.lapon trolt adott azonostj szveg kiratsa soremelssel
;
;
;	Alknyvtrt megjell szveg
;
LC545:	.db	" <dir>  ",000h
;
;
;	DIR parancs opcionlis paramtereinek tblzata
;
LC54E:	.db	'S',008h		; /S -> fjlmret kirsa
	.db	'T',004h		; /T -> fjl dtumnak s idejnek kirsa
	.db	'W',080h		; /W -> "szles" megjelents
LC554:	.db	'H',002h		; /H -> mveletek engedlyezse rejtett fjlokon is
	.db	000h
;
;
;	"VOL" belpsi pontja
;
LC557:	set	3,(ix+006h)		; FCB1 keressi attribtumban ktetnv bit belltsa
	call	LCB4E			; tvonalnv elemzse, IX ltal mutatott FCB inicializlsa
	call	LCA95			; a htralv karakterlncban szveg keresse
	ret	nz			; visszatrs, ha tovbbi ismeretlen karakterek voltak
	ld	a,b			; A reg.= tvonalnvelemzs visszatrsi jelzbitjei (0.bit a lnyeg)
;
;
;	Ktetnv keresse s kiratsa, vagy ltrehozsa
;	in:   A - funkcivlaszts  0.bit =1 -> ktetnv ltrehozsa   =0 -> ktetnv kiratsa
;	out:  A - hibakd
;
LC563:	call	LCBBE			; BC s DE belltsa az FCB adatterletekre
	and	001h			; A reg. ellenrzse
	ld	a,006h			; funkcikd: fjl ltrehozsa
	jp	nz,LCB38		; ugrs a FISH funkci vgrehajtsra, ha a 0. bit 1 volt
	ld	a,004h			; funkcikd: els keresse
	call	LCB38			; FISH funkci vgrehajtsa IX mentsvel
	cp	0A1h			; .NOFIL hiba ellenrzse
	jr	z,LC578			; ugrs, ha a fjl nem tallhat
	or	a
	ret	nz			; visszatrs, ha brmilyen ms hiba trtnt
LC578:	ex	af,af'			; hibakd mentse
	ld	a,026h			; A reg.-ben az azonost: "Volume in "
	call	LCD42			; az 1.lapon trolt adott azonostj szveg kiratsa
	call	LCD36			; aktulis meghajt betjelnek kirsa az output-ra FCB1-bl
	ex	af,af'			; hibakd vissza
	or	a
LC583:	ld	a,027h			; A reg.-ben az azonost: " has no name"
	jp	nz,LCD2A		; ha nem tallta meg a ktetazonostt, ugrs a befejezsre: szveg kirsa soremelssel 
	ld	a,028h			; A reg.-ben az jabb azonost: " is "
	call	LCD42			; az 1.lapon trolt adott azonostj szveg kiratsa
	ld	hl,00CBCh		; HL FCB2-ben az tvonalnv elemzs jelzbitjeire mutat
	ld	(hl),000h		; jelzbitek nullzsa s egyben a fjlnevet lezr nulla karakter
	ld	de,00CB1h		; DE FCB2-ben a fjlnvre mutat (tallt fjlnv)
	call	LCD48			; nullval lezrt karakterlnc kirsa a vlasztott outputra
	jp	LCD2D			; ugrs a befejezsre: soremels kirsa
;
;
;	"DATE" belpsi pontja
;
LC59B:	and	(hl)			; aktulis parancssori karakter ellenrzse
	jr	nz,LC5FD		; ugrs, ha a parancssorban vannak tovbbi karakterek
	ld	a,01Bh			; A reg.= aktulis dtum beolvassa
	call	LCB38			; FISH funkci vgrehajtsa IX mentsvel
	ret	nz			; visszatrs, ha hiba volt
	push	hl			; funkci visszatrsi rtkeinek elmentse
	push	de
	push	bc
	ld	a,00Fh			; A reg.-ben az azonost: "Current date is "
	call	LCD42			; az 1.lapon trolt adott azonostj szveg kiratsa
	pop	bc			; C= nap a hten bell
	ld	b,000h
	ld	hl,LC667		; azonostk tblzatnak cme
	add	hl,bc
	ld	a,(hl)			; ht napjnak megfelel azonost A reg.-be
	call	LCD42			; az 1.lapon trolt adott azonostj szveg kiratsa
	pop	de
	pop	hl			; dtum funkci visszatrsi rtkeinek helyrelltsa a verembl
	ld	bc,0F844h		; BC= -1980
	add	hl,bc			; HL= relatv vszm (1980-hoz kpest)
	ld	a,d			; A reg.= hnap
	add	a,a
	add	a,a
	add	a,a
	add	a,a
	add	a,a			; A reg. balra lptetve 5-el
	rl	l			; relatv v 1-el balra lptetve, CY belp a 0. bitre
	or	e			; A reg.= 7..5.bit: hnap  4..0.bit: nap
	ld	d,l			; D= 7..1.bit: eltolt relatv v  0.bit: hnap fels bit
	ld	hl,00C76h		; HL= 4 bjtos puffer msodik bjtjnak cme
	ld	(hl),d			; als sz fels bjtba v/hnap MSB
	dec	hl
	ld	(hl),a			; als sz als bjtba hnap LSB/nap, HL a puffer elejre mutat
	call	LCE66			; dtum kirsa az outputra
	call	LCD2D			; soremels kirsa
LC5D3:	ld	a,(00D6Dh)		; A reg.= CLI karakteres output vlaszts
	bit	0,a
	ld	a,000h			; hibakd trlse
	ret	nz			; visszatrs, ha a CLI puffer az output
	ld	a,010h			; A reg.-ben az azonost: "Enter new date"
	call	LCD42			; az 1.lapon trolt adott azonostj szveg kiratsa
	call	LCD51			; adatok beolvassa a parancssorbl, a sor elejn ':' jellel
	ret	nz			; visszatrs, ha hiba trtnt
	jr	nc,LC5EA		; ugrs, ha nem nyomtak ESC-et
	call	LCD2D			; soremels kirsa
	ret				; visszatrs
;
LC5EA:	ld	a,(00BF5h)		; A reg.= a beolvasott parancssor hossza
	or	a
	ret	z			; visszatrs, ha nincs beolvasott karakter
	ld	hl,00BF6h		; HL= parancssori string kezdcme
	push	hl
	ld	c,a			; C= parancssori string hossza
	xor	a			; A reg.= 0
	ld	b,a			; B= 0
	add	hl,bc
	ld	(hl),a			; parancssori string vgre zr nulla karakter elhelyezse
	pop	hl			; HL= parancssori string kezdcme
	call	LCC8C			; kvetkez kirtkelhet karakter olvassa a stringbl
	ret	z			; visszatrs, ha elrte a string vgt
LC5FD:	exx
	ld	a,01Bh			; A reg.= aktulis dtum beolvassa
	call	LCB38			; FISH funkci vgrehajtsa IX mentsvel
	ret	nz			; visszatrs, ha hiba volt
	exx
	ld	a,(iy-061h)		; A reg.= DTFORM (0D01Fh cmrl)
	add	a,a			; fels bit kilptetse
	jr	nz,LC60D		; ugrs, ha a dtum formtuma nem a default
	ld	a,036h			; formtum kd: angol (balra lptetve 1-el)
LC60D:	add	a,a			; tovbbi lptets balra 1-el
	ld	b,003h			; B= ciklusszmll (fellrdik a LCC92-s rutinban, bug (!!!))
	push	af			; formtum kd mentse
	jr	LC61A
;
LC613:	push	bc
	call	LCC3D			; az els specilis karakter utni hasznos (nem SPACE vagy TAB) karakter beolvassa
	pop	bc
	jr	c,LC658			; ugrs, ha elrte az szveg vgt vagy nem specilis karakter volt az els karakter
LC61A:	call	LCC92			; ktjegy szm beolvassa HL mutatta stringbl
	push	af			; hibakd a verembe
	ld	a,c			; beolvasott szm A reg.-be
	exx
	pop	bc			; hibakd B'-be
	ld	c,a			; C'= beolvasott szm
	pop	af			; A reg.= formtum kd
	rlca
	rlca				; forgats 2-vel balra
	push	af			; elforgatott kd mentse
	inc	b
	dec	b
	jr	nz,LC646		; ugrs, ha sikertelen volt a szmbeolvass
	and	003h
	jr	z,LC646			; ugrs, ha az adott pozciban a formtum 0
	dec	a
	jr	z,LC645			; ugrs, ha az adott pozci a nap
	dec	a
	jr	z,LC643			; ugrs, ha az adott pozci a hnap
	ld	a,c
	sub	050h			; A reg.= beolvasott szm - 80
	jr	nc,LC63B		; ugrs, ha nincs alulcsorduls
	add	a,064h			; A reg.= beolvasott szm - 80 + 100
LC63B:	ld	c,a			; C'= relatv v
	ld	b,000h
	ld	hl,007BCh		; HL'= 1980
	add	hl,bc			; HL'= abszolt v (>=1980)
	ld	c,d			; C'= FISH-tl lekrdezett vagy korbban mr belltott hnap
LC643:	ld	d,c			; hnap belltsa
	.db	00Eh			; a kvetkez bjttal: ld c,059h -> elfedi LD E,C -t
LC645:	ld	e,c			; nap belltsa
LC646:	exx
	djnz	LC613			; ismtls 3-szor (?)
	call	LCC8C			; kvetkez kirtkelhet karakter olvassa a stringbl
	jr	nz,LC658		; ugrs, ha van mg htra hasznos karakter
	pop	af			; verem kitakartsa
	exx
	ld	a,01Ch			; A reg.= aktulis dtum belltsa
	call	LCB38			; FISH funkci vgrehajtsa IX mentsvel
	ret	z			; visszatrs, ha nem volt hiba
	jr	LC65B			; ugrs a folytatsra
;
LC658:	pop	af			; verem kitakartsa
	ld	a,097h			; hibakd: .IDATE - rvnytelen dtum
LC65B:	ld	hl,00D6Dh		; CLI karakteres output vlaszt vltoz cme
	bit	0,(hl)
	ret	nz			; visszatrs, ha CLI puffer a kimenet
	call	LCEBD			; hibazenet kirsa a vlasztott karakteres outputra
	jp	LC5D3			; beolvass megismtlse
;
;
;	Ht napjainak megfelel azonostk az 1. lapon trolt szvegekhez
;
LC667:	.db	017h,011h,012h,013h,014h,015h,016h

;
;
;	"TIME" belpsi pontja
;
LC66E:	and	(hl)			; aktulis parancssori karakter ellenrzse
	jr	nz,LC6B7		; ugrs, ha a parancssorban vannak tovbbi karakterek
	ld	a,01Dh			; A reg.= aktulis id beolvassa
	call	LCB38			; FISH funkci vgrehajtsa IX mentsvel
	ret	nz			; visszatrs, ha hiba volt
	ld	a,024h			; A reg.-ben az azonost: "Current time is "
	call	LCD42			; az 1.lapon trolt adott azonostj szveg kiratsa
	ld	a,l			; A reg.= perc
	add	a,a
	add	a,a			; A reg. balra lptetve 2-vel
	ld	b,003h			; jabb balra lptets 3-szor
LC681:	add	a,a
	rl	h			; az A reg.-bl kilp bitek belptetse H-ba
	djnz	LC681
	ld	c,h			; C= 7..3.bit: ra  2..0.bit: perc fels 3 bit
	ld	hl,00C75h		; HL= 4 bjtos puffer cme binris->decimlis konverzihoz
	ld	(hl),a			; puffer als bjtja 7..5.bit: perc als 3 bit
	inc	hl
	ld	(hl),c			; puffer fels bjtja ra/perc fels 3 bit
	call	LCE25			; id kirsa az outputra (ra:perc)
	call	LCD2D			; soremels kirsa
LC693:	ld	a,(00D6Dh)		; A reg.= CLI karakteres output vlaszts
	bit	0,a
	ld	a,000h			; hibakd trlse
	ret	nz			; visszatrs, ha a CLI puffer az output
	ld	a,025h			; A reg.-ben az azonost: "Enter new time"
	call	LCD42			; az 1.lapon trolt adott azonostj szveg kiratsa
	call	LCD51			; adatok beolvassa a parancssorbl, a sor elejn ':' jellel
	ret	c			; visszatrs, ha ESC-et nyomtak
	ret	nz			; visszatrs, ha hiba trtnt
	ld	hl,00BF5h		; HL= a beolvasott parancssor-string hosszra mutat
	ld	a,(hl)			; A reg.= parancssor-string hossza
	inc	hl			; HL a stringre mutat
	or	a
	ret	z			; visszatrs, ha nulla a hossz
	push	hl			; HL mentse
	ld	c,a
	xor	a			; A reg.= 00h
	ld	b,a
	add	hl,bc			; HL a string vgre mutat
	ld	(hl),a			; zr nulla karakter elhelyezse
	pop	hl			; HL ismt a string elejre mutat
	call	LCC8C			; kvetkez kirtkelhet karakter olvassa a stringbl
	ret	z			; visszatrs, ha nincs tbb karakter
LC6B7:	exx
	ld	a,01Dh			; A reg.= aktulis id beolvassa
	call	LCB38			; FISH funkci vgrehajtsa IX mentsvel
	ret	nz			; visszatrs, ha hiba volt
	exx
	call	LCC92			; ktjegy szm beolvassa HL mutatta stringbl
	jr	nz,LC6C8		; ugrs, ha hiba trtnt
	ld	a,c			; beolvasott szm A reg.-be
	exx
	ld	h,a			; H'= beolvasott szm (ra)
	exx
LC6C8:	call	LCC3D			; az els specilis karakter utni hasznos (nem SPACE vagy TAB) karakter beolvassa
	sbc	a,a
	jr	nz,LC6D1		; ugrs, ha elrte a szveg vgt vagy nem specilis karakter volt az els karakter
	call	LCC92			; ktjegy szm beolvassa HL mutatta stringbl
LC6D1:	jr	nz,LC6D7		; ugrs, ha hiba trtnt
	ld	a,c
	exx
	ld	l,a			; L'= beolvasott szm (perc)
	exx
LC6D7:	call	LCC3D			; az els specilis karakter utni hasznos (nem SPACE vagy TAB) karakter beolvassa
	sbc	a,a
	jr	nz,LC6E0		; ugrs, ha elrte a szveg vgt vagy nem specilis karakter volt az els karakter
	call	LCC92			; ktjegy szm beolvassa HL mutatta stringbl
LC6E0:	jr	nz,LC6E6		; ugrs, ha hiba trtnt
	ld	a,c
	exx
	ld	d,a			; D'= beolvasott szm (msodperc)
	exx
LC6E6:	call	LCC3D			; az els specilis karakter utni hasznos (nem SPACE vagy TAB) karakter beolvassa
	sbc	a,a
	jr	nz,LC6EF		; ugrs, ha elrte a szveg vgt vagy nem specilis karakter volt az els karakter
	call	LCC92			; ktjegy szm beolvassa HL mutatta stringbl
LC6EF:	jr	nz,LC6F5		; ugrs, ha hiba trtnt
	ld	a,c
	exx
	ld	e,a			; E'= beolvasott szm (szzadmsodperc)
	exx
LC6F5:	call	LCC8C			; kvetkez kirtkelhet karakter olvassa a stringbl
	call	LC1D3			; angol kisbet nagybetv alaktsa
	cp	041h
	jr	z,LC70E			; ugrs, ha 'A' bet (CY=0)
	cp	050h
	scf				; CY=1
	jr	z,LC70E			; ugrs, ha 'P' bet (CY=1)
	or	a
	exx
	jr	z,LC72E			; ugrs, ha zr nulla karakter volt
	.db	03Eh			; a kvetkez bjttal: ld a,0F1h -> elfedi POP AF -t
LC709:	pop	af
LC70A:	ld	a,096h			; hibakd: .ITIME - rvnytelen id
	jr	LC734			; ugrs a hibakezelsre
;
LC70E:	push	af			; CY mentse
	inc	hl			; HL a kvetkez karakterre mutat
	call	LCC8C			; kvetkez kirtkelhet karakter olvassa a stringbl
	jr	nz,LC709		; ugrs, ha nem zr nulla karakter kvetkezett
	pop	af			; CY mutatja, hogy 'A' vagy 'P' volt a napszak
	exx
	ld	b,00Ch			; B'= 12
	ld	a,h			; A reg.= ra
	jr	c,LC726			; ugrs, ha dlutn ('P')
	cp	b
	jr	z,LC722			; ugrs, ha pont ji 12 ra
	jr	nc,LC70A		; ugrs, ha nagyobb 12 rnl s dleltt ('A') volt megjellve
	.db	0D2h			; a kvetkez bjtokkal: jp nc,L0026 -> elfedi LD H,000h -t
LC722:	ld	h,000h
	jr	LC72E
;
LC726:	or	a
	jr	z,LC70A			; ugrs, ha 0 ra s dlutn volt megjellve
	cp	b
	jr	nc,LC72D		; ugrs, ha nagyobb vagy egyenl 12 rval
	add	a,b			; ra nvelse 12-vel
LC72D:	ld	h,a			; H= 24 rs id
LC72E:	ld	a,01Eh			; A reg.= aktulis id belltsa
	call	LCB38			; FISH funkci vgrehajtsa IX mentsvel
	ret	z			; visszatrs, ha nem volt hiba
LC734:	ld	hl,00D6Dh		; CLI karakteres output vlaszt vltoz cme
	bit	0,(hl)
	ret	nz			; visszatrs, ha CLI puffer a kimenet
	call	LCEBD			; hibazenet kirsa a vlasztott karakteres outputra
	jp	LC693			; beolvass megismtlse
;
;
;	"VAR" belpsi pontja
;
LC740:	and	(hl)			; aktulis parancssori karakter ellenrzse
	ld	a,08Dh			; hibakd: .INP - rvnytelen szm paramter
	ret	z			; visszatrs, ha nincs tbb karakter a parancssorban
	call	LCC92			; ktjegy szm beolvassa HL mutatta stringbl
	ret	nz			; visszatrs, ha hiba volt
	call	LCCBD			; az els specilis karaktert kvet karakter keresse, ha kzben nincs zr nulla
	ret	nz			; visszatrs, ha nem volt specilis vagy zr nulla karakter
	or	(hl)			; az aktulis karakter vizsglata
	jr	nz,LC761		; ugrs, ha nem zr nulla karakter
	ld	e,c			; E= a beolvasott ktjegy szm (rendszervltoz szma)
	ld	b,000h			; B= olvassi irny
	ld	a,01Ah			; A reg.= rendszervltoz olvassa funkcikd
	call	LCB38			; FISH funkci vgrehajtsa IX mentsvel
	ret	nz			; visszatrs, ha hiba volt
	ld	l,d			; L= a vltoz aktulis rtke
	ld	h,a			; H= 00h
	call	LCEE8			; 16 bites binris szm kirsa decimlis ASCII formtumban a vlasztott outputra
	call	LCD2D			; soremels kirsa
	ret
;
LC761:	push	bc			; beolvasott ktjegy szm a verembe (rendszervltoz szma)
	ex	de,hl
	dec	de			; DE a hasznos karaktert megelz pozcira mutat
	ld	hl,LC795		; HL az "ON" s "OFF" szvegekre mutat
	ld	bc,00200h		; B= 002h (sszehasonltsi hossz)  C= 000h
	call	LC1B9			; karakterlncok sszehasonltsa
	jr	nc,LC776		; ugrs, ha megegyeznek
	inc	b			; B= 003h
	dec	c			; C= 0FFh
	call	LC1B9			; karakterlncok sszehasonltsa
	jr	c,LC779			; ugrs, ha nem egyeznek meg
LC776:	inc	de			; DE= hasznos szveg utols karakterre mutat (vagy +2 (ON) vagy +3 (OFF))
	djnz	LC776
LC779:	inc	de			; DE a beazonostott szveg utnra vagy a be nem azonostott elejre mutat
	ex	de,hl			; HL-be a cm
	sbc	a,a
	jr	z,LC783			; ugrs, ha sikeresen beazonostotta a szveget
	call	LCC92			; egybknt, ktjegy szm beolvassa HL mutatta stringbl
	jr	nz,LC786		; ugrs, ha ez is sikertelen
LC783:	call	LCCBD			; az els specilis karaktert kvet karakter keresse, ha kzben nincs zr nulla
LC786:	pop	de			; E= rendszervltoz szma
	ret	nz			; visszatrs, ha nem volt specilis vagy zr nulla karakter vagy sikertelen volt a paramter azonostsa
	or	(hl)
	ld	a,08Dh			; hibakd: .INP - rvnytelen szm paramter
	ret	nz			; visszatrs, ha nem zr nulla karaktert tallt
	ld	b,0FFh			; B= rsi irny
	ld	d,c			; D= rendszervltoz j adata ( 000h (ON) vagy 0FFh (OFF) vagy a beolvasott ktjegy szm)
	ld	a,01Ah			; A reg.= rendszervltoz belltsa funkcikd
	call	LCB38			; FISH funkci vgrehajtsa IX mentsvel
	ret
;
;
;	Szvegkonstansok a rendszervltozk belltshoz
;
LC795:	.db	002h,"ON"
	.db	003h,"OFF"

;
;
;	"LTYPE" belpsi pontja
;
LC79C:	call	LCCCB			; az aktulis kimenet belltsa a nyomtatra
;
;
;	"TYPE" belpsi pontja
;
LC79F:	xor	a			; "TYPE" mvelet jelzse az 5.biten
	ld	(00D6Ch),a		; flag vltoz belltsa
	jr	LC7AB			; ugrs a folytatsra
;
;
;	"COPY" belpsi pontja
;
LC7A5:	ld	a,020h			; "COPY" mvelet jelzse az 5.biten
	ld	(00D6Ch),a		; flag vltoz belltsa
	xor	a
LC7AB:	call	LC8C7			; tvonalnv elemzse, helyrellts ha nem device-ra hivatkozik
	push	hl			; parancssori string kezdcme a verembe
	push	bc			; tvonal jelzbitek s zr karakter a verembe
	ld	hl,0C8C4h		; HL= opcionlis paramterek tblzata
	call	LCBEB			; opcionlis paramterek feldolgozsa CY-tl fggen
	jr	nz,LC800		; ugrs, ha rvnytelen paramter
	call	LCA8A			; hibakd belltsa A reg.-ben, ha nincs megfelel tvonalnv megadva
	jr	nz,LC800		; ugrs, ha nem megfelel az tvonalnv
	exx
	ld	b,c			; B'= C'= opcis flag bjt msolata
	exx
	ex	de,hl			; HL - az utols feldolgozott parancssori karakterre mutat
	call	LCA03			; "TYPE" s "COPY" parancs vgrehajtsnak megklnbztetse
	jr	nz,LC7D7		; ugrs, ha "COPY"
	push	hl			; parancssori pozci mentse
LC7C7:	ld	a,(hl)			; utols feldolgozott karakter A reg.-be
	call	LCC5D			; A reg.-ben lv karakter kielemzse
	inc	hl			; HL= kvetkez karakter cme
	jr	c,LC7C7			; ugrs, ha SPACE vagy TAB
	jr	z,LC7D6			; ugrs, ha zr nulla karakter
	ld	a,08Dh			; hibakd: .INP - rvnytelen szm paramter
	pop	hl			; verem kitakartsa
	pop	bc
	pop	bc
	ret				; visszatrs (hiba)
;
LC7D6:	pop	hl			; HL az opcionlis paramterek utnra mutat
LC7D7:	call	LCBCA			; IX belltsa FCB3-ra, FCB3 inicializlsa hasznlatlan FCB-nek
	call	LCC8C			; kvetkez kirtkelhet karakter olvassa a stringbl
	xor	a
	call	LCA03			; "TYPE" s "COPY" parancs vgrehajtsnak megklnbztetse
	jr	nz,LC7E8		; ugrs, ha "COPY"
	exx
	ld	c,a			; C'= 000h
	exx
	jr	LC7F8			; ugrs a "TYPE" folytatsra
;
LC7E8:	ld	c,a			; C= 000h
	call	LC8C7			; tvonalnv elemzse (eredmny FCB3-ban), parancssor helyrelltsa, ha nem device-ra hivatkozik
	push	hl
	exx
	pop	de			; DE'= cl tvonalnv eleje
	exx
	ld	hl,LC8C6		; HL egy zr nulla bjtra mutat (nincs opcis paramter)
	call	LCBEB			; opcionlis paramterek feldolgozsa CY-tl fggen
	jr	nz,LC800		; ugrs, ha rvnytelen paramter
LC7F8:	call	LCA95			; htralv karakterlncban paramter keresse
	jr	z,LC800			; ugrs, ha nincs tbb paramter
	pop	bc			; verem kitakartsa
	pop	hl
	ret				; visszatrs (hiba)
;
LC800:	ld	de,0FFA0h		; DE= -60h
	add	ix,de			; IX FCB1-re mutat (nem lltja ZF-et)
	pop	bc			; BC= tvonal jelzbitek s zr karakter
	pop	hl			; HL= parancssori string kezdcme
	ret	nz			; visszatrs, ha ZF=0 (rvnytelen paramter volt)
	exx
	ld	a,b			; A reg.= opcis paramterek flagjai
	or	c			; ssze VAGY-ols a msik opcis flag-ekkel
	ld	(00D6Fh),a		; eredmny trolsa a RAM vltozban
	exx
	call	LCAB7			; parancssorban adott fjl kikeresse
	ret	nz			; visszatrs, ha hiba trtnt
	ld	hl,00D6Ch		; HL= "TYPE" s "COPY" megklnbztet vltoz cme
	res	6,(hl)			; 6.bit trlse
LC818:	call	LCBBE			; BC s DE belltsa az FCB adatterletekre
	ex	de,hl			; HL FCB1-re mutat (keressi FCB)
	ld	e,c			; DE FCB2-re mutat (meghatrozott FCB)
	ld	d,b
	ld	a,00Ch			; A reg.= fjl megnyits funkcikd
	call	LCB38			; FISH funkci vgrehajtsa IX mentsvel
	ret	nz			; visszatrs, ha hiba trtnt
	exx
	ld	bc,(00BF0h)		; BC'= CLI puffer kezdcme
	ld	hl,(00BF2h)		; HL'= CLI puffer mrete
	ld	a,h			; HL' lefel kerektse n*512 bjtra
	and	0FEh
	ld	h,a
	ld	l,000h
	ld	a,08Ch			; hibakd: .NORAM - nincs elg memria
	ret	z			; visszatrs, ha a CLI puffer kisebb 512 bjtnl
	call	LCA03			; "TYPE" s "COPY" parancs vgrehajtsnak megklnbztetse
	jr	nz,LC840		; ugrs, ha "COPY"
	ld	a,018h
	cp	h
	jr	nc,LC840		; ugrs, ha H'<= 24 ( a CLI puffer < 12kB)
	ld	h,a			; puffer mretnek korltozsa
LC840:	exx
	call	LC8E3			; FCB2-ben adott nyitott forrsfjl olvassa s kirsa a kpernyre vagy msolsa a clfjlba
	push	af			; hibakd mentse
	ld	de,00D09h		; DE= FCB4 cme (ltrehozott cl fjl)
	ld	hl,00CD9h		; HL= FCB3 cme (prototpus FCB a cl fjl ltrehozshoz)
	push	hl
	pop	ix			; IX= FCB3 cme
	call	LCA03			; "TYPE" s "COPY" parancs vgrehajtsnak megklnbztetse
	jr	z,LC8A6			; ugrs, ha "TYPE"
	bit	7,(ix+014h)		; FCB3-ban a +14h bjt vizsglata
	jr	nz,LC8A6		; ugrs, ha nem lett ltrehozva s megnyitva a cl fjl
	ld	a,00Dh			; A reg.= fjl lezrsa funkcikd (FCB4-t)
	call	LCB38			; FISH funkci vgrehajtsa IX mentsvel
	ld	b,a			; hibakd mentse B-be
	pop	af			; A reg.= a msols utni hibakd
	jr	nz,LC863		; ugrs, ha volt hiba
	or	b			; fjl lezrsa utni hibakd A reg.-be s flag-ek belltsa
LC863:	push	af			; hibakd a verembe
	jr	z,LC870			; ugrs, ha egybknt nem volt hiba
	push	ix
	pop	hl			; HL= FCB3 cme
	ld	a,008h			; A reg.= trls funkcikd
	call	LCB38			; FISH funkci vgrehajtsa IX mentsvel
	jr	LC8A6			; ugrs a folytatsra
;
LC870:	ld	a,(ix-01Dh)		; A reg.= FCB2 +13h bjtja
	set	5,a			; 5.bit=1 (archivlsi attribtum bit)
	ld	(ix+043h),a		; mdostott rtk bersa FCB4 +13h bjtjra
	push	de			; DE= FCB4 cme
	ld	hl,00021h
	add	hl,de
	ex	de,hl			; DE= +021h bjt FCB4-ben (meghatrozott FCB-ben az utols mdosts dtuma)
	ld	hl,0FF9Bh		; HL= -65h
	add	hl,de			; HL FCB2-ben a +01Ch bjtra mutat (nyitott FCB-ben az utols mdosts dtuma)
	push	hl			; cm mentse
	ldd				; 2 bjt msolsa FCB2-bl FCB4-be (cm cskkentssel)
	ldd
	pop	hl
	inc	hl
	inc	hl			; HL FCB2-ben az utols mdosts idejre mutat
	ldd				; 2 bjt msolsa FCB2-bl FCB4-be (cm cskkentssel)
	ldd
	pop	de			; DE= FCB4 cme
	push	ix
	pop	hl			; HL= FCB3 cme
	ld	a,00Bh			; A reg.= attribtumok vltoztatsa (+ dtum s id is)
	call	LCB38			; FISH funkci vgrehajtsa IX mentsvel
	ld	b,a			; hibakd mentse B-be
	pop	af			; korbbi hibakd vissza
	jr	nz,LC89C		; ugrs, ha mr volt hiba
	or	b			; attribtumok vltoztatsa utni hibakd A reg.-be s flag-ek belltsa
LC89C:	push	af			; hibakd a verembe
	ld	b,(ix+007h)		; B= FCB3-bl a meghajt azonost
	ld	c,a			; C= 00h (ha nem volt korbban hiba) -> csak pufferek trlse lesz
	ld	a,00Eh			; A reg.= pufferek trlse funkci
	call	z,LCB38			; ha korbban nem volt hiba, FISH funkci vgrehajtsa IX mentsvel
LC8A6:	pop	af			; hibakd vissza
	ret	nz			; visszatrs, ha korbban volt hiba 
	call	LCA03			; "TYPE" s "COPY" parancs vgrehajtsnak megklnbztetse
	jr	nz,LC8B3		; ugrs, ha "COPY"
	call	LC9FB			; CLI karakteres output vlaszts megklnbztetse
	call	z,LCD2D			; ha nem CLI puffer a kimenet, soremels kirsa
LC8B3:	ld	de,0FFA0h		; DE= -60h
	add	ix,de			; IX FCB1-re mutat (keressi FCB)
	bit	5,(ix+013h)
	ret	z
	call	LCB8F			; kvetkez knyvtrbejegyzs keresse FCB1 alapjn
	jp	nc,LC818		; ugrs, ha nem trtnt hiba
	ret
;
;
;	TYPE s COPY parancs opcionlis paramtereinek tblzata
;
LC8C4:	.db	'H',002h
LC8C6:	.db	000h

;
;
;	tvonalnv elemzse, helyrellts ha nem device-ra hivatkozik
;	/megj.: a device kezelsek nincsenek megvalstva (ellenttben a pdf.-ben lltottakkal)/
;	in:   C - fjlnv flag (ld. FISH_01 funkci)
;	     DE - FCB1-re mutat
;	     HL - a parancssorban megadott tvonalnvre mutat
;	     IX - FCB-re mutat (FCB1 vagy FCB3)
;	out:  A - hibakd (0)
;	      B - tvonalnvelemzs visszatrsi jelzbitjei
;	      C - zr karakter
;	     DE - zr karakterre mutat
;	     HL - megrzdik
;	     IX - megrzdik
;	     CY - CY=1
;
LC8C7:	ex	af,af'
	ld	a,(hl)			; aktulis parancssori karakter beolvassa A reg.-be
	exx
	ld	l,a			; L'= beolvasott karakter
	exx
	call	LCB4E			; tvonalnv elemzse, IX ltal mutatott FCB inicializlsa
	ld	a,c			; A reg.= zr karakter
	cp	03Ah
	jr	nz,LC8D9		; ugrs, ha nem ':' (nem device volt megadva)
	ld	(de),a			; zr karakter visszarsa
	exx
	ld	a,l			; els parancssori karakter vissza A reg.-be
	exx
	ld	(hl),a			; parancssori karakter visszarsa a string elejre
LC8D9:	xor	a			; A reg.= 000h
	scf				; CY=1
	set	7,(ix+014h)		; FCB1-ben a +14h bjt legfels bit belltsa
	ld	(ix+013h),b		; tvonalnvelemzs visszatrsi jelzbitjeinek elmentse FCB1-be
	ret
;
;
;	FCB2-ben adott nyitott forrsfjl olvassa s kirsa a kpernyre ("TYPE") vagy
;	msolsa adott tvonalon lv, FCB3-ban definilt ltrehozand fjlba
;	/megj.: a mveletek utn mind a forrs mind a cl fjl FCB-je nyitott marad/
;	in:/ DE - FCB2-re mutat (nyitott meghatrozott FCB) /
;	   / HL - FCB1-re mutat (keressi FCB)              /
;	     BC'- CLI puffer kezdcme
;	     DE'- cl tvonalnv eleje
;	     HL'- CLI puffer mrete
;	     IX - FCB1-re mutat
;	out:  A - hibakd
;	     IX - FCB1-re mutat
;
LC8E3:	call	LCBBE			; BC s DE belltsa az FCB adatterletekre
	set	7,(ix+074h)		; FCB3 +14h bjtjnak 7.bitje=1 (nincs mg ltrehozva a cl fjl)
	bit	5,(ix+013h)		; FCB1-ben az tvonalnv flag-ek ellenrzse
	jr	z,LC8FC			; ugrs, ha az utols elem nem tbbrtelm
	scf
	call	LC9FB			; CLI karakteres output vlaszts megklnbztetse
	jr	nz,LC8FC		; ugrs, ha CLI puffer a kimenet
	call	LCDB0			; fjlnv kirsa az outputra FCB2-bl (aktulis forrs fjl neve)
	call	LCD2D			; soremels kirsa
LC8FC:	xor	a			; A reg.= 000h  ZF=1
LC8FD:	ex	af,af'
	exx
	push	hl
	exx
	pop	bc			; BC= CLI puffer mrete
	ld	a,00Fh			; A reg.= olvass fjlbl funkcikd
	call	LC9E2			; FISH adattvitel vgrehajtsa a CLI pufferen
	ret	nz			; visszatrs, ha hiba volt (kivve .EOF, ilyenkor A=00h A'=.EOF)
	ld	de,00060h
	add	ix,de			; IX FCB3-ra mutat
	call	LCA03			; "TYPE" s "COPY" parancs vgrehajtsnak megklnbztetse
	jr	nz,LC93A		; ugrs, ha "COPY"
	ld	l,c			; HL= olvasott bjtok szma
	ld	h,b
	exx
	push	bc
	exx
	pop	de			; DE= CLI puffer kezdcme
LC918:	ld	a,h
	or	l
	jp	z,LC9D5			; ugrs, ha az sszes olvasott bjtot feldolgozta
	ld	a,(de)			; A reg.= els olvasott bjt
	cp	01Ah
	jr	nz,LC929		; ugrs, ha nem CTRL-Z (fjl vge jelzs)
	xor	0FEh			; A reg.= 0E4h (nem definilt hibakd)
	ex	af,af'			; hibakd s flag-ek mentse
	xor	a			; ZF=1
	jp	z,LC9D5			; ugrs, ha ZF=1 (? bug)
LC929:	inc	de			; DE a kvetkez olvasott karakterre mutat
	dec	hl			; bjtok szmnak cskkentse
	call	LC9FB			; CLI karakteres output vlaszts megklnbztetse
	call	z,LCCD8			; ha nem CLI puffer, karakter kirsa a vlasztott outputra
	ld	a,(0DFF4h)		; A reg.= STOP_FLAG msolata
	or	a
	jr	z,LC918			; ugrs az ismtlshez, ha nem nyomtak CTRL-ESC-t
	ld	a,0F5h			; hibakd: .STOP - CTRL-ESC-t nyomtak
	ret
;
LC93A:	bit	7,(ix+014h)		; FCB3 +14h bjtjnak vizsglata
	jp	z,LC9CD			; ugrs, ha nulla (a cl fjl mr ltrehozva s megnyitva)
	push	bc			; BC= olvasott bjtok szma
LC942:	ld	hl,00D83h
	ex	de,hl			; DE= 00D83h (tmeneti puffer cme)
	push	de
	ld	hl,0FF5Eh		; HL= -0A2h
	add	hl,de			; HL= FCB3-ban a fjlnv cme
	push	hl			; cm ktszer a verembe
	push	hl
	ld	bc,0000Dh		; 13 bjt mozgatsa lesz
	ldir				; adatok msolsa a 00D83h cmre
	pop	de			; DE= FCB3-ban a fjlnv cme
	ld	hl,0FFD0h		; HL= -30h
	add	hl,de			; HL= FCB2-ben a fjlnv cme
	ld	b,00Bh			; B= 11 ciklus lesz (fjlnv hossza)
LC959:	ld	a,(de)			; FCB3 fjlnevnek karakterei A reg.-be
	cp	03Fh			; sszehasonlts '?'-el
	jr	nz,LC960		; ugrs, ha nem joker karakter van a fjlnv adott pozcijban
	ld	a,(hl)
	ld	(de),a			; FCB3-ban a krdjel fellrsa az FCB2 azonos pozcijban lv karakterrel
LC960:	inc	hl			; mutatk nvelse
	inc	de
	djnz	LC959			; ismtls, a teljes fjlnvre
	call	LCBBE			; BC s DE belltsa az FCB adatterletekre (FCB4 s FCB3)
	exx
	push	de
	exx
	pop	hl			; HL= cl tvonalnv eleje (vagy keressi FCB a msodik prblkozsnl)
	bit	6,(ix-060h)		; FCB1 0. bjtjnak vizsglata
	jr	z,LC976			; ugrs, ha nulla a 6. bit (?)
	ld	a,0FFh
	ld	(0DFF3h),a		; RAM vltoz belltsa 0FFh-ra
LC976:	ld	a,006h			; A reg.= fjl ltrehozsa funkcikd
	push	hl			; HL mentse
	ld	hl,00D6Ch		; HL= flag bjt cme
	bit	6,(hl)			; 6.bit vizsglata
	set	6,(hl)			; 6.bit belltsa
	pop	hl			; HL= cl tvonalnv eleje
	jr	nz,LC9B4		; ugrs, ha a 6.bit=1 volt (mr volt egy prblkozs)
	call	LCB38			; FISH funkci vgrehajtsa IX mentsvel
	jr	z,LC9B9			; ugrs, ha nem volt hiba
	cp	09Ch			; .DIRX hiba ellenrzse
	jr	nz,LC9C3		; ugrs, ha nem .DIRX hiba volt
	bit	5,(ix+013h)		; FCB3-ban az tvonalnv jelzbitek (v. attribtum bjt) ellenrzse
	jr	nz,LC9C3		; ugrs, ha tbbrtelm az utols elem (visszatrs hibajelzssel)
	ld	hl,00060h
	add	hl,de			; HL FCB5-re mutat
	push	hl
	exx
	pop	de			; DE' FCB5-re mutat (keressi FCB)
	exx
	ex	de,hl			; DE= FCB5 cme   HL= FCB3 cme (a ltez knyvtr keressi FCB-je)
	ld	bc,00030h
	ldir				; a teljes FCB3 tmsolsa FCB5-be
	call	LCB75			; FCB3 s FCB4 tartalmnak felcserlse, FCB3 fjlnevnek kitltse krdjelekkel
	ld	a,(ix+073h)		; A reg.= FCB5 +13h bjtja
	or	b			; (?) B= 0Dh (FCB4 cmnek fels bjtja)
	ld	(ix+013h),a		; mdostott bjt belltsa FCB3 azonos pozcijba
	ld	a,(ix+074h)		; A reg.= FCB5 +14h bjtja
	ld	(ix+014h),a		; bjt tmsolsa FCB3 azonos pozcijba
	pop	de			; verem kitakartsa
	pop	hl
	jr	LC942			; ismtls (most a fjlt hozza ltre a knyvtron bell)
;
LC9B4:	call	LCB38			; FISH funkci vgrehajtsa IX mentsvel
	jr	nz,LC9C3		; ugrs, ha hiba volt
LC9B9:	ld	hl,00030h
	add	hl,de
	ex	de,hl			; DE= FCB4 cme (ltrehozott cl fjl meghatrozott FCB-je)  HL= FCB3 cme (keressi FCB)
	ld	a,00Ch			; A reg.= fjl megnyitsa funkci
	call	LCB38			; FISH funkci vgrehajtsa IX mentsvel
LC9C3:	pop	de			; DE= FCB3-ban a fjlnv cme
	pop	hl			; HL= FCB3-bl kimsolt fjlnv cme
	ld	bc,0000Dh
	ldir				; kimsolt bjtok visszamsolsa FCB3-ba (pl. joker karakterek miatt)
	pop	bc			; BC= forrsbl olvasott bjtok szma
	or	a
	ret	nz			; visszatrs, ha hiba trtnt
LC9CD:	res	7,(ix+014h)		; FCB3-ban +14h bjt 7.bit-jnek trlse
	call	LC9E0			; fjl rsa a CLI pufferbl (FCB4-ben megnyitott fjlba)
	ret	nz			; visszatrs, ha hiba trtnt
LC9D5:	ld	de,0FFA0h		; DE= -60h
	add	ix,de			; IX FCB1-re mutat
	ex	af,af'			; elmentett hibakd visszalltsa (00h vagy .EOF vagy 0E4h)
	jp	z,LC8FD			; ismtls, amg nincs vge a fjlnak
	xor	a			; hibakd trlse
	ret
;
;
;	Fjl rsa a CLI pufferbl
;
LC9E0:	ld	a,010h			; A reg.= rs fjlba funkcikd
;
;
;	FISH adattvitel vgrehajtsa a CLI pufferen
;	/megj. fjl vge esetn a hibakdot A'-be rja, A-ban nullt ad vissza/
;	in:   A - FISH funkcikd (0Fh -olvass v. 10h - rs)
;	     BC - tviteli hossz
;	     BC'- CLI puffer kezdcme
;	     IX - FCB1-re (v. FCB3-ra) mutat
;	out:  A - hibakd
;	      A'- fjl vge esetn .EOF hibakdot tartalmazza (ilyenkor A= 00h, F' is belltva)
;	     BC - tvitt bjtok szma
;
LC9E2:	push	bc			; BC mentse
	call	LCBBE			; BC s DE belltsa az FCB adatterletekre
	ld	e,c			; DE= a megnyitott FCB2 (v. FCB4) cme
	ld	d,b
	pop	bc			; BC vissza
	exx
	push	bc
	exx
	ex	(sp),ix			; IX= CLI puffer kezdcme, rgi rtk a verembe
	call	LCB38			; FISH funkci vgrehajtsa IX mentsvel
	pop	ix			; IX helyrelltsa
	ret	z			; visszatrs, ha nem volt hiba
	cp	0ECh
	ret	nz			; visszatrs, ha nem .EOF hiba
	or	a
	ex	af,af'			; hibakd s flag-ek mentse AF'-be
	xor	a			; hibakd trlse
	ret
;
;
;	CLI karakteres output vlaszts megklnbztetse
;	in:  -
;	out: ZF - ZF=1 ha kperny v. nyomtat   ZF=0 ha CLI puffer
;
LC9FB:	push	hl			; HL mentse
	ld	hl,00D6Dh		; HL= CLI karakteres output vlaszts vltoz
	bit	0,(hl)			; 0. bit vizsglata
	pop	hl			; HL vissza
	ret
;
;
;	"TYPE" s "COPY" parancs vgrehajtsnak megklnbztetse
;	in:  -
;	out: ZF - ZF=1 ha "TYPE" v. "LTYPE"  ZF=0 ha "COPY"
;
LCA03:	push	hl			; HL mentse
	ld	hl,00D6Ch		; "TYPE" s "COPY" megklnbztet vltoz
	bit	5,(hl)			; bit vizsglata
	pop	hl			; HL vissza
	ret
;
;
;	"CLS" belpsi pontja
;
LCA0B:	and	(hl)
	ld	a,08Dh			; hibakd: .INP - rvnytelen szm paramter
	ret	nz			; visszatrs, ha mg van htra karakter
	ld	a,(00D6Dh)		; A reg.= CLI karakteres output vlaszts
	and	001h
	ld	a,000h
	ret	nz			; visszatrs, ha buffer a kimenet
	call	LDB2E			; 0.lapon lv rutin hvsa (cm: 0C767h)
;
	.dw	0C767h			; eredeti memrialapozs (P_SAVE) s INT vektor visszalltsa
;
	rst	30h			; MOPS funkcihvs
;
	.db	005h			; kpernytrls
;
	call	LDB2E			; 0.lapon lv rutin hvsa (cm: 0C741h)
;
	.dw	0C741h			; memrialapozs mentse, sajt megszaktsi rutin belltsa
;
	ret
;
;
;	"DOS" belpsi pontja
;
LCA24:	and	(hl)
	ld	a,08Dh			; hibakd: .INP - rvnytelen szm paramter
	ret	nz			; visszatrs, ha mg van htra karakter
	ld	hl,0DFF2h
	ld	a,(hl)			; A reg.= VT-DOS cartridge flagbjt
	or	a
	ld	a,08Bh			; hibakd: .NCART - nincs VT-DOS programmodul
	ret	nz			; visszatrs, ha flagbjt nem nulla
	ld	a,(00D6Dh)		; A reg.= CLI karakteres output vlaszts
	bit	0,a
	jr	nz,LCA41		; ugrs, ha buffer a kimenet
	push	hl
LCA38:	ld	a,020h			; A reg. a "Enter VT-DOS (Y/N)? " szveg-azonostt tartalmazza
	call	LC30C			; adott azonostj szveg kiratsa, vrakozs 'Y' vagy 'N'-re
	jr	nc,LCA38		; ismtls, ha nem 'Y'-t vagy 'N'-t nyomtak
	pop	hl
	ret	nz			; visszatrs, ha 'N'-t vlasztottak
LCA41:	dec	(hl)
	call	LDB2E			; 0.lapon lv rutin hvsa (cm: 0C353h)
;
	.dw	0C353h			; VT-DOS cartridge indtsa (mr nem tr vissza)

;
;
;	"HELP" belpsi pontja
;
LCA47:	and	(hl)
	ld	a,08Dh			; hibakd: .INP - rvnytelen szm paramter
	ret	nz			; visszatrs, ha mg van htra karakter
	ld	a,023h			; A reg.= szvegazonost: "Press ESC to exit CLI.\r\nCommands are:\r\n"
	call	LCD2A			; az 1.lapon trolt adott azonostj szveg kiratsa soremelssel
	ld	a,(00D6Dh)		; A reg.= CLI karakteres output vlaszts
	rrca				; A reg. 0.bit CY-be
	jr	c,LCA5B			; ugrs, ha a CLI puffer az output (64 karakter/sor lesz)
	ld	a,(00B73h)		; A reg.= vide zemmd
	sub	001h
LCA5B:	ld	a,040h			; A reg.= 64
	jr	c,LCA63			; ugrs, ha 2-szn md
	rrca				; A reg.= A reg. / 2 = 32
	jr	z,LCA63			; ugrs, ha 4-szn md
	rrca				; A reg.= A reg. / 2 = 16
LCA63:	ld	e,a			; E= soronknti karakterek szma
	ld	d,000h			; D= aktulis soron belli karakterpozci
	ld	hl,0C1DCh		; HL= CLI parancs-azonostk tblzata
LCA69:	ld	a,(hl)			; kvetkez azonost hosszbjtja A reg.-be
	or	a
	jp	z,LCD2D			; ha nulla (tblzat vge), ugrs a soremels kirsra, majd visszatrs a hvhoz
	inc	a
	add	a,d			; A reg.= kirand azonost utni karakterpozci
	cp	e			; sszehasonlts a sor hosszval
	ld	a,d			; kezd karakterpozci A reg.-be
	call	nc,LCD2D		; ha nem fr ki a teljes azonost, akkor soremels
	ld	d,a			; D=00h ha soremels volt, vagy az eredeti pozci, ha nem volt soremels
	ld	b,(hl)			; B= azonost hossza
	inc	hl			; HL az azonostra mutat
LCA78:	ld	a,(hl)			; aktulis karakter A reg.-be
	call	LCCD8			; karakter kirsa a vlasztott outputra
	inc	d			; karakter pozci nvelse
	inc	hl			; HL az azonost kvetkez karakterre mutat
	djnz	LCA78			; ismtls az sszes karakterre
	ld	a,020h			; A reg.= SPACE
	call	LCCD8			; karakter kirsa a vlasztott outputra
	inc	d			; karakter pozci nvelse
	inc	hl			; az azonost utni rutincmek tlpse
	inc	hl
	jr	LCA69			; ismtls a kvetkez azonost kirsval


;
;-----------------------------------------------------
;	CLI ltalnos parancs-vgrehajtsi segdrutinok
;-----------------------------------------------------
;

;
;
;	Hibakd belltsa A reg.-ben, ha nincs megfelel tvonalnv megadva
;	in:   B - tvonalnv-elemzs visszatrsi jelzbitjei
;	out:  A - hibakd
;
LCA8A:	ld	a,b			; tvonalnv-elemzs jelzbitjei A reg.-be
	and	005h			; van specifiklt meghajt nv (2.bit) s a meghajt nven kvl vannak ms elemek is(0.bit)
	sub	001h
	sbc	a,a			; A reg. = 0FFh ha a kt bit kzl egyik sem volt 1 (egybknt 000h)
	and	08Dh			; A reg. = hibakd (.INP - rvnytelen szm paramter), ha az elbb 0FFh volt
	ret
;
;	Htralv karakterlncban paramter keresse
;	ZF jelzi a regiszteek llapott:
;	  ZF=1 -> C reg.-ben van az els karakter
;	  ZF=0 -> az els karaktert DE mutatta cmrl be kell olvasni
;
LCA93:	jr	nz,LCAA0		; ugrs, ha DE cmrl kell olvasni az els karaktert
;
;
;	Htralv karakterlncban paramter keresse
;	in:   C - els ellenrzend karakter
;	     DE - a karakterlncra mutat
;	out:  A - hibakd (volt mg paramter)
;	      C - utoljra kiolvasott karakter
;	     DE - a kvetkez karakterre mutat a karakterlncban
;
LCA95:	ld	a,c
LCA96:	inc	de			; karaktermutat nvelse
	call	LCC5D			; A reg.-ben lv karakter kielemzse
	jr	c,LCAA0			; ugrs, ha SPACE vagy TAB karakter
	ret	z			; visszatrs, ha zr nulla karakter
	ld	a,08Dh			; hibakd: .INP - rvnytelen szm paramter
	ret
;
LCAA0:	ld	a,(de)			; kvetkez karakter A reg.-be
	ld	c,a			; karakter C-be is
	jr	LCA96			; ellenrzs ismtlse
;
;
;
;	Szveg tmsolsa SPACE karakterek kihagysval
;	in:   A - a bert els karakter, ha LCAAA cmen lp be
;	      B - tmsoland szveg hossza
;	     HL - forrs
;	     DE - cl
;	out:  A - utols tmsolt karakter
;	     DE,HL - a szvegek vgre mutatnak
;
LCAA4:	ld	a,(hl)			; kvetkez karakter beolvassa
	inc	hl
	cp	020h
	jr	z,LCAAC			; ugrs, ha HL mutatta cmen SPACE karakter tallhat
LCAAA:	ld	(de),a			; egybknt msols a cl terletre
	inc	de
LCAAC:	djnz	LCAA4			; ciklus ismtlse B reg.-ben adott szmszor
	ret
;
;	Ide ugrik pl. knyvtrtrls esetn
;
LCAAF:	ex	af,af'			; CY ismtelt mentse
	pop	hl			; verem kitakartsa
	ld	hl,00D6Fh		; HL a parancssorban megadott opcionlis paramterek flagbjtjra mutat
	set	4,(hl)			; 4. bit (?) belltsa
	ret				; visszatrs (avagy ugrs a veremben elhelyezett rutin cmre)
;
;
;	Parancssorban adott fjl kikeresse
;	in:  B - tvonalnvelemzs visszatrsi jelzbitjei
;	    HL - tvonalnv string
;	     F'- CY=1 ha knyvtrtrls
;	out:  A - hibakd
;	     BC - FCB2-re mutat
;	     DE - FCB1-re mutat
;	     CY - 1- hiba trtnt
;
LCAB7:	ld	de,LCB97		; DE= visszatrsi hibakezel rutin cme
	push	de			; cm elhelyezse a verembe (mindig ezen keresztl tr vissza)
	push	bc
	ld	bc,00000h
	ld	(00D69h),bc		; szmll (?) nullzsa
	call	LCBBE			; BC s DE belltsa az FCB adatterletekre
	call	LCB36			; els keresse FISH funkci meghvsa
	ex	af,af'			; korbban elmentett CY flag visszalltsa
	jr	c,LCAAF			; ugrs, ha knyvtrtrls van (RMDIR)
	ex	af,af'			; CY ismtelt mentse
	ex	de,hl			; HL-keressi FCB cme  DE-tvonalnv string
	pop	bc			; BC-be a belpskori rtke
	ld	c,000h
	jr	z,LCAD8			; ugrs, ha keresskor nem trtnt hiba
	cp	0A1h			; .NOFIL hiba ellenrzse
	scf
	jr	nz,LCB24		; ugrs, ha nem .NOFIL hiba
LCAD8:	ld	hl,00D71h		; HL= a sajt '>' karakter mtrixnak kezdcme
	ld	c,(hl)			; a karaktermtrix els sora C-be
	jr	c,LCB24			; ugrs, ha korbban .NOFIL hiba volt
	scf
	bit	5,b			; jelzbitek ellenrzse
	jr	nz,LCB24		; ugrs, ha az tvonalnv utols eleme tbbrtelm
	bit	4,(ix+043h)		; FCB2-ben az attribtum bjt (+13h) vizsglata
	jr	z,LCB24			; ugrs, ha nem alknyvtr
	ld	a,c
	or	a
	jr	z,LCB24			; ugrs, ha a karakter-mtrix els bjtja 0
	push	de			; regiszterek mentse
	push	bc
	ld	c,b			; jelzbitek C-be
	dec	de			; tvonalnv string-mutat cskkentse
LCAF1:	ld	a,(de)			; aktulis karakter beolvassa
	inc	de			; mutat nvelse
	or	a
	jr	nz,LCAF1		; ismtls, amg nem rte el a zr nulla bjtot
	dec	de			; DE az utols "hasznos" karakterre mutat
	bit	6,c			; az utols elem "." vagy ".." ?
	jr	z,LCB0A			; ugrs ha nem
	bit	7,c			; az utols elem ".." ?
	jr	z,LCB1D			; ugrs, ha nem
LCAFF:	dec	de			; tvonalnv mutat cskkentse
	ld	a,(de)
	cp	05Ch			; '\' ellenrzse
	jr	z,LCB1D			; ugrs, ha '\' jel
	or	a
	jr	z,LCB1D			; ugrs, ha zr nulla karakter
	jr	LCAFF			; ismtls a teljes utvonalnv tvizsglsig
;
LCB0A:	ld	hl,00CB1h		; HL az FCB2-n bell a fjlnvre mutat (forrs) (a keress ltal tallt fjl)
	ld	a,05Ch			; A reg.= '\' (kezd karakter)
	ld	b,009h			; max. 9 karaktert msol
	call	LCAAA			; szveg tmsolsa SPACE karakterek kihagysval DE cmre
	bit	4,c			; jelzbitek vizsglata
	ld	a,02Eh			; A reg.= '.' (kezd karakter)
	ld	b,004h			; max. 4 karaktert msol
	call	nz,LCAAA		; ha van fjlnv kiterjeszts, szveg tmsolsa SPACE karakterek kihagysval DE cmre
LCB1D:	xor	a
	ex	de,hl
	ld	(hl),a			; tvonalnv aktulis pozcijba zr nulla bjt elhelyezse
	inc	hl
	ld	(hl),a			; a kvetkez cmet is kinullzza
	pop	bc			; elmentett regiszterek visszalltsa
	pop	de
LCB24:	push	af			; flag-ek s keress hibakdjnak mentse
	inc	c
	dec	c			; sajt '>' karaktermtrix els bjtjnak vizsglata
	call	nz,LC2C7		; ha nem nulla, aktulis meghajt betjelnek s DE mutatta tvonalstringnek kirsa az output-ra
	call	LCBBE			; BC s DE belltsa az FCB adatterletekre
	pop	af			; keress hibakd s flag-ek vissza
	ret	c			; visszatrs, ha korbban hiba volt
	call	LCB75			; FCB1 s FCB2 tartalmnak felcserlse, FCB1 fjlnevnek kitltse krdjelekkel
	set	5,(ix+013h)		; az "utols elem tbbrtelm" jelzs FCB1-ben (?)
;
LCB36:	ld	a,004h			; A reg.= "els keresse" funkcikd
;
;	FISH funkci vgrehajtsa IX mentsvel
;
LCB38:	push	ix
	call	LDB2E			; 0.lapon lv rutin hvsa (cm: 0CD46h)
;
	.dw	0CD46h			; FISH funkci vgrehajtsa 
;
	pop	ix
	ret	z			; visszatrs, ha nem volt hiba
	scf				; egybknt CY=1
	ret
;
;
;	Knyvtr/fjlmd belltsa (?), tvonalnv elemzse, IX ltal mutatott FCB inicializlsa
;	in:   CY - 1: knyvtrtrls  0: fjltrls
;	out: AF' - CY a msodlagos flag-regiszterbe kerl
;
LCB44:	jr	nc,LCB4D		; ugrs, ha fjlmvelet (pl. DEL)
	push	hl
	ld	hl,00D6Bh
	set	4,(hl)			; jelzs (?)
	pop	hl
LCB4D:	ex	af,af'			; CY flag mentse (fjl/knyvtr jelzs)
;
;
;	tvonalnv elemzse, IX ltal mutatott FCB inicializlsa
;	(FCB-ben lv fjlnv kitltse joker karakterekkel, ha nem volt megadva)
;	in:   C - fjlnv flag (ld. FISH_01 funkci)
;	     DE - FCB1-re mutat
;	     HL - a parancssorban megadott tvonalnvre mutat
;	     IX - FCB-re mutat (FCB1 vagy FCB3)
;	out:  A - hibakd (0)
;	      B - tvonalnvelemzs visszatrsi jelzbitjei
;	      C - zr karakter
;	     DE - zr karakterre mutat
;	     HL - megrzdik
;	     IX - megrzdik
;
LCB4E:	ld	a,001h			; A reg.= 01h - tvonalnv-string elemzse
	call	LCB38			; FISH funkci vgrehajtsa IX mentsvel
	ld	a,b
	and	018h			; visszatrsi jelzbitek ellenrzse
	jr	nz,LCB70		; ugrs, ha az utols elem fjlnv vagy fjlnv kiterjeszts
;
;	FCB1 fjlnevnek kitltse krdjelekkel (joker karakterek)
;	in:   B - visszatrsi jelzbitek
;	out:  A - hibakd (0)
;	      B - visszatrsi jelzbitek
;	     DE,HL - megrzdik
;
LCB58:	push	bc
	push	de
	call	LCBBE			; BC s DE belltsa
	ld	a,008h
	add	a,e			; DE= DE+8 (fjlnv az FCB1-ben)
	ld	e,a
	jr	nc,LCB64		; ugrs, ha nincs tvitel az als 8 bitrl
	inc	d
LCB64:	ld	a,03Fh			; A reg.= '?'
	ld	b,00Bh			; 11 karakter lesz
LCB68:	ld	(de),a
	inc	de
	djnz	LCB68			; FCB1-beli fjlnv kitltse krdjelekkel
	pop	de
	pop	bc
	set	5,b			; az utols elem "tbbrtelm" jelzs
LCB70:	ld	(ix+013h),b		; jelzbitek mentse az FCB1 nem hasznlt bjtjra
	xor	a
	ret
;
;	FCB1 s FCB2 tartalmnak felcserlse, FCB1 fjlnevnek kitltse krdjelekkel
;	in:  IX - FCB1 (v. FCB3) cme
;	out:  A - hibakd (0)
;	     BC - FCB2-re mutat
;	     DE - FCB1-re mutat
;
LCB75:	call	LCBBE			; BC s DE belltsa az FCB adatterletekre
	push	de			; regiszterek mentse
	push	bc
	ld	l,c			; HL= FCB2 cme
	ld	h,b
	ld	b,030h			; B= egy FCB hossza
LCB7E:	ld	a,(de)			; FCB1 aktulis bjtja A reg.-be
	ld	c,(hl)			; FCB2 aktulis bjtja C reg.-be
	ld	(hl),a			; FCB1 bjtjnak msolsa FCB2-be
	ld	a,c
	ld	(de),a			; FCB2 bjtjnak msolsa FCB1-be
	inc	hl			; mutatk nvelse
	inc	de
	djnz	LCB7E			; ismtls a teljes FCB-kre
	pop	hl			; HL= FCB2 kezd cme
	pop	de			; DE= FCB1 kezd cme
	call	LCB58			; FCB1 fjlnevnek kitltse krdjelekkel (joker karakterek)
	ld	c,l			; BC= FCB2 kezd cme
	ld	b,h
	ret
;
;
;	Kvetkez knyvtrbejegyzs keresse FCB1 alapjn
;	in: -
;	out:  A - hibakd
;	     CY - 1: ha brmilyen hiba trtnt
;	     ZF - 1: mr volt tallt bejegyzs (ilyenkor A= 00h)
;
LCB8F:	call	LCBBE			; BC s DE belltsa az FCB adatterletekre
;
;
;	Hibakezels, keress ismtlse, ha a fjlt nem sikerlt megtallni
;	in: -
;	out:  A - hibakd
;	     CY - 1: ha brmilyen hiba trtnt
;	     ZF - 1: mr volt tallt bejegyzs (ilyenkor A= 00h)
;
LCB92:	ld	a,005h			; A reg.= "kvetkez keresse" funkcikd
	call	LCB38			; FISH funkci vgrehajtsa
LCB97:	or	a			; hibakd ellenrzse, CY=0
	call	z,LCC23			; ha nem volt hiba, bels flag-ek ellenrzse FCB2-n
	jr	c,LCB92			; ugrs, ha a flag-eknek nem felel meg
	ld	hl,(00D69h)
	jr	nz,LCBA7		; ugrs, ha mr a keress sorn volt hiba
	inc	hl			; szmll nvelse
	ld	(00D69h),hl		; frisstett rtk elmentse
	ret
;
LCBA7:	cp	0A1h
	scf				; CY=1
	ret	nz			; visszatrs, ha nem .NOFIL hiba volt
	ld	a,h			; szmll ellenrzse
	or	l
	sub	001h			; ha HL=0000h -> CY=1
	sbc	a,a			; ha CY=1  -> NZ, egybknt A= 00h
	scf
	ret	z			; visszatrs, ha HL nem 0000h
	ld	a,(00D6Bh)		; flag bjt A reg.-be
	bit	4,a
	ld	a,0A0h			; hibakd: .NODIR - a knyvtr nem tallhat
	ret	nz			; visszatrs, ha knyvtrmvelet volt
	sbc	a,a			; CY=1  ZF= 0
	ld	a,0A1h			; hibakd: .NOFIL - a fjl nem tallhat
	ret
;
;
;	BC s DE belltsa az FCB adatterletekre
;	in:  IX - FCB1 cme
;	out: BC - FCB2 cme (IX+30h)
;	     DE - FCB1 cme (IX)
;	     HL - megrzdik
;
LCBBE:	push	hl
	push	ix
	pop	de			; DE= IX
	ld	hl,00030h
	add	hl,de
	ld	c,l
	ld	b,h
	pop	hl
	ret
;
;
;	IX belltsa FCB3-ra, FCB3 inicializlsa hasznlatlan FCB-nek
;
LCBCA:	ld	ix,00CD9h		; IX= FCB3 cme
	xor	a
	push	ix
	pop	de			; DE= FCB3 cme
	ld	(ix+006h),a		; keressi attribtum nullzsa
	ld	(ix+007h),a		; meghajt sorszm nullzsa (default meghajt)
	ld	c,a			; C= 0
	dec	a
	ld	(de),a			; hasznlatlan FCB jelzse
	ret
;
;
;	Parancssorban megadott tvonalnv s az azt kvet opcis paramterek feldolgozsa
;	in:   C - fjlnv flag (ld. FISH_01 funkci)
;	     DE - bels FCB-re mutat
;	     HL - a parancssorban megadott tvonalnvre mutat
;	     IX - bels FCB-re mutat
;	out:  A - hibakd
;	      B - tvonalnvelemzs visszatrsi jelzbitjei
;	      C - zr karakter
;	     DE - zr karakterre mutat
;	     HL - megrzdik
;	     IX - megrzdik
;
LCBDC:	call	LCB44			; megadott tvonalnv elemzse, s CY-ben adott jelzs rtelmezse
	call	LCA8A			; hibakd belltsa A reg.-ben, ha nincs megfelel tvonalnv megadva
	push	hl
	ld	hl,LC554		; HL a lehetsges paramterek tblzatra mutat
	call	z,LCBFD			; ha eddig nem volt hiba, zr karakter utni karakterlncban opcionlis paramterek keresse
	pop	hl
	ret
;
;
;	Opcionlis paramterek feldolgozsa CY-tl fggen
;	in:   C - aktulis karakter (DE cmrl)
;	     DE - parancssori string aktulis pozcija
;	     HL - a keresend opcionlis paramterek tblzatcme
;	     CY - CY=0 HL mutatta tblzatcm nvelse 4-el
;
LCBEB:	jr	c,LCBFD			; ugrs, ha CY=1
	inc	hl			; egybknt a tblzatcm nvelse 4-el
	inc	hl
	inc	hl
	inc	hl
	jr	LCBFD			; ugrs az opcionlis paramterek feldolgozsra
;
;
;	Tallt opcis paramternek megfelel bit belltsa a flag bjtban
;
LCBF3:	ld	a,(00D6Fh)		; eddigi opcis bitek A reg.-be
	or	(hl)			; tallt opci bitjeinek belltsa
	ld	(00D6Fh),a		; frisstett opcis flagbjt mentse
	inc	de			; feldolgozott parancssori karakter mutatjnak nvelse
	pop	hl
	.db	00Eh			; a kvetkez bjttal: ld c,0AFh -> elfedi XOR A-t
;
;
;	Opcionlis paramterek feldolgozsa
;	in:   C - aktulis karakter (DE cmrl)
;	     DE - parancssori string aktulis pozcija
;	     HL - a keresend opcionlis paramterek tblzatcme
;	out:  A - hibakd
;	     DE - az utols feldolgozott karakterre mutat
;	     HL - megrzdik
;	      C'- opcis flag bjt msolata
;
LCBFD:	xor	a			; A reg.= 0  ZF= 1
	set	0,a			; opcis flagbjt rvnyes jelzs (?)
	ld	(00D6Fh),a		; flagbjt mentse
	exx
	ld	c,a			; flagbjt C'-be is
	exx
	push	hl
	call	LCA93			; htralv karakterlncban paramter keresse
	ld	a,c			; utoljra kiolvasott karakter ellenrzse
	cp	02Fh			; '/'
	jr	nz,LCC1F		; ugrs, ha nem '/' az utols karakter
LCC0F:	ld	a,(de)			; kvetkez karakter A reg.-be
	call	LC1D3			; angol kisbet nagybetv alaktsa
	cp	(hl)			; sszehasonlts a HL ltal mutatott karakterrel
	inc	hl			; HL az opcis paramter utni bjtkdra mutat
	jr	z,LCBF3			; ugrs, ha megegyeznek a paramter karakterek
	inc	hl
	ld	a,(hl)			; kvetkez sszehasonltand karakter A reg.-be
	or	a
	jr	nz,LCC0F		; ugrs, ha mg nem rt a tblzat vgre
	or	08Eh			; hibakd: .IPARAM - rvnytelen paramter
	.db	0CAh			; a kvetkez kt bjttal: jp z,LAF1B -> elfedi DEC DE-t s XOR A-t
LCC1F:	dec	de			; DE visszalptetse az utols feldolgozott karakterre
	xor	a			; hibakd trlse
	pop	hl
	ret
;
;
;	Bvszkeds FCB2 attribtum bitjeivel s az opcionlis paramterek flag-bjtjval
;	.NOFIL hiba generlsa, ha a bitek ezt mutatjk
;	in:  IX - FCB1-re mutat
;	out:  A - hibakd
;	     CY - CY=1 ha hiba van
;
LCC23:	ld	a,(ix+043h)		; A reg.= FCB2 attribtum bitjei
	cpl				; bitek neglsa
	ld	l,a			; neglt bitek L-be
	ld	a,(00D6Fh)		; A reg.= parancssorban megadott opcionlis paramterek flagbjtja
	or	l			; paramter flagbjt VAGY-olsa az attribtum bitekkel
	cpl				; az eredmny visszaneglsa
	and	017h
LCC2F:	ld	a,0A1h			; hibakd: .NOFIL - a fjl nem tallhat
	scf
	ret	nz			; visszatrs, ha nem egyezik az eredmny
	ld	a,(00D6Bh)		; msik flagbjt A reg.-be
	and	l			; S kapcsolat a neglt attribtum bitekkel
	and	010h
	jr	nz,LCC2F		; ugrs, ha a 4. bit (alknyvtr) nem lett 0 (hiba)
	ret


;
;-----------------------------------------------------
;	CLI karakteres megjelents I/O segdrutinjai
;-----------------------------------------------------
;

;
;	Az els specilis karakter utni hasznos (nem SPACE vagy TAB) karakter beolvassa
;	A specilis karakterek halmaza korltozott (':'  '-'  '.' kihagyva)
;

LCC3C:	.db	006h			; kvetkez bjtokkal: ld b,006h s nop

;
;
;	Az els specilis karakter utni hasznos (nem SPACE vagy TAB) karakter beolvassa
;	megj.: viszont a SPACE vagy TAB is specilis karakter !!!
;	in:  HL - a karakterlncra mutat
;	out:  A - karakter
;	     HL - aktulis karakterre mutat
;	     CY - nem specilis karakter (specilis a nulla is) volt az els karakter vagy 256 karaktert dolgozott fel eddig
;
LCC3D:	ld	b,000h			; B= sszes specilis karakter ellenrzse lesz
	call	LCC50			; kvetkez karakter olvassa a stringbl SPACE s TAB karakterek kiszrsvel
	inc	c
	jr	z,LCC4A			; ugrs, ha mr az els karakter nem SPACE vagy TAB volt
	call	LCC4A
	or	a			; CY=0
	ret
;
LCC4A:	call	LCC67			; A reg.-ben lv karakter specilis karakter-e ?
	ret	c			; visszatrs, ha nem
	ret	z			; visszatrs, ha nulla karakter volt
	inc	hl			; HL a kvetkez karakterre mutat
;
;
;	Kvetkez karakter olvassa a stringbl SPACE s TAB karakterek kiszrsvel
;	in:  HL - a karakterlncra mutat
;	out:  A - aktulis karakter
;	     HL - aktulis karakterre mutat
;	     CY - CY=1 256 karaktert dolgozott fel s nem rte el a szveg vgt
;	     ZF - ZF=1 ha A reg.-ben zr nulla karakter van
;
LCC50:	ld	c,000h
LCC52:	dec	c			; karakterszmll cskkentse
	scf
	ret	z			; visszatrs, ha mr 256 karaktert dolgozott fel
	call	LCC5C			; HL mutatta szveg kvetkez karakternek beolvassa
	ret	nc			; visszatrs, ha nem SPACE vagy TAB karakter
	inc	hl			; HL a kvetkez karakterre mutat
	jr	LCC52			; ismtls
;
;
;	HL mutatta szveg kvetkez karakternek beolvassa
;	in:  HL - a string aktulis karakterre mutat
;	out:  A - aktulis karakter
;	     CY - CY=1 -> SPACE vagy TAB karakter
;	     ZF - ZF=1 -> 00h vagy SPACE vagy TAB karakter
;
LCC5C:	ld	a,(hl)			; aktulis karakter A reg.-be
;
;	A reg.-ben lv karakter kielemzse
;
LCC5D:	cp	020h
	scf
	ret	z			; visszatrs, ha SPACE, CY=1
	cp	009h
	scf
	ret	z			; visszatrs, ha TAB, CY=1
	or	a			; egybknt CY=0
	ret
;
;
;	A reg.-ben lv karakter specilis karakter-e
;	in:   A - ellenrzend karakter
;	      B - ha B=0 akkor a teljes specilis karakter listra ellenriz, egybknt ':'  '-'  '.' kihagyja
;	out:  A - megrzdik
;	     BC,HL - megrzdik
;	     CY - CY=0-> A reg.-ben specilis karakter van
;
LCC67:	push	hl			; regiszterek mentse
	push	bc
	ld	hl,LCC80		; HL a teljes specilis karakter tblzat elejre mutat
	ld	c,00Ch			; 12 karakter lesz
	inc	b			; B ellenrzse
	dec	b
	jr	z,LCC78			; ugrs, ha B=0
	ld	hl,LCC83		; HL csak a rsz tblzatra mutat
	ld	bc,00009h		; csak 9 karakter lesz
LCC78:	cpir				; A reg. tartalmnak keresse a tblzatban
	pop	bc			; regiszterek helyrelltsa
	pop	hl
	scf				; CY=1
	ret	nz			; visszatrs, ha A reg. tartalma nem tallhat a tblzatban
	or	a			; CY=0
	ret
;
;	Specilis karakterek tblzata
;
LCC80:	.db	03Ah,02Dh,02Eh		; ':'  '-'  '.'
LCC83:	.db	020h,009h,03Bh		; SPACE, TAB, ';'
	.db	02Ch,03Dh,02Fh		; ','  '='  '/'
	.db	05Bh,05Dh,000h		; '['  ']'  NULL

;
;
;	Kvetkez kirtkelhet karakter olvassa a stringbl
;	in:  HL - a karakterlncra mutat
;	out:  A - kiolvasott karakter
;	     HL - kiolvasott karakterre mutat
;	     BC,DE - megrzdik
;	     CY - CY=1 -> elrte az szveg vgt
;	     ZF - ZF=1 -> A reg.=0 vagy elrte az szveg vgt
;
LCC8C:	push	bc
	call	LCC50			; kvetkez karakter olvassa a stringbl SPACE s TAB karakterek kiszrsvel
	pop	bc
	ret
;
;
;	Ktjegy (8 bites) szm beolvassa HL mutatta stringbl
;	in:  HL - karakterlncra mutat
;	out:  A - hibakd  
;	      C - binrisra konvertlt ktjegy szm
;	     HL - az utoljra feldolgozott karakterre mutat
;
LCC92:	call	LCCB5			; HL mutatta karakter decimlis szmjeggy konvertlsa
	jr	c,LCCAD			; ugrs, ha nem szmjegy volt
	xor	a			; A reg.= 0
LCC98:	ld	c,a			; eddigi konverzik eredmnye C-be
	call	LCCB5			; HL mutatta karakter decimlis szmjeggy konvertlsa
	ld	b,a			; konvertlt szmjegy B-be
	ccf
	sbc	a,a
	ret	z			; visszatrs, ha a legutols konvertls sikertelen volt (A reg.= 0)
	inc	hl			; HL a kvetkez karakterre mutat
	ld	a,c
	call	LCCB1			; A reg.= C * 4
	call	nc,LCCB1		; A reg.= C * 10
	jr	c,LCCAD			; ugrs, ha tlcsorduls volt
	add	a,b			; egyesek hozzadsa A reg.-hez
	jr	nc,LCC98		; ugrs, ha a szm mg brzolhat egy bjton
LCCAD:	ld	a,08Fh			; hibakd: .BADNO - rvnytelen szm
	or	a
	ret
;
;	Segdrutin 10-zel val szorzshoz
;	/ A reg.= (A reg. + C) * 2 /
;
LCCB1:	add	a,c
	ret	c			; visszatrs, ha tlcsorduls volt
	add	a,a
	ret
;
;
;	HL mutatta karakter decimlis szmjeggy konvertlsa
;	in:  HL - konvertland karakterre mutat
;	out:  A - szmrtk 0..9 (ha CY=0)
;	     HL - megrzdik
;	     CY - CY=1 -> sikertelen konvertls
;
LCCB5:	ld	a,(hl)			; HL mutatta karakter A reg.-be
	sub	030h
	ret	c			; visszatrs, ha A reg. < '0'
	cp	00Ah
	ccf				; CY=1 ha A reg. > 9
	ret
;
;
;	Az els specilis karaktert kvet karakter keresse
;	in:  HL - a stringre mutat
;	out:  A - hibakd
;	     BC - megrzdik
;	     HL - az aktulis karakterre mutat
;
LCCBD:	push	bc			; BC mentse
	call	LCC3C			; az els specilis karakter utni hasznos (nem SPACE vagy TAB) karakter beolvassa
	pop	bc			; BC vissza
	sbc	a,a
	and	08Eh			; hibakd: .IPARAM - rvnytelen paramter
	ret	nz			; visszatrs, ha nem specilis karakter volt a legels karakter
	call	LCC8C			; jra beolvassa a karaktert (bug ?)
	xor	a			; hibakd trlse (s a beolvasott karaktert is, bug ?)
	ret
;
;
;	Az aktulis kimenet belltsa a nyomtatra
;	in:  -
;	out: -
;
LCCCB:	push	af
	ld	a,(00D6Dh)		; A reg.= CLI karakteres output vlaszts
	or	002h			; nyomtat bit belltsa
	ld	(00D6Dh),a		; output vezrl bjt visszarsa
	pop	af
	ret
;
;
;	'K' karakter kirsa az outputra
;
LCCD6:	ld	a,04Bh			; A reg.= 'K'
;
;
;	Karakter kirsa a vlasztott outputra
;
;	/ a 0D6Dh cmre mentett bjt vlaszt:
;	  00h - kperny a kimenet
;	  01h - a definilt CLI pufferbe kerlnek a kirand karakterek
;	  02h - a nyomtatra kerl a kimenet /
;
;	in:   A - karakterkd
;	out:  A - hibakd (0)
;	     BC,DE,HL - megrzdik
;
LCCD8:	push	hl			; megrzend regiszterek mentse
	push	de
	push	af			; karakterkd mentse
	ld	a,(00D6Dh)		; I/O vlaszts ellenrzse
	bit	0,a
	jr	z,LCD0A			; ugrs, ha a kpernyre vagy a nyomtatra kell rni
	ld	hl,(00D80h)		; HL= CLI pufferben eddig letrolt karakterek szma
	push	hl
	ex	de,hl
	ld	hl,(00BF2h)		; HL= CLI puffer mrete
	xor	a
	sbc	hl,de
	jr	z,LCD03			; ugrs, ha betelt a puffer
	ld	hl,(00BF0h)		; HL= CLI puffer kezdcm
	pop	de
	xor	a
	adc	hl,de			; HL a CLI pufferben a kvetkez res karakterhelyre mutat
	pop	af
	ld	(hl),a			; karakter trolsa
	pop	de
	ld	hl,(00D80h)		; letrolt karakterek szmnak nvelse
	inc	hl
	ld	(00D80h),hl
	pop	hl
	xor	a			; hibakd trlse
	ret
;
LCD03:	ld	sp,(00D7Eh)		; veremmutat helyrelltsa
	jp	LC0C4			; ugrs, a puffer betelt hibakd belltsra
;
LCD0A:	bit	1,a
	jr	z,LCD16			; ugrs, ha a kperny a kimenet
	pop	af			; A reg.= kirand karakter
	call	LDB2E			; 1.lapon lv rutin hvsa (cm: 0DBE0h)
;
	.dw	0DBE0h			; egy karakter kirsa a nyomtatra
;
	jr	LCD27
;
LCD16:	pop	af			; A reg.= kirand karakter
	push	af
	cp	00Dh
	jr	nz,LCD21		; ugrs, ha nem "RETURN" karakter
	ld	a,00Bh			; helyettests "sormaradk-trls" karakterrel (a kurzortl jobbra lv karaktereket letrli)
	call	LCCD8			; a helyettest karakter kirsa
LCD21:	pop	af			; A reg.= eredeti kirand karakter
	call	LDB2E			; 1.lapon lv rutin hvsa (cm: 0DBCDh)
;
	.dw	0DBCDh			; egy karakter kirsa a kpernyre
;
LCD27:	pop	de			; megrzend regiszterek visszalltsa
	pop	hl
	ret
;
;
;	Az 1.lapon trolt adott azonostj szveg kiratsa soremelssel
;	in:   A - azonostszm
;	out:  -
;
LCD2A:	call	LCD42			; az 1.lapon trolt adott azonostj szveg kiratsa
;
;
;	Soremels a vlasztott output eszkzn
;	in:   -
;	out:  A - hibakd (0)
;	     BC,DE,HL - megrzdik
;
LCD2D:	ld	a,00Dh			; A reg.= "RETURN" karakter
	call	LCCD8			; karakter kirsa a vlasztott outputra
	ld	a,00Ah			; A reg.= soremels karakter
	jr	LCCD8			; karakter kirsa a vlasztott outputra, majd vissza a hv rutinra
;
;
;	Aktulis meghajt betjelnek kirsa az output-ra
;	in:  IX - FCB-re mutat
;	out:  A - hibakd (0)
;	     BC,DE,HL - megrzdik
;
LCD36:	ld	a,(ix+007h)		; meghajt szm az FCB-bl (?)
	add	a,040h			; meghajt betjelnek kirsa
	call	LCCD8			; karakter kirsa a vlasztott outputra
	ld	a,03Ah			; ':'
	jr	LCCD8			; ugrs a befejezshez: karakter kirsa a vlasztott outputra
;
;
;
;	Az 1.lapon trolt adott azonostj szveg kiratsa
;	in:   A - azonostszm
;	out:  -
;
LCD42:	call	LDB2E			; 1.lapon lv rutin hvsa (cm: 0DBFBh)
;
	.dw	0DBFBh			; az 1.lapon trolt szveg karaktereinek tadsa egyesvel a CLI feldolgozjnak
;
	ret
;
;
;	Nullval lezrt karakterlnc kirsa a vlasztott outputra
;	in:  DE - a nullval lezrt karaktelncra mutat
;	out:  A - 0
;	     DE - a zrkarakter utnra mutat
;
LCD48:	ld	a,(de)			; string kvetkez karakternek vizsglata
	inc	de			; mutat nvelse
	or	a
	ret	z			; visszatrs, ha zr nulla karakter
	call	LCCD8			; karakter kirsa a vlasztott outputra
	jr	LCD48			; ismtls a string vgig
;
;
;	Adatok beolvassa a parancssorbl, a sor elejn ':' jellel
;	(beolvasott karakterek a parancssor pufferben)
;
LCD51:	ld	hl,LCDAF		; ':' karaktermtrix utols bjtjnak cme
	ld	de,00D7Bh		; cl: a sajt '>' karakter mtrix utols utni bjtcme
	ld	bc,0000Ah		; 10 bjtot msol
	lddr				; adatok msolsa
	inc	de			; DE az tmsolt terleten a mtrix els bjtjra mutat (0D72h)
	ld	c,0DFh			; tdefiniland karakter kdja: 223
	call	LDB2E			; 0.lapon lv rutin hvsa (cm: 0C767h)
;
	.dw	0C767h			; eredeti memrialapozs (P_SAVE) s INT vektor visszalltsa
;
	rst	30h
;
	.db	00Bh			; DEFC - karakterdefinils
;
	call	LDB2E			; 0.lapon lv rutin hvsa (cm: 0C741h)
;
	.dw	0C741h			; memrialapozs mentse, sajt megszaktsi rutin belltsa
;
	ld	a,0DFh			; A reg.= a most definlt karakter kdja
	call	LCCD8			; karakter kirsa a vlasztott outputra
	ld	a,020h			; A reg.= SPACE
	call	LCCD8			; karakter kirsa a vlasztott outputra
;
;
;	Parancssor beolvassa a billentyzetrl (a parancssor pufferbe)
;	in: -
;	out:  A - hibakd, ha ZF=0
;	     ZF - ZF=0 -> MOPS hiba trtnt
;	     CY - CY=1 -> ESC-et nyomtak (ha ZF=1)
;
LCD75:	call	LDB2E			; 0.lapon lv rutin hvsa (cm: 0C767h)
;
	.dw	0C767h			; eredeti memrialapozs (P_SAVE) s INT vektor visszalltsa
;
LCD7A:	ld	hl,00BF6h		; HL= parancssor puffer
	xor	a			; A reg.= 0
LCD7E:	ld	(00BF5h),a		; parancssor pufferben trolt karakterek szmnak belltsa
LCD81:	rst	30h			; funkcihvs
;
	.db	0A1h			; ED_CHIN: karakterbeolvass
;
	jr	nz,LCDA0		; ugrs, ha hiba trtnt
	ld	a,c			; beolvasott karakterkd A reg.-be
	cp	0DFh
	jr	z,LCD7A			; ugrs, ha ez megegyezik a prompt utols karaktervel (sajt '>' vagy ':')
	sub	00Dh
	jr	z,LCDA0			; ugrs, ha RETURN karakter, CY=0 (visszatrs)
	ld	a,c
	sub	01Bh			; ESC kdjnak kivonsa
	scf
	jr	z,LCDA0			; ugrs, ha ESC karakter, CY=1 (visszatrs)
	ld	a,(00BF5h)		; karakterszmll A reg.-be
	inc	a			; szmll nvelse
	jp	m,LCD81			; ugrs, ha a karakterek szma elrte a 128-at (7.bit 1 lett)
	ld	(hl),c			; egybknt a beolvasott karakter trolsa
	inc	hl			; karakter-mutat nvelse
	jp	LCD7E			; folytats a szmll mentsvel s a kvetkez karakter beolvassval
;
LCDA0:	call	LDB2E			; 0.lapon lv rutin hvsa (cm: 0C741h)
;
	.dw	0C741h			; memrialapozs mentse, sajt megszaktsi rutin belltsa
;
	ret
;
;
;	Sajt ':' karakter mtrixa
;
	.db	000h,000h,000h,018h,018h,000h,018h,018h,000h
LCDAF:	.db	000h
;
;
;	Fjlnv kirsa az outputra
;	in:  BC - FCB-re mutat (pl. FCB2)
;	     CY - 0: SPACE-eket is   1: SPACE nlkl
;	out: -
;
LCDB0:	sbc	a,a
	ld	hl,00008h
	add	hl,bc			; HL FCB2-ben a fjlnvre mutat
	ld	b,008h			; elszr a 8 karakteres fjlnv lesz
	jr	nz,LCDC9		; ugrs, ha CY belpskor 1 volt
	call	LCDC1			; B-ben adott szm karakter kirsa az outputra
	call	LCDE3			; SPACE kirsa az outputra
LCDBF:	ld	b,003h			; 3 karakteres fjlnv kiterjeszts kirsa
;
;	B-ben adott szm karakter kirsa az outputra
;
LCDC1:	ld	a,(hl)			; aktulis karakter A reg.-be
	inc	hl			; mutat nvelse
	call	LCCD8			; karakter kirsa a vlasztott outputra
	djnz	LCDC1			; ismtls az sszes karakterre
	ret
;
LCDC9:	ld	b,008h			; elszr a 8 karakteres fjlnv lesz
LCDCB:	ld	a,(hl)			; aktulis karakter A reg.-be
	inc	hl			; mutat nvelse
	cp	020h			; SPACE karakter ellenrzse
	call	nz,LCCD8		; ha nem SPACE, karakter kirsa a vlasztott outputra
	djnz	LCDCB			; ismtls az sszes karakterre
	ld	a,(hl)			; aktulis karakter A reg.-be
	cp	020h			; SPACE karakter ellenrzse
	jr	z,LCDDB			; ugrs, ha SPACE
	ld	a,02Eh			; A reg.= '.'
LCDDB:	call	LCCD8			; karakter kirsa a vlasztott outputra
	call	LCDBF			; 3 karakteres fjlnv kiterjeszts kirsa (utna ZF=1)
;
;	A reg.-ben lv karakter (ZF=0) vagy SPACE (ZF=1) kirsa
;
LCDE1:	jr	nz,LCE22		; ha ZF= 0, befejezs kzvetett ugrssal a karakter kirsa funkcin keresztl
;
;	SPACE kirsa az outputra
;
LCDE3:	ld	a,020h			; A reg.= SPACE kdja
	jr	LCE22			; befejezs kzvetett ugrssal a karakter kirsa funkcin keresztl
;
;
;	Elfoglalt lemezterlet kirsa az outputra
;	in:  HL - a kirand 4 bjtos binris szm
;	out:    -
;
LCDE7:	push	hl			; kirand szm cmnek mentse
	ld	e,(hl)			; als sz betltse DE-be
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	a,(hl)			; fels sz als bjtja A reg.-be
	inc	hl
	or	(hl)			; fels sz fels bjtjnak ellenrzse
	jr	nz,LCE0C		; ugrs, ha a fels sz nem 0000h
	ld	a,d
	and	0FCh			; als sz fels bjt ellenrzse
	jr	nz,LCE0C		; ugrs, ha a fels 6 bitje nem nulla (az als sz nagyobb 1024-nl)
	ex	de,hl			; HL= az als sz (< 1 kbjt)
	pop	de			; DE= kirand szm cme
	ld	a,01Ah			; A reg.-ben az azonost: " byte"
;
;
;	HL-ben adott szm kirsa a megadott szveg kisretben
;	in:   A - az 1.lapon lv szveg azonostja
;	     HL - 16 bites szm
;	out:    -
;
LCDFA:	push	hl
	push	af
	call	LCEE8			; HL-ben adott 16 bites binris szm kirsa decimlis ASCII formtumban a vlasztott outputra
	pop	af
	call	LCD42			; az 1.lapon trolt adott azonostj szveg kiratsa
	pop	hl			; HL= kirt 16 bites szm
	dec	hl			; szm cskkentse
	ld	a,h
	or	l
	ret	z			; visszatrs ha HL= 0001h volt
	ld	a,073h			; A reg.= 's'  (-> "bytes" vagy "files")
	jr	LCE22			; befejezs kzvetett ugrssal a karakter kirsa funkcin keresztl
;
LCE0C:	ld	c,00Ah			; C= 10 bittel kell a szmot jobbra lptetni (oszts 1024-el)
LCE0E:	push	hl			; szm kezdcme a verembe
	ld	b,004h			; 4 bjtot fog elforgatni
	or	a			; CY= 0
LCE12:	rr	(hl)			; aktulis bjt jobbra lptets eggyel
	dec	hl
	djnz	LCE12			; ismtls mind a 4 bjtra
	pop	hl
	dec	c			; lptets szmnak cskkentse
	jr	nz,LCE0E		; ismtls, amg kell
	pop	de			; DE= kirand szm cme
	xor	a			; A= 00h (bevezet nullk elhagysa)
	call	LCEF5			; DE mutatta 4-bjtos szm kirsa decimlis ASCII formtumban a vlasztott outputra
	ld	a,04Bh			; A reg.= 'K'
LCE22:	jp	LCCD8			; befejezs a karakter kirsa funkcin keresztl
;
;
;	Id kirsa az outputra (ra:perc)
;	in:  HL - a 2 bjton kdolt id cme fels bjt (ld. pdf 62. oldal)
;	out:    -
;
LCE25:	ld	a,020h			; A reg.= SPACE
	call	LCCD8			; karakter kirsa a vlasztott outputra
	ld	b,a			; B= 00h  (CY=0)
	ld	a,(hl)			; id fels bjt A reg.-be
	rra
	rra
	rra
	and	01Fh			; A reg. jobbra lptetve 3-al, majd az als 5 bit megtartva
	ld	c,a			; C= ra
	ld	a,(iy-061h)		; A reg.= DTFORM (0D01Fh cmrl)
	or	a			; SF belltsa
	ld	a,c			; A reg.= ra
	jp	m,LCE49			; ugrs, ha a 7.bit=1 -> 24 rs formtum (ld. pdf 118. oldal)
	ld	b,061h			; B= 'a' (dleltt)
	cp	00Ch
	jr	c,LCE44			; ugrs, ha az ra < 12
	sub	00Ch			; cskkents 12-vel
	ld	b,070h			; B= 'p' (dlutn)
LCE44:	or	a
	jr	nz,LCE49		; ugrs, ha az ra nem 00
	ld	a,00Ch			; egybknt 12-re lltja
LCE49:	call	LCEAC			; A reg.-ben lv binris szm kirsa ktjegy decimlisknt
	ld	a,03Ah			; A reg.= ':'
	call	LCCD8			; karakter kirsa a vlasztott outputra
	ld	a,(hl)			; id fels bjt A reg.-be
	dec	hl
	rl	(hl)			; als bjt forgatsa balra CY-n keresztl
	rla				; kilp bitek beforgatsa A reg.-be
	rl	(hl)
	rla
	rl	(hl)
	rla
	and	03Fh			; 3 bit tlptetse utn A reg. als 6 bitjnek megtartsa (percek)
	call	LCEAC			; A reg.-ben lv binris szm kirsa ktjegy decimlisknt
	xor	a
	or	b			; A reg.=B s flag-ek lltsa
	ret	z			; visszatrs, ha B=0 volt (24 rs md)
LCE64:	jr	LCE22			; befejezs kzvetett ugrssal a karakter kirsa funkcin keresztl
;
;
;	Dtum kirsa az outputra
;	in:  HL - a 2 bjton kdolt dtum cme (ld. pdf 62. oldal)
;	out:  A - a dtum megjelentsi formtum kd
;
LCE66:	ld	a,(hl)			; als bjt A reg.-be
	and	01Fh
	ld	c,a			; C= napok
	ld	a,(hl)			; als bjt A reg.-be
	inc	hl
	ld	h,(hl)			; fels bjt H-ba
	srl	h			; als bit CY-be, H= relatv v
	rla
	rla
	rla
	rla				; A reg.= hnap
	and	00Fh			; csak az als 4 bit meghagysa
	ld	l,a			; L= hnap
	ld	a,(iy-061h)		; A reg.= DTFORM (0D01Fh cmrl)
	add	a,a
	add	a,a			; A reg. balralptetve 2 bittel
	jr	nz,LCE7F		; ugrs, ha nem 0 (nem a default angol dtum sorrend kell)
	ld	a,06Ch			; angol dtumformtum (ld. pdf 118. oldal)
LCE7F:	ld	b,003h			; B= ciklus szmll -> 3 ktjegy szmot r ki (00-00-00)
	ld	e,020h			; E= a szm eltt kirand karakter (az elsnl SPACE)
LCE83:	rlca
	rlca				; A reg. balra forgatva 2 bittel
	push	af			; A reg. mentse
	and	003h			; baloldali mez kdjnak maszkolsa
	ld	d,a			; kd D-be
	jr	z,LCE96			; ugrs, ha nulla
	ld	a,c			; A reg.= napok
	dec	d
	jr	z,LCE96			; ugrs, ha D=1 volt
	ld	a,l			; A reg.= hnap
	dec	d
	jr	z,LCE96			; ugrs, ha D=2 volt
	ld	a,h			; A= relatv v
	add	a,050h			; nvels 80-al (csak 2 szmjegy az v megjelentse is)
LCE96:	ld	d,a			; D= a kirand rtk
	ld	a,e			; A reg.= szmot megelz karakter (SPACE vagy '-')
	call	LCCD8			; karakter kirsa a vlasztott outputra
	ld	a,d			; A reg.= a kirand rtk
	cp	064h
	jr	c,LCEA2			; ugrs, ha kisebb 100-nl
	sub	064h			; cskkents 100-al
LCEA2:	call	LCEAC			; A reg.-ben lv binris szm kirsa ktjegy decimlisknt
	pop	af			; elmentett dtum formtum bjt visszalltsa
	ld	e,02Dh			; E= '-'
	djnz	LCE83			; ismtls a teljes dtum kirsig
	or	a			; A reg.-ben a dtum megjelentsi formtum kd
	ret
;
;
;	A reg.-ben lv binris szm kirsa ktjegy decimlisknt
;
LCEAC:	ld	e,02Fh			; E= a '0' karaktert megelz szmrtk
LCEAE:	sub	00Ah			; A reg.= A reg. - 10
	inc	e			; E nvelse a tzes helyirtknek megfelelen
	jr	nc,LCEAE		; ugrs, ha A reg. >= 10 volt
	ld	d,a			; D= "maradk" (0 - az egyesek szma)
	ld	a,e			; A reg.= tzes helyirtk karaktere
	call	LCCD8			; karakter kirsa a vlasztott outputra
	ld	a,d			; maradk vissza A reg.-be
	add	a,03Ah			; korrigls a '9' karaktert kvet szmrtkkel
	jr	LCE64			; kzvetett ugrs a karakter kirsra, majd visszatrs
;
;
;	Hibazenet kirsa a vlasztott karakteres outputra
;	megj.: nem azonostott hibakdokat kzvetlenl numerikus fomban rja ki (*** Error xxx)
;	in:   A - hibakd
;	out:  -
;
LCEBD:	push	af			; hibakd mentse
	call	LCD2D			; soremels a vlasztott output eszkzn
	ld	a,00Eh			; A reg.= "*** " azonost kdja
	call	LCD42			; az 1.lapon trolt adott azonostj szveg kiratsa
	pop	hl			; hibakd H-ba
	ld	a,h			; a hibakdnak megfelel azonostj szveg kikeresse
	ld	de,0D42Dh		; DE= default cm, ha nem szerepel a keresett szveg a tbzatban
	call	LDB2E			; 1.lapon lv rutin hvsa (cm: 0DFD5h)
;
	.dw	0DFD5h			; adott azonostszm szveg kezdcmnek kikeresse
;
	jr	nc,LCEDD		; ugrs, ha van tallat
	ld	a,00Ah			; A reg.= "Error " azonost kdja
	call	LCD42			; az 1.lapon trolt adott azonostj szveg kiratsa
	ld	a,h			; A reg.= hibakd
	call	LCEE5			; 8 bites binris szm kirsa decimlisan
	jr	LCEE2			; ugrs a befejezsre
;
LCEDD:	call	LDB2E			; 1.lapon lv rutin hvsa (cm: 0DC02h)
;
	.dw	0DC02h			; kezdcmmel adott szveg karaktereinek tadsa egyesvel a CLI karakteres outputjnak
;
LCEE2:	jp	0CD2Dh			; Soremels a vlasztott output eszkzn, majd visszatrs a hvhoz
;
;
;	8 bites binris szm kirsa decimlis ASCII formtumban a vlasztott outputra
;	in:   A - 8 bites szm
;	out: -
;
LCEE5:	ld	l,a			; 8 bites szm HL-be
	ld	h,00h			; fels bitekre nulla
;
;
;	16 bites binris szm kirsa decimlis ASCII formtumban a vlasztott outputra
;	megj.: a szm eleji bevezet nullkat levgja
;	in:  HL - kirand 16 bites szm
;	out: -
;
LCEE8:	ex	de,hl			; 16 bites szm DE regiszterbe
	ld	hl,00C78h		; HL a 4-bjtos munkaterletre mutat
	xor	a
	ld	(hl),a			; MSB bjt nullzsa
	dec	hl
	ld	(hl),a			; kvetkez bjtot is nullza
	dec	hl
	ld	(hl),d			; als szra kerl a 16 bites szm
	dec	hl
	ld	(hl),e
	ex	de,hl			; DE a 4-bjtos munkaterletre mutat
;
;	DE mutatta 4-bjtos szm kirsa decimlis ASCII formtumban a vlasztott outputra
;	in:  A - bevezet nullk helyett kirand karakter
;	    DE - kirand szm
;	out:   -
;
LCEF5:	exx
	ld	e,a			; E'= bevezet nullk helyett kirand karakter
	ld	d,030h			; D'= a '0' ASCII kdja
	exx
	ld	hl,LCF2D		; HL a decimlis helyirtkek tblzatra mutat
LCEFD:	ld	a,(hl)			; a tblzatban kvetkez 4-bjtos szm LSB bjtjnak vizsglata
	dec	a
	jr	nz,LCF04		; ugrs, ha ez nem az 1-es (az utols helyirtk)
	exx
	ld	e,d			; ha az utols helyirtk, akkor E'= 030h
	exx
LCF04:	xor	a			; A reg.= 00h  CY=0
	ld	c,a			; C= 00h (az oszts eredmnyt trolja)
LCF06:	push	hl			; aktulis szmok cmnek mentse
	push	de
	ld	b,004h			; 4-bjtosak a szmok
LCF0A:	ld	a,(de)			; DE ltal mutatott szmbl a HL ltal mutatott szm kivonsa 
	sbc	a,(hl)
	ld	(de),a			; eredmny trolsa a DE ltal mutatott cmen
	inc	hl			; mutatk nvelse
	inc	de
	djnz	LCF0A			; ismtls a kvetkez bjtokra
	pop	de			; mutatk ismt az LSB bjtokra mutatnak
	pop	hl
	inc	c			; kivonsok szmllsa (1-el tbbet szmol mint ahnyszor ki lehet vonni)
	jr	nc,LCF06		; ismtls, ha a legutols kivonsnl nem volt alulcsorduls
	call	LCF4E			; az utoljra kivont szm hozzadsa DE mutatta szmhoz
	ld	a,c			; A reg.-ben az oszts eredmnynek egsz rsze +1
	exx
	dec	a			; A reg.-ben a korrekt eredmny
	jr	z,LCF21			; ugrs, ha az eredmny 0 (csak az adott helyirtken)
	add	a,d			; A reg.= decimlis szmjegy ASCII kdja  ZF=0
	ld	e,d			; E'= 030h  (ASCII '0' karakter)
	.db	028h			; a kvetkez bjttal: jr z,LCED5  -> elfedi OR E -t
LCF21:	or	e			; utols szmjegynl vagy ha volt mr rtkes szmjegy E'= 030h, egybknt 00h
	jr	z,LCF27			; ugrs, ha mg nem az utols szmjegy s eddig 0 az eredmny
	call	LCCD8			; karakter kirsa a vlasztott outputra
LCF27:	exx
	ld	a,(hl)			; A reg.= kvetkez szm LSB bjtja a tblzatbl
	inc	a
	jr	nz,LCEFD		; ugrs, ha mg nem a tblzat zr bjtja
	ret
;
;
;	Decimlis helyirtkeknek megfelel szmok tblzata
;	(4 bjtos binris szmok, LSB->MSB sorrendben letrolva)
;
LCF2D:	.db	080h,096h,098h,000h		;  10 milli hexadecimlisan (LSB->MSB)
	.db	040h,042h,00Fh,000h		;   1 milli hexadecimlisan (LSB->MSB)
	.db	0A0h,086h,001h,000h		; 100 ezer
	.db	010h,027h,000h,000h		;  10 ezer
	.db	0E8h,003h,000h,000h		;   1 ezer
	.db	064h,000h,000h,000h		; 100
	.db	00Ah,000h,000h,000h		;  10
	.db	001h,000h,000h,000h		;   1
	.db	0FFh				; tblzatot zr bjt
;
;
;	Kt 4-bjtos binris szm sszeadsa
;	in:  DE - cl 4 bjtos szm cme (LSB->MSB)
;	     HL - hozzadand 4 bjtos szm cme (LSB->MSB)
;	out: DE - megrzdik, az eredmnyre mutat
;	     HL - a hozzadand szm utni bjtra mutat
;
LCF4E:	push	de			; DE mentse
	ld	b,004h			; 4 bjt lesz
	or	a			; CY=0
LCF52:	ld	a,(de)
	adc	a,(hl)			; szm hozzadsa az tvitel figyelembe vtelvel
	ld	(de),a
	inc	hl			; mutatk nvelse
	inc	de
	djnz	LCF52			; ismtls az sszes bjtra
	pop	de			; DE visszalltsa
	ret

;
;	itt volt mg nmi salta, a kb. LCEDD..LCEFD tart kd msolata
;


	.org	0CFFFh			; kitlts 0FFh-val a 4kB-os ROM lap vgig
	.db	0FFh


.end
